/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern0 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern0 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    case E_HFmode:
      if (pattern0 (x3, 
E_HFmode) != 0)
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    case E_DImode:
      if (pattern3 (x3) != 0)
        return -1;
      return 4;

    case E_RVVM8QImode:
      if (pattern0 (x3, 
E_RVVM8QImode) != 0)
        return -1;
      return 5;

    case E_RVVM4QImode:
      if (pattern0 (x3, 
E_RVVM4QImode) != 0)
        return -1;
      return 6;

    case E_RVVM2QImode:
      if (pattern0 (x3, 
E_RVVM2QImode) != 0)
        return -1;
      return 7;

    case E_RVVM1QImode:
      if (pattern0 (x3, 
E_RVVM1QImode) != 0)
        return -1;
      return 8;

    case E_RVVM8HImode:
      if (pattern0 (x3, 
E_RVVM8HImode) != 0)
        return -1;
      return 9;

    case E_RVVM4HImode:
      if (pattern0 (x3, 
E_RVVM4HImode) != 0)
        return -1;
      return 10;

    case E_RVVM2HImode:
      if (pattern0 (x3, 
E_RVVM2HImode) != 0)
        return -1;
      return 11;

    case E_RVVM1HImode:
      if (pattern0 (x3, 
E_RVVM1HImode) != 0)
        return -1;
      return 12;

    case E_RVVM8SImode:
      if (pattern0 (x3, 
E_RVVM8SImode) != 0)
        return -1;
      return 13;

    case E_RVVM4SImode:
      if (pattern0 (x3, 
E_RVVM4SImode) != 0)
        return -1;
      return 14;

    case E_RVVM2SImode:
      if (pattern0 (x3, 
E_RVVM2SImode) != 0)
        return -1;
      return 15;

    case E_RVVM1SImode:
      if (pattern0 (x3, 
E_RVVM1SImode) != 0)
        return -1;
      return 16;

    case E_RVVM8DImode:
      if (pattern0 (x3, 
E_RVVM8DImode) != 0)
        return -1;
      return 17;

    case E_RVVM4DImode:
      if (pattern0 (x3, 
E_RVVM4DImode) != 0)
        return -1;
      return 18;

    case E_RVVM2DImode:
      if (pattern0 (x3, 
E_RVVM2DImode) != 0)
        return -1;
      return 19;

    case E_RVVM1DImode:
      if (pattern0 (x3, 
E_RVVM1DImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2QImode:
      if (pattern0 (x3, 
E_RVVMF2QImode) != 0)
        return -1;
      return 21;

    case E_RVVMF4QImode:
      if (pattern0 (x3, 
E_RVVMF4QImode) != 0)
        return -1;
      return 22;

    case E_RVVMF8QImode:
      if (pattern0 (x3, 
E_RVVMF8QImode) != 0)
        return -1;
      return 23;

    case E_RVVMF2HImode:
      if (pattern0 (x3, 
E_RVVMF2HImode) != 0)
        return -1;
      return 24;

    case E_RVVMF4HImode:
      if (pattern0 (x3, 
E_RVVMF4HImode) != 0)
        return -1;
      return 25;

    case E_RVVMF2SImode:
      if (pattern0 (x3, 
E_RVVMF2SImode) != 0)
        return -1;
      return 26;

    case E_V1QImode:
      if (pattern0 (x3, 
E_V1QImode) != 0)
        return -1;
      return 27;

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 28;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 29;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 30;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 31;

    case E_V32QImode:
      if (pattern0 (x3, 
E_V32QImode) != 0)
        return -1;
      return 32;

    case E_V64QImode:
      if (pattern0 (x3, 
E_V64QImode) != 0)
        return -1;
      return 33;

    case E_V128QImode:
      if (pattern0 (x3, 
E_V128QImode) != 0)
        return -1;
      return 34;

    case E_V256QImode:
      if (pattern0 (x3, 
E_V256QImode) != 0)
        return -1;
      return 35;

    case E_V512QImode:
      if (pattern0 (x3, 
E_V512QImode) != 0)
        return -1;
      return 36;

    case E_V1024QImode:
      if (pattern0 (x3, 
E_V1024QImode) != 0)
        return -1;
      return 37;

    case E_V2048QImode:
      if (pattern0 (x3, 
E_V2048QImode) != 0)
        return -1;
      return 38;

    case E_V4096QImode:
      if (pattern0 (x3, 
E_V4096QImode) != 0)
        return -1;
      return 39;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 40;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 41;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 42;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 43;

    case E_V16HImode:
      if (pattern0 (x3, 
E_V16HImode) != 0)
        return -1;
      return 44;

    case E_V32HImode:
      if (pattern0 (x3, 
E_V32HImode) != 0)
        return -1;
      return 45;

    case E_V64HImode:
      if (pattern0 (x3, 
E_V64HImode) != 0)
        return -1;
      return 46;

    case E_V128HImode:
      if (pattern0 (x3, 
E_V128HImode) != 0)
        return -1;
      return 47;

    case E_V256HImode:
      if (pattern0 (x3, 
E_V256HImode) != 0)
        return -1;
      return 48;

    case E_V512HImode:
      if (pattern0 (x3, 
E_V512HImode) != 0)
        return -1;
      return 49;

    case E_V1024HImode:
      if (pattern0 (x3, 
E_V1024HImode) != 0)
        return -1;
      return 50;

    case E_V2048HImode:
      if (pattern0 (x3, 
E_V2048HImode) != 0)
        return -1;
      return 51;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 52;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 53;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 54;

    case E_V8SImode:
      if (pattern0 (x3, 
E_V8SImode) != 0)
        return -1;
      return 55;

    case E_V16SImode:
      if (pattern0 (x3, 
E_V16SImode) != 0)
        return -1;
      return 56;

    case E_V32SImode:
      if (pattern0 (x3, 
E_V32SImode) != 0)
        return -1;
      return 57;

    case E_V64SImode:
      if (pattern0 (x3, 
E_V64SImode) != 0)
        return -1;
      return 58;

    case E_V128SImode:
      if (pattern0 (x3, 
E_V128SImode) != 0)
        return -1;
      return 59;

    case E_V256SImode:
      if (pattern0 (x3, 
E_V256SImode) != 0)
        return -1;
      return 60;

    case E_V512SImode:
      if (pattern0 (x3, 
E_V512SImode) != 0)
        return -1;
      return 61;

    case E_V1024SImode:
      if (pattern0 (x3, 
E_V1024SImode) != 0)
        return -1;
      return 62;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 63;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 64;

    case E_V4DImode:
      if (pattern0 (x3, 
E_V4DImode) != 0)
        return -1;
      return 65;

    case E_V8DImode:
      if (pattern0 (x3, 
E_V8DImode) != 0)
        return -1;
      return 66;

    case E_V16DImode:
      if (pattern0 (x3, 
E_V16DImode) != 0)
        return -1;
      return 67;

    case E_V32DImode:
      if (pattern0 (x3, 
E_V32DImode) != 0)
        return -1;
      return 68;

    case E_V64DImode:
      if (pattern0 (x3, 
E_V64DImode) != 0)
        return -1;
      return 69;

    case E_V128DImode:
      if (pattern0 (x3, 
E_V128DImode) != 0)
        return -1;
      return 70;

    case E_V256DImode:
      if (pattern0 (x3, 
E_V256DImode) != 0)
        return -1;
      return 71;

    case E_V512DImode:
      if (pattern0 (x3, 
E_V512DImode) != 0)
        return -1;
      return 72;

    case E_RVVM8HFmode:
      if (pattern0 (x3, 
E_RVVM8HFmode) != 0)
        return -1;
      return 73;

    case E_RVVM4HFmode:
      if (pattern0 (x3, 
E_RVVM4HFmode) != 0)
        return -1;
      return 74;

    case E_RVVM2HFmode:
      if (pattern0 (x3, 
E_RVVM2HFmode) != 0)
        return -1;
      return 75;

    case E_RVVM1HFmode:
      if (pattern0 (x3, 
E_RVVM1HFmode) != 0)
        return -1;
      return 76;

    case E_RVVMF2HFmode:
      if (pattern0 (x3, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 77;

    case E_RVVMF4HFmode:
      if (pattern0 (x3, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 78;

    case E_RVVM8SFmode:
      if (pattern0 (x3, 
E_RVVM8SFmode) != 0)
        return -1;
      return 79;

    case E_RVVM4SFmode:
      if (pattern0 (x3, 
E_RVVM4SFmode) != 0)
        return -1;
      return 80;

    case E_RVVM2SFmode:
      if (pattern0 (x3, 
E_RVVM2SFmode) != 0)
        return -1;
      return 81;

    case E_RVVM1SFmode:
      if (pattern0 (x3, 
E_RVVM1SFmode) != 0)
        return -1;
      return 82;

    case E_RVVMF2SFmode:
      if (pattern0 (x3, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 83;

    case E_RVVM8DFmode:
      if (pattern0 (x3, 
E_RVVM8DFmode) != 0)
        return -1;
      return 84;

    case E_RVVM4DFmode:
      if (pattern0 (x3, 
E_RVVM4DFmode) != 0)
        return -1;
      return 85;

    case E_RVVM2DFmode:
      if (pattern0 (x3, 
E_RVVM2DFmode) != 0)
        return -1;
      return 86;

    case E_RVVM1DFmode:
      if (pattern0 (x3, 
E_RVVM1DFmode) != 0)
        return -1;
      return 87;

    case E_V1HFmode:
      if (pattern0 (x3, 
E_V1HFmode) != 0)
        return -1;
      return 88;

    case E_V2HFmode:
      if (pattern0 (x3, 
E_V2HFmode) != 0)
        return -1;
      return 89;

    case E_V4HFmode:
      if (pattern0 (x3, 
E_V4HFmode) != 0)
        return -1;
      return 90;

    case E_V8HFmode:
      if (pattern0 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 91;

    case E_V16HFmode:
      if (pattern0 (x3, 
E_V16HFmode) != 0)
        return -1;
      return 92;

    case E_V32HFmode:
      if (pattern0 (x3, 
E_V32HFmode) != 0)
        return -1;
      return 93;

    case E_V64HFmode:
      if (pattern0 (x3, 
E_V64HFmode) != 0)
        return -1;
      return 94;

    case E_V128HFmode:
      if (pattern0 (x3, 
E_V128HFmode) != 0)
        return -1;
      return 95;

    case E_V256HFmode:
      if (pattern0 (x3, 
E_V256HFmode) != 0)
        return -1;
      return 96;

    case E_V512HFmode:
      if (pattern0 (x3, 
E_V512HFmode) != 0)
        return -1;
      return 97;

    case E_V1024HFmode:
      if (pattern0 (x3, 
E_V1024HFmode) != 0)
        return -1;
      return 98;

    case E_V2048HFmode:
      if (pattern0 (x3, 
E_V2048HFmode) != 0)
        return -1;
      return 99;

    case E_V1SFmode:
      if (pattern0 (x3, 
E_V1SFmode) != 0)
        return -1;
      return 100;

    case E_V2SFmode:
      if (pattern0 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 101;

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 102;

    case E_V8SFmode:
      if (pattern0 (x3, 
E_V8SFmode) != 0)
        return -1;
      return 103;

    case E_V16SFmode:
      if (pattern0 (x3, 
E_V16SFmode) != 0)
        return -1;
      return 104;

    case E_V32SFmode:
      if (pattern0 (x3, 
E_V32SFmode) != 0)
        return -1;
      return 105;

    case E_V64SFmode:
      if (pattern0 (x3, 
E_V64SFmode) != 0)
        return -1;
      return 106;

    case E_V128SFmode:
      if (pattern0 (x3, 
E_V128SFmode) != 0)
        return -1;
      return 107;

    case E_V256SFmode:
      if (pattern0 (x3, 
E_V256SFmode) != 0)
        return -1;
      return 108;

    case E_V512SFmode:
      if (pattern0 (x3, 
E_V512SFmode) != 0)
        return -1;
      return 109;

    case E_V1024SFmode:
      if (pattern0 (x3, 
E_V1024SFmode) != 0)
        return -1;
      return 110;

    case E_V1DFmode:
      if (pattern0 (x3, 
E_V1DFmode) != 0)
        return -1;
      return 111;

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 112;

    case E_V4DFmode:
      if (pattern0 (x3, 
E_V4DFmode) != 0)
        return -1;
      return 113;

    case E_V8DFmode:
      if (pattern0 (x3, 
E_V8DFmode) != 0)
        return -1;
      return 114;

    case E_V16DFmode:
      if (pattern0 (x3, 
E_V16DFmode) != 0)
        return -1;
      return 115;

    case E_V32DFmode:
      if (pattern0 (x3, 
E_V32DFmode) != 0)
        return -1;
      return 116;

    case E_V64DFmode:
      if (pattern0 (x3, 
E_V64DFmode) != 0)
        return -1;
      return 117;

    case E_V128DFmode:
      if (pattern0 (x3, 
E_V128DFmode) != 0)
        return -1;
      return 118;

    case E_V256DFmode:
      if (pattern0 (x3, 
E_V256DFmode) != 0)
        return -1;
      return 119;

    case E_V512DFmode:
      if (pattern0 (x3, 
E_V512DFmode) != 0)
        return -1;
      return 120;

    default:
      return -1;
    }
}

int
pattern120 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 2)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XEXP (x6, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i5)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != SET)
    return -1;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != MEM)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != PLUS)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 2)
    return -1;
  x16 = XEXP (x14, 1);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XEXP (x12, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != i4)
    return -1;
  x18 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x18) != SET)
    return -1;
  x19 = XEXP (x18, 1);
  if (GET_CODE (x19) != MEM)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_CODE (x20) != PLUS)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 2)
    return -1;
  x22 = XEXP (x20, 1);
  if (GET_CODE (x22) != CONST_INT)
    return -1;
  x23 = XEXP (x18, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != i3)
    return -1;
  x24 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x24) != SET)
    return -1;
  x25 = XEXP (x24, 1);
  if (GET_CODE (x25) != MEM)
    return -1;
  x26 = XEXP (x25, 0);
  if (GET_CODE (x26) != PLUS)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 2)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_CODE (x28) != CONST_INT)
    return -1;
  x29 = XEXP (x24, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != i2)
    return -1;
  x30 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x30) != SET)
    return -1;
  x31 = XEXP (x30, 1);
  if (GET_CODE (x31) != MEM)
    return -1;
  x32 = XEXP (x31, 0);
  if (GET_CODE (x32) != PLUS)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 2)
    return -1;
  x34 = XEXP (x32, 1);
  if (GET_CODE (x34) != CONST_INT)
    return -1;
  x35 = XEXP (x30, 0);
  if (GET_CODE (x35) != REG
      || REGNO (x35) != i1)
    return -1;
  return 0;
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern53 (x1); /* [-1, 1] */

    case E_RVVM4HFmode:
      res = pattern54 (x1);
      if (res >= 0)
        return res + 2; /* [2, 4] */
      return -1;

    case E_RVVM2HFmode:
      res = pattern55 (x1);
      if (res >= 0)
        return res + 5; /* [5, 7] */
      return -1;

    case E_RVVM1HFmode:
      res = pattern56 (x1);
      if (res >= 0)
        return res + 8; /* [8, 10] */
      return -1;

    case E_RVVMF2HFmode:
      res = pattern57 (x1);
      if (res >= 0)
        return res + 11; /* [11, 13] */
      return -1;

    case E_RVVMF4HFmode:
      res = pattern58 (x1);
      if (res >= 0)
        return res + 14; /* [14, 16] */
      return -1;

    case E_RVVM8SFmode:
      res = pattern59 (x1);
      if (res >= 0)
        return res + 17; /* [17, 18] */
      return -1;

    case E_RVVM4SFmode:
      res = pattern60 (x1);
      if (res >= 0)
        return res + 19; /* [19, 21] */
      return -1;

    case E_RVVM2SFmode:
      res = pattern61 (x1);
      if (res >= 0)
        return res + 22; /* [22, 24] */
      return -1;

    case E_RVVM1SFmode:
      res = pattern62 (x1);
      if (res >= 0)
        return res + 25; /* [25, 27] */
      return -1;

    case E_RVVMF2SFmode:
      res = pattern63 (x1);
      if (res >= 0)
        return res + 28; /* [28, 30] */
      return -1;

    case E_RVVM8DFmode:
      res = pattern64 (x1);
      if (res >= 0)
        return res + 31; /* [31, 32] */
      return -1;

    case E_RVVM4DFmode:
      res = pattern65 (x1);
      if (res >= 0)
        return res + 33; /* [33, 34] */
      return -1;

    case E_RVVM2DFmode:
      res = pattern66 (x1);
      if (res >= 0)
        return res + 35; /* [35, 36] */
      return -1;

    case E_RVVM1DFmode:
      res = pattern67 (x1);
      if (res >= 0)
        return res + 37; /* [37, 38] */
      return -1;

    case E_V1HFmode:
      res = pattern68 (x1);
      if (res >= 0)
        return res + 39; /* [39, 41] */
      return -1;

    case E_V2HFmode:
      res = pattern69 (x1);
      if (res >= 0)
        return res + 42; /* [42, 44] */
      return -1;

    case E_V4HFmode:
      res = pattern70 (x1);
      if (res >= 0)
        return res + 45; /* [45, 47] */
      return -1;

    case E_V8HFmode:
      res = pattern71 (x1);
      if (res >= 0)
        return res + 48; /* [48, 50] */
      return -1;

    case E_V16HFmode:
      res = pattern72 (x1);
      if (res >= 0)
        return res + 51; /* [51, 53] */
      return -1;

    case E_V32HFmode:
      res = pattern73 (x1);
      if (res >= 0)
        return res + 54; /* [54, 56] */
      return -1;

    case E_V64HFmode:
      res = pattern74 (x1);
      if (res >= 0)
        return res + 57; /* [57, 59] */
      return -1;

    case E_V128HFmode:
      res = pattern75 (x1);
      if (res >= 0)
        return res + 60; /* [60, 62] */
      return -1;

    case E_V256HFmode:
      res = pattern76 (x1);
      if (res >= 0)
        return res + 63; /* [63, 65] */
      return -1;

    case E_V512HFmode:
      res = pattern77 (x1);
      if (res >= 0)
        return res + 66; /* [66, 68] */
      return -1;

    case E_V1024HFmode:
      res = pattern78 (x1);
      if (res >= 0)
        return res + 69; /* [69, 71] */
      return -1;

    case E_V2048HFmode:
      res = pattern79 (x1);
      if (res >= 0)
        return res + 72; /* [72, 73] */
      return -1;

    case E_V1SFmode:
      res = pattern80 (x1);
      if (res >= 0)
        return res + 74; /* [74, 76] */
      return -1;

    case E_V2SFmode:
      res = pattern81 (x1);
      if (res >= 0)
        return res + 77; /* [77, 79] */
      return -1;

    case E_V4SFmode:
      res = pattern82 (x1);
      if (res >= 0)
        return res + 80; /* [80, 82] */
      return -1;

    case E_V8SFmode:
      res = pattern83 (x1);
      if (res >= 0)
        return res + 83; /* [83, 85] */
      return -1;

    case E_V16SFmode:
      res = pattern84 (x1);
      if (res >= 0)
        return res + 86; /* [86, 88] */
      return -1;

    case E_V32SFmode:
      res = pattern85 (x1);
      if (res >= 0)
        return res + 89; /* [89, 91] */
      return -1;

    case E_V64SFmode:
      res = pattern86 (x1);
      if (res >= 0)
        return res + 92; /* [92, 94] */
      return -1;

    case E_V128SFmode:
      res = pattern87 (x1);
      if (res >= 0)
        return res + 95; /* [95, 97] */
      return -1;

    case E_V256SFmode:
      res = pattern88 (x1);
      if (res >= 0)
        return res + 98; /* [98, 100] */
      return -1;

    case E_V512SFmode:
      res = pattern89 (x1);
      if (res >= 0)
        return res + 101; /* [101, 103] */
      return -1;

    case E_V1024SFmode:
      res = pattern90 (x1);
      if (res >= 0)
        return res + 104; /* [104, 105] */
      return -1;

    case E_V1DFmode:
      res = pattern91 (x1);
      if (res >= 0)
        return res + 106; /* [106, 107] */
      return -1;

    case E_V2DFmode:
      res = pattern92 (x1);
      if (res >= 0)
        return res + 108; /* [108, 109] */
      return -1;

    case E_V4DFmode:
      res = pattern93 (x1);
      if (res >= 0)
        return res + 110; /* [110, 111] */
      return -1;

    case E_V8DFmode:
      res = pattern94 (x1);
      if (res >= 0)
        return res + 112; /* [112, 113] */
      return -1;

    case E_V16DFmode:
      res = pattern95 (x1);
      if (res >= 0)
        return res + 114; /* [114, 115] */
      return -1;

    case E_V32DFmode:
      res = pattern96 (x1);
      if (res >= 0)
        return res + 116; /* [116, 117] */
      return -1;

    case E_V64DFmode:
      res = pattern97 (x1);
      if (res >= 0)
        return res + 118; /* [118, 119] */
      return -1;

    case E_V128DFmode:
      res = pattern98 (x1);
      if (res >= 0)
        return res + 120; /* [120, 121] */
      return -1;

    case E_V256DFmode:
      res = pattern99 (x1);
      if (res >= 0)
        return res + 122; /* [122, 123] */
      return -1;

    case E_V512DFmode:
      res = pattern100 (x1);
      if (res >= 0)
        return res + 124; /* [124, 125] */
      return -1;

    default:
      return -1;
    }
}

int
pattern144 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MULT)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern143 (x1, 
E_RVVM8HFmode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern143 (x1, 
E_RVVM4HFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern143 (x1, 
E_RVVM2HFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern143 (x1, 
E_RVVM1HFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern143 (x1, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern143 (x1, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern143 (x1, 
E_RVVM8SFmode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern143 (x1, 
E_RVVM4SFmode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern143 (x1, 
E_RVVM2SFmode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern143 (x1, 
E_RVVM1SFmode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern143 (x1, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern143 (x1, 
E_RVVM8DFmode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern143 (x1, 
E_RVVM4DFmode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern143 (x1, 
E_RVVM2DFmode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern143 (x1, 
E_RVVM1DFmode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern143 (x1, 
E_V1HFmode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern143 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern143 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern143 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern143 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern143 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern143 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern143 (x1, 
E_V128HFmode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern143 (x1, 
E_V256HFmode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern143 (x1, 
E_V512HFmode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern143 (x1, 
E_V1024HFmode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern143 (x1, 
E_V2048HFmode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern143 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern143 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern143 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern143 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern143 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern143 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern143 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern143 (x1, 
E_V128SFmode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern143 (x1, 
E_V256SFmode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern143 (x1, 
E_V512SFmode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern143 (x1, 
E_V1024SFmode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern143 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern143 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern143 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern143 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern143 (x1, 
E_V16DFmode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern143 (x1, 
E_V32DFmode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern143 (x1, 
E_V64DFmode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern143 (x1, 
E_V128DFmode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern143 (x1, 
E_V256DFmode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern143 (x1, 
E_V512DFmode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern155 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case ZERO_EXTEND:
      x3 = XEXP (x1, 0);
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      return pattern145 (x1); /* [-1, 47] */

    case REG:
    case SUBREG:
      res = pattern153 (x1);
      if (res >= 0)
        return res + 48; /* [48, 95] */
      return -1;

    case SIGN_EXTEND:
      x3 = XEXP (x1, 0);
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          if (pattern154 (x1, 
E_RVVM4QImode, 
E_RVVM8HImode) != 0)
            return -1;
          return 96;

        case E_RVVM4HImode:
          if (pattern154 (x1, 
E_RVVM2QImode, 
E_RVVM4HImode) != 0)
            return -1;
          return 97;

        case E_RVVM2HImode:
          if (pattern154 (x1, 
E_RVVM1QImode, 
E_RVVM2HImode) != 0)
            return -1;
          return 98;

        case E_RVVM1HImode:
          if (pattern154 (x1, 
E_RVVMF2QImode, 
E_RVVM1HImode) != 0)
            return -1;
          return 99;

        case E_RVVMF2HImode:
          if (pattern154 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HImode) != 0)
            return -1;
          return 100;

        case E_RVVMF4HImode:
          if (pattern154 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HImode) != 0)
            return -1;
          return 101;

        case E_RVVM8SImode:
          if (pattern154 (x1, 
E_RVVM4HImode, 
E_RVVM8SImode) != 0)
            return -1;
          return 102;

        case E_RVVM4SImode:
          if (pattern154 (x1, 
E_RVVM2HImode, 
E_RVVM4SImode) != 0)
            return -1;
          return 103;

        case E_RVVM2SImode:
          if (pattern154 (x1, 
E_RVVM1HImode, 
E_RVVM2SImode) != 0)
            return -1;
          return 104;

        case E_RVVM1SImode:
          if (pattern154 (x1, 
E_RVVMF2HImode, 
E_RVVM1SImode) != 0)
            return -1;
          return 105;

        case E_RVVMF2SImode:
          if (pattern154 (x1, 
E_RVVMF4HImode, 
E_RVVMF2SImode) != 0)
            return -1;
          return 106;

        case E_RVVM8DImode:
          if (pattern154 (x1, 
E_RVVM4SImode, 
E_RVVM8DImode) != 0)
            return -1;
          return 107;

        case E_RVVM4DImode:
          if (pattern154 (x1, 
E_RVVM2SImode, 
E_RVVM4DImode) != 0)
            return -1;
          return 108;

        case E_RVVM2DImode:
          if (pattern154 (x1, 
E_RVVM1SImode, 
E_RVVM2DImode) != 0)
            return -1;
          return 109;

        case E_RVVM1DImode:
          if (pattern154 (x1, 
E_RVVMF2SImode, 
E_RVVM1DImode) != 0)
            return -1;
          return 110;

        case E_V1HImode:
          if (pattern154 (x1, 
E_V1QImode, 
E_V1HImode) != 0)
            return -1;
          return 111;

        case E_V2HImode:
          if (pattern154 (x1, 
E_V2QImode, 
E_V2HImode) != 0)
            return -1;
          return 112;

        case E_V4HImode:
          if (pattern154 (x1, 
E_V4QImode, 
E_V4HImode) != 0)
            return -1;
          return 113;

        case E_V8HImode:
          if (pattern154 (x1, 
E_V8QImode, 
E_V8HImode) != 0)
            return -1;
          return 114;

        case E_V16HImode:
          if (pattern154 (x1, 
E_V16QImode, 
E_V16HImode) != 0)
            return -1;
          return 115;

        case E_V32HImode:
          if (pattern154 (x1, 
E_V32QImode, 
E_V32HImode) != 0)
            return -1;
          return 116;

        case E_V64HImode:
          if (pattern154 (x1, 
E_V64QImode, 
E_V64HImode) != 0)
            return -1;
          return 117;

        case E_V128HImode:
          if (pattern154 (x1, 
E_V128QImode, 
E_V128HImode) != 0)
            return -1;
          return 118;

        case E_V256HImode:
          if (pattern154 (x1, 
E_V256QImode, 
E_V256HImode) != 0)
            return -1;
          return 119;

        case E_V512HImode:
          if (pattern154 (x1, 
E_V512QImode, 
E_V512HImode) != 0)
            return -1;
          return 120;

        case E_V1024HImode:
          if (pattern154 (x1, 
E_V1024QImode, 
E_V1024HImode) != 0)
            return -1;
          return 121;

        case E_V2048HImode:
          if (pattern154 (x1, 
E_V2048QImode, 
E_V2048HImode) != 0)
            return -1;
          return 122;

        case E_V1SImode:
          if (pattern154 (x1, 
E_V1HImode, 
E_V1SImode) != 0)
            return -1;
          return 123;

        case E_V2SImode:
          if (pattern154 (x1, 
E_V2HImode, 
E_V2SImode) != 0)
            return -1;
          return 124;

        case E_V4SImode:
          if (pattern154 (x1, 
E_V4HImode, 
E_V4SImode) != 0)
            return -1;
          return 125;

        case E_V8SImode:
          if (pattern154 (x1, 
E_V8HImode, 
E_V8SImode) != 0)
            return -1;
          return 126;

        case E_V16SImode:
          if (pattern154 (x1, 
E_V16HImode, 
E_V16SImode) != 0)
            return -1;
          return 127;

        case E_V32SImode:
          if (pattern154 (x1, 
E_V32HImode, 
E_V32SImode) != 0)
            return -1;
          return 128;

        case E_V64SImode:
          if (pattern154 (x1, 
E_V64HImode, 
E_V64SImode) != 0)
            return -1;
          return 129;

        case E_V128SImode:
          if (pattern154 (x1, 
E_V128HImode, 
E_V128SImode) != 0)
            return -1;
          return 130;

        case E_V256SImode:
          if (pattern154 (x1, 
E_V256HImode, 
E_V256SImode) != 0)
            return -1;
          return 131;

        case E_V512SImode:
          if (pattern154 (x1, 
E_V512HImode, 
E_V512SImode) != 0)
            return -1;
          return 132;

        case E_V1024SImode:
          if (pattern154 (x1, 
E_V1024HImode, 
E_V1024SImode) != 0)
            return -1;
          return 133;

        case E_V1DImode:
          if (pattern154 (x1, 
E_V1SImode, 
E_V1DImode) != 0)
            return -1;
          return 134;

        case E_V2DImode:
          if (pattern154 (x1, 
E_V2SImode, 
E_V2DImode) != 0)
            return -1;
          return 135;

        case E_V4DImode:
          if (pattern154 (x1, 
E_V4SImode, 
E_V4DImode) != 0)
            return -1;
          return 136;

        case E_V8DImode:
          if (pattern154 (x1, 
E_V8SImode, 
E_V8DImode) != 0)
            return -1;
          return 137;

        case E_V16DImode:
          if (pattern154 (x1, 
E_V16SImode, 
E_V16DImode) != 0)
            return -1;
          return 138;

        case E_V32DImode:
          if (pattern154 (x1, 
E_V32SImode, 
E_V32DImode) != 0)
            return -1;
          return 139;

        case E_V64DImode:
          if (pattern154 (x1, 
E_V64SImode, 
E_V64DImode) != 0)
            return -1;
          return 140;

        case E_V128DImode:
          if (pattern154 (x1, 
E_V128SImode, 
E_V128DImode) != 0)
            return -1;
          return 141;

        case E_V256DImode:
          if (pattern154 (x1, 
E_V256SImode, 
E_V256DImode) != 0)
            return -1;
          return 142;

        case E_V512DImode:
          if (pattern154 (x1, 
E_V512SImode, 
E_V512DImode) != 0)
            return -1;
          return 143;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern188 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1QImode:
      if (!register_operand (operands[3], E_RVVM1QImode))
        return -1;
      return 0;

    case E_RVVM2HImode:
      if (!register_operand (operands[3], E_RVVM2HImode))
        return -1;
      return 1;

    case E_RVVM4SImode:
      if (!register_operand (operands[3], E_RVVM4SImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      if (!register_operand (operands[3], E_RVVM8DImode))
        return -1;
      return 3;

    case E_RVVM2BFmode:
      if (!register_operand (operands[3], E_RVVM2BFmode))
        return -1;
      return 4;

    case E_RVVM2HFmode:
      if (!register_operand (operands[3], E_RVVM2HFmode))
        return -1;
      return 5;

    case E_RVVM4SFmode:
      if (!register_operand (operands[3], E_RVVM4SFmode))
        return -1;
      return 6;

    case E_RVVM8DFmode:
      if (!register_operand (operands[3], E_RVVM8DFmode))
        return -1;
      return 7;

    case E_RVVM1x2QImode:
      if (!register_operand (operands[3], E_RVVM1x2QImode))
        return -1;
      return 8;

    case E_RVVM1x3QImode:
      if (!register_operand (operands[3], E_RVVM1x3QImode))
        return -1;
      return 9;

    case E_RVVM1x4QImode:
      if (!register_operand (operands[3], E_RVVM1x4QImode))
        return -1;
      return 10;

    case E_RVVM1x5QImode:
      if (!register_operand (operands[3], E_RVVM1x5QImode))
        return -1;
      return 11;

    case E_RVVM1x6QImode:
      if (!register_operand (operands[3], E_RVVM1x6QImode))
        return -1;
      return 12;

    case E_RVVM1x7QImode:
      if (!register_operand (operands[3], E_RVVM1x7QImode))
        return -1;
      return 13;

    case E_RVVM1x8QImode:
      if (!register_operand (operands[3], E_RVVM1x8QImode))
        return -1;
      return 14;

    case E_RVVM2x2HImode:
      if (!register_operand (operands[3], E_RVVM2x2HImode))
        return -1;
      return 15;

    case E_RVVM2x3HImode:
      if (!register_operand (operands[3], E_RVVM2x3HImode))
        return -1;
      return 16;

    case E_RVVM2x4HImode:
      if (!register_operand (operands[3], E_RVVM2x4HImode))
        return -1;
      return 17;

    case E_RVVM4x2SImode:
      if (!register_operand (operands[3], E_RVVM4x2SImode))
        return -1;
      return 18;

    case E_RVVM2x2BFmode:
      if (!register_operand (operands[3], E_RVVM2x2BFmode))
        return -1;
      return 19;

    case E_RVVM2x3BFmode:
      if (!register_operand (operands[3], E_RVVM2x3BFmode))
        return -1;
      return 20;

    case E_RVVM2x4BFmode:
      if (!register_operand (operands[3], E_RVVM2x4BFmode))
        return -1;
      return 21;

    case E_RVVM2x2HFmode:
      if (!register_operand (operands[3], E_RVVM2x2HFmode))
        return -1;
      return 22;

    case E_RVVM2x3HFmode:
      if (!register_operand (operands[3], E_RVVM2x3HFmode))
        return -1;
      return 23;

    case E_RVVM2x4HFmode:
      if (!register_operand (operands[3], E_RVVM2x4HFmode))
        return -1;
      return 24;

    case E_RVVM4x2SFmode:
      if (!register_operand (operands[3], E_RVVM4x2SFmode))
        return -1;
      return 25;

    default:
      return -1;
    }
}

int
pattern194 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_merge_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !reg_or_0_operand (operands[4], i3))
    return -1;
  return 0;
}

int
pattern197 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 7
      || XINT (x3, 1) != 93)
    return -1;
  x4 = XVECEXP (x3, 0, 5);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x3, 0, 6);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 67
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XVECEXP (x3, 0, 0);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 1);
  operands[5] = x8;
  if (!vector_length_operand (operands[5], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x3, 0, 2);
  operands[6] = x9;
  if (!const_int_operand (operands[6], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 3);
  operands[7] = x10;
  if (!const_int_operand (operands[7], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x3, 0, 4);
  operands[8] = x11;
  if (!const_int_operand (operands[8], E_VOIDmode))
    return -1;
  x12 = XVECEXP (x2, 0, 1);
  operands[2] = x12;
  x13 = XVECEXP (x2, 0, 2);
  operands[3] = x13;
  x14 = XVECEXP (x2, 0, 3);
  operands[4] = x14;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern196 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern196 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern196 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern196 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern196 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern196 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern196 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode, 
E_SFmode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern196 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern196 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern196 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern196 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern196 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode, 
E_DFmode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern196 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode, 
E_DFmode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern196 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode, 
E_DFmode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern196 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode, 
E_DFmode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern196 (x2, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern196 (x2, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern196 (x2, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern196 (x2, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern196 (x2, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern196 (x2, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern196 (x2, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern196 (x2, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern196 (x2, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern196 (x2, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern196 (x2, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern196 (x2, 
E_V2048HFmode, 
E_V2048BImode, 
E_HFmode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern196 (x2, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern196 (x2, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern196 (x2, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern196 (x2, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern196 (x2, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern196 (x2, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern196 (x2, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern196 (x2, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern196 (x2, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern196 (x2, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern196 (x2, 
E_V1024SFmode, 
E_V1024BImode, 
E_SFmode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern196 (x2, 
E_V1DFmode, 
E_V1BImode, 
E_DFmode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern196 (x2, 
E_V2DFmode, 
E_V2BImode, 
E_DFmode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern196 (x2, 
E_V4DFmode, 
E_V4BImode, 
E_DFmode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern196 (x2, 
E_V8DFmode, 
E_V8BImode, 
E_DFmode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern196 (x2, 
E_V16DFmode, 
E_V16BImode, 
E_DFmode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern196 (x2, 
E_V32DFmode, 
E_V32BImode, 
E_DFmode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern196 (x2, 
E_V64DFmode, 
E_V64BImode, 
E_DFmode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern196 (x2, 
E_V128DFmode, 
E_V128BImode, 
E_DFmode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern196 (x2, 
E_V256DFmode, 
E_V256BImode, 
E_DFmode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern196 (x2, 
E_V512DFmode, 
E_V512BImode, 
E_DFmode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern219 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[3] = x3;
      x4 = XEXP (x1, 2);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          return pattern206 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

        case E_RVVM4QImode:
          if (pattern206 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2QImode:
          if (pattern206 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1QImode:
          if (pattern206 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 3;

        case E_RVVM8HImode:
          if (pattern206 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 4;

        case E_RVVM4HImode:
          if (pattern206 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 5;

        case E_RVVM2HImode:
          if (pattern206 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 6;

        case E_RVVM1HImode:
          if (pattern206 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 7;

        case E_RVVM8SImode:
          if (pattern206 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 8;

        case E_RVVM4SImode:
          if (pattern206 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 9;

        case E_RVVM2SImode:
          if (pattern206 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 10;

        case E_RVVM1SImode:
          if (pattern206 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 11;

        case E_RVVM8DImode:
          if (pattern206 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 12;

        case E_RVVM4DImode:
          if (pattern206 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 13;

        case E_RVVM2DImode:
          if (pattern206 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 14;

        case E_RVVM1DImode:
          if (pattern206 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 15;

        case E_RVVMF2QImode:
          if (pattern206 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 16;

        case E_RVVMF4QImode:
          if (pattern206 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 17;

        case E_RVVMF8QImode:
          if (pattern206 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 18;

        case E_RVVMF2HImode:
          if (pattern206 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 19;

        case E_RVVMF4HImode:
          if (pattern206 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 20;

        case E_RVVMF2SImode:
          if (pattern206 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 21;

        case E_RVVM8BFmode:
          if (pattern206 (x1, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 22;

        case E_RVVM4BFmode:
          if (pattern206 (x1, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 23;

        case E_RVVM2BFmode:
          if (pattern206 (x1, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 24;

        case E_RVVM1BFmode:
          if (pattern206 (x1, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 25;

        case E_RVVMF2BFmode:
          if (pattern206 (x1, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 26;

        case E_RVVMF4BFmode:
          if (pattern206 (x1, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 27;

        case E_RVVM8HFmode:
          if (pattern206 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 28;

        case E_RVVM4HFmode:
          if (pattern206 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 29;

        case E_RVVM2HFmode:
          if (pattern206 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 30;

        case E_RVVM1HFmode:
          if (pattern206 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 31;

        case E_RVVMF2HFmode:
          if (pattern206 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 32;

        case E_RVVMF4HFmode:
          if (pattern206 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 33;

        case E_RVVM8SFmode:
          if (pattern206 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 34;

        case E_RVVM4SFmode:
          if (pattern206 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 35;

        case E_RVVM2SFmode:
          if (pattern206 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 36;

        case E_RVVM1SFmode:
          if (pattern206 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 37;

        case E_RVVMF2SFmode:
          if (pattern206 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 38;

        case E_RVVM8DFmode:
          if (pattern206 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 39;

        case E_RVVM4DFmode:
          if (pattern206 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 40;

        case E_RVVM2DFmode:
          if (pattern206 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 41;

        case E_RVVM1DFmode:
          if (pattern206 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 42;

        case E_V1QImode:
          if (pattern206 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
            return -1;
          return 43;

        case E_V2QImode:
          if (pattern206 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
            return -1;
          return 44;

        case E_V4QImode:
          if (pattern206 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
            return -1;
          return 45;

        case E_V8QImode:
          if (pattern206 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
            return -1;
          return 46;

        case E_V16QImode:
          if (pattern206 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          return 47;

        case E_V32QImode:
          if (pattern206 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
            return -1;
          return 48;

        case E_V64QImode:
          if (pattern206 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
            return -1;
          return 49;

        case E_V128QImode:
          if (pattern206 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
            return -1;
          return 50;

        case E_V256QImode:
          if (pattern206 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
            return -1;
          return 51;

        case E_V512QImode:
          if (pattern206 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
            return -1;
          return 52;

        case E_V1024QImode:
          if (pattern206 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
            return -1;
          return 53;

        case E_V2048QImode:
          if (pattern206 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
            return -1;
          return 54;

        case E_V4096QImode:
          if (pattern206 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
            return -1;
          return 55;

        case E_V1HImode:
          if (pattern206 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
            return -1;
          return 56;

        case E_V2HImode:
          if (pattern206 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
            return -1;
          return 57;

        case E_V4HImode:
          if (pattern206 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
            return -1;
          return 58;

        case E_V8HImode:
          if (pattern206 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 59;

        case E_V16HImode:
          if (pattern206 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
            return -1;
          return 60;

        case E_V32HImode:
          if (pattern206 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
            return -1;
          return 61;

        case E_V64HImode:
          if (pattern206 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
            return -1;
          return 62;

        case E_V128HImode:
          if (pattern206 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
            return -1;
          return 63;

        case E_V256HImode:
          if (pattern206 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
            return -1;
          return 64;

        case E_V512HImode:
          if (pattern206 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
            return -1;
          return 65;

        case E_V1024HImode:
          if (pattern206 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
            return -1;
          return 66;

        case E_V2048HImode:
          if (pattern206 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
            return -1;
          return 67;

        case E_V1SImode:
          if (pattern206 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
            return -1;
          return 68;

        case E_V2SImode:
          if (pattern206 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
            return -1;
          return 69;

        case E_V4SImode:
          if (pattern206 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 70;

        case E_V8SImode:
          if (pattern206 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
            return -1;
          return 71;

        case E_V16SImode:
          if (pattern206 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
            return -1;
          return 72;

        case E_V32SImode:
          if (pattern206 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
            return -1;
          return 73;

        case E_V64SImode:
          if (pattern206 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
            return -1;
          return 74;

        case E_V128SImode:
          if (pattern206 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
            return -1;
          return 75;

        case E_V256SImode:
          if (pattern206 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
            return -1;
          return 76;

        case E_V512SImode:
          if (pattern206 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
            return -1;
          return 77;

        case E_V1024SImode:
          if (pattern206 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
            return -1;
          return 78;

        case E_V1DImode:
          if (pattern206 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
            return -1;
          return 79;

        case E_V2DImode:
          if (pattern206 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
            return -1;
          return 80;

        case E_V4DImode:
          if (pattern206 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
            return -1;
          return 81;

        case E_V8DImode:
          if (pattern206 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
            return -1;
          return 82;

        case E_V16DImode:
          if (pattern206 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
            return -1;
          return 83;

        case E_V32DImode:
          if (pattern206 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
            return -1;
          return 84;

        case E_V64DImode:
          if (pattern206 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
            return -1;
          return 85;

        case E_V128DImode:
          if (pattern206 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
            return -1;
          return 86;

        case E_V256DImode:
          if (pattern206 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
            return -1;
          return 87;

        case E_V512DImode:
          if (pattern206 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
            return -1;
          return 88;

        case E_V1HFmode:
          if (pattern206 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 89;

        case E_V2HFmode:
          if (pattern206 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 90;

        case E_V4HFmode:
          if (pattern206 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 91;

        case E_V8HFmode:
          if (pattern206 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 92;

        case E_V16HFmode:
          if (pattern206 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 93;

        case E_V32HFmode:
          if (pattern206 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 94;

        case E_V64HFmode:
          if (pattern206 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 95;

        case E_V128HFmode:
          if (pattern206 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 96;

        case E_V256HFmode:
          if (pattern206 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 97;

        case E_V512HFmode:
          if (pattern206 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 98;

        case E_V1024HFmode:
          if (pattern206 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 99;

        case E_V2048HFmode:
          if (pattern206 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 100;

        case E_V1SFmode:
          if (pattern206 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 101;

        case E_V2SFmode:
          if (pattern206 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 102;

        case E_V4SFmode:
          if (pattern206 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 103;

        case E_V8SFmode:
          if (pattern206 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 104;

        case E_V16SFmode:
          if (pattern206 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 105;

        case E_V32SFmode:
          if (pattern206 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 106;

        case E_V64SFmode:
          if (pattern206 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 107;

        case E_V128SFmode:
          if (pattern206 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 108;

        case E_V256SFmode:
          if (pattern206 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 109;

        case E_V512SFmode:
          if (pattern206 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 110;

        case E_V1024SFmode:
          if (pattern206 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 111;

        case E_V1DFmode:
          if (pattern206 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 112;

        case E_V2DFmode:
          if (pattern206 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 113;

        case E_V4DFmode:
          if (pattern206 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 114;

        case E_V8DFmode:
          if (pattern206 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 115;

        case E_V16DFmode:
          if (pattern206 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 116;

        case E_V32DFmode:
          if (pattern206 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 117;

        case E_V64DFmode:
          if (pattern206 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 118;

        case E_V128DFmode:
          if (pattern206 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 119;

        case E_V256DFmode:
          if (pattern206 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 120;

        case E_V512DFmode:
          if (pattern206 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 121;

        default:
          return -1;
        }

    case ABS:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern207 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 122;

        case E_RVVM4HFmode:
          if (pattern207 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 123;

        case E_RVVM2HFmode:
          if (pattern207 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 124;

        case E_RVVM1HFmode:
          if (pattern207 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 125;

        case E_RVVMF2HFmode:
          if (pattern207 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 126;

        case E_RVVMF4HFmode:
          if (pattern207 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 127;

        case E_RVVM8SFmode:
          if (pattern207 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 128;

        case E_RVVM4SFmode:
          if (pattern207 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 129;

        case E_RVVM2SFmode:
          if (pattern207 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 130;

        case E_RVVM1SFmode:
          if (pattern207 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 131;

        case E_RVVMF2SFmode:
          if (pattern207 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 132;

        case E_RVVM8DFmode:
          if (pattern207 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 133;

        case E_RVVM4DFmode:
          if (pattern207 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 134;

        case E_RVVM2DFmode:
          if (pattern207 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 135;

        case E_RVVM1DFmode:
          if (pattern207 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 136;

        case E_V1HFmode:
          if (pattern207 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 137;

        case E_V2HFmode:
          if (pattern207 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 138;

        case E_V4HFmode:
          if (pattern207 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 139;

        case E_V8HFmode:
          if (pattern207 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 140;

        case E_V16HFmode:
          if (pattern207 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 141;

        case E_V32HFmode:
          if (pattern207 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 142;

        case E_V64HFmode:
          if (pattern207 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 143;

        case E_V128HFmode:
          if (pattern207 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 144;

        case E_V256HFmode:
          if (pattern207 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 145;

        case E_V512HFmode:
          if (pattern207 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 146;

        case E_V1024HFmode:
          if (pattern207 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 147;

        case E_V2048HFmode:
          if (pattern207 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 148;

        case E_V1SFmode:
          if (pattern207 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 149;

        case E_V2SFmode:
          if (pattern207 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 150;

        case E_V4SFmode:
          if (pattern207 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 151;

        case E_V8SFmode:
          if (pattern207 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 152;

        case E_V16SFmode:
          if (pattern207 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 153;

        case E_V32SFmode:
          if (pattern207 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 154;

        case E_V64SFmode:
          if (pattern207 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 155;

        case E_V128SFmode:
          if (pattern207 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 156;

        case E_V256SFmode:
          if (pattern207 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 157;

        case E_V512SFmode:
          if (pattern207 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 158;

        case E_V1024SFmode:
          if (pattern207 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 159;

        case E_V1DFmode:
          if (pattern207 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 160;

        case E_V2DFmode:
          if (pattern207 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 161;

        case E_V4DFmode:
          if (pattern207 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 162;

        case E_V8DFmode:
          if (pattern207 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 163;

        case E_V16DFmode:
          if (pattern207 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 164;

        case E_V32DFmode:
          if (pattern207 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 165;

        case E_V64DFmode:
          if (pattern207 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 166;

        case E_V128DFmode:
          if (pattern207 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 167;

        case E_V256DFmode:
          if (pattern207 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 168;

        case E_V512DFmode:
          if (pattern207 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 169;

        default:
          return -1;
        }

    case SQRT:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern208 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 170;

        case E_RVVM4HFmode:
          if (pattern208 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 171;

        case E_RVVM2HFmode:
          if (pattern208 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 172;

        case E_RVVM1HFmode:
          if (pattern208 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 173;

        case E_RVVMF2HFmode:
          if (pattern208 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 174;

        case E_RVVMF4HFmode:
          if (pattern208 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 175;

        case E_RVVM8SFmode:
          if (pattern208 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 176;

        case E_RVVM4SFmode:
          if (pattern208 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 177;

        case E_RVVM2SFmode:
          if (pattern208 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 178;

        case E_RVVM1SFmode:
          if (pattern208 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 179;

        case E_RVVMF2SFmode:
          if (pattern208 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 180;

        case E_RVVM8DFmode:
          if (pattern208 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 181;

        case E_RVVM4DFmode:
          if (pattern208 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 182;

        case E_RVVM2DFmode:
          if (pattern208 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 183;

        case E_RVVM1DFmode:
          if (pattern208 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 184;

        case E_V1HFmode:
          if (pattern208 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 185;

        case E_V2HFmode:
          if (pattern208 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 186;

        case E_V4HFmode:
          if (pattern208 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 187;

        case E_V8HFmode:
          if (pattern208 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 188;

        case E_V16HFmode:
          if (pattern208 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 189;

        case E_V32HFmode:
          if (pattern208 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 190;

        case E_V64HFmode:
          if (pattern208 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 191;

        case E_V128HFmode:
          if (pattern208 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 192;

        case E_V256HFmode:
          if (pattern208 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 193;

        case E_V512HFmode:
          if (pattern208 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 194;

        case E_V1024HFmode:
          if (pattern208 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 195;

        case E_V2048HFmode:
          if (pattern208 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 196;

        case E_V1SFmode:
          if (pattern208 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 197;

        case E_V2SFmode:
          if (pattern208 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 198;

        case E_V4SFmode:
          if (pattern208 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 199;

        case E_V8SFmode:
          if (pattern208 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 200;

        case E_V16SFmode:
          if (pattern208 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 201;

        case E_V32SFmode:
          if (pattern208 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 202;

        case E_V64SFmode:
          if (pattern208 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 203;

        case E_V128SFmode:
          if (pattern208 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 204;

        case E_V256SFmode:
          if (pattern208 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 205;

        case E_V512SFmode:
          if (pattern208 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 206;

        case E_V1024SFmode:
          if (pattern208 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 207;

        case E_V1DFmode:
          if (pattern208 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 208;

        case E_V2DFmode:
          if (pattern208 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 209;

        case E_V4DFmode:
          if (pattern208 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 210;

        case E_V8DFmode:
          if (pattern208 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 211;

        case E_V16DFmode:
          if (pattern208 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 212;

        case E_V32DFmode:
          if (pattern208 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 213;

        case E_V64DFmode:
          if (pattern208 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 214;

        case E_V128DFmode:
          if (pattern208 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 215;

        case E_V256DFmode:
          if (pattern208 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 216;

        case E_V512DFmode:
          if (pattern208 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 217;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      res = pattern210 (x1);
      if (res >= 0)
        return res + 218; /* [218, 309] */
      return -1;

    case ZERO_EXTEND:
      res = pattern210 (x1);
      if (res >= 0)
        return res + 310; /* [310, 401] */
      return -1;

    case TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          x4 = XEXP (x1, 2);
          operands[3] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM4QImode:
              if (pattern209 (x1, 
E_RVVM4QImode, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
                return -1;
              return 402;

            case E_RVVM2QImode:
              if (pattern209 (x1, 
E_RVVM2QImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
                return -1;
              return 403;

            case E_RVVM1QImode:
              if (pattern209 (x1, 
E_RVVM1QImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 404;

            case E_RVVMF2QImode:
              if (pattern209 (x1, 
E_RVVMF2QImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 405;

            case E_RVVMF4QImode:
              if (pattern209 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 406;

            case E_RVVMF8QImode:
              if (pattern209 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 407;

            case E_RVVM4HImode:
              if (pattern209 (x1, 
E_RVVM4HImode, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
                return -1;
              return 408;

            case E_RVVM2HImode:
              if (pattern209 (x1, 
E_RVVM2HImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 409;

            case E_RVVM1HImode:
              if (pattern209 (x1, 
E_RVVM1HImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 410;

            case E_RVVMF2HImode:
              if (pattern209 (x1, 
E_RVVMF2HImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 411;

            case E_RVVMF4HImode:
              if (pattern209 (x1, 
E_RVVMF4HImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 412;

            case E_RVVM4SImode:
              if (pattern209 (x1, 
E_RVVM4SImode, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 413;

            case E_RVVM2SImode:
              if (pattern209 (x1, 
E_RVVM2SImode, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 414;

            case E_RVVM1SImode:
              if (pattern209 (x1, 
E_RVVM1SImode, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 415;

            case E_RVVMF2SImode:
              if (pattern209 (x1, 
E_RVVMF2SImode, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 416;

            case E_V1QImode:
              if (pattern209 (x1, 
E_V1QImode, 
E_V1HImode, 
E_V1BImode) != 0)
                return -1;
              return 417;

            case E_V2QImode:
              if (pattern209 (x1, 
E_V2QImode, 
E_V2HImode, 
E_V2BImode) != 0)
                return -1;
              return 418;

            case E_V4QImode:
              if (pattern209 (x1, 
E_V4QImode, 
E_V4HImode, 
E_V4BImode) != 0)
                return -1;
              return 419;

            case E_V8QImode:
              if (pattern209 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V8BImode) != 0)
                return -1;
              return 420;

            case E_V16QImode:
              if (pattern209 (x1, 
E_V16QImode, 
E_V16HImode, 
E_V16BImode) != 0)
                return -1;
              return 421;

            case E_V32QImode:
              if (pattern209 (x1, 
E_V32QImode, 
E_V32HImode, 
E_V32BImode) != 0)
                return -1;
              return 422;

            case E_V64QImode:
              if (pattern209 (x1, 
E_V64QImode, 
E_V64HImode, 
E_V64BImode) != 0)
                return -1;
              return 423;

            case E_V128QImode:
              if (pattern209 (x1, 
E_V128QImode, 
E_V128HImode, 
E_V128BImode) != 0)
                return -1;
              return 424;

            case E_V256QImode:
              if (pattern209 (x1, 
E_V256QImode, 
E_V256HImode, 
E_V256BImode) != 0)
                return -1;
              return 425;

            case E_V512QImode:
              if (pattern209 (x1, 
E_V512QImode, 
E_V512HImode, 
E_V512BImode) != 0)
                return -1;
              return 426;

            case E_V1024QImode:
              if (pattern209 (x1, 
E_V1024QImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
                return -1;
              return 427;

            case E_V2048QImode:
              if (pattern209 (x1, 
E_V2048QImode, 
E_V2048HImode, 
E_V2048BImode) != 0)
                return -1;
              return 428;

            case E_V1HImode:
              if (pattern209 (x1, 
E_V1HImode, 
E_V1SImode, 
E_V1BImode) != 0)
                return -1;
              return 429;

            case E_V2HImode:
              if (pattern209 (x1, 
E_V2HImode, 
E_V2SImode, 
E_V2BImode) != 0)
                return -1;
              return 430;

            case E_V4HImode:
              if (pattern209 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V4BImode) != 0)
                return -1;
              return 431;

            case E_V8HImode:
              if (pattern209 (x1, 
E_V8HImode, 
E_V8SImode, 
E_V8BImode) != 0)
                return -1;
              return 432;

            case E_V16HImode:
              if (pattern209 (x1, 
E_V16HImode, 
E_V16SImode, 
E_V16BImode) != 0)
                return -1;
              return 433;

            case E_V32HImode:
              if (pattern209 (x1, 
E_V32HImode, 
E_V32SImode, 
E_V32BImode) != 0)
                return -1;
              return 434;

            case E_V64HImode:
              if (pattern209 (x1, 
E_V64HImode, 
E_V64SImode, 
E_V64BImode) != 0)
                return -1;
              return 435;

            case E_V128HImode:
              if (pattern209 (x1, 
E_V128HImode, 
E_V128SImode, 
E_V128BImode) != 0)
                return -1;
              return 436;

            case E_V256HImode:
              if (pattern209 (x1, 
E_V256HImode, 
E_V256SImode, 
E_V256BImode) != 0)
                return -1;
              return 437;

            case E_V512HImode:
              if (pattern209 (x1, 
E_V512HImode, 
E_V512SImode, 
E_V512BImode) != 0)
                return -1;
              return 438;

            case E_V1024HImode:
              if (pattern209 (x1, 
E_V1024HImode, 
E_V1024SImode, 
E_V1024BImode) != 0)
                return -1;
              return 439;

            case E_V1SImode:
              if (pattern209 (x1, 
E_V1SImode, 
E_V1DImode, 
E_V1BImode) != 0)
                return -1;
              return 440;

            case E_V2SImode:
              if (pattern209 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V2BImode) != 0)
                return -1;
              return 441;

            case E_V4SImode:
              if (pattern209 (x1, 
E_V4SImode, 
E_V4DImode, 
E_V4BImode) != 0)
                return -1;
              return 442;

            case E_V8SImode:
              if (pattern209 (x1, 
E_V8SImode, 
E_V8DImode, 
E_V8BImode) != 0)
                return -1;
              return 443;

            case E_V16SImode:
              if (pattern209 (x1, 
E_V16SImode, 
E_V16DImode, 
E_V16BImode) != 0)
                return -1;
              return 444;

            case E_V32SImode:
              if (pattern209 (x1, 
E_V32SImode, 
E_V32DImode, 
E_V32BImode) != 0)
                return -1;
              return 445;

            case E_V64SImode:
              if (pattern209 (x1, 
E_V64SImode, 
E_V64DImode, 
E_V64BImode) != 0)
                return -1;
              return 446;

            case E_V128SImode:
              if (pattern209 (x1, 
E_V128SImode, 
E_V128DImode, 
E_V128BImode) != 0)
                return -1;
              return 447;

            case E_V256SImode:
              if (pattern209 (x1, 
E_V256SImode, 
E_V256DImode, 
E_V256BImode) != 0)
                return -1;
              return 448;

            case E_V512SImode:
              if (pattern209 (x1, 
E_V512SImode, 
E_V512DImode, 
E_V512BImode) != 0)
                return -1;
              return 449;

            default:
              return -1;
            }

        case ASHIFTRT:
          res = pattern214 (x1);
          if (res >= 0)
            return res + 450; /* [450, 593] */
          return -1;

        case LSHIFTRT:
          res = pattern214 (x1);
          if (res >= 0)
            return res + 594; /* [594, 737] */
          return -1;

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SFmode:
          if (pattern209 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 738;

        case E_RVVM4SFmode:
          if (pattern209 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 739;

        case E_RVVM2SFmode:
          if (pattern209 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 740;

        case E_RVVM1SFmode:
          if (pattern209 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 741;

        case E_RVVMF2SFmode:
          if (pattern209 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 742;

        case E_RVVM8DFmode:
          if (pattern209 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 743;

        case E_RVVM4DFmode:
          if (pattern209 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 744;

        case E_RVVM2DFmode:
          if (pattern209 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 745;

        case E_RVVM1DFmode:
          if (pattern209 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 746;

        case E_V1SFmode:
          if (pattern209 (x1, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 747;

        case E_V2SFmode:
          if (pattern209 (x1, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 748;

        case E_V4SFmode:
          if (pattern209 (x1, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 749;

        case E_V8SFmode:
          if (pattern209 (x1, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 750;

        case E_V16SFmode:
          if (pattern209 (x1, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 751;

        case E_V32SFmode:
          if (pattern209 (x1, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 752;

        case E_V64SFmode:
          if (pattern209 (x1, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 753;

        case E_V128SFmode:
          if (pattern209 (x1, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 754;

        case E_V256SFmode:
          if (pattern209 (x1, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 755;

        case E_V512SFmode:
          if (pattern209 (x1, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 756;

        case E_V1024SFmode:
          if (pattern209 (x1, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 757;

        case E_V1DFmode:
          if (pattern209 (x1, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 758;

        case E_V2DFmode:
          if (pattern209 (x1, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 759;

        case E_V4DFmode:
          if (pattern209 (x1, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 760;

        case E_V8DFmode:
          if (pattern209 (x1, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 761;

        case E_V16DFmode:
          if (pattern209 (x1, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 762;

        case E_V32DFmode:
          if (pattern209 (x1, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 763;

        case E_V64DFmode:
          if (pattern209 (x1, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 764;

        case E_V128DFmode:
          if (pattern209 (x1, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 765;

        case E_V256DFmode:
          if (pattern209 (x1, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 766;

        case E_V512DFmode:
          if (pattern209 (x1, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 767;

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4HFmode:
          if (pattern209 (x1, 
E_RVVM4HFmode, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 768;

        case E_RVVM2HFmode:
          if (pattern209 (x1, 
E_RVVM2HFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 769;

        case E_RVVM1HFmode:
          if (pattern209 (x1, 
E_RVVM1HFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 770;

        case E_RVVMF2HFmode:
          if (pattern209 (x1, 
E_RVVMF2HFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 771;

        case E_RVVMF4HFmode:
          if (pattern209 (x1, 
E_RVVMF4HFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 772;

        case E_RVVM4SFmode:
          if (pattern209 (x1, 
E_RVVM4SFmode, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 773;

        case E_RVVM2SFmode:
          if (pattern209 (x1, 
E_RVVM2SFmode, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 774;

        case E_RVVM1SFmode:
          if (pattern209 (x1, 
E_RVVM1SFmode, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 775;

        case E_RVVMF2SFmode:
          if (pattern209 (x1, 
E_RVVMF2SFmode, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 776;

        case E_V1HFmode:
          if (pattern209 (x1, 
E_V1HFmode, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 777;

        case E_V2HFmode:
          if (pattern209 (x1, 
E_V2HFmode, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 778;

        case E_V4HFmode:
          if (pattern209 (x1, 
E_V4HFmode, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 779;

        case E_V8HFmode:
          if (pattern209 (x1, 
E_V8HFmode, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 780;

        case E_V16HFmode:
          if (pattern209 (x1, 
E_V16HFmode, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 781;

        case E_V32HFmode:
          if (pattern209 (x1, 
E_V32HFmode, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 782;

        case E_V64HFmode:
          if (pattern209 (x1, 
E_V64HFmode, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 783;

        case E_V128HFmode:
          if (pattern209 (x1, 
E_V128HFmode, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 784;

        case E_V256HFmode:
          if (pattern209 (x1, 
E_V256HFmode, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 785;

        case E_V512HFmode:
          if (pattern209 (x1, 
E_V512HFmode, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 786;

        case E_V1024HFmode:
          if (pattern209 (x1, 
E_V1024HFmode, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 787;

        case E_V1SFmode:
          if (pattern209 (x1, 
E_V1SFmode, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 788;

        case E_V2SFmode:
          if (pattern209 (x1, 
E_V2SFmode, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 789;

        case E_V4SFmode:
          if (pattern209 (x1, 
E_V4SFmode, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 790;

        case E_V8SFmode:
          if (pattern209 (x1, 
E_V8SFmode, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 791;

        case E_V16SFmode:
          if (pattern209 (x1, 
E_V16SFmode, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 792;

        case E_V32SFmode:
          if (pattern209 (x1, 
E_V32SFmode, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 793;

        case E_V64SFmode:
          if (pattern209 (x1, 
E_V64SFmode, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 794;

        case E_V128SFmode:
          if (pattern209 (x1, 
E_V128SFmode, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 795;

        case E_V256SFmode:
          if (pattern209 (x1, 
E_V256SFmode, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 796;

        case E_V512SFmode:
          if (pattern209 (x1, 
E_V512SFmode, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 797;

        default:
          return -1;
        }

    case FIX:
      res = pattern215 (x1);
      if (res >= 0)
        return res + 798; /* [798, 923] */
      return -1;

    case UNSIGNED_FIX:
      res = pattern215 (x1);
      if (res >= 0)
        return res + 924; /* [924, 1049] */
      return -1;

    case FLOAT:
      res = pattern216 (x1);
      if (res >= 0)
        return res + 1050; /* [1050, 1175] */
      return -1;

    case UNSIGNED_FLOAT:
      res = pattern216 (x1);
      if (res >= 0)
        return res + 1176; /* [1176, 1301] */
      return -1;

    case SMUL_HIGHPART:
      res = pattern218 (x1);
      if (res >= 0)
        return res + 1302; /* [1302, 1369] */
      return -1;

    case UMUL_HIGHPART:
      res = pattern218 (x1);
      if (res >= 0)
        return res + 1370; /* [1370, 1437] */
      return -1;

    default:
      return -1;
    }
}

int
pattern433 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern439 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != ASHIFT
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x4, 0);
  return pattern341 (x6); /* [-1, 3] */
}

int
pattern446 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8SImode:
      if (!register_operand (operands[1], E_RVVM8SImode))
        return -1;
      return 0;

    case E_RVVM4SImode:
      if (!register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 1;

    case E_RVVM2SImode:
      if (!register_operand (operands[1], E_RVVM2SImode))
        return -1;
      return 2;

    case E_RVVM1SImode:
      if (!register_operand (operands[1], E_RVVM1SImode))
        return -1;
      return 3;

    case E_RVVMF2SImode:
      if (!register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 4;

    case E_V1SImode:
      if (!register_operand (operands[1], E_V1SImode))
        return -1;
      return 5;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 6;

    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 7;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 8;

    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      return 9;

    case E_V32SImode:
      if (!register_operand (operands[1], E_V32SImode))
        return -1;
      return 10;

    case E_V64SImode:
      if (!register_operand (operands[1], E_V64SImode))
        return -1;
      return 11;

    case E_V128SImode:
      if (!register_operand (operands[1], E_V128SImode))
        return -1;
      return 12;

    case E_V256SImode:
      if (!register_operand (operands[1], E_V256SImode))
        return -1;
      return 13;

    case E_V512SImode:
      if (!register_operand (operands[1], E_V512SImode))
        return -1;
      return 14;

    case E_V1024SImode:
      if (!register_operand (operands[1], E_V1024SImode))
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern456 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!autovec_length_operand (operands[4], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x3, 0, 4);
  operands[5] = x8;
  if (!const_0_operand (operands[5], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x2, 0, 1);
  operands[6] = x9;
  if (!autovec_length_operand (operands[6], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern455 (x1, 
E_SImode); /* [-1, 19] */

    case E_DImode:
      res = pattern455 (x1, 
E_DImode);
      if (res >= 0)
        return res + 20; /* [20, 39] */
      return -1;

    default:
      return -1;
    }
}

int
pattern466 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  if (!branch_on_bit_operand (operands[3], E_VOIDmode))
    return -1;
  return pattern464 (x1); /* [-1, 1] */
}

int
pattern470 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i3)
      || !vector_merge_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern474 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[5] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[6] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[7] = x6;
  x7 = XEXP (x1, 1);
  operands[3] = x7;
  x8 = XEXP (x1, 2);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern473 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern473 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern473 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern473 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern473 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern473 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern473 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern473 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern473 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern473 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern473 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern473 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern473 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern473 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern473 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern473 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern473 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern473 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern473 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern473 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern473 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern473 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 21;

    case E_RVVM8BFmode:
      if (pattern473 (x1, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 22;

    case E_RVVM4BFmode:
      if (pattern473 (x1, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 23;

    case E_RVVM2BFmode:
      if (pattern473 (x1, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 24;

    case E_RVVM1BFmode:
      if (pattern473 (x1, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 25;

    case E_RVVMF2BFmode:
      if (pattern473 (x1, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 26;

    case E_RVVMF4BFmode:
      if (pattern473 (x1, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 27;

    case E_RVVM8HFmode:
      if (pattern473 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 28;

    case E_RVVM4HFmode:
      if (pattern473 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 29;

    case E_RVVM2HFmode:
      if (pattern473 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 30;

    case E_RVVM1HFmode:
      if (pattern473 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 31;

    case E_RVVMF2HFmode:
      if (pattern473 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 32;

    case E_RVVMF4HFmode:
      if (pattern473 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 33;

    case E_RVVM8SFmode:
      if (pattern473 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 34;

    case E_RVVM4SFmode:
      if (pattern473 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 35;

    case E_RVVM2SFmode:
      if (pattern473 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 36;

    case E_RVVM1SFmode:
      if (pattern473 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 37;

    case E_RVVMF2SFmode:
      if (pattern473 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 38;

    case E_RVVM8DFmode:
      if (pattern473 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 39;

    case E_RVVM4DFmode:
      if (pattern473 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 40;

    case E_RVVM2DFmode:
      if (pattern473 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 41;

    case E_RVVM1DFmode:
      if (pattern473 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 42;

    case E_V1QImode:
      if (pattern473 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 43;

    case E_V2QImode:
      if (pattern473 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 44;

    case E_V4QImode:
      if (pattern473 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 45;

    case E_V8QImode:
      if (pattern473 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 46;

    case E_V16QImode:
      if (pattern473 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 47;

    case E_V32QImode:
      if (pattern473 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 48;

    case E_V64QImode:
      if (pattern473 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 49;

    case E_V128QImode:
      if (pattern473 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 50;

    case E_V256QImode:
      if (pattern473 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 51;

    case E_V512QImode:
      if (pattern473 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 52;

    case E_V1024QImode:
      if (pattern473 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 53;

    case E_V2048QImode:
      if (pattern473 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 54;

    case E_V4096QImode:
      if (pattern473 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
        return -1;
      return 55;

    case E_V1HImode:
      if (pattern473 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 56;

    case E_V2HImode:
      if (pattern473 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 57;

    case E_V4HImode:
      if (pattern473 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 58;

    case E_V8HImode:
      if (pattern473 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 59;

    case E_V16HImode:
      if (pattern473 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 60;

    case E_V32HImode:
      if (pattern473 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 61;

    case E_V64HImode:
      if (pattern473 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 62;

    case E_V128HImode:
      if (pattern473 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 63;

    case E_V256HImode:
      if (pattern473 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 64;

    case E_V512HImode:
      if (pattern473 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 65;

    case E_V1024HImode:
      if (pattern473 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 66;

    case E_V2048HImode:
      if (pattern473 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 67;

    case E_V1SImode:
      if (pattern473 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 68;

    case E_V2SImode:
      if (pattern473 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 69;

    case E_V4SImode:
      if (pattern473 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 70;

    case E_V8SImode:
      if (pattern473 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 71;

    case E_V16SImode:
      if (pattern473 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 72;

    case E_V32SImode:
      if (pattern473 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 73;

    case E_V64SImode:
      if (pattern473 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 74;

    case E_V128SImode:
      if (pattern473 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 75;

    case E_V256SImode:
      if (pattern473 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 76;

    case E_V512SImode:
      if (pattern473 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 77;

    case E_V1024SImode:
      if (pattern473 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 78;

    case E_V1DImode:
      if (pattern473 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 79;

    case E_V2DImode:
      if (pattern473 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 80;

    case E_V4DImode:
      if (pattern473 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 81;

    case E_V8DImode:
      if (pattern473 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 82;

    case E_V16DImode:
      if (pattern473 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 83;

    case E_V32DImode:
      if (pattern473 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 84;

    case E_V64DImode:
      if (pattern473 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 85;

    case E_V128DImode:
      if (pattern473 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 86;

    case E_V256DImode:
      if (pattern473 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 87;

    case E_V512DImode:
      if (pattern473 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 88;

    case E_V1HFmode:
      if (pattern473 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 89;

    case E_V2HFmode:
      if (pattern473 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 90;

    case E_V4HFmode:
      if (pattern473 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 91;

    case E_V8HFmode:
      if (pattern473 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 92;

    case E_V16HFmode:
      if (pattern473 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 93;

    case E_V32HFmode:
      if (pattern473 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 94;

    case E_V64HFmode:
      if (pattern473 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 95;

    case E_V128HFmode:
      if (pattern473 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 96;

    case E_V256HFmode:
      if (pattern473 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 97;

    case E_V512HFmode:
      if (pattern473 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 98;

    case E_V1024HFmode:
      if (pattern473 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 99;

    case E_V2048HFmode:
      if (pattern473 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 100;

    case E_V1SFmode:
      if (pattern473 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
        return -1;
      return 101;

    case E_V2SFmode:
      if (pattern473 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
        return -1;
      return 102;

    case E_V4SFmode:
      if (pattern473 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
        return -1;
      return 103;

    case E_V8SFmode:
      if (pattern473 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
        return -1;
      return 104;

    case E_V16SFmode:
      if (pattern473 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
        return -1;
      return 105;

    case E_V32SFmode:
      if (pattern473 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
        return -1;
      return 106;

    case E_V64SFmode:
      if (pattern473 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
        return -1;
      return 107;

    case E_V128SFmode:
      if (pattern473 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
        return -1;
      return 108;

    case E_V256SFmode:
      if (pattern473 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
        return -1;
      return 109;

    case E_V512SFmode:
      if (pattern473 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
        return -1;
      return 110;

    case E_V1024SFmode:
      if (pattern473 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
        return -1;
      return 111;

    case E_V1DFmode:
      if (pattern473 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
        return -1;
      return 112;

    case E_V2DFmode:
      if (pattern473 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
        return -1;
      return 113;

    case E_V4DFmode:
      if (pattern473 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
        return -1;
      return 114;

    case E_V8DFmode:
      if (pattern473 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
        return -1;
      return 115;

    case E_V16DFmode:
      if (pattern473 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
        return -1;
      return 116;

    case E_V32DFmode:
      if (pattern473 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
        return -1;
      return 117;

    case E_V64DFmode:
      if (pattern473 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
        return -1;
      return 118;

    case E_V128DFmode:
      if (pattern473 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
        return -1;
      return 119;

    case E_V256DFmode:
      if (pattern473 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
        return -1;
      return 120;

    case E_V512DFmode:
      if (pattern473 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
        return -1;
      return 121;

    default:
      return -1;
    }
}

int
pattern509 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ZERO_EXTEND
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!immediate_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern511 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM4QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM4QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVM4QImode))
        return -1;
      return 0;

    case E_RVVM8HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern513 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM1QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVM1QImode))
        return -1;
      return 0;

    case E_RVVM2HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM2HImode))
        return -1;
      return 1;

    case E_RVVM4SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM4SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM8DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern516 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVMF8QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF8QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 0;

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 1;

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF2SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 2;

    case E_RVVM1DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM1DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM1DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern519 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V4QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      return 0;

    case E_V4HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    case E_V4SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern522 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V32QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V32QImode))
        return -1;
      return 0;

    case E_V32HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V32HImode))
        return -1;
      return 1;

    case E_V32SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V32SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern525 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V256QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V256QImode))
        return -1;
      return 0;

    case E_V256HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V256HImode))
        return -1;
      return 1;

    case E_V256SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V256SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern528 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V2048QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2048QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V2048QImode))
        return -1;
      return 0;

    case E_V2048HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2048HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V2048HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern532 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !reg_or_0_operand (operands[4], i3)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern534 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          return pattern531 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode); /* [-1, 0] */

        case E_RVVM4HImode:
          if (pattern531 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2HImode:
          if (pattern531 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1HImode:
          if (pattern531 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 3;

        case E_RVVMF2HImode:
          if (pattern531 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 4;

        case E_RVVMF4HImode:
          if (pattern531 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 5;

        case E_RVVM8SImode:
          if (pattern531 (x1, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 6;

        case E_RVVM4SImode:
          if (pattern531 (x1, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 7;

        case E_RVVM2SImode:
          if (pattern531 (x1, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 8;

        case E_RVVM1SImode:
          if (pattern531 (x1, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 9;

        case E_RVVMF2SImode:
          if (pattern531 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 10;

        case E_RVVM8DImode:
          if (pattern531 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 11;

        case E_RVVM4DImode:
          if (pattern531 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 12;

        case E_RVVM2DImode:
          if (pattern531 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 13;

        case E_RVVM1DImode:
          if (pattern531 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 14;

        case E_V1HImode:
          if (pattern531 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode) != 0)
            return -1;
          return 15;

        case E_V2HImode:
          if (pattern531 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode) != 0)
            return -1;
          return 16;

        case E_V4HImode:
          if (pattern531 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode) != 0)
            return -1;
          return 17;

        case E_V8HImode:
          if (pattern531 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode) != 0)
            return -1;
          return 18;

        case E_V16HImode:
          if (pattern531 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          return 19;

        case E_V32HImode:
          if (pattern531 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode) != 0)
            return -1;
          return 20;

        case E_V64HImode:
          if (pattern531 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode) != 0)
            return -1;
          return 21;

        case E_V128HImode:
          if (pattern531 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode) != 0)
            return -1;
          return 22;

        case E_V256HImode:
          if (pattern531 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode) != 0)
            return -1;
          return 23;

        case E_V512HImode:
          if (pattern531 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode) != 0)
            return -1;
          return 24;

        case E_V1024HImode:
          if (pattern531 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode) != 0)
            return -1;
          return 25;

        case E_V2048HImode:
          if (pattern531 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode) != 0)
            return -1;
          return 26;

        case E_V1SImode:
          if (pattern531 (x1, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode) != 0)
            return -1;
          return 27;

        case E_V2SImode:
          if (pattern531 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode) != 0)
            return -1;
          return 28;

        case E_V4SImode:
          if (pattern531 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode) != 0)
            return -1;
          return 29;

        case E_V8SImode:
          if (pattern531 (x1, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 30;

        case E_V16SImode:
          if (pattern531 (x1, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode) != 0)
            return -1;
          return 31;

        case E_V32SImode:
          if (pattern531 (x1, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode) != 0)
            return -1;
          return 32;

        case E_V64SImode:
          if (pattern531 (x1, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode) != 0)
            return -1;
          return 33;

        case E_V128SImode:
          if (pattern531 (x1, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode) != 0)
            return -1;
          return 34;

        case E_V256SImode:
          if (pattern531 (x1, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode) != 0)
            return -1;
          return 35;

        case E_V512SImode:
          if (pattern531 (x1, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode) != 0)
            return -1;
          return 36;

        case E_V1024SImode:
          if (pattern531 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
            return -1;
          return 37;

        case E_V1DImode:
          if (pattern531 (x1, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode) != 0)
            return -1;
          return 38;

        case E_V2DImode:
          if (pattern531 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V2BImode) != 0)
            return -1;
          return 39;

        case E_V4DImode:
          if (pattern531 (x1, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 40;

        case E_V8DImode:
          if (pattern531 (x1, 
E_V8DImode, 
E_V8SImode, 
E_V8BImode) != 0)
            return -1;
          return 41;

        case E_V16DImode:
          if (pattern531 (x1, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode) != 0)
            return -1;
          return 42;

        case E_V32DImode:
          if (pattern531 (x1, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode) != 0)
            return -1;
          return 43;

        case E_V64DImode:
          if (pattern531 (x1, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode) != 0)
            return -1;
          return 44;

        case E_V128DImode:
          if (pattern531 (x1, 
E_V128DImode, 
E_V128SImode, 
E_V128BImode) != 0)
            return -1;
          return 45;

        case E_V256DImode:
          if (pattern531 (x1, 
E_V256DImode, 
E_V256SImode, 
E_V256BImode) != 0)
            return -1;
          return 46;

        case E_V512DImode:
          if (pattern531 (x1, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x4, 0);
      operands[4] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          if (pattern533 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0)
            return -1;
          return 48;

        case E_RVVM4HImode:
          if (pattern533 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0)
            return -1;
          return 49;

        case E_RVVM2HImode:
          if (pattern533 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0)
            return -1;
          return 50;

        case E_RVVM1HImode:
          if (pattern533 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0)
            return -1;
          return 51;

        case E_RVVMF2HImode:
          if (pattern533 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0)
            return -1;
          return 52;

        case E_RVVMF4HImode:
          if (pattern533 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0)
            return -1;
          return 53;

        case E_RVVM8SImode:
          if (pattern533 (x1, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0)
            return -1;
          return 54;

        case E_RVVM4SImode:
          if (pattern533 (x1, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0)
            return -1;
          return 55;

        case E_RVVM2SImode:
          if (pattern533 (x1, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0)
            return -1;
          return 56;

        case E_RVVM1SImode:
          if (pattern533 (x1, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0)
            return -1;
          return 57;

        case E_RVVMF2SImode:
          if (pattern533 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0)
            return -1;
          return 58;

        case E_RVVM8DImode:
          if (pattern533 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0)
            return -1;
          return 59;

        case E_RVVM4DImode:
          if (pattern533 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0)
            return -1;
          return 60;

        case E_RVVM2DImode:
          if (pattern533 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0)
            return -1;
          return 61;

        case E_RVVM1DImode:
          if (pattern533 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0)
            return -1;
          return 62;

        case E_V1HImode:
          if (pattern533 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0)
            return -1;
          return 63;

        case E_V2HImode:
          if (pattern533 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0)
            return -1;
          return 64;

        case E_V4HImode:
          if (pattern533 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0)
            return -1;
          return 65;

        case E_V8HImode:
          if (pattern533 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0)
            return -1;
          return 66;

        case E_V16HImode:
          if (pattern533 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0)
            return -1;
          return 67;

        case E_V32HImode:
          if (pattern533 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0)
            return -1;
          return 68;

        case E_V64HImode:
          if (pattern533 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0)
            return -1;
          return 69;

        case E_V128HImode:
          if (pattern533 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0)
            return -1;
          return 70;

        case E_V256HImode:
          if (pattern533 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0)
            return -1;
          return 71;

        case E_V512HImode:
          if (pattern533 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0)
            return -1;
          return 72;

        case E_V1024HImode:
          if (pattern533 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0)
            return -1;
          return 73;

        case E_V2048HImode:
          if (pattern533 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0)
            return -1;
          return 74;

        case E_V1SImode:
          if (pattern533 (x1, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0)
            return -1;
          return 75;

        case E_V2SImode:
          if (pattern533 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0)
            return -1;
          return 76;

        case E_V4SImode:
          if (pattern533 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0)
            return -1;
          return 77;

        case E_V8SImode:
          if (pattern533 (x1, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0)
            return -1;
          return 78;

        case E_V16SImode:
          if (pattern533 (x1, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0)
            return -1;
          return 79;

        case E_V32SImode:
          if (pattern533 (x1, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
            return -1;
          return 80;

        case E_V64SImode:
          if (pattern533 (x1, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
            return -1;
          return 81;

        case E_V128SImode:
          if (pattern533 (x1, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0)
            return -1;
          return 82;

        case E_V256SImode:
          if (pattern533 (x1, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0)
            return -1;
          return 83;

        case E_V512SImode:
          if (pattern533 (x1, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0)
            return -1;
          return 84;

        case E_V1024SImode:
          if (pattern533 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0)
            return -1;
          return 85;

        case E_V1DImode:
          if (pattern533 (x1, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0)
            return -1;
          return 86;

        case E_V2DImode:
          if (pattern533 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
            return -1;
          return 87;

        case E_V4DImode:
          if (pattern533 (x1, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
            return -1;
          return 88;

        case E_V8DImode:
          if (pattern533 (x1, 
E_V8DImode, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0)
            return -1;
          return 89;

        case E_V16DImode:
          if (pattern533 (x1, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0)
            return -1;
          return 90;

        case E_V32DImode:
          if (pattern533 (x1, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0)
            return -1;
          return 91;

        case E_V64DImode:
          if (pattern533 (x1, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
            return -1;
          return 92;

        case E_V128DImode:
          if (pattern533 (x1, 
E_V128DImode, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0)
            return -1;
          return 93;

        case E_V256DImode:
          if (pattern533 (x1, 
E_V256DImode, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0)
            return -1;
          return 94;

        case E_V512DImode:
          if (pattern533 (x1, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
            return -1;
          return 95;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern566 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  return pattern534 (x1); /* [-1, 95] */
}

int
pattern568 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i4
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern571 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (!comparison_except_ge_operator (x3, i1))
    return -1;
  return 0;
}

int
pattern573 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_all_trues_mask_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern575 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x1, 2);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern493 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern493 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern493 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern493 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern493 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern493 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern493 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern493 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern493 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern493 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern493 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern493 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern493 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern493 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern493 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern493 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern493 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern493 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern493 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern493 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern493 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern493 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern493 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern493 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern493 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern493 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern493 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern493 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern493 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern493 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern493 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern493 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern493 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern493 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern493 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern493 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern493 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern493 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern493 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern493 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern493 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern493 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern493 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern493 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern493 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern493 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern493 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern493 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern590 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[3], i2)
      || !register_operand (operands[2], i1)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern594 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  if (!register_operand (operands[4], i2))
    return -1;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  if (!vector_neg_arith_operand (operands[5], i2))
    return -1;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern599 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern603 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern606 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern608 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], i1))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!register_operand (operands[4], i1))
    return -1;
  x9 = XEXP (x1, 2);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  return 0;
}

int
pattern610 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF8BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF8BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM2HFmode:
      if (!register_operand (operands[4], E_RVVM2HFmode)
          || !register_operand (operands[5], E_RVVM2HFmode))
        return -1;
      return 0;

    case E_RVVM4SFmode:
      if (!register_operand (operands[4], E_RVVM4SFmode)
          || !register_operand (operands[5], E_RVVM4SFmode))
        return -1;
      return 1;

    case E_RVVM8DFmode:
      if (!register_operand (operands[4], E_RVVM8DFmode)
          || !register_operand (operands[5], E_RVVM8DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern612 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF32BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF32BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVMF2HFmode:
      if (!register_operand (operands[4], E_RVVMF2HFmode)
          || !register_operand (operands[5], E_RVVMF2HFmode))
        return -1;
      return 0;

    case E_RVVM1SFmode:
      if (!register_operand (operands[4], E_RVVM1SFmode)
          || !register_operand (operands[5], E_RVVM1SFmode))
        return -1;
      return 1;

    case E_RVVM2DFmode:
      if (!register_operand (operands[4], E_RVVM2DFmode)
          || !register_operand (operands[5], E_RVVM2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern615 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V2BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V2BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V2HFmode:
      if (!register_operand (operands[4], E_V2HFmode)
          || !register_operand (operands[5], E_V2HFmode))
        return -1;
      return 0;

    case E_V2SFmode:
      if (!register_operand (operands[4], E_V2SFmode)
          || !register_operand (operands[5], E_V2SFmode))
        return -1;
      return 1;

    case E_V2DFmode:
      if (!register_operand (operands[4], E_V2DFmode)
          || !register_operand (operands[5], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern618 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V16BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V16BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V16HFmode:
      if (!register_operand (operands[4], E_V16HFmode)
          || !register_operand (operands[5], E_V16HFmode))
        return -1;
      return 0;

    case E_V16SFmode:
      if (!register_operand (operands[4], E_V16SFmode)
          || !register_operand (operands[5], E_V16SFmode))
        return -1;
      return 1;

    case E_V16DFmode:
      if (!register_operand (operands[4], E_V16DFmode)
          || !register_operand (operands[5], E_V16DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern621 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V128BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V128BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V128HFmode:
      if (!register_operand (operands[4], E_V128HFmode)
          || !register_operand (operands[5], E_V128HFmode))
        return -1;
      return 0;

    case E_V128SFmode:
      if (!register_operand (operands[4], E_V128SFmode)
          || !register_operand (operands[5], E_V128SFmode))
        return -1;
      return 1;

    case E_V128DFmode:
      if (!register_operand (operands[4], E_V128DFmode)
          || !register_operand (operands[5], E_V128DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern625 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], i1))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!register_operand (operands[4], i3))
    return -1;
  x10 = XEXP (x1, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  return 0;
}

int
pattern629 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM4QImode:
      if (!register_operand (operands[1], E_RVVM4QImode)
          || !vector_arith_operand (operands[2], E_RVVM4QImode))
        return -1;
      return 0;

    case E_RVVM8HImode:
      if (!register_operand (operands[1], E_RVVM8HImode)
          || !vector_arith_operand (operands[2], E_RVVM8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern633 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM1SImode:
      if (!register_operand (operands[1], E_RVVM1SImode)
          || !vector_arith_operand (operands[2], E_RVVM1SImode))
        return -1;
      return 0;

    case E_RVVM2DImode:
      if (!register_operand (operands[1], E_RVVM2DImode)
          || !vector_arith_operand (operands[2], E_RVVM2DImode))
        return -1;
      return 1;

    case E_RVVMF4QImode:
      if (!register_operand (operands[1], E_RVVMF4QImode)
          || !vector_arith_operand (operands[2], E_RVVMF4QImode))
        return -1;
      return 2;

    case E_RVVMF2HImode:
      if (!register_operand (operands[1], E_RVVMF2HImode)
          || !vector_arith_operand (operands[2], E_RVVMF2HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern637 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM1QImode:
      if (!register_operand (operands[1], E_RVVM1QImode)
          || !register_operand (operands[2], E_RVVM1QImode))
        return -1;
      return 0;

    case E_RVVM2HImode:
      if (!register_operand (operands[1], E_RVVM2HImode)
          || !register_operand (operands[2], E_RVVM2HImode))
        return -1;
      return 1;

    case E_RVVM4SImode:
      if (!register_operand (operands[1], E_RVVM4SImode)
          || !register_operand (operands[2], E_RVVM4SImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      if (!register_operand (operands[1], E_RVVM8DImode)
          || !register_operand (operands[2], E_RVVM8DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern642 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_eew16_stride_operand (operands[2], E_VOIDmode)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern645 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i3)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern652 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF64BImode
      || !vector_mask_operand (operands[1], E_RVVMF64BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVMF8QImode:
      if (!register_operand (operands[4], E_RVVMF8QImode))
        return -1;
      return 0;

    case E_RVVMF4HImode:
      if (!register_operand (operands[4], E_RVVMF4HImode))
        return -1;
      return 1;

    case E_RVVMF2SImode:
      if (!register_operand (operands[4], E_RVVMF2SImode))
        return -1;
      return 2;

    case E_RVVM1DImode:
      if (!register_operand (operands[4], E_RVVM1DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern659 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF4BImode
      || !vector_mask_operand (operands[1], E_RVVMF4BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM8SImode:
      if (!register_operand (operands[4], E_RVVM8SImode))
        return -1;
      return 0;

    case E_RVVM4HImode:
      if (!register_operand (operands[4], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (!register_operand (operands[4], E_RVVM2QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern663 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF64BImode
      || !vector_mask_operand (operands[1], E_RVVMF64BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVMF2SImode:
      if (!register_operand (operands[4], E_RVVMF2SImode))
        return -1;
      return 0;

    case E_RVVMF4HImode:
      if (!register_operand (operands[4], E_RVVMF4HImode))
        return -1;
      return 1;

    case E_RVVMF8QImode:
      if (!register_operand (operands[4], E_RVVMF8QImode))
        return -1;
      return 2;

    case E_RVVM1DImode:
      if (!register_operand (operands[4], E_RVVM1DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern670 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern675 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  return 0;
}

int
pattern680 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1DImode)
      || GET_MODE (x1) != E_RVVM1DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != E_RVVM1DImode
      || !register_operand (operands[4], E_RVVM1DImode)
      || !vector_merge_operand (operands[2], E_RVVM1DImode))
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF8BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[3], E_RVVM8DImode))
        return -1;
      return 0;

    case E_RVVMF16BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[3], E_RVVM4DImode))
        return -1;
      return 1;

    case E_RVVMF32BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[3], E_RVVM2DImode))
        return -1;
      return 2;

    case E_RVVMF64BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[3], E_RVVM1DImode))
        return -1;
      return 3;

    case E_V1BImode:
      if (!vector_mask_operand (operands[1], E_V1BImode)
          || !register_operand (operands[3], E_V1DImode))
        return -1;
      return 4;

    case E_V2BImode:
      if (!vector_mask_operand (operands[1], E_V2BImode)
          || !register_operand (operands[3], E_V2DImode))
        return -1;
      return 5;

    case E_V4BImode:
      if (!vector_mask_operand (operands[1], E_V4BImode)
          || !register_operand (operands[3], E_V4DImode))
        return -1;
      return 6;

    case E_V8BImode:
      if (!vector_mask_operand (operands[1], E_V8BImode)
          || !register_operand (operands[3], E_V8DImode))
        return -1;
      return 7;

    case E_V16BImode:
      if (!vector_mask_operand (operands[1], E_V16BImode)
          || !register_operand (operands[3], E_V16DImode))
        return -1;
      return 8;

    case E_V32BImode:
      if (!vector_mask_operand (operands[1], E_V32BImode)
          || !register_operand (operands[3], E_V32DImode))
        return -1;
      return 9;

    case E_V64BImode:
      if (!vector_mask_operand (operands[1], E_V64BImode)
          || !register_operand (operands[3], E_V64DImode))
        return -1;
      return 10;

    case E_V128BImode:
      if (!vector_mask_operand (operands[1], E_V128BImode)
          || !register_operand (operands[3], E_V128DImode))
        return -1;
      return 11;

    case E_V256BImode:
      if (!vector_mask_operand (operands[1], E_V256BImode)
          || !register_operand (operands[3], E_V256DImode))
        return -1;
      return 12;

    case E_V512BImode:
      if (!vector_mask_operand (operands[1], E_V512BImode)
          || !register_operand (operands[3], E_V512DImode))
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern684 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern688 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern695 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  return 0;
}

int
pattern704 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[3], i4))
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[4], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern711 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern714 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern717 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[3], i1)
      || !vector_eew16_stride_operand (operands[4], E_VOIDmode)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern721 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern726 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2))
    return -1;
  x5 = XEXP (x3, 1);
  return pattern725 (x5, 
i1, 
i2, 
i4); /* [-1, 0] */
}

int
pattern728 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern542 (x1, 
E_RVVM8HFmode, 
E_HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern542 (x1, 
E_RVVM4HFmode, 
E_HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern542 (x1, 
E_RVVM2HFmode, 
E_HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern542 (x1, 
E_RVVM1HFmode, 
E_HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern542 (x1, 
E_RVVMF2HFmode, 
E_HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern542 (x1, 
E_RVVMF4HFmode, 
E_HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern542 (x1, 
E_RVVM8SFmode, 
E_SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern542 (x1, 
E_RVVM4SFmode, 
E_SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern542 (x1, 
E_RVVM2SFmode, 
E_SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern542 (x1, 
E_RVVM1SFmode, 
E_SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern542 (x1, 
E_RVVMF2SFmode, 
E_SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern542 (x1, 
E_RVVM8DFmode, 
E_DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern542 (x1, 
E_RVVM4DFmode, 
E_DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern542 (x1, 
E_RVVM2DFmode, 
E_DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern542 (x1, 
E_RVVM1DFmode, 
E_DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern729 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern671 (x1, 
E_RVVM8HImode, 
E_RVVM8HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode)
          || GET_MODE (x1) != E_RVVM4HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM4HImode
          || !vector_merge_operand (operands[2], E_RVVM4HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HFmode:
          if (!register_operand (operands[3], E_RVVM4HFmode))
            return -1;
          return 1;

        case E_RVVM8SFmode:
          if (!register_operand (operands[3], E_RVVM8SFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode)
          || GET_MODE (x1) != E_RVVM2HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM2HImode
          || !vector_merge_operand (operands[2], E_RVVM2HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HFmode:
          if (!register_operand (operands[3], E_RVVM2HFmode))
            return -1;
          return 3;

        case E_RVVM4SFmode:
          if (!register_operand (operands[3], E_RVVM4SFmode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode)
          || GET_MODE (x1) != E_RVVM1HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM1HImode
          || !vector_merge_operand (operands[2], E_RVVM1HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HFmode:
          if (!register_operand (operands[3], E_RVVM1HFmode))
            return -1;
          return 5;

        case E_RVVM2SFmode:
          if (!register_operand (operands[3], E_RVVM2SFmode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || GET_MODE (x1) != E_RVVMF2HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVMF2HImode
          || !vector_merge_operand (operands[2], E_RVVMF2HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HFmode:
          if (!register_operand (operands[3], E_RVVMF2HFmode))
            return -1;
          return 7;

        case E_RVVM1SFmode:
          if (!register_operand (operands[3], E_RVVM1SFmode))
            return -1;
          return 8;

        default:
          return -1;
        }

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || GET_MODE (x1) != E_RVVMF4HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVMF4HImode
          || !vector_merge_operand (operands[2], E_RVVMF4HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF4HFmode:
          if (!register_operand (operands[3], E_RVVMF4HFmode))
            return -1;
          return 9;

        case E_RVVMF2SFmode:
          if (!register_operand (operands[3], E_RVVMF2SFmode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM8SImode
          || !vector_merge_operand (operands[2], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM8SFmode:
          if (!register_operand (operands[3], E_RVVM8SFmode))
            return -1;
          return 11;

        case E_RVVM4HFmode:
          if (!register_operand (operands[3], E_RVVM4HFmode))
            return -1;
          return 12;

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM4SImode
          || !vector_merge_operand (operands[2], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4SFmode:
          if (!register_operand (operands[3], E_RVVM4SFmode))
            return -1;
          return 13;

        case E_RVVM2HFmode:
          if (!register_operand (operands[3], E_RVVM2HFmode))
            return -1;
          return 14;

        case E_RVVM8DFmode:
          if (!register_operand (operands[3], E_RVVM8DFmode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM2SImode
          || !vector_merge_operand (operands[2], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2SFmode:
          if (!register_operand (operands[3], E_RVVM2SFmode))
            return -1;
          return 16;

        case E_RVVM1HFmode:
          if (!register_operand (operands[3], E_RVVM1HFmode))
            return -1;
          return 17;

        case E_RVVM4DFmode:
          if (!register_operand (operands[3], E_RVVM4DFmode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM1SImode
          || !vector_merge_operand (operands[2], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1SFmode:
          if (!register_operand (operands[3], E_RVVM1SFmode))
            return -1;
          return 19;

        case E_RVVMF2HFmode:
          if (!register_operand (operands[3], E_RVVMF2HFmode))
            return -1;
          return 20;

        case E_RVVM2DFmode:
          if (!register_operand (operands[3], E_RVVM2DFmode))
            return -1;
          return 21;

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVMF2SImode
          || !vector_merge_operand (operands[2], E_RVVMF2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2SFmode:
          if (!register_operand (operands[3], E_RVVMF2SFmode))
            return -1;
          return 22;

        case E_RVVMF4HFmode:
          if (!register_operand (operands[3], E_RVVMF4HFmode))
            return -1;
          return 23;

        case E_RVVM1DFmode:
          if (!register_operand (operands[3], E_RVVM1DFmode))
            return -1;
          return 24;

        default:
          return -1;
        }

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode)
          || GET_MODE (x1) != E_RVVM8DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM8DImode
          || !vector_merge_operand (operands[2], E_RVVM8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM8DFmode:
          if (!register_operand (operands[3], E_RVVM8DFmode))
            return -1;
          return 25;

        case E_RVVM4SFmode:
          if (!register_operand (operands[3], E_RVVM4SFmode))
            return -1;
          return 26;

        default:
          return -1;
        }

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode)
          || GET_MODE (x1) != E_RVVM4DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM4DImode
          || !vector_merge_operand (operands[2], E_RVVM4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4DFmode:
          if (!register_operand (operands[3], E_RVVM4DFmode))
            return -1;
          return 27;

        case E_RVVM2SFmode:
          if (!register_operand (operands[3], E_RVVM2SFmode))
            return -1;
          return 28;

        default:
          return -1;
        }

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode)
          || GET_MODE (x1) != E_RVVM2DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM2DImode
          || !vector_merge_operand (operands[2], E_RVVM2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2DFmode:
          if (!register_operand (operands[3], E_RVVM2DFmode))
            return -1;
          return 29;

        case E_RVVM1SFmode:
          if (!register_operand (operands[3], E_RVVM1SFmode))
            return -1;
          return 30;

        default:
          return -1;
        }

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode)
          || GET_MODE (x1) != E_RVVM1DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM1DImode
          || !vector_merge_operand (operands[2], E_RVVM1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1DFmode:
          if (!register_operand (operands[3], E_RVVM1DFmode))
            return -1;
          return 31;

        case E_RVVMF2SFmode:
          if (!register_operand (operands[3], E_RVVMF2SFmode))
            return -1;
          return 32;

        default:
          return -1;
        }

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1HImode
          || !vector_merge_operand (operands[2], E_V1HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1HFmode:
          if (!register_operand (operands[3], E_V1HFmode))
            return -1;
          return 33;

        case E_V1SFmode:
          if (!register_operand (operands[3], E_V1SFmode))
            return -1;
          return 34;

        default:
          return -1;
        }

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2HImode
          || !vector_merge_operand (operands[2], E_V2HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2HFmode:
          if (!register_operand (operands[3], E_V2HFmode))
            return -1;
          return 35;

        case E_V2SFmode:
          if (!register_operand (operands[3], E_V2SFmode))
            return -1;
          return 36;

        default:
          return -1;
        }

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V4HImode
          || !vector_merge_operand (operands[2], E_V4HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4HFmode:
          if (!register_operand (operands[3], E_V4HFmode))
            return -1;
          return 37;

        case E_V4SFmode:
          if (!register_operand (operands[3], E_V4SFmode))
            return -1;
          return 38;

        default:
          return -1;
        }

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V8HImode
          || !vector_merge_operand (operands[2], E_V8HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[3], E_V8HFmode))
            return -1;
          return 39;

        case E_V8SFmode:
          if (!register_operand (operands[3], E_V8SFmode))
            return -1;
          return 40;

        default:
          return -1;
        }

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V16HImode
          || !vector_merge_operand (operands[2], E_V16HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16HFmode:
          if (!register_operand (operands[3], E_V16HFmode))
            return -1;
          return 41;

        case E_V16SFmode:
          if (!register_operand (operands[3], E_V16SFmode))
            return -1;
          return 42;

        default:
          return -1;
        }

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V32HImode
          || !vector_merge_operand (operands[2], E_V32HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32HFmode:
          if (!register_operand (operands[3], E_V32HFmode))
            return -1;
          return 43;

        case E_V32SFmode:
          if (!register_operand (operands[3], E_V32SFmode))
            return -1;
          return 44;

        default:
          return -1;
        }

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x1) != E_V64HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V64HImode
          || !vector_merge_operand (operands[2], E_V64HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64HFmode:
          if (!register_operand (operands[3], E_V64HFmode))
            return -1;
          return 45;

        case E_V64SFmode:
          if (!register_operand (operands[3], E_V64SFmode))
            return -1;
          return 46;

        default:
          return -1;
        }

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || GET_MODE (x1) != E_V128HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V128HImode
          || !vector_merge_operand (operands[2], E_V128HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128HFmode:
          if (!register_operand (operands[3], E_V128HFmode))
            return -1;
          return 47;

        case E_V128SFmode:
          if (!register_operand (operands[3], E_V128SFmode))
            return -1;
          return 48;

        default:
          return -1;
        }

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || GET_MODE (x1) != E_V256HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V256HImode
          || !vector_merge_operand (operands[2], E_V256HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256HFmode:
          if (!register_operand (operands[3], E_V256HFmode))
            return -1;
          return 49;

        case E_V256SFmode:
          if (!register_operand (operands[3], E_V256SFmode))
            return -1;
          return 50;

        default:
          return -1;
        }

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || GET_MODE (x1) != E_V512HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V512HImode
          || !vector_merge_operand (operands[2], E_V512HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512HFmode:
          if (!register_operand (operands[3], E_V512HFmode))
            return -1;
          return 51;

        case E_V512SFmode:
          if (!register_operand (operands[3], E_V512SFmode))
            return -1;
          return 52;

        default:
          return -1;
        }

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || GET_MODE (x1) != E_V1024HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1024BImode
          || !vector_mask_operand (operands[1], E_V1024BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1024HImode
          || !vector_merge_operand (operands[2], E_V1024HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1024HFmode:
          if (!register_operand (operands[3], E_V1024HFmode))
            return -1;
          return 53;

        case E_V1024SFmode:
          if (!register_operand (operands[3], E_V1024SFmode))
            return -1;
          return 54;

        default:
          return -1;
        }

    case E_V2048HImode:
      if (pattern671 (x1, 
E_V2048HImode, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 55;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1SImode
          || !vector_merge_operand (operands[2], E_V1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1SFmode:
          if (!register_operand (operands[3], E_V1SFmode))
            return -1;
          return 56;

        case E_V1HFmode:
          if (!register_operand (operands[3], E_V1HFmode))
            return -1;
          return 57;

        case E_V1DFmode:
          if (!register_operand (operands[3], E_V1DFmode))
            return -1;
          return 58;

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2SImode
          || !vector_merge_operand (operands[2], E_V2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2SFmode:
          if (!register_operand (operands[3], E_V2SFmode))
            return -1;
          return 59;

        case E_V2HFmode:
          if (!register_operand (operands[3], E_V2HFmode))
            return -1;
          return 60;

        case E_V2DFmode:
          if (!register_operand (operands[3], E_V2DFmode))
            return -1;
          return 61;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V4SImode
          || !vector_merge_operand (operands[2], E_V4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[3], E_V4SFmode))
            return -1;
          return 62;

        case E_V4HFmode:
          if (!register_operand (operands[3], E_V4HFmode))
            return -1;
          return 63;

        case E_V4DFmode:
          if (!register_operand (operands[3], E_V4DFmode))
            return -1;
          return 64;

        default:
          return -1;
        }

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V8SImode
          || !vector_merge_operand (operands[2], E_V8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[3], E_V8SFmode))
            return -1;
          return 65;

        case E_V8HFmode:
          if (!register_operand (operands[3], E_V8HFmode))
            return -1;
          return 66;

        case E_V8DFmode:
          if (!register_operand (operands[3], E_V8DFmode))
            return -1;
          return 67;

        default:
          return -1;
        }

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V16SImode
          || !vector_merge_operand (operands[2], E_V16SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16SFmode:
          if (!register_operand (operands[3], E_V16SFmode))
            return -1;
          return 68;

        case E_V16HFmode:
          if (!register_operand (operands[3], E_V16HFmode))
            return -1;
          return 69;

        case E_V16DFmode:
          if (!register_operand (operands[3], E_V16DFmode))
            return -1;
          return 70;

        default:
          return -1;
        }

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V32SImode
          || !vector_merge_operand (operands[2], E_V32SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32SFmode:
          if (!register_operand (operands[3], E_V32SFmode))
            return -1;
          return 71;

        case E_V32HFmode:
          if (!register_operand (operands[3], E_V32HFmode))
            return -1;
          return 72;

        case E_V32DFmode:
          if (!register_operand (operands[3], E_V32DFmode))
            return -1;
          return 73;

        default:
          return -1;
        }

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V64SImode
          || !vector_merge_operand (operands[2], E_V64SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64SFmode:
          if (!register_operand (operands[3], E_V64SFmode))
            return -1;
          return 74;

        case E_V64HFmode:
          if (!register_operand (operands[3], E_V64HFmode))
            return -1;
          return 75;

        case E_V64DFmode:
          if (!register_operand (operands[3], E_V64DFmode))
            return -1;
          return 76;

        default:
          return -1;
        }

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V128SImode
          || !vector_merge_operand (operands[2], E_V128SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128SFmode:
          if (!register_operand (operands[3], E_V128SFmode))
            return -1;
          return 77;

        case E_V128HFmode:
          if (!register_operand (operands[3], E_V128HFmode))
            return -1;
          return 78;

        case E_V128DFmode:
          if (!register_operand (operands[3], E_V128DFmode))
            return -1;
          return 79;

        default:
          return -1;
        }

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V256SImode
          || !vector_merge_operand (operands[2], E_V256SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256SFmode:
          if (!register_operand (operands[3], E_V256SFmode))
            return -1;
          return 80;

        case E_V256HFmode:
          if (!register_operand (operands[3], E_V256HFmode))
            return -1;
          return 81;

        case E_V256DFmode:
          if (!register_operand (operands[3], E_V256DFmode))
            return -1;
          return 82;

        default:
          return -1;
        }

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V512SImode
          || !vector_merge_operand (operands[2], E_V512SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512SFmode:
          if (!register_operand (operands[3], E_V512SFmode))
            return -1;
          return 83;

        case E_V512HFmode:
          if (!register_operand (operands[3], E_V512HFmode))
            return -1;
          return 84;

        case E_V512DFmode:
          if (!register_operand (operands[3], E_V512DFmode))
            return -1;
          return 85;

        default:
          return -1;
        }

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || GET_MODE (x1) != E_V1024SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1024BImode
          || !vector_mask_operand (operands[1], E_V1024BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1024SImode
          || !vector_merge_operand (operands[2], E_V1024SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1024SFmode:
          if (!register_operand (operands[3], E_V1024SFmode))
            return -1;
          return 86;

        case E_V1024HFmode:
          if (!register_operand (operands[3], E_V1024HFmode))
            return -1;
          return 87;

        default:
          return -1;
        }

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1DImode
          || !vector_merge_operand (operands[2], E_V1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1DFmode:
          if (!register_operand (operands[3], E_V1DFmode))
            return -1;
          return 88;

        case E_V1SFmode:
          if (!register_operand (operands[3], E_V1SFmode))
            return -1;
          return 89;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2DImode
          || !vector_merge_operand (operands[2], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[3], E_V2DFmode))
            return -1;
          return 90;

        case E_V2SFmode:
          if (!register_operand (operands[3], E_V2SFmode))
            return -1;
          return 91;

        default:
          return -1;
        }

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V4DImode
          || !vector_merge_operand (operands[2], E_V4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4DFmode:
          if (!register_operand (operands[3], E_V4DFmode))
            return -1;
          return 92;

        case E_V4SFmode:
          if (!register_operand (operands[3], E_V4SFmode))
            return -1;
          return 93;

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V8DImode
          || !vector_merge_operand (operands[2], E_V8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8DFmode:
          if (!register_operand (operands[3], E_V8DFmode))
            return -1;
          return 94;

        case E_V8SFmode:
          if (!register_operand (operands[3], E_V8SFmode))
            return -1;
          return 95;

        default:
          return -1;
        }

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V16DImode
          || !vector_merge_operand (operands[2], E_V16DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16DFmode:
          if (!register_operand (operands[3], E_V16DFmode))
            return -1;
          return 96;

        case E_V16SFmode:
          if (!register_operand (operands[3], E_V16SFmode))
            return -1;
          return 97;

        default:
          return -1;
        }

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V32DImode
          || !vector_merge_operand (operands[2], E_V32DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32DFmode:
          if (!register_operand (operands[3], E_V32DFmode))
            return -1;
          return 98;

        case E_V32SFmode:
          if (!register_operand (operands[3], E_V32SFmode))
            return -1;
          return 99;

        default:
          return -1;
        }

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V64DImode
          || !vector_merge_operand (operands[2], E_V64DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64DFmode:
          if (!register_operand (operands[3], E_V64DFmode))
            return -1;
          return 100;

        case E_V64SFmode:
          if (!register_operand (operands[3], E_V64SFmode))
            return -1;
          return 101;

        default:
          return -1;
        }

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || GET_MODE (x1) != E_V128DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V128DImode
          || !vector_merge_operand (operands[2], E_V128DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128DFmode:
          if (!register_operand (operands[3], E_V128DFmode))
            return -1;
          return 102;

        case E_V128SFmode:
          if (!register_operand (operands[3], E_V128SFmode))
            return -1;
          return 103;

        default:
          return -1;
        }

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || GET_MODE (x1) != E_V256DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V256DImode
          || !vector_merge_operand (operands[2], E_V256DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256DFmode:
          if (!register_operand (operands[3], E_V256DFmode))
            return -1;
          return 104;

        case E_V256SFmode:
          if (!register_operand (operands[3], E_V256SFmode))
            return -1;
          return 105;

        default:
          return -1;
        }

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || GET_MODE (x1) != E_V512DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V512DImode
          || !vector_merge_operand (operands[2], E_V512DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512DFmode:
          if (!register_operand (operands[3], E_V512DFmode))
            return -1;
          return 106;

        case E_V512SFmode:
          if (!register_operand (operands[3], E_V512SFmode))
            return -1;
          return 107;

        default:
          return -1;
        }

    case E_RVVM4QImode:
      if (pattern671 (x1, 
E_RVVM4QImode, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 108;

    case E_RVVM2QImode:
      if (pattern671 (x1, 
E_RVVM2QImode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 109;

    case E_RVVM1QImode:
      if (pattern671 (x1, 
E_RVVM1QImode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 110;

    case E_RVVMF2QImode:
      if (pattern671 (x1, 
E_RVVMF2QImode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 111;

    case E_RVVMF4QImode:
      if (pattern671 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 112;

    case E_RVVMF8QImode:
      if (pattern671 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 113;

    case E_V1QImode:
      if (pattern671 (x1, 
E_V1QImode, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 114;

    case E_V2QImode:
      if (pattern671 (x1, 
E_V2QImode, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 115;

    case E_V4QImode:
      if (pattern671 (x1, 
E_V4QImode, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 116;

    case E_V8QImode:
      if (pattern671 (x1, 
E_V8QImode, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 117;

    case E_V16QImode:
      if (pattern671 (x1, 
E_V16QImode, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 118;

    case E_V32QImode:
      if (pattern671 (x1, 
E_V32QImode, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 119;

    case E_V64QImode:
      if (pattern671 (x1, 
E_V64QImode, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 120;

    case E_V128QImode:
      if (pattern671 (x1, 
E_V128QImode, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 121;

    case E_V256QImode:
      if (pattern671 (x1, 
E_V256QImode, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 122;

    case E_V512QImode:
      if (pattern671 (x1, 
E_V512QImode, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 123;

    case E_V1024QImode:
      if (pattern671 (x1, 
E_V1024QImode, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 124;

    case E_V2048QImode:
      if (pattern671 (x1, 
E_V2048QImode, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 125;

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (XINT (x3, 1))
        {
        case 23:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2186 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 179; /* lrintsfsi2_sext */

            case 1:
              if (!(
#line 2186 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 180; /* lrintdfsi2_sext */

            case 2:
              if (!(
#line 2186 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 181; /* lrinthfsi2_sext */

            default:
              return -1;
            }

        case 17:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2235 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 203; /* lroundsfsi2_sext */

            case 1:
              if (!(
#line 2235 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 209; /* lrounddfsi2_sext */

            case 2:
              if (!(
#line 2235 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 215; /* lroundhfsi2_sext */

            default:
              return -1;
            }

        case 18:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2235 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 204; /* lfloorsfsi2_sext */

            case 1:
              if (!(
#line 2235 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 210; /* lfloordfsi2_sext */

            case 2:
              if (!(
#line 2235 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 216; /* lfloorhfsi2_sext */

            default:
              return -1;
            }

        case 19:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2235 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 205; /* lceilsfsi2_sext */

            case 1:
              if (!(
#line 2235 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 211; /* lceildfsi2_sext */

            case 2:
              if (!(
#line 2235 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 217; /* lceilhfsi2_sext */

            default:
              return -1;
            }

        case 20:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2235 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 206; /* lbtruncsfsi2_sext */

            case 1:
              if (!(
#line 2235 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 212; /* lbtruncdfsi2_sext */

            case 2:
              if (!(
#line 2235 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 218; /* lbtrunchfsi2_sext */

            default:
              return -1;
            }

        case 21:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2235 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 207; /* lroundevensfsi2_sext */

            case 1:
              if (!(
#line 2235 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 213; /* lroundevendfsi2_sext */

            case 2:
              if (!(
#line 2235 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 219; /* lroundevenhfsi2_sext */

            default:
              return -1;
            }

        case 22:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2235 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 208; /* lnearbyintsfsi2_sext */

            case 1:
              if (!(
#line 2235 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 214; /* lnearbyintdfsi2_sext */

            case 2:
              if (!(
#line 2235 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 220; /* lnearbyinthfsi2_sext */

            default:
              return -1;
            }

        case 62:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 336 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
            return -1;
          return 698; /* riscv_sha256sig0_di_extended */

        case 63:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 336 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
            return -1;
          return 699; /* riscv_sha256sig1_di_extended */

        case 64:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 336 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
            return -1;
          return 700; /* riscv_sha256sum0_di_extended */

        case 65:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 336 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
            return -1;
          return 701; /* riscv_sha256sum1_di_extended */

        case 76:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 465 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZKSH && TARGET_64BIT))
            return -1;
          return 714; /* riscv_sm3p0_di_extended */

        case 77:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 465 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZKSH && TARGET_64BIT))
            return -1;
          return 715; /* riscv_sm3p1_di_extended */

        default:
          return -1;
        }

    case 3:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_0_3_operand (operands[3], E_SImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 78:
          if (!
#line 510 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZKSED && TARGET_64BIT))
            return -1;
          return 718; /* riscv_sm4ed_di_extended */

        case 79:
          if (!
#line 510 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZKSED && TARGET_64BIT))
            return -1;
          return 719; /* riscv_sm4ks_di_extended */

        default:
          return -1;
        }

    case 2:
      return recog_15 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_SImode) != 0)
        return -1;
      if ((
#line 350 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return 907; /* *th_mulssi */
      if (
#line 373 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC && TARGET_64BIT))
        return 910; /* *th_mulswsi2 */
      if (!
#line 209 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
        return -1;
      return 33906; /* riscv_cv_mac_msu */

    case E_DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_DImode) != 0
          || !(
#line 350 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 908; /* *th_mulsdi */

    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8QImode) != 0
          || !
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27247; /* fnmarvvm8qi4 */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4QImode) != 0
          || !
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27248; /* fnmarvvm4qi4 */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2QImode) != 0
          || !
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27249; /* fnmarvvm2qi4 */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1QImode) != 0
          || !
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27250; /* fnmarvvm1qi4 */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8HImode) != 0
          || !
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27251; /* fnmarvvm8hi4 */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4HImode) != 0
          || !
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27252; /* fnmarvvm4hi4 */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2HImode) != 0
          || !
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27253; /* fnmarvvm2hi4 */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1HImode) != 0
          || !
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27254; /* fnmarvvm1hi4 */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8SImode) != 0
          || !
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27255; /* fnmarvvm8si4 */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4SImode) != 0
          || !
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27256; /* fnmarvvm4si4 */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2SImode) != 0
          || !
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27257; /* fnmarvvm2si4 */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1SImode) != 0
          || !
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27258; /* fnmarvvm1si4 */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8DImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27259; /* fnmarvvm8di4 */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4DImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27260; /* fnmarvvm4di4 */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2DImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27261; /* fnmarvvm2di4 */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1DImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27262; /* fnmarvvm1di4 */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2QImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 27263; /* fnmarvvmf2qi4 */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF4QImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 27264; /* fnmarvvmf4qi4 */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF8QImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 27265; /* fnmarvvmf8qi4 */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2HImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 27266; /* fnmarvvmf2hi4 */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF4HImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 27267; /* fnmarvvmf4hi4 */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2SImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 27268; /* fnmarvvmf2si4 */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1QImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 27269; /* fnmav1qi4 */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2QImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 27270; /* fnmav2qi4 */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4QImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 27271; /* fnmav4qi4 */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8QImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 27272; /* fnmav8qi4 */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16QImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 27273; /* fnmav16qi4 */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32QImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 27274; /* fnmav32qi4 */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64QImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27275; /* fnmav64qi4 */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128QImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27276; /* fnmav128qi4 */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256QImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27277; /* fnmav256qi4 */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512QImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27278; /* fnmav512qi4 */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024QImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27279; /* fnmav1024qi4 */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2048QImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27280; /* fnmav2048qi4 */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4096QImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27281; /* fnmav4096qi4 */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1HImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 27282; /* fnmav1hi4 */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2HImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 27283; /* fnmav2hi4 */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4HImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 27284; /* fnmav4hi4 */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8HImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 27285; /* fnmav8hi4 */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16HImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 27286; /* fnmav16hi4 */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32HImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27287; /* fnmav32hi4 */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64HImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27288; /* fnmav64hi4 */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128HImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27289; /* fnmav128hi4 */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256HImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27290; /* fnmav256hi4 */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512HImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27291; /* fnmav512hi4 */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024HImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27292; /* fnmav1024hi4 */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2048HImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27293; /* fnmav2048hi4 */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1SImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 27294; /* fnmav1si4 */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2SImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 27295; /* fnmav2si4 */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4SImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 27296; /* fnmav4si4 */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8SImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 27297; /* fnmav8si4 */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16SImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27298; /* fnmav16si4 */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32SImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27299; /* fnmav32si4 */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64SImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27300; /* fnmav64si4 */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128SImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27301; /* fnmav128si4 */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256SImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27302; /* fnmav256si4 */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512SImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27303; /* fnmav512si4 */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024SImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27304; /* fnmav1024si4 */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1DImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27305; /* fnmav1di4 */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2DImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27306; /* fnmav2di4 */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4DImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27307; /* fnmav4di4 */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8DImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27308; /* fnmav8di4 */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16DImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27309; /* fnmav16di4 */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32DImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27310; /* fnmav32di4 */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64DImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27311; /* fnmav64di4 */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128DImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27312; /* fnmav128di4 */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256DImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27313; /* fnmav256di4 */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512DImode) != 0
          || !(
#line 1208 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27314; /* fnmav512di4 */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8HFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27363; /* fnmarvvm8hf4 */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4HFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27364; /* fnmarvvm4hf4 */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2HFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27365; /* fnmarvvm2hf4 */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1HFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27366; /* fnmarvvm1hf4 */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2HFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27367; /* fnmarvvmf2hf4 */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF4HFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27368; /* fnmarvvmf4hf4 */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8SFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27369; /* fnmarvvm8sf4 */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4SFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27370; /* fnmarvvm4sf4 */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2SFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27371; /* fnmarvvm2sf4 */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1SFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27372; /* fnmarvvm1sf4 */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2SFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27373; /* fnmarvvmf2sf4 */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8DFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27374; /* fnmarvvm8df4 */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4DFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27375; /* fnmarvvm4df4 */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2DFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27376; /* fnmarvvm2df4 */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1DFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27377; /* fnmarvvm1df4 */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1HFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27378; /* fnmav1hf4 */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2HFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27379; /* fnmav2hf4 */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4HFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27380; /* fnmav4hf4 */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8HFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27381; /* fnmav8hf4 */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16HFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27382; /* fnmav16hf4 */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32HFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27383; /* fnmav32hf4 */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64HFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27384; /* fnmav64hf4 */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128HFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27385; /* fnmav128hf4 */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256HFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27386; /* fnmav256hf4 */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512HFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27387; /* fnmav512hf4 */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024HFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27388; /* fnmav1024hf4 */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2048HFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27389; /* fnmav2048hf4 */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1SFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27390; /* fnmav1sf4 */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2SFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27391; /* fnmav2sf4 */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4SFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27392; /* fnmav4sf4 */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8SFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27393; /* fnmav8sf4 */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16SFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27394; /* fnmav16sf4 */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32SFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27395; /* fnmav32sf4 */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64SFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27396; /* fnmav64sf4 */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128SFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27397; /* fnmav128sf4 */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256SFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27398; /* fnmav256sf4 */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512SFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27399; /* fnmav512sf4 */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024SFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27400; /* fnmav1024sf4 */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1DFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27401; /* fnmav1df4 */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2DFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27402; /* fnmav2df4 */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4DFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27403; /* fnmav4df4 */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8DFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27404; /* fnmav8df4 */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16DFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27405; /* fnmav16df4 */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32DFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27406; /* fnmav32df4 */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64DFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27407; /* fnmav64df4 */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128DFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27408; /* fnmav128df4 */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256DFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27409; /* fnmav256df4 */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512DFmode) != 0
          || !(
#line 1264 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27410; /* fnmav512df4 */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_SImode) != 0
          || !
#line 1416 "../../../gcc/config/riscv/riscv.md"
(TARGET_DIV))
        return -1;
      return 36; /* *divsi3 */

    case E_DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_DImode) != 0
          || !
#line 1443 "../../../gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
        return -1;
      return 40; /* divdi3 */

    case E_SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_SFmode) != 0
          || !(
#line 1478 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && TARGET_FDIV) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
        return -1;
      return 48; /* divsf3 */

    case E_DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_DFmode) != 0
          || !(
#line 1478 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && TARGET_FDIV) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 49; /* divdf3 */

    case E_HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_HFmode) != 0
          || !(
#line 1478 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && TARGET_FDIV) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 50; /* divhf3 */

    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8QImode) != 0
          || !
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24551; /* divrvvm8qi3 */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4QImode) != 0
          || !
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24565; /* divrvvm4qi3 */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2QImode) != 0
          || !
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24579; /* divrvvm2qi3 */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1QImode) != 0
          || !
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24593; /* divrvvm1qi3 */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8HImode) != 0
          || !
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24607; /* divrvvm8hi3 */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4HImode) != 0
          || !
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24621; /* divrvvm4hi3 */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2HImode) != 0
          || !
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24635; /* divrvvm2hi3 */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1HImode) != 0
          || !
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24649; /* divrvvm1hi3 */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8SImode) != 0
          || !
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24663; /* divrvvm8si3 */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4SImode) != 0
          || !
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24677; /* divrvvm4si3 */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2SImode) != 0
          || !
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24691; /* divrvvm2si3 */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1SImode) != 0
          || !
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24705; /* divrvvm1si3 */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8DImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24719; /* divrvvm8di3 */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4DImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24733; /* divrvvm4di3 */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2DImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24747; /* divrvvm2di3 */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1DImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24761; /* divrvvm1di3 */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2QImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24775; /* divrvvmf2qi3 */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4QImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24789; /* divrvvmf4qi3 */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF8QImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24803; /* divrvvmf8qi3 */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2HImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24817; /* divrvvmf2hi3 */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4HImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24831; /* divrvvmf4hi3 */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2SImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24845; /* divrvvmf2si3 */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1QImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24859; /* divv1qi3 */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2QImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24873; /* divv2qi3 */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4QImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24887; /* divv4qi3 */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8QImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24901; /* divv8qi3 */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16QImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24915; /* divv16qi3 */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32QImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24929; /* divv32qi3 */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64QImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24943; /* divv64qi3 */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128QImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24957; /* divv128qi3 */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256QImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24971; /* divv256qi3 */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512QImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24985; /* divv512qi3 */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024QImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24999; /* divv1024qi3 */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048QImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25013; /* divv2048qi3 */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4096QImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25027; /* divv4096qi3 */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1HImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25041; /* divv1hi3 */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2HImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25055; /* divv2hi3 */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4HImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25069; /* divv4hi3 */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8HImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25083; /* divv8hi3 */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16HImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25097; /* divv16hi3 */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32HImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25111; /* divv32hi3 */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64HImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25125; /* divv64hi3 */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128HImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25139; /* divv128hi3 */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256HImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25153; /* divv256hi3 */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512HImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25167; /* divv512hi3 */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024HImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25181; /* divv1024hi3 */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048HImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25195; /* divv2048hi3 */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1SImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25209; /* divv1si3 */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2SImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25223; /* divv2si3 */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4SImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25237; /* divv4si3 */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8SImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25251; /* divv8si3 */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16SImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25265; /* divv16si3 */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32SImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25279; /* divv32si3 */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64SImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25293; /* divv64si3 */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128SImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25307; /* divv128si3 */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256SImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25321; /* divv256si3 */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512SImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25335; /* divv512si3 */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024SImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25349; /* divv1024si3 */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1DImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25363; /* divv1di3 */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2DImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25377; /* divv2di3 */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4DImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25391; /* divv4di3 */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8DImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25405; /* divv8di3 */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16DImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25419; /* divv16di3 */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32DImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25433; /* divv32di3 */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64DImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25447; /* divv64di3 */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128DImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25461; /* divv128di3 */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256DImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25475; /* divv256di3 */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512DImode) != 0
          || !(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25489; /* divv512di3 */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8HFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27510; /* divrvvm8hf3 */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4HFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27514; /* divrvvm4hf3 */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2HFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27518; /* divrvvm2hf3 */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1HFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27522; /* divrvvm1hf3 */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2HFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27526; /* divrvvmf2hf3 */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4HFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27530; /* divrvvmf4hf3 */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8SFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27534; /* divrvvm8sf3 */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4SFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27538; /* divrvvm4sf3 */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2SFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27542; /* divrvvm2sf3 */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1SFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27546; /* divrvvm1sf3 */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2SFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27550; /* divrvvmf2sf3 */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8DFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27554; /* divrvvm8df3 */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4DFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27558; /* divrvvm4df3 */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2DFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27562; /* divrvvm2df3 */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1DFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27566; /* divrvvm1df3 */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1HFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27570; /* divv1hf3 */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2HFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27574; /* divv2hf3 */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4HFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27578; /* divv4hf3 */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8HFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27582; /* divv8hf3 */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16HFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27586; /* divv16hf3 */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32HFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27590; /* divv32hf3 */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64HFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27594; /* divv64hf3 */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128HFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27598; /* divv128hf3 */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256HFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27602; /* divv256hf3 */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512HFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27606; /* divv512hf3 */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024HFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27610; /* divv1024hf3 */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048HFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27614; /* divv2048hf3 */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1SFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27618; /* divv1sf3 */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2SFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27622; /* divv2sf3 */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4SFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27626; /* divv4sf3 */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8SFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27630; /* divv8sf3 */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16SFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27634; /* divv16sf3 */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32SFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27638; /* divv32sf3 */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64SFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27642; /* divv64sf3 */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128SFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27646; /* divv128sf3 */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256SFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27650; /* divv256sf3 */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512SFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27654; /* divv512sf3 */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024SFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27658; /* divv1024sf3 */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1DFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27662; /* divv1df3 */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2DFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27666; /* divv2df3 */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4DFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27670; /* divv4df3 */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8DFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27674; /* divv8df3 */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16DFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27678; /* divv16df3 */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32DFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27682; /* divv32df3 */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64DFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27686; /* divv64df3 */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128DFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27690; /* divv128df3 */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256DFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27694; /* divv256df3 */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512DFmode) != 0
          || !(
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27698; /* divv512df3 */

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 10)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (GET_MODE (x3) != E_SImode
          || !symbolic_operand (operands[0], E_SImode)
          || !(
#line 2400 "../../../gcc/config/riscv/riscv.md"
(TARGET_TLSDESC) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return -1;
      *pnum_clobbers = 1;
      return 268; /* tlsdescsi */

    case E_DImode:
      if (GET_MODE (x3) != E_DImode
          || !symbolic_operand (operands[0], E_DImode)
          || !(
#line 2400 "../../../gcc/config/riscv/riscv.md"
(TARGET_TLSDESC) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      *pnum_clobbers = 1;
      return 269; /* tlsdescdi */

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern589 (x2, 
E_RVVMF32BImode) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF4QImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVMF4QImode
          || !register_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !
#line 3496 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8694; /* pred_madcrvvmf4qi_scalar */

    case E_RVVMF2HImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVMF2HImode
          || !register_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVMF2HImode)
          || !
#line 3496 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8700; /* pred_madcrvvmf2hi_scalar */

    case E_RVVM1SImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM1SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM1SImode)
          || !
#line 3496 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8705; /* pred_madcrvvm1si_scalar */

    case E_RVVM2DImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM2DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM2DImode)
          || !(
#line 3567 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8799; /* *pred_madcrvvm2di_scalar */

    default:
      return -1;
    }
}

 int
recog_63 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18673; /* pred_redmin_vl0srvvm8qi */

        case 1:
          if (!
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18681; /* pred_redmin_vl0srvvm4qi */

        case 2:
          if (!
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18689; /* pred_redmin_vl0srvvm2qi */

        case 3:
          if (!
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18697; /* pred_redmin_vl0srvvm1qi */

        case 4:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18801; /* pred_redmin_vl0srvvmf2qi */

        case 5:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18809; /* pred_redmin_vl0srvvmf4qi */

        case 6:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18817; /* pred_redmin_vl0srvvmf8qi */

        case 7:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18849; /* pred_redmin_vl0sv1qi */

        case 8:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18857; /* pred_redmin_vl0sv2qi */

        case 9:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18865; /* pred_redmin_vl0sv4qi */

        case 10:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18873; /* pred_redmin_vl0sv8qi */

        case 11:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18881; /* pred_redmin_vl0sv16qi */

        case 12:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18889; /* pred_redmin_vl0sv32qi */

        case 13:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18897; /* pred_redmin_vl0sv64qi */

        case 14:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18905; /* pred_redmin_vl0sv128qi */

        case 15:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18913; /* pred_redmin_vl0sv256qi */

        case 16:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18921; /* pred_redmin_vl0sv512qi */

        case 17:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18929; /* pred_redmin_vl0sv1024qi */

        case 18:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18937; /* pred_redmin_vl0sv2048qi */

        case 19:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18945; /* pred_redmin_vl0sv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18705; /* pred_redmin_vl0srvvm8hi */

        case 1:
          if (!
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18713; /* pred_redmin_vl0srvvm4hi */

        case 2:
          if (!
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18721; /* pred_redmin_vl0srvvm2hi */

        case 3:
          if (!
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18729; /* pred_redmin_vl0srvvm1hi */

        case 4:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18825; /* pred_redmin_vl0srvvmf2hi */

        case 5:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18833; /* pred_redmin_vl0srvvmf4hi */

        case 6:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18953; /* pred_redmin_vl0sv1hi */

        case 7:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18961; /* pred_redmin_vl0sv2hi */

        case 8:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18969; /* pred_redmin_vl0sv4hi */

        case 9:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18977; /* pred_redmin_vl0sv8hi */

        case 10:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18985; /* pred_redmin_vl0sv16hi */

        case 11:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18993; /* pred_redmin_vl0sv32hi */

        case 12:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19001; /* pred_redmin_vl0sv64hi */

        case 13:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19009; /* pred_redmin_vl0sv128hi */

        case 14:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19017; /* pred_redmin_vl0sv256hi */

        case 15:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19025; /* pred_redmin_vl0sv512hi */

        case 16:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19033; /* pred_redmin_vl0sv1024hi */

        case 17:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19041; /* pred_redmin_vl0sv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18737; /* pred_redmin_vl0srvvm8si */

        case 1:
          if (!
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18745; /* pred_redmin_vl0srvvm4si */

        case 2:
          if (!
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18753; /* pred_redmin_vl0srvvm2si */

        case 3:
          if (!
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18761; /* pred_redmin_vl0srvvm1si */

        case 4:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18841; /* pred_redmin_vl0srvvmf2si */

        case 5:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 19049; /* pred_redmin_vl0sv1si */

        case 6:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 19057; /* pred_redmin_vl0sv2si */

        case 7:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 19065; /* pred_redmin_vl0sv4si */

        case 8:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 19073; /* pred_redmin_vl0sv8si */

        case 9:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19081; /* pred_redmin_vl0sv16si */

        case 10:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19089; /* pred_redmin_vl0sv32si */

        case 11:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19097; /* pred_redmin_vl0sv64si */

        case 12:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19105; /* pred_redmin_vl0sv128si */

        case 13:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19113; /* pred_redmin_vl0sv256si */

        case 14:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19121; /* pred_redmin_vl0sv512si */

        case 15:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19129; /* pred_redmin_vl0sv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18769; /* pred_redmin_vl0srvvm8di */

        case 1:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18777; /* pred_redmin_vl0srvvm4di */

        case 2:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18785; /* pred_redmin_vl0srvvm2di */

        case 3:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18793; /* pred_redmin_vl0srvvm1di */

        case 4:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19137; /* pred_redmin_vl0sv1di */

        case 5:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19145; /* pred_redmin_vl0sv2di */

        case 6:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19153; /* pred_redmin_vl0sv4di */

        case 7:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19161; /* pred_redmin_vl0sv8di */

        case 8:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19169; /* pred_redmin_vl0sv16di */

        case 9:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19177; /* pred_redmin_vl0sv32di */

        case 10:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19185; /* pred_redmin_vl0sv64di */

        case 11:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19193; /* pred_redmin_vl0sv128di */

        case 12:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19201; /* pred_redmin_vl0sv256di */

        case 13:
          if (!(
#line 7803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19209; /* pred_redmin_vl0sv512di */

        default:
          return -1;
        }

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern681 (x2, 
E_RVVM1HFmode))
        {
        case 0:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19526; /* pred_redmin_vl0srvvm8hf */

        case 1:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19528; /* pred_redmin_vl0srvvm4hf */

        case 2:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19530; /* pred_redmin_vl0srvvm2hf */

        case 3:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19532; /* pred_redmin_vl0srvvm1hf */

        case 4:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19534; /* pred_redmin_vl0srvvmf2hf */

        case 5:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19536; /* pred_redmin_vl0srvvmf4hf */

        case 6:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 19556; /* pred_redmin_vl0sv1hf */

        case 7:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 19558; /* pred_redmin_vl0sv2hf */

        case 8:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 19560; /* pred_redmin_vl0sv4hf */

        case 9:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 19562; /* pred_redmin_vl0sv8hf */

        case 10:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 19564; /* pred_redmin_vl0sv16hf */

        case 11:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19566; /* pred_redmin_vl0sv32hf */

        case 12:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19568; /* pred_redmin_vl0sv64hf */

        case 13:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19570; /* pred_redmin_vl0sv128hf */

        case 14:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19572; /* pred_redmin_vl0sv256hf */

        case 15:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19574; /* pred_redmin_vl0sv512hf */

        case 16:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19576; /* pred_redmin_vl0sv1024hf */

        case 17:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19578; /* pred_redmin_vl0sv2048hf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern682 (x2, 
E_RVVM1SFmode))
        {
        case 0:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19538; /* pred_redmin_vl0srvvm8sf */

        case 1:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19540; /* pred_redmin_vl0srvvm4sf */

        case 2:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19542; /* pred_redmin_vl0srvvm2sf */

        case 3:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19544; /* pred_redmin_vl0srvvm1sf */

        case 4:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19546; /* pred_redmin_vl0srvvmf2sf */

        case 5:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19580; /* pred_redmin_vl0sv1sf */

        case 6:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19582; /* pred_redmin_vl0sv2sf */

        case 7:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19584; /* pred_redmin_vl0sv4sf */

        case 8:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19586; /* pred_redmin_vl0sv8sf */

        case 9:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19588; /* pred_redmin_vl0sv16sf */

        case 10:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19590; /* pred_redmin_vl0sv32sf */

        case 11:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19592; /* pred_redmin_vl0sv64sf */

        case 12:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19594; /* pred_redmin_vl0sv128sf */

        case 13:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19596; /* pred_redmin_vl0sv256sf */

        case 14:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19598; /* pred_redmin_vl0sv512sf */

        case 15:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19600; /* pred_redmin_vl0sv1024sf */

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      switch (pattern683 (x2))
        {
        case 0:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19548; /* pred_redmin_vl0srvvm8df */

        case 1:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19550; /* pred_redmin_vl0srvvm4df */

        case 2:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19552; /* pred_redmin_vl0srvvm2df */

        case 3:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19554; /* pred_redmin_vl0srvvm1df */

        case 4:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19602; /* pred_redmin_vl0sv1df */

        case 5:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19604; /* pred_redmin_vl0sv2df */

        case 6:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19606; /* pred_redmin_vl0sv4df */

        case 7:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19608; /* pred_redmin_vl0sv8df */

        case 8:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19610; /* pred_redmin_vl0sv16df */

        case 9:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19612; /* pred_redmin_vl0sv32df */

        case 10:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19614; /* pred_redmin_vl0sv64df */

        case 11:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19616; /* pred_redmin_vl0sv128df */

        case 12:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19618; /* pred_redmin_vl0sv256df */

        case 13:
          if (!(
#line 7889 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19620; /* pred_redmin_vl0sv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18132; /* pred_redxorrvvm8qi */

        case 1:
          if (!
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18140; /* pred_redxorrvvm4qi */

        case 2:
          if (!
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18148; /* pred_redxorrvvm2qi */

        case 3:
          if (!
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18156; /* pred_redxorrvvm1qi */

        case 4:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18260; /* pred_redxorrvvmf2qi */

        case 5:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18268; /* pred_redxorrvvmf4qi */

        case 6:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18276; /* pred_redxorrvvmf8qi */

        case 7:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18308; /* pred_redxorv1qi */

        case 8:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18316; /* pred_redxorv2qi */

        case 9:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18324; /* pred_redxorv4qi */

        case 10:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18332; /* pred_redxorv8qi */

        case 11:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18340; /* pred_redxorv16qi */

        case 12:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18348; /* pred_redxorv32qi */

        case 13:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18356; /* pred_redxorv64qi */

        case 14:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18364; /* pred_redxorv128qi */

        case 15:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18372; /* pred_redxorv256qi */

        case 16:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18380; /* pred_redxorv512qi */

        case 17:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18388; /* pred_redxorv1024qi */

        case 18:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18396; /* pred_redxorv2048qi */

        case 19:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18404; /* pred_redxorv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18164; /* pred_redxorrvvm8hi */

        case 1:
          if (!
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18172; /* pred_redxorrvvm4hi */

        case 2:
          if (!
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18180; /* pred_redxorrvvm2hi */

        case 3:
          if (!
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18188; /* pred_redxorrvvm1hi */

        case 4:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18284; /* pred_redxorrvvmf2hi */

        case 5:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18292; /* pred_redxorrvvmf4hi */

        case 6:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18412; /* pred_redxorv1hi */

        case 7:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18420; /* pred_redxorv2hi */

        case 8:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18428; /* pred_redxorv4hi */

        case 9:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18436; /* pred_redxorv8hi */

        case 10:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18444; /* pred_redxorv16hi */

        case 11:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18452; /* pred_redxorv32hi */

        case 12:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18460; /* pred_redxorv64hi */

        case 13:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18468; /* pred_redxorv128hi */

        case 14:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18476; /* pred_redxorv256hi */

        case 15:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18484; /* pred_redxorv512hi */

        case 16:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18492; /* pred_redxorv1024hi */

        case 17:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18500; /* pred_redxorv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18196; /* pred_redxorrvvm8si */

        case 1:
          if (!
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18204; /* pred_redxorrvvm4si */

        case 2:
          if (!
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18212; /* pred_redxorrvvm2si */

        case 3:
          if (!
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18220; /* pred_redxorrvvm1si */

        case 4:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18300; /* pred_redxorrvvmf2si */

        case 5:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18508; /* pred_redxorv1si */

        case 6:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18516; /* pred_redxorv2si */

        case 7:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18524; /* pred_redxorv4si */

        case 8:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18532; /* pred_redxorv8si */

        case 9:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18540; /* pred_redxorv16si */

        case 10:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18548; /* pred_redxorv32si */

        case 11:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18556; /* pred_redxorv64si */

        case 12:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18564; /* pred_redxorv128si */

        case 13:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18572; /* pred_redxorv256si */

        case 14:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18580; /* pred_redxorv512si */

        case 15:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18588; /* pred_redxorv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18228; /* pred_redxorrvvm8di */

        case 1:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18236; /* pred_redxorrvvm4di */

        case 2:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18244; /* pred_redxorrvvm2di */

        case 3:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18252; /* pred_redxorrvvm1di */

        case 4:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18596; /* pred_redxorv1di */

        case 5:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18604; /* pred_redxorv2di */

        case 6:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18612; /* pred_redxorv4di */

        case 7:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18620; /* pred_redxorv8di */

        case 8:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18628; /* pred_redxorv16di */

        case 9:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18636; /* pred_redxorv32di */

        case 10:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18644; /* pred_redxorv64di */

        case 11:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18652; /* pred_redxorv128di */

        case 12:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18660; /* pred_redxorv256di */

        case 13:
          if (!(
#line 7781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18668; /* pred_redxorv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern681 (x2, 
E_RVVM1HFmode))
        {
        case 0:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19717; /* pred_redosum_vl0srvvm8hf */

        case 1:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19719; /* pred_redosum_vl0srvvm4hf */

        case 2:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19721; /* pred_redosum_vl0srvvm2hf */

        case 3:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19723; /* pred_redosum_vl0srvvm1hf */

        case 4:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19725; /* pred_redosum_vl0srvvmf2hf */

        case 5:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19727; /* pred_redosum_vl0srvvmf4hf */

        case 6:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 19747; /* pred_redosum_vl0sv1hf */

        case 7:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 19749; /* pred_redosum_vl0sv2hf */

        case 8:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 19751; /* pred_redosum_vl0sv4hf */

        case 9:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 19753; /* pred_redosum_vl0sv8hf */

        case 10:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 19755; /* pred_redosum_vl0sv16hf */

        case 11:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19757; /* pred_redosum_vl0sv32hf */

        case 12:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19759; /* pred_redosum_vl0sv64hf */

        case 13:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19761; /* pred_redosum_vl0sv128hf */

        case 14:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19763; /* pred_redosum_vl0sv256hf */

        case 15:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19765; /* pred_redosum_vl0sv512hf */

        case 16:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19767; /* pred_redosum_vl0sv1024hf */

        case 17:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19769; /* pred_redosum_vl0sv2048hf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern682 (x2, 
E_RVVM1SFmode))
        {
        case 0:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19729; /* pred_redosum_vl0srvvm8sf */

        case 1:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19731; /* pred_redosum_vl0srvvm4sf */

        case 2:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19733; /* pred_redosum_vl0srvvm2sf */

        case 3:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19735; /* pred_redosum_vl0srvvm1sf */

        case 4:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19737; /* pred_redosum_vl0srvvmf2sf */

        case 5:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19771; /* pred_redosum_vl0sv1sf */

        case 6:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19773; /* pred_redosum_vl0sv2sf */

        case 7:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19775; /* pred_redosum_vl0sv4sf */

        case 8:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19777; /* pred_redosum_vl0sv8sf */

        case 9:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19779; /* pred_redosum_vl0sv16sf */

        case 10:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19781; /* pred_redosum_vl0sv32sf */

        case 11:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19783; /* pred_redosum_vl0sv64sf */

        case 12:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19785; /* pred_redosum_vl0sv128sf */

        case 13:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19787; /* pred_redosum_vl0sv256sf */

        case 14:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19789; /* pred_redosum_vl0sv512sf */

        case 15:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19791; /* pred_redosum_vl0sv1024sf */

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      switch (pattern683 (x2))
        {
        case 0:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19739; /* pred_redosum_vl0srvvm8df */

        case 1:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19741; /* pred_redosum_vl0srvvm4df */

        case 2:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19743; /* pred_redosum_vl0srvvm2df */

        case 3:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19745; /* pred_redosum_vl0srvvm1df */

        case 4:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19793; /* pred_redosum_vl0sv1df */

        case 5:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19795; /* pred_redosum_vl0sv2df */

        case 6:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19797; /* pred_redosum_vl0sv4df */

        case 7:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19799; /* pred_redosum_vl0sv8df */

        case 8:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19801; /* pred_redosum_vl0sv16df */

        case 9:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19803; /* pred_redosum_vl0sv32df */

        case 10:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19805; /* pred_redosum_vl0sv64df */

        case 11:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19807; /* pred_redosum_vl0sv128df */

        case 12:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19809; /* pred_redosum_vl0sv256df */

        case 13:
          if (!(
#line 7938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19811; /* pred_redosum_vl0sv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern451 (x2))
    {
    case 0:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 940; /* pred_th_whole_movrvvm8qi */

    case 1:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 941; /* pred_th_whole_movrvvm4qi */

    case 2:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 942; /* pred_th_whole_movrvvm2qi */

    case 3:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 943; /* pred_th_whole_movrvvm1qi */

    case 4:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 944; /* pred_th_whole_movrvvm8hi */

    case 5:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 945; /* pred_th_whole_movrvvm4hi */

    case 6:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 946; /* pred_th_whole_movrvvm2hi */

    case 7:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 947; /* pred_th_whole_movrvvm1hi */

    case 8:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 948; /* pred_th_whole_movrvvm8si */

    case 9:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 949; /* pred_th_whole_movrvvm4si */

    case 10:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 950; /* pred_th_whole_movrvvm2si */

    case 11:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 951; /* pred_th_whole_movrvvm1si */

    case 12:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 952; /* pred_th_whole_movrvvm8di */

    case 13:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 953; /* pred_th_whole_movrvvm4di */

    case 14:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 954; /* pred_th_whole_movrvvm2di */

    case 15:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 955; /* pred_th_whole_movrvvm1di */

    case 16:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 956; /* pred_th_whole_movrvvmf8qi */

    case 17:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 957; /* pred_th_whole_movrvvmf4hi */

    case 18:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 958; /* pred_th_whole_movrvvmf2si */

    case 19:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 959; /* pred_th_whole_movrvvm8bf */

    case 20:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 960; /* pred_th_whole_movrvvm4bf */

    case 21:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 961; /* pred_th_whole_movrvvm2bf */

    case 22:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 962; /* pred_th_whole_movrvvm1bf */

    case 23:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 963; /* pred_th_whole_movrvvmf2bf */

    case 24:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 964; /* pred_th_whole_movrvvmf4bf */

    case 25:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 965; /* pred_th_whole_movrvvm8hf */

    case 26:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 966; /* pred_th_whole_movrvvm4hf */

    case 27:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 967; /* pred_th_whole_movrvvm2hf */

    case 28:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 968; /* pred_th_whole_movrvvm1hf */

    case 29:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 969; /* pred_th_whole_movrvvmf2hf */

    case 30:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 970; /* pred_th_whole_movrvvmf4hf */

    case 31:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 971; /* pred_th_whole_movrvvm8sf */

    case 32:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 972; /* pred_th_whole_movrvvm4sf */

    case 33:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 973; /* pred_th_whole_movrvvm2sf */

    case 34:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 974; /* pred_th_whole_movrvvm1sf */

    case 35:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 975; /* pred_th_whole_movrvvmf2sf */

    case 36:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 976; /* pred_th_whole_movrvvm8df */

    case 37:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 977; /* pred_th_whole_movrvvm4df */

    case 38:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 978; /* pred_th_whole_movrvvm2df */

    case 39:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 979; /* pred_th_whole_movrvvm1df */

    case 40:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 980; /* pred_th_whole_movv1qi */

    case 41:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 981; /* pred_th_whole_movv2qi */

    case 42:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 982; /* pred_th_whole_movv4qi */

    case 43:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 983; /* pred_th_whole_movv8qi */

    case 44:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 984; /* pred_th_whole_movv16qi */

    case 45:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 985; /* pred_th_whole_movv32qi */

    case 46:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 986; /* pred_th_whole_movv64qi */

    case 47:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 987; /* pred_th_whole_movv128qi */

    case 48:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 988; /* pred_th_whole_movv256qi */

    case 49:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 989; /* pred_th_whole_movv512qi */

    case 50:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 990; /* pred_th_whole_movv1024qi */

    case 51:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 991; /* pred_th_whole_movv2048qi */

    case 52:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 992; /* pred_th_whole_movv4096qi */

    case 53:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 993; /* pred_th_whole_movv1hi */

    case 54:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 994; /* pred_th_whole_movv2hi */

    case 55:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 995; /* pred_th_whole_movv4hi */

    case 56:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 996; /* pred_th_whole_movv8hi */

    case 57:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 997; /* pred_th_whole_movv16hi */

    case 58:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 998; /* pred_th_whole_movv32hi */

    case 59:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 999; /* pred_th_whole_movv64hi */

    case 60:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1000; /* pred_th_whole_movv128hi */

    case 61:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1001; /* pred_th_whole_movv256hi */

    case 62:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1002; /* pred_th_whole_movv512hi */

    case 63:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1003; /* pred_th_whole_movv1024hi */

    case 64:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1004; /* pred_th_whole_movv2048hi */

    case 65:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 1005; /* pred_th_whole_movv1si */

    case 66:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 1006; /* pred_th_whole_movv2si */

    case 67:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 1007; /* pred_th_whole_movv4si */

    case 68:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 1008; /* pred_th_whole_movv8si */

    case 69:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1009; /* pred_th_whole_movv16si */

    case 70:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1010; /* pred_th_whole_movv32si */

    case 71:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1011; /* pred_th_whole_movv64si */

    case 72:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1012; /* pred_th_whole_movv128si */

    case 73:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1013; /* pred_th_whole_movv256si */

    case 74:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1014; /* pred_th_whole_movv512si */

    case 75:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1015; /* pred_th_whole_movv1024si */

    case 76:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1016; /* pred_th_whole_movv1di */

    case 77:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1017; /* pred_th_whole_movv2di */

    case 78:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1018; /* pred_th_whole_movv4di */

    case 79:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1019; /* pred_th_whole_movv8di */

    case 80:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1020; /* pred_th_whole_movv16di */

    case 81:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1021; /* pred_th_whole_movv32di */

    case 82:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1022; /* pred_th_whole_movv64di */

    case 83:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1023; /* pred_th_whole_movv128di */

    case 84:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1024; /* pred_th_whole_movv256di */

    case 85:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1025; /* pred_th_whole_movv512di */

    case 86:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1026; /* pred_th_whole_movv1hf */

    case 87:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1027; /* pred_th_whole_movv2hf */

    case 88:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1028; /* pred_th_whole_movv4hf */

    case 89:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 275 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1029; /* pred_th_whole_movv8hf */

    case 90:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1030; /* pred_th_whole_movv16hf */

    case 91:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1031; /* pred_th_whole_movv32hf */

    case 92:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 278 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1032; /* pred_th_whole_movv64hf */

    case 93:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 279 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1033; /* pred_th_whole_movv128hf */

    case 94:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1034; /* pred_th_whole_movv256hf */

    case 95:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1035; /* pred_th_whole_movv512hf */

    case 96:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 282 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1036; /* pred_th_whole_movv1024hf */

    case 97:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 283 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1037; /* pred_th_whole_movv2048hf */

    case 98:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1038; /* pred_th_whole_movv1sf */

    case 99:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1039; /* pred_th_whole_movv2sf */

    case 100:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 286 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1040; /* pred_th_whole_movv4sf */

    case 101:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 287 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1041; /* pred_th_whole_movv8sf */

    case 102:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1042; /* pred_th_whole_movv16sf */

    case 103:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1043; /* pred_th_whole_movv32sf */

    case 104:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 290 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1044; /* pred_th_whole_movv64sf */

    case 105:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 291 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1045; /* pred_th_whole_movv128sf */

    case 106:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 292 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1046; /* pred_th_whole_movv256sf */

    case 107:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 293 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1047; /* pred_th_whole_movv512sf */

    case 108:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 294 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1048; /* pred_th_whole_movv1024sf */

    case 109:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 295 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1049; /* pred_th_whole_movv1df */

    case 110:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 296 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1050; /* pred_th_whole_movv2df */

    case 111:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 297 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1051; /* pred_th_whole_movv4df */

    case 112:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 298 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1052; /* pred_th_whole_movv8df */

    case 113:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 299 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1053; /* pred_th_whole_movv16df */

    case 114:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 300 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1054; /* pred_th_whole_movv32df */

    case 115:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 301 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1055; /* pred_th_whole_movv64df */

    case 116:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 302 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1056; /* pred_th_whole_movv128df */

    case 117:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 303 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1057; /* pred_th_whole_movv256df */

    case 118:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 304 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1058; /* pred_th_whole_movv512df */

    case 119:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1059; /* pred_th_whole_movrvvmf8x2qi */

    case 120:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1060; /* pred_th_whole_movrvvmf8x3qi */

    case 121:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1061; /* pred_th_whole_movrvvmf8x4qi */

    case 122:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1062; /* pred_th_whole_movrvvmf8x5qi */

    case 123:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1063; /* pred_th_whole_movrvvmf8x6qi */

    case 124:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1064; /* pred_th_whole_movrvvmf8x7qi */

    case 125:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1173 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1065; /* pred_th_whole_movrvvmf8x8qi */

    case 126:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1174 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1066; /* pred_th_whole_movrvvmf4x2hi */

    case 127:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1175 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1067; /* pred_th_whole_movrvvmf4x3hi */

    case 128:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1068; /* pred_th_whole_movrvvmf4x4hi */

    case 129:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1069; /* pred_th_whole_movrvvmf4x5hi */

    case 130:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1070; /* pred_th_whole_movrvvmf4x6hi */

    case 131:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1179 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1071; /* pred_th_whole_movrvvmf4x7hi */

    case 132:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1072; /* pred_th_whole_movrvvmf4x8hi */

    case 133:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1073; /* pred_th_whole_movrvvmf2x2si */

    case 134:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1182 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1074; /* pred_th_whole_movrvvmf2x3si */

    case 135:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1075; /* pred_th_whole_movrvvmf2x4si */

    case 136:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1076; /* pred_th_whole_movrvvmf2x5si */

    case 137:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1185 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1077; /* pred_th_whole_movrvvmf2x6si */

    case 138:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1186 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1078; /* pred_th_whole_movrvvmf2x7si */

    case 139:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1187 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1079; /* pred_th_whole_movrvvmf2x8si */

    case 140:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1188 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1080; /* pred_th_whole_movrvvm1x2di */

    case 141:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1189 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1081; /* pred_th_whole_movrvvm1x3di */

    case 142:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1190 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1082; /* pred_th_whole_movrvvm1x4di */

    case 143:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1191 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1083; /* pred_th_whole_movrvvm1x5di */

    case 144:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1192 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1084; /* pred_th_whole_movrvvm1x6di */

    case 145:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1193 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1085; /* pred_th_whole_movrvvm1x7di */

    case 146:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1194 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1086; /* pred_th_whole_movrvvm1x8di */

    case 147:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1195 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1087; /* pred_th_whole_movrvvmf4x2bf */

    case 148:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1196 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1088; /* pred_th_whole_movrvvmf4x3bf */

    case 149:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1197 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1089; /* pred_th_whole_movrvvmf4x4bf */

    case 150:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1198 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1090; /* pred_th_whole_movrvvmf4x5bf */

    case 151:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1199 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1091; /* pred_th_whole_movrvvmf4x6bf */

    case 152:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1200 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1092; /* pred_th_whole_movrvvmf4x7bf */

    case 153:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1201 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1093; /* pred_th_whole_movrvvmf4x8bf */

    case 154:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1202 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1094; /* pred_th_whole_movrvvmf4x2hf */

    case 155:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1203 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1095; /* pred_th_whole_movrvvmf4x3hf */

    case 156:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1204 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1096; /* pred_th_whole_movrvvmf4x4hf */

    case 157:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1205 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1097; /* pred_th_whole_movrvvmf4x5hf */

    case 158:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1206 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1098; /* pred_th_whole_movrvvmf4x6hf */

    case 159:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1207 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1099; /* pred_th_whole_movrvvmf4x7hf */

    case 160:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1208 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1100; /* pred_th_whole_movrvvmf4x8hf */

    case 161:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1209 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1101; /* pred_th_whole_movrvvmf2x2sf */

    case 162:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1210 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1102; /* pred_th_whole_movrvvmf2x3sf */

    case 163:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1211 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1103; /* pred_th_whole_movrvvmf2x4sf */

    case 164:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1212 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1104; /* pred_th_whole_movrvvmf2x5sf */

    case 165:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1213 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1105; /* pred_th_whole_movrvvmf2x6sf */

    case 166:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1214 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1106; /* pred_th_whole_movrvvmf2x7sf */

    case 167:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1215 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1107; /* pred_th_whole_movrvvmf2x8sf */

    case 168:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1216 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1108; /* pred_th_whole_movrvvm1x2df */

    case 169:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1217 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1109; /* pred_th_whole_movrvvm1x3df */

    case 170:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1218 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1110; /* pred_th_whole_movrvvm1x4df */

    case 171:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1219 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1111; /* pred_th_whole_movrvvm1x5df */

    case 172:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1220 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1112; /* pred_th_whole_movrvvm1x6df */

    case 173:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1221 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1113; /* pred_th_whole_movrvvm1x7df */

    case 174:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1222 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1114; /* pred_th_whole_movrvvm1x8df */

    case 175:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1115; /* pred_th_whole_movrvvmf4x2qi */

    case 176:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1116; /* pred_th_whole_movrvvmf4x3qi */

    case 177:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1117; /* pred_th_whole_movrvvmf4x4qi */

    case 178:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1118; /* pred_th_whole_movrvvmf4x5qi */

    case 179:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1119; /* pred_th_whole_movrvvmf4x6qi */

    case 180:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1120; /* pred_th_whole_movrvvmf4x7qi */

    case 181:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1121; /* pred_th_whole_movrvvmf4x8qi */

    case 182:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1122; /* pred_th_whole_movrvvmf2x2hi */

    case 183:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1123; /* pred_th_whole_movrvvmf2x3hi */

    case 184:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1124; /* pred_th_whole_movrvvmf2x4hi */

    case 185:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1125; /* pred_th_whole_movrvvmf2x5hi */

    case 186:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1126; /* pred_th_whole_movrvvmf2x6hi */

    case 187:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1127; /* pred_th_whole_movrvvmf2x7hi */

    case 188:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1128; /* pred_th_whole_movrvvmf2x8hi */

    case 189:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1129; /* pred_th_whole_movrvvm1x2si */

    case 190:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1130; /* pred_th_whole_movrvvm1x3si */

    case 191:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1131; /* pred_th_whole_movrvvm1x4si */

    case 192:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1132; /* pred_th_whole_movrvvm1x5si */

    case 193:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1133; /* pred_th_whole_movrvvm1x6si */

    case 194:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1134; /* pred_th_whole_movrvvm1x7si */

    case 195:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1135; /* pred_th_whole_movrvvm1x8si */

    case 196:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1247 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1136; /* pred_th_whole_movrvvm2x2di */

    case 197:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1248 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1137; /* pred_th_whole_movrvvm2x3di */

    case 198:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1249 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1138; /* pred_th_whole_movrvvm2x4di */

    case 199:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1250 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1139; /* pred_th_whole_movrvvmf2x2bf */

    case 200:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1251 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1140; /* pred_th_whole_movrvvmf2x3bf */

    case 201:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1252 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1141; /* pred_th_whole_movrvvmf2x4bf */

    case 202:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1253 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1142; /* pred_th_whole_movrvvmf2x5bf */

    case 203:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1254 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1143; /* pred_th_whole_movrvvmf2x6bf */

    case 204:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1255 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1144; /* pred_th_whole_movrvvmf2x7bf */

    case 205:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1256 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1145; /* pred_th_whole_movrvvmf2x8bf */

    case 206:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1257 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1146; /* pred_th_whole_movrvvmf2x2hf */

    case 207:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1258 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1147; /* pred_th_whole_movrvvmf2x3hf */

    case 208:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1259 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1148; /* pred_th_whole_movrvvmf2x4hf */

    case 209:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1260 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1149; /* pred_th_whole_movrvvmf2x5hf */

    case 210:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1261 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1150; /* pred_th_whole_movrvvmf2x6hf */

    case 211:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1262 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1151; /* pred_th_whole_movrvvmf2x7hf */

    case 212:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1263 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1152; /* pred_th_whole_movrvvmf2x8hf */

    case 213:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1264 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1153; /* pred_th_whole_movrvvm1x2sf */

    case 214:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1265 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1154; /* pred_th_whole_movrvvm1x3sf */

    case 215:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1266 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1155; /* pred_th_whole_movrvvm1x4sf */

    case 216:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1267 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1156; /* pred_th_whole_movrvvm1x5sf */

    case 217:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1268 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1157; /* pred_th_whole_movrvvm1x6sf */

    case 218:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1269 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1158; /* pred_th_whole_movrvvm1x7sf */

    case 219:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1270 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1159; /* pred_th_whole_movrvvm1x8sf */

    case 220:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1271 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1160; /* pred_th_whole_movrvvm2x2df */

    case 221:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1272 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1161; /* pred_th_whole_movrvvm2x3df */

    case 222:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1273 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1162; /* pred_th_whole_movrvvm2x4df */

    case 223:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1163; /* pred_th_whole_movrvvmf2x2qi */

    case 224:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1164; /* pred_th_whole_movrvvmf2x3qi */

    case 225:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1165; /* pred_th_whole_movrvvmf2x4qi */

    case 226:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1166; /* pred_th_whole_movrvvmf2x5qi */

    case 227:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1167; /* pred_th_whole_movrvvmf2x6qi */

    case 228:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1168; /* pred_th_whole_movrvvmf2x7qi */

    case 229:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1169; /* pred_th_whole_movrvvmf2x8qi */

    case 230:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1170; /* pred_th_whole_movrvvm1x2hi */

    case 231:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1171; /* pred_th_whole_movrvvm1x3hi */

    case 232:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1172; /* pred_th_whole_movrvvm1x4hi */

    case 233:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1173; /* pred_th_whole_movrvvm1x5hi */

    case 234:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1174; /* pred_th_whole_movrvvm1x6hi */

    case 235:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1175; /* pred_th_whole_movrvvm1x7hi */

    case 236:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1176; /* pred_th_whole_movrvvm1x8hi */

    case 237:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1177; /* pred_th_whole_movrvvm2x2si */

    case 238:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1178; /* pred_th_whole_movrvvm2x3si */

    case 239:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1179; /* pred_th_whole_movrvvm2x4si */

    case 240:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1294 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1180; /* pred_th_whole_movrvvm4x2di */

    case 241:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1295 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1181; /* pred_th_whole_movrvvm1x2bf */

    case 242:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1296 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1182; /* pred_th_whole_movrvvm1x3bf */

    case 243:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1297 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1183; /* pred_th_whole_movrvvm1x4bf */

    case 244:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1298 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1184; /* pred_th_whole_movrvvm1x5bf */

    case 245:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1299 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1185; /* pred_th_whole_movrvvm1x6bf */

    case 246:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1300 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1186; /* pred_th_whole_movrvvm1x7bf */

    case 247:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1301 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1187; /* pred_th_whole_movrvvm1x8bf */

    case 248:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1302 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1188; /* pred_th_whole_movrvvm1x2hf */

    case 249:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1303 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1189; /* pred_th_whole_movrvvm1x3hf */

    case 250:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1304 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1190; /* pred_th_whole_movrvvm1x4hf */

    case 251:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1305 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1191; /* pred_th_whole_movrvvm1x5hf */

    case 252:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1306 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1192; /* pred_th_whole_movrvvm1x6hf */

    case 253:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1307 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1193; /* pred_th_whole_movrvvm1x7hf */

    case 254:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1308 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1194; /* pred_th_whole_movrvvm1x8hf */

    case 255:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1309 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1195; /* pred_th_whole_movrvvm2x2sf */

    case 256:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1310 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1196; /* pred_th_whole_movrvvm2x3sf */

    case 257:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1311 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1197; /* pred_th_whole_movrvvm2x4sf */

    case 258:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1312 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1198; /* pred_th_whole_movrvvm4x2df */

    case 259:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1199; /* pred_th_whole_movrvvm1x2qi */

    case 260:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1200; /* pred_th_whole_movrvvm1x3qi */

    case 261:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1201; /* pred_th_whole_movrvvm1x4qi */

    case 262:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1202; /* pred_th_whole_movrvvm1x5qi */

    case 263:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1203; /* pred_th_whole_movrvvm1x6qi */

    case 264:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1204; /* pred_th_whole_movrvvm1x7qi */

    case 265:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1205; /* pred_th_whole_movrvvm1x8qi */

    case 266:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1206; /* pred_th_whole_movrvvm2x2hi */

    case 267:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1207; /* pred_th_whole_movrvvm2x3hi */

    case 268:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1208; /* pred_th_whole_movrvvm2x4hi */

    case 269:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1209; /* pred_th_whole_movrvvm4x2si */

    case 270:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1327 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1210; /* pred_th_whole_movrvvm2x2bf */

    case 271:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1328 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1211; /* pred_th_whole_movrvvm2x3bf */

    case 272:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1329 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1212; /* pred_th_whole_movrvvm2x4bf */

    case 273:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1330 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1213; /* pred_th_whole_movrvvm2x2hf */

    case 274:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1331 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1214; /* pred_th_whole_movrvvm2x3hf */

    case 275:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1332 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1215; /* pred_th_whole_movrvvm2x4hf */

    case 276:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1333 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1216; /* pred_th_whole_movrvvm4x2sf */

    case 277:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1217; /* pred_th_whole_movrvvm2x2qi */

    case 278:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1218; /* pred_th_whole_movrvvm2x3qi */

    case 279:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1219; /* pred_th_whole_movrvvm2x4qi */

    case 280:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1220; /* pred_th_whole_movrvvm4x2hi */

    case 281:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1341 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1221; /* pred_th_whole_movrvvm4x2bf */

    case 282:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1342 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1222; /* pred_th_whole_movrvvm4x2hf */

    case 283:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1223; /* pred_th_whole_movrvvm4x2qi */

    case 284:
      if (!(
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1224; /* pred_th_whole_movrvvmf64bi */

    case 285:
      if (!
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1225; /* pred_th_whole_movrvvmf32bi */

    case 286:
      if (!
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1226; /* pred_th_whole_movrvvmf16bi */

    case 287:
      if (!
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1227; /* pred_th_whole_movrvvmf8bi */

    case 288:
      if (!
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1228; /* pred_th_whole_movrvvmf4bi */

    case 289:
      if (!
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1229; /* pred_th_whole_movrvvmf2bi */

    case 290:
      if (!
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1230; /* pred_th_whole_movrvvm1bi */

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[1], E_SImode))
    return -1;
  if (
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
    return 114; /* one_cmplsi2 */
  if (!
#line 1787 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
    return -1;
  return 116; /* *one_cmplsi2_internal */
}

 int
recog_112 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return recog_111 (x1, insn, pnum_clobbers);

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
        return -1;
      return 115; /* one_cmpldi2 */

    case E_RVVMF64BImode:
      if (!register_operand (operands[0], E_RVVMF64BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF64BImode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || !(
#line 580 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25961; /* one_cmplrvvmf64bi2 */

    case E_RVVMF32BImode:
      if (!register_operand (operands[0], E_RVVMF32BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF32BImode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || !
#line 580 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25962; /* one_cmplrvvmf32bi2 */

    case E_RVVMF16BImode:
      if (!register_operand (operands[0], E_RVVMF16BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF16BImode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || !
#line 580 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25963; /* one_cmplrvvmf16bi2 */

    case E_RVVMF8BImode:
      if (!register_operand (operands[0], E_RVVMF8BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8BImode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || !
#line 580 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25964; /* one_cmplrvvmf8bi2 */

    case E_RVVMF4BImode:
      if (!register_operand (operands[0], E_RVVMF4BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4BImode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || !
#line 580 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25965; /* one_cmplrvvmf4bi2 */

    case E_RVVMF2BImode:
      if (!register_operand (operands[0], E_RVVMF2BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2BImode
          || !register_operand (operands[1], E_RVVMF2BImode)
          || !
#line 580 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25966; /* one_cmplrvvmf2bi2 */

    case E_RVVM1BImode:
      if (!register_operand (operands[0], E_RVVM1BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1BImode
          || !register_operand (operands[1], E_RVVM1BImode)
          || !
#line 580 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25967; /* one_cmplrvvm1bi2 */

    case E_V1BImode:
      if (!register_operand (operands[0], E_V1BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1BImode
          || !register_operand (operands[1], E_V1BImode)
          || !(
#line 580 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
        return -1;
      return 25968; /* one_cmplv1bi2 */

    case E_V2BImode:
      if (!register_operand (operands[0], E_V2BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2BImode
          || !register_operand (operands[1], E_V2BImode)
          || !(
#line 580 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
        return -1;
      return 25969; /* one_cmplv2bi2 */

    case E_V4BImode:
      if (!register_operand (operands[0], E_V4BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4BImode
          || !register_operand (operands[1], E_V4BImode)
          || !(
#line 580 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
        return -1;
      return 25970; /* one_cmplv4bi2 */

    case E_V8BImode:
      if (!register_operand (operands[0], E_V8BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8BImode
          || !register_operand (operands[1], E_V8BImode)
          || !(
#line 580 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
        return -1;
      return 25971; /* one_cmplv8bi2 */

    case E_V16BImode:
      if (!register_operand (operands[0], E_V16BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16BImode
          || !register_operand (operands[1], E_V16BImode)
          || !(
#line 580 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
        return -1;
      return 25972; /* one_cmplv16bi2 */

    case E_V32BImode:
      if (!register_operand (operands[0], E_V32BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32BImode
          || !register_operand (operands[1], E_V32BImode)
          || !(
#line 580 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
        return -1;
      return 25973; /* one_cmplv32bi2 */

    case E_V64BImode:
      if (!register_operand (operands[0], E_V64BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64BImode
          || !register_operand (operands[1], E_V64BImode)
          || !(
#line 580 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25974; /* one_cmplv64bi2 */

    case E_V128BImode:
      if (!register_operand (operands[0], E_V128BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128BImode
          || !register_operand (operands[1], E_V128BImode)
          || !(
#line 580 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25975; /* one_cmplv128bi2 */

    case E_V256BImode:
      if (!register_operand (operands[0], E_V256BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256BImode
          || !register_operand (operands[1], E_V256BImode)
          || !(
#line 580 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25976; /* one_cmplv256bi2 */

    case E_V512BImode:
      if (!register_operand (operands[0], E_V512BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512BImode
          || !register_operand (operands[1], E_V512BImode)
          || !(
#line 580 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25977; /* one_cmplv512bi2 */

    case E_V1024BImode:
      if (!register_operand (operands[0], E_V1024BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024BImode
          || !register_operand (operands[1], E_V1024BImode)
          || !(
#line 580 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25978; /* one_cmplv1024bi2 */

    case E_V2048BImode:
      if (!register_operand (operands[0], E_V2048BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048BImode
          || !register_operand (operands[1], E_V2048BImode)
          || !(
#line 580 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25979; /* one_cmplv2048bi2 */

    case E_V4096BImode:
      if (!register_operand (operands[0], E_V4096BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4096BImode
          || !register_operand (operands[1], E_V4096BImode)
          || !(
#line 580 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25980; /* one_cmplv4096bi2 */

    case E_RVVM8QImode:
      if (!register_operand (operands[0], E_RVVM8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8QImode
          || !register_operand (operands[1], E_RVVM8QImode)
          || !
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26900; /* one_cmplrvvm8qi2 */

    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4QImode
          || !register_operand (operands[1], E_RVVM4QImode)
          || !
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26902; /* one_cmplrvvm4qi2 */

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2QImode
          || !register_operand (operands[1], E_RVVM2QImode)
          || !
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26904; /* one_cmplrvvm2qi2 */

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1QImode
          || !register_operand (operands[1], E_RVVM1QImode)
          || !
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26906; /* one_cmplrvvm1qi2 */

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM8HImode)
          || !
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26908; /* one_cmplrvvm8hi2 */

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM4HImode)
          || !
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26910; /* one_cmplrvvm4hi2 */

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM2HImode)
          || !
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26912; /* one_cmplrvvm2hi2 */

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVM1HImode)
          || !
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26914; /* one_cmplrvvm1hi2 */

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8SImode
          || !register_operand (operands[1], E_RVVM8SImode)
          || !
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26916; /* one_cmplrvvm8si2 */

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM4SImode)
          || !
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26918; /* one_cmplrvvm4si2 */

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM2SImode)
          || !
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26920; /* one_cmplrvvm2si2 */

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM1SImode)
          || !
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26922; /* one_cmplrvvm1si2 */

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8DImode
          || !register_operand (operands[1], E_RVVM8DImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26924; /* one_cmplrvvm8di2 */

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4DImode
          || !register_operand (operands[1], E_RVVM4DImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26926; /* one_cmplrvvm4di2 */

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2DImode
          || !register_operand (operands[1], E_RVVM2DImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26928; /* one_cmplrvvm2di2 */

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1DImode
          || !register_operand (operands[1], E_RVVM1DImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26930; /* one_cmplrvvm1di2 */

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2QImode
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 26932; /* one_cmplrvvmf2qi2 */

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4QImode
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 26934; /* one_cmplrvvmf4qi2 */

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8QImode
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26936; /* one_cmplrvvmf8qi2 */

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF2HImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 26938; /* one_cmplrvvmf2hi2 */

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF4HImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26940; /* one_cmplrvvmf4hi2 */

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVMF2SImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26942; /* one_cmplrvvmf2si2 */

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 26944; /* one_cmplv1qi2 */

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 26946; /* one_cmplv2qi2 */

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 26948; /* one_cmplv4qi2 */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 26950; /* one_cmplv8qi2 */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 26952; /* one_cmplv16qi2 */

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 26954; /* one_cmplv32qi2 */

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64QImode
          || !register_operand (operands[1], E_V64QImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26956; /* one_cmplv64qi2 */

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128QImode
          || !register_operand (operands[1], E_V128QImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26958; /* one_cmplv128qi2 */

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256QImode
          || !register_operand (operands[1], E_V256QImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26960; /* one_cmplv256qi2 */

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512QImode
          || !register_operand (operands[1], E_V512QImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26962; /* one_cmplv512qi2 */

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024QImode
          || !register_operand (operands[1], E_V1024QImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26964; /* one_cmplv1024qi2 */

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048QImode
          || !register_operand (operands[1], E_V2048QImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26966; /* one_cmplv2048qi2 */

    case E_V4096QImode:
      if (!register_operand (operands[0], E_V4096QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4096QImode
          || !register_operand (operands[1], E_V4096QImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26968; /* one_cmplv4096qi2 */

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 26970; /* one_cmplv1hi2 */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 26972; /* one_cmplv2hi2 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 26974; /* one_cmplv4hi2 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 26976; /* one_cmplv8hi2 */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 26978; /* one_cmplv16hi2 */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HImode
          || !register_operand (operands[1], E_V32HImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26980; /* one_cmplv32hi2 */

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64HImode
          || !register_operand (operands[1], E_V64HImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26982; /* one_cmplv64hi2 */

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128HImode
          || !register_operand (operands[1], E_V128HImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26984; /* one_cmplv128hi2 */

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256HImode
          || !register_operand (operands[1], E_V256HImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26986; /* one_cmplv256hi2 */

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512HImode
          || !register_operand (operands[1], E_V512HImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26988; /* one_cmplv512hi2 */

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024HImode
          || !register_operand (operands[1], E_V1024HImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26990; /* one_cmplv1024hi2 */

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048HImode
          || !register_operand (operands[1], E_V2048HImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26992; /* one_cmplv2048hi2 */

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 26994; /* one_cmplv1si2 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 26996; /* one_cmplv2si2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 26998; /* one_cmplv4si2 */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 27000; /* one_cmplv8si2 */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16SImode
          || !register_operand (operands[1], E_V16SImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27002; /* one_cmplv16si2 */

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32SImode
          || !register_operand (operands[1], E_V32SImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27004; /* one_cmplv32si2 */

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64SImode
          || !register_operand (operands[1], E_V64SImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27006; /* one_cmplv64si2 */

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128SImode
          || !register_operand (operands[1], E_V128SImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27008; /* one_cmplv128si2 */

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256SImode
          || !register_operand (operands[1], E_V256SImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27010; /* one_cmplv256si2 */

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512SImode
          || !register_operand (operands[1], E_V512SImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27012; /* one_cmplv512si2 */

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024SImode
          || !register_operand (operands[1], E_V1024SImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27014; /* one_cmplv1024si2 */

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27016; /* one_cmplv1di2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27018; /* one_cmplv2di2 */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27020; /* one_cmplv4di2 */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8DImode
          || !register_operand (operands[1], E_V8DImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27022; /* one_cmplv8di2 */

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16DImode
          || !register_operand (operands[1], E_V16DImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27024; /* one_cmplv16di2 */

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32DImode
          || !register_operand (operands[1], E_V32DImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27026; /* one_cmplv32di2 */

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64DImode
          || !register_operand (operands[1], E_V64DImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27028; /* one_cmplv64di2 */

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128DImode
          || !register_operand (operands[1], E_V128DImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27030; /* one_cmplv128di2 */

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256DImode
          || !register_operand (operands[1], E_V256DImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27032; /* one_cmplv256di2 */

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512DImode
          || !register_operand (operands[1], E_V512DImode)
          || !(
#line 1093 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27034; /* one_cmplv512di2 */

    default:
      return -1;
    }
}

 int
recog_214 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2SImode)
      && reg_or_mem_operand (operands[1], E_V2SImode)
      && (
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2SImode)
       || register_operand (operands[1], V2SImode))) && 
#line 4315 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 3203; /* *movv2si */
  if (!register_operand (operands[0], E_V2SImode)
      || !register_operand (operands[1], E_V2SImode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 3362; /* *movv2si_vls */
}

 int
recog_221 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16QImode)
      && reg_or_mem_operand (operands[1], E_V16QImode)
      && (
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16QImode)
       || register_operand (operands[1], V16QImode))) && 
#line 4308 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
    return 3196; /* *movv16qi */
  if (!register_operand (operands[0], E_V16QImode)
      || !register_operand (operands[1], E_V16QImode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
    return -1;
  return 3340; /* *movv16qi_vls */
}

 int
recog_228 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2HFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1342 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3188; /* *movrvvm4x2hf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1342 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3189; /* *movrvvm4x2hf_di */
}

 int
recog_235 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x4HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x4HFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1332 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3174; /* *movrvvm2x4hf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1332 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3175; /* *movrvvm2x4hf_di */
}

 int
recog_242 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x4HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x4HImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3160; /* *movrvvm2x4hi_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3161; /* *movrvvm2x4hi_di */
}

 int
recog_249 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x4QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x4QImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3146; /* *movrvvm1x4qi_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3147; /* *movrvvm1x4qi_di */
}

 int
recog_256 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x8HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x8HFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1308 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3132; /* *movrvvm1x8hf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1308 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3133; /* *movrvvm1x8hf_di */
}

 int
recog_263 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x8BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x8BFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1301 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3118; /* *movrvvm1x8bf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1301 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3119; /* *movrvvm1x8bf_di */
}

 int
recog_271 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x4SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x4SImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3102; /* *movrvvm2x4si_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3103; /* *movrvvm2x4si_di */
}

 int
recog_278 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x4HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x4HImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3088; /* *movrvvm1x4hi_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3089; /* *movrvvm1x4hi_di */
}

 int
recog_286 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x3QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x3QImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3072; /* *movrvvmf2x3qi_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3073; /* *movrvvmf2x3qi_di */
}

 int
recog_294 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x5SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x5SFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1267 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3056; /* *movrvvm1x5sf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1267 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3057; /* *movrvvm1x5sf_di */
}

 int
recog_302 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x4HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x4HFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1259 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3040; /* *movrvvmf2x4hf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1259 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3041; /* *movrvvmf2x4hf_di */
}

 int
recog_310 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x3BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x3BFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1251 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3024; /* *movrvvmf2x3bf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1251 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3025; /* *movrvvmf2x3bf_di */
}

 int
recog_318 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x5SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x5SImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3008; /* *movrvvm1x5si_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3009; /* *movrvvm1x5si_di */
}

 int
recog_325 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x5HImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x5HImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2994; /* *movrvvmf2x5hi_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2995; /* *movrvvmf2x5hi_di */
}

 int
recog_333 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x4QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x4QImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2978; /* *movrvvmf4x4qi_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2979; /* *movrvvmf4x4qi_di */
}

 int
recog_341 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x3DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x3DFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1217 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2962; /* *movrvvm1x3df_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1217 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2963; /* *movrvvm1x3df_di */
}

 int
recog_349 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x2SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x2SFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1209 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2946; /* *movrvvmf2x2sf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1209 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2947; /* *movrvvmf2x2sf_di */
}

 int
recog_357 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x8BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x8BFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1201 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2930; /* *movrvvmf4x8bf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1201 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2931; /* *movrvvmf4x8bf_di */
}

 int
recog_365 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x7DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x7DImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1193 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2914; /* *movrvvm1x7di_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1193 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2915; /* *movrvvm1x7di_di */
}

 int
recog_373 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x6SImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x6SImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1185 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2898; /* *movrvvmf2x6si_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1185 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2899; /* *movrvvmf2x6si_di */
}

 int
recog_381 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern328 (x2))
    {
    case 0:
      return 297; /* *ashrsi3 */

    case 1:
      if (!
#line 2914 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 300; /* ashrdi3 */

    case 2:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25494; /* ashrrvvm8qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM8QImode)
          || !
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25698; /* vashrrvvm8qi3 */

    case 3:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25497; /* ashrrvvm4qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM4QImode)
          || !
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25701; /* vashrrvvm4qi3 */

    case 4:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25500; /* ashrrvvm2qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM2QImode)
          || !
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25704; /* vashrrvvm2qi3 */

    case 5:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25503; /* ashrrvvm1qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM1QImode)
          || !
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25707; /* vashrrvvm1qi3 */

    case 6:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25506; /* ashrrvvm8hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM8HImode)
          || !
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25710; /* vashrrvvm8hi3 */

    case 7:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25509; /* ashrrvvm4hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM4HImode)
          || !
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25713; /* vashrrvvm4hi3 */

    case 8:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25512; /* ashrrvvm2hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM2HImode)
          || !
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25716; /* vashrrvvm2hi3 */

    case 9:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25515; /* ashrrvvm1hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM1HImode)
          || !
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25719; /* vashrrvvm1hi3 */

    case 10:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25518; /* ashrrvvm8si3 */
      if (!vector_shift_operand (operands[2], E_RVVM8SImode)
          || !
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25722; /* vashrrvvm8si3 */

    case 11:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25521; /* ashrrvvm4si3 */
      if (!vector_shift_operand (operands[2], E_RVVM4SImode)
          || !
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25725; /* vashrrvvm4si3 */

    case 12:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25524; /* ashrrvvm2si3 */
      if (!vector_shift_operand (operands[2], E_RVVM2SImode)
          || !
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25728; /* vashrrvvm2si3 */

    case 13:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25527; /* ashrrvvm1si3 */
      if (!vector_shift_operand (operands[2], E_RVVM1SImode)
          || !
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25731; /* vashrrvvm1si3 */

    case 14:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 25530; /* ashrrvvm8di3 */
      if (!vector_shift_operand (operands[2], E_RVVM8DImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25734; /* vashrrvvm8di3 */

    case 15:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 25533; /* ashrrvvm4di3 */
      if (!vector_shift_operand (operands[2], E_RVVM4DImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25737; /* vashrrvvm4di3 */

    case 16:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 25536; /* ashrrvvm2di3 */
      if (!vector_shift_operand (operands[2], E_RVVM2DImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25740; /* vashrrvvm2di3 */

    case 17:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 25539; /* ashrrvvm1di3 */
      if (!vector_shift_operand (operands[2], E_RVVM1DImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25743; /* vashrrvvm1di3 */

    case 18:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 25542; /* ashrrvvmf2qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2QImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25746; /* vashrrvvmf2qi3 */

    case 19:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 25545; /* ashrrvvmf4qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF4QImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25749; /* vashrrvvmf4qi3 */

    case 20:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 25548; /* ashrrvvmf8qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF8QImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25752; /* vashrrvvmf8qi3 */

    case 21:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 25551; /* ashrrvvmf2hi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2HImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25755; /* vashrrvvmf2hi3 */

    case 22:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 25554; /* ashrrvvmf4hi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF4HImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25758; /* vashrrvvmf4hi3 */

    case 23:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 25557; /* ashrrvvmf2si3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2SImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25761; /* vashrrvvmf2si3 */

    case 24:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 25560; /* ashrv1qi3 */
      if (!vector_shift_operand (operands[2], E_V1QImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 25764; /* vashrv1qi3 */

    case 25:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 25563; /* ashrv2qi3 */
      if (!vector_shift_operand (operands[2], E_V2QImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 25767; /* vashrv2qi3 */

    case 26:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 25566; /* ashrv4qi3 */
      if (!vector_shift_operand (operands[2], E_V4QImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 25770; /* vashrv4qi3 */

    case 27:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 25569; /* ashrv8qi3 */
      if (!vector_shift_operand (operands[2], E_V8QImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 25773; /* vashrv8qi3 */

    case 28:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 25572; /* ashrv16qi3 */
      if (!vector_shift_operand (operands[2], E_V16QImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 25776; /* vashrv16qi3 */

    case 29:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 25575; /* ashrv32qi3 */
      if (!vector_shift_operand (operands[2], E_V32QImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 25779; /* vashrv32qi3 */

    case 30:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 25578; /* ashrv64qi3 */
      if (!vector_shift_operand (operands[2], E_V64QImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25782; /* vashrv64qi3 */

    case 31:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 25581; /* ashrv128qi3 */
      if (!vector_shift_operand (operands[2], E_V128QImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25785; /* vashrv128qi3 */

    case 32:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 25584; /* ashrv256qi3 */
      if (!vector_shift_operand (operands[2], E_V256QImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25788; /* vashrv256qi3 */

    case 33:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 25587; /* ashrv512qi3 */
      if (!vector_shift_operand (operands[2], E_V512QImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25791; /* vashrv512qi3 */

    case 34:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 25590; /* ashrv1024qi3 */
      if (!vector_shift_operand (operands[2], E_V1024QImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25794; /* vashrv1024qi3 */

    case 35:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 25593; /* ashrv2048qi3 */
      if (!vector_shift_operand (operands[2], E_V2048QImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25797; /* vashrv2048qi3 */

    case 36:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 25596; /* ashrv4096qi3 */
      if (!vector_shift_operand (operands[2], E_V4096QImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25800; /* vashrv4096qi3 */

    case 37:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 25599; /* ashrv1hi3 */
      if (!vector_shift_operand (operands[2], E_V1HImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25803; /* vashrv1hi3 */

    case 38:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 25602; /* ashrv2hi3 */
      if (!vector_shift_operand (operands[2], E_V2HImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25806; /* vashrv2hi3 */

    case 39:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 25605; /* ashrv4hi3 */
      if (!vector_shift_operand (operands[2], E_V4HImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25809; /* vashrv4hi3 */

    case 40:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 25608; /* ashrv8hi3 */
      if (!vector_shift_operand (operands[2], E_V8HImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25812; /* vashrv8hi3 */

    case 41:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 25611; /* ashrv16hi3 */
      if (!vector_shift_operand (operands[2], E_V16HImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25815; /* vashrv16hi3 */

    case 42:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 25614; /* ashrv32hi3 */
      if (!vector_shift_operand (operands[2], E_V32HImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25818; /* vashrv32hi3 */

    case 43:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 25617; /* ashrv64hi3 */
      if (!vector_shift_operand (operands[2], E_V64HImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25821; /* vashrv64hi3 */

    case 44:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 25620; /* ashrv128hi3 */
      if (!vector_shift_operand (operands[2], E_V128HImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25824; /* vashrv128hi3 */

    case 45:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 25623; /* ashrv256hi3 */
      if (!vector_shift_operand (operands[2], E_V256HImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25827; /* vashrv256hi3 */

    case 46:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 25626; /* ashrv512hi3 */
      if (!vector_shift_operand (operands[2], E_V512HImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25830; /* vashrv512hi3 */

    case 47:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 25629; /* ashrv1024hi3 */
      if (!vector_shift_operand (operands[2], E_V1024HImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25833; /* vashrv1024hi3 */

    case 48:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 25632; /* ashrv2048hi3 */
      if (!vector_shift_operand (operands[2], E_V2048HImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25836; /* vashrv2048hi3 */

    case 49:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 25635; /* ashrv1si3 */
      if (!vector_shift_operand (operands[2], E_V1SImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25839; /* vashrv1si3 */

    case 50:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 25638; /* ashrv2si3 */
      if (!vector_shift_operand (operands[2], E_V2SImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25842; /* vashrv2si3 */

    case 51:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 25641; /* ashrv4si3 */
      if (!vector_shift_operand (operands[2], E_V4SImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25845; /* vashrv4si3 */

    case 52:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 25644; /* ashrv8si3 */
      if (!vector_shift_operand (operands[2], E_V8SImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25848; /* vashrv8si3 */

    case 53:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 25647; /* ashrv16si3 */
      if (!vector_shift_operand (operands[2], E_V16SImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25851; /* vashrv16si3 */

    case 54:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 25650; /* ashrv32si3 */
      if (!vector_shift_operand (operands[2], E_V32SImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25854; /* vashrv32si3 */

    case 55:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 25653; /* ashrv64si3 */
      if (!vector_shift_operand (operands[2], E_V64SImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25857; /* vashrv64si3 */

    case 56:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 25656; /* ashrv128si3 */
      if (!vector_shift_operand (operands[2], E_V128SImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25860; /* vashrv128si3 */

    case 57:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 25659; /* ashrv256si3 */
      if (!vector_shift_operand (operands[2], E_V256SImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25863; /* vashrv256si3 */

    case 58:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 25662; /* ashrv512si3 */
      if (!vector_shift_operand (operands[2], E_V512SImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25866; /* vashrv512si3 */

    case 59:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 25665; /* ashrv1024si3 */
      if (!vector_shift_operand (operands[2], E_V1024SImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25869; /* vashrv1024si3 */

    case 60:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 25668; /* ashrv1di3 */
      if (!vector_shift_operand (operands[2], E_V1DImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25872; /* vashrv1di3 */

    case 61:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 25671; /* ashrv2di3 */
      if (!vector_shift_operand (operands[2], E_V2DImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25875; /* vashrv2di3 */

    case 62:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 25674; /* ashrv4di3 */
      if (!vector_shift_operand (operands[2], E_V4DImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25878; /* vashrv4di3 */

    case 63:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 25677; /* ashrv8di3 */
      if (!vector_shift_operand (operands[2], E_V8DImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25881; /* vashrv8di3 */

    case 64:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 25680; /* ashrv16di3 */
      if (!vector_shift_operand (operands[2], E_V16DImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25884; /* vashrv16di3 */

    case 65:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 25683; /* ashrv32di3 */
      if (!vector_shift_operand (operands[2], E_V32DImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25887; /* vashrv32di3 */

    case 66:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 25686; /* ashrv64di3 */
      if (!vector_shift_operand (operands[2], E_V64DImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25890; /* vashrv64di3 */

    case 67:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 25689; /* ashrv128di3 */
      if (!vector_shift_operand (operands[2], E_V128DImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25893; /* vashrv128di3 */

    case 68:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 25692; /* ashrv256di3 */
      if (!vector_shift_operand (operands[2], E_V256DImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25896; /* vashrv256di3 */

    case 69:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 25695; /* ashrv512di3 */
      if (!vector_shift_operand (operands[2], E_V512DImode)
          || !(
#line 533 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25899; /* vashrv512di3 */

    default:
      return -1;
    }
}

 int
recog_402 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern481 (x2))
    {
    case 0:
      if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33508; /* pred_crypto_vvsm4rvsrvvm8si */
      if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33568; /* pred_crypto_vvsm4rvsx1rvvm8si_scalar */

    case 1:
      if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33628; /* pred_crypto_vvsm4rvsx2rvvm4si_scalar */

    case 2:
      if (!
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33676; /* pred_crypto_vvsm4rvsx4rvvm2si_scalar */

    case 3:
      if (!
#line 574 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33712; /* pred_crypto_vvsm4rvsx8rvvm1si_scalar */

    case 4:
      if (!(
#line 592 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4419 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33736; /* pred_crypto_vvsm4rvsx16rvvmf2si_scalar */

    case 5:
      if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33520; /* pred_crypto_vvsm4rvsrvvm4si */
      if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33580; /* pred_crypto_vvsm4rvsx1rvvm4si_scalar */

    case 6:
      if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33640; /* pred_crypto_vvsm4rvsx2rvvm2si_scalar */

    case 7:
      if (!
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33688; /* pred_crypto_vvsm4rvsx4rvvm1si_scalar */

    case 8:
      if (!(
#line 574 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4415 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33724; /* pred_crypto_vvsm4rvsx8rvvmf2si_scalar */

    case 9:
      if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33532; /* pred_crypto_vvsm4rvsrvvm2si */
      if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33592; /* pred_crypto_vvsm4rvsx1rvvm2si_scalar */

    case 10:
      if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33652; /* pred_crypto_vvsm4rvsx2rvvm1si_scalar */

    case 11:
      if (!(
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4411 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33700; /* pred_crypto_vvsm4rvsx4rvvmf2si_scalar */

    case 12:
      if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33544; /* pred_crypto_vvsm4rvsrvvm1si */
      if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33604; /* pred_crypto_vvsm4rvsx1rvvm1si_scalar */

    case 13:
      if (!(
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4407 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33664; /* pred_crypto_vvsm4rvsx2rvvmf2si_scalar */

    case 14:
      if ((
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4403 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 33556; /* pred_crypto_vvsm4rvsrvvmf2si */
      if (!(
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4403 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33616; /* pred_crypto_vvsm4rvsx1rvvmf2si_scalar */

    default:
      return -1;
    }
}

 int
recog_405 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern481 (x2))
    {
    case 0:
      if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33505; /* pred_crypto_vvaesdmvsrvvm8si */
      if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33565; /* pred_crypto_vvaesdmvsx1rvvm8si_scalar */

    case 1:
      if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33625; /* pred_crypto_vvaesdmvsx2rvvm4si_scalar */

    case 2:
      if (!
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33673; /* pred_crypto_vvaesdmvsx4rvvm2si_scalar */

    case 3:
      if (!
#line 574 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33709; /* pred_crypto_vvaesdmvsx8rvvm1si_scalar */

    case 4:
      if (!(
#line 592 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4419 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33733; /* pred_crypto_vvaesdmvsx16rvvmf2si_scalar */

    case 5:
      if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33517; /* pred_crypto_vvaesdmvsrvvm4si */
      if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33577; /* pred_crypto_vvaesdmvsx1rvvm4si_scalar */

    case 6:
      if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33637; /* pred_crypto_vvaesdmvsx2rvvm2si_scalar */

    case 7:
      if (!
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33685; /* pred_crypto_vvaesdmvsx4rvvm1si_scalar */

    case 8:
      if (!(
#line 574 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4415 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33721; /* pred_crypto_vvaesdmvsx8rvvmf2si_scalar */

    case 9:
      if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33529; /* pred_crypto_vvaesdmvsrvvm2si */
      if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33589; /* pred_crypto_vvaesdmvsx1rvvm2si_scalar */

    case 10:
      if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33649; /* pred_crypto_vvaesdmvsx2rvvm1si_scalar */

    case 11:
      if (!(
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4411 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33697; /* pred_crypto_vvaesdmvsx4rvvmf2si_scalar */

    case 12:
      if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33541; /* pred_crypto_vvaesdmvsrvvm1si */
      if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33601; /* pred_crypto_vvaesdmvsx1rvvm1si_scalar */

    case 13:
      if (!(
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4407 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33661; /* pred_crypto_vvaesdmvsx2rvvmf2si_scalar */

    case 14:
      if ((
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4403 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 33553; /* pred_crypto_vvaesdmvsrvvmf2si */
      if (!(
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4403 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33613; /* pred_crypto_vvaesdmvsx1rvvmf2si_scalar */

    default:
      return -1;
    }
}

 int
recog_409 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  if (!vector_length_operand (x4, E_VOIDmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!const_int_operand (x5, E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[3] = x7;
      operands[5] = x4;
      operands[6] = x5;
      x8 = XVECEXP (x3, 0, 2);
      operands[7] = x8;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      x10 = XEXP (x6, 2);
      operands[4] = x10;
      x11 = XEXP (x2, 2);
      operands[1] = x11;
      return recog_397 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      operands[5] = x4;
      operands[6] = x5;
      x8 = XVECEXP (x3, 0, 2);
      operands[7] = x8;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      x10 = XEXP (x6, 2);
      operands[4] = x10;
      x11 = XEXP (x2, 2);
      operands[1] = x11;
      x12 = XEXP (x7, 0);
      switch (GET_CODE (x12))
        {
        case REG:
        case SUBREG:
          operands[3] = x12;
          return recog_398 (x1, insn, pnum_clobbers);

        case SIGN_EXTEND:
          if (GET_MODE (x12) != E_DImode)
            return -1;
          x13 = XEXP (x12, 0);
          operands[3] = x13;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8DImode:
              if (pattern684 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
                  || !(
#line 2104 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4033; /* *pred_mergervvm8di_extended_scalar */

            case E_RVVM4DImode:
              if (pattern684 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
                  || !(
#line 2104 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4034; /* *pred_mergervvm4di_extended_scalar */

            case E_RVVM2DImode:
              if (pattern684 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
                  || !(
#line 2104 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4035; /* *pred_mergervvm2di_extended_scalar */

            case E_RVVM1DImode:
              if (pattern684 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 2104 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4036; /* *pred_mergervvm1di_extended_scalar */

            case E_V1DImode:
              if (pattern684 (x2, 
E_V1DImode, 
E_V1BImode) != 0
                  || !(
#line 2104 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4037; /* *pred_mergev1di_extended_scalar */

            case E_V2DImode:
              if (pattern684 (x2, 
E_V2DImode, 
E_V2BImode) != 0
                  || !(
#line 2104 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4038; /* *pred_mergev2di_extended_scalar */

            case E_V4DImode:
              if (pattern684 (x2, 
E_V4DImode, 
E_V4BImode) != 0
                  || !(
#line 2104 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4039; /* *pred_mergev4di_extended_scalar */

            case E_V8DImode:
              if (pattern684 (x2, 
E_V8DImode, 
E_V8BImode) != 0
                  || !(
#line 2104 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 4040; /* *pred_mergev8di_extended_scalar */

            case E_V16DImode:
              if (pattern684 (x2, 
E_V16DImode, 
E_V16BImode) != 0
                  || !(
#line 2104 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 4041; /* *pred_mergev16di_extended_scalar */

            case E_V32DImode:
              if (pattern684 (x2, 
E_V32DImode, 
E_V32BImode) != 0
                  || !(
#line 2104 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 4042; /* *pred_mergev32di_extended_scalar */

            case E_V64DImode:
              if (pattern684 (x2, 
E_V64DImode, 
E_V64BImode) != 0
                  || !(
#line 2104 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 4043; /* *pred_mergev64di_extended_scalar */

            case E_V128DImode:
              if (pattern684 (x2, 
E_V128DImode, 
E_V128BImode) != 0
                  || !(
#line 2104 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 4044; /* *pred_mergev128di_extended_scalar */

            case E_V256DImode:
              if (pattern684 (x2, 
E_V256DImode, 
E_V256BImode) != 0
                  || !(
#line 2104 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 4045; /* *pred_mergev256di_extended_scalar */

            case E_V512DImode:
              if (pattern684 (x2, 
E_V512DImode, 
E_V512BImode) != 0
                  || !(
#line 2104 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 4046; /* *pred_mergev512di_extended_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern472 (x2))
        {
        case 0:
          if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28608; /* *cond_len_extendrvvm4qirvvm8hi */

        case 1:
          if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28610; /* *cond_len_extendrvvm2qirvvm4hi */

        case 2:
          if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28612; /* *cond_len_extendrvvm1qirvvm2hi */

        case 3:
          if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28614; /* *cond_len_extendrvvmf2qirvvm1hi */

        case 4:
          if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28616; /* *cond_len_extendrvvmf4qirvvmf2hi */

        case 5:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28618; /* *cond_len_extendrvvmf8qirvvmf4hi */

        case 6:
          if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28620; /* *cond_len_extendrvvm4hirvvm8si */

        case 7:
          if (!
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28704; /* *cond_len_extendrvvm2qirvvm8si */

        case 8:
          if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28622; /* *cond_len_extendrvvm2hirvvm4si */

        case 9:
          if (!
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28706; /* *cond_len_extendrvvm1qirvvm4si */

        case 10:
          if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28624; /* *cond_len_extendrvvm1hirvvm2si */

        case 11:
          if (!
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28708; /* *cond_len_extendrvvmf2qirvvm2si */

        case 12:
          if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28626; /* *cond_len_extendrvvmf2hirvvm1si */

        case 13:
          if (!
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28710; /* *cond_len_extendrvvmf4qirvvm1si */

        case 14:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28628; /* *cond_len_extendrvvmf4hirvvmf2si */

        case 15:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1106 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28712; /* *cond_len_extendrvvmf8qirvvmf2si */

        case 16:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28630; /* *cond_len_extendrvvm4sirvvm8di */

        case 17:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28714; /* *cond_len_extendrvvm2hirvvm8di */

        case 18:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1151 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28764; /* *cond_len_extendrvvm1qirvvm8di */

        case 19:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28632; /* *cond_len_extendrvvm2sirvvm4di */

        case 20:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28716; /* *cond_len_extendrvvm1hirvvm4di */

        case 21:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1151 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28766; /* *cond_len_extendrvvmf2qirvvm4di */

        case 22:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28634; /* *cond_len_extendrvvm1sirvvm2di */

        case 23:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28718; /* *cond_len_extendrvvmf2hirvvm2di */

        case 24:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1152 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28768; /* *cond_len_extendrvvmf4qirvvm2di */

        case 25:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28636; /* *cond_len_extendrvvmf2sirvvm1di */

        case 26:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28720; /* *cond_len_extendrvvmf4hirvvm1di */

        case 27:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1152 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28770; /* *cond_len_extendrvvmf8qirvvm1di */

        case 28:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 28638; /* *cond_len_extendv1qiv1hi */

        case 29:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 28640; /* *cond_len_extendv2qiv2hi */

        case 30:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 28642; /* *cond_len_extendv4qiv4hi */

        case 31:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 28644; /* *cond_len_extendv8qiv8hi */

        case 32:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 28646; /* *cond_len_extendv16qiv16hi */

        case 33:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28648; /* *cond_len_extendv32qiv32hi */

        case 34:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28650; /* *cond_len_extendv64qiv64hi */

        case 35:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28652; /* *cond_len_extendv128qiv128hi */

        case 36:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28654; /* *cond_len_extendv256qiv256hi */

        case 37:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28656; /* *cond_len_extendv512qiv512hi */

        case 38:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28658; /* *cond_len_extendv1024qiv1024hi */

        case 39:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28660; /* *cond_len_extendv2048qiv2048hi */

        case 40:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 28662; /* *cond_len_extendv1hiv1si */

        case 41:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1111 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 28722; /* *cond_len_extendv1qiv1si */

        case 42:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 28664; /* *cond_len_extendv2hiv2si */

        case 43:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1112 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 28724; /* *cond_len_extendv2qiv2si */

        case 44:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 28666; /* *cond_len_extendv4hiv4si */

        case 45:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1113 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 28726; /* *cond_len_extendv4qiv4si */

        case 46:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 28668; /* *cond_len_extendv8hiv8si */

        case 47:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1114 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 28728; /* *cond_len_extendv8qiv8si */

        case 48:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28670; /* *cond_len_extendv16hiv16si */

        case 49:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1115 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28730; /* *cond_len_extendv16qiv16si */

        case 50:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28672; /* *cond_len_extendv32hiv32si */

        case 51:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1116 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28732; /* *cond_len_extendv32qiv32si */

        case 52:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28674; /* *cond_len_extendv64hiv64si */

        case 53:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1117 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28734; /* *cond_len_extendv64qiv64si */

        case 54:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28676; /* *cond_len_extendv128hiv128si */

        case 55:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1118 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28736; /* *cond_len_extendv128qiv128si */

        case 56:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28678; /* *cond_len_extendv256hiv256si */

        case 57:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1119 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28738; /* *cond_len_extendv256qiv256si */

        case 58:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28680; /* *cond_len_extendv512hiv512si */

        case 59:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1120 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28740; /* *cond_len_extendv512qiv512si */

        case 60:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28682; /* *cond_len_extendv1024hiv1024si */

        case 61:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1121 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28742; /* *cond_len_extendv1024qiv1024si */

        case 62:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28684; /* *cond_len_extendv1siv1di */

        case 63:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1122 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28744; /* *cond_len_extendv1hiv1di */

        case 64:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1154 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28772; /* *cond_len_extendv1qiv1di */

        case 65:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28686; /* *cond_len_extendv2siv2di */

        case 66:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1123 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28746; /* *cond_len_extendv2hiv2di */

        case 67:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1155 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28774; /* *cond_len_extendv2qiv2di */

        case 68:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28688; /* *cond_len_extendv4siv4di */

        case 69:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1124 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28748; /* *cond_len_extendv4hiv4di */

        case 70:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1156 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28776; /* *cond_len_extendv4qiv4di */

        case 71:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28690; /* *cond_len_extendv8siv8di */

        case 72:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1125 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28750; /* *cond_len_extendv8hiv8di */

        case 73:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1157 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28778; /* *cond_len_extendv8qiv8di */

        case 74:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28692; /* *cond_len_extendv16siv16di */

        case 75:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1126 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28752; /* *cond_len_extendv16hiv16di */

        case 76:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1158 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28780; /* *cond_len_extendv16qiv16di */

        case 77:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28694; /* *cond_len_extendv32siv32di */

        case 78:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1127 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28754; /* *cond_len_extendv32hiv32di */

        case 79:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1159 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28782; /* *cond_len_extendv32qiv32di */

        case 80:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28696; /* *cond_len_extendv64siv64di */

        case 81:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1128 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28756; /* *cond_len_extendv64hiv64di */

        case 82:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1160 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28784; /* *cond_len_extendv64qiv64di */

        case 83:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28698; /* *cond_len_extendv128siv128di */

        case 84:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1129 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28758; /* *cond_len_extendv128hiv128di */

        case 85:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1161 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28786; /* *cond_len_extendv128qiv128di */

        case 86:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28700; /* *cond_len_extendv256siv256di */

        case 87:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1130 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28760; /* *cond_len_extendv256hiv256di */

        case 88:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1162 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28788; /* *cond_len_extendv256qiv256di */

        case 89:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28702; /* *cond_len_extendv512siv512di */

        case 90:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1131 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28762; /* *cond_len_extendv512hiv512di */

        case 91:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1163 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28790; /* *cond_len_extendv512qiv512di */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      return recog_399 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      operands[4] = x4;
      operands[5] = x5;
      x8 = XVECEXP (x3, 0, 2);
      operands[6] = x8;
      x12 = XEXP (x7, 0);
      operands[2] = x12;
      x9 = XEXP (x6, 1);
      operands[1] = x9;
      x10 = XEXP (x6, 2);
      operands[3] = x10;
      x11 = XEXP (x2, 2);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SFmode:
          if (pattern470 (x2, 
E_RVVMF4BImode, 
E_RVVM8SFmode, 
E_RVVM4HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 990 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28870; /* *cond_len_extendrvvm4hfrvvm8sf */

        case E_RVVM4SFmode:
          if (pattern470 (x2, 
E_RVVMF8BImode, 
E_RVVM4SFmode, 
E_RVVM2HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 991 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28871; /* *cond_len_extendrvvm2hfrvvm4sf */

        case E_RVVM2SFmode:
          if (pattern470 (x2, 
E_RVVMF16BImode, 
E_RVVM2SFmode, 
E_RVVM1HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 992 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28872; /* *cond_len_extendrvvm1hfrvvm2sf */

        case E_RVVM1SFmode:
          if (pattern470 (x2, 
E_RVVMF32BImode, 
E_RVVM1SFmode, 
E_RVVMF2HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 993 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28873; /* *cond_len_extendrvvmf2hfrvvm1sf */

        case E_RVVMF2SFmode:
          if (pattern470 (x2, 
E_RVVMF64BImode, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 994 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28874; /* *cond_len_extendrvvmf4hfrvvmf2sf */

        case E_RVVM8DFmode:
          if (pattern470 (x2, 
E_RVVMF8BImode, 
E_RVVM8DFmode, 
E_RVVM4SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 996 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28875; /* *cond_len_extendrvvm4sfrvvm8df */

        case E_RVVM4DFmode:
          if (pattern470 (x2, 
E_RVVMF16BImode, 
E_RVVM4DFmode, 
E_RVVM2SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 996 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28876; /* *cond_len_extendrvvm2sfrvvm4df */

        case E_RVVM2DFmode:
          if (pattern470 (x2, 
E_RVVMF32BImode, 
E_RVVM2DFmode, 
E_RVVM1SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 997 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28877; /* *cond_len_extendrvvm1sfrvvm2df */

        case E_RVVM1DFmode:
          if (pattern470 (x2, 
E_RVVMF64BImode, 
E_RVVM1DFmode, 
E_RVVMF2SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 997 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28878; /* *cond_len_extendrvvmf2sfrvvm1df */

        case E_V1SFmode:
          if (pattern470 (x2, 
E_V1BImode, 
E_V1SFmode, 
E_V1HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 999 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28879; /* *cond_len_extendv1hfv1sf */

        case E_V2SFmode:
          if (pattern470 (x2, 
E_V2BImode, 
E_V2SFmode, 
E_V2HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1000 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28880; /* *cond_len_extendv2hfv2sf */

        case E_V4SFmode:
          if (pattern470 (x2, 
E_V4BImode, 
E_V4SFmode, 
E_V4HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1001 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28881; /* *cond_len_extendv4hfv4sf */

        case E_V8SFmode:
          if (pattern470 (x2, 
E_V8BImode, 
E_V8SFmode, 
E_V8HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1002 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28882; /* *cond_len_extendv8hfv8sf */

        case E_V16SFmode:
          if (pattern470 (x2, 
E_V16BImode, 
E_V16SFmode, 
E_V16HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1003 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28883; /* *cond_len_extendv16hfv16sf */

        case E_V32SFmode:
          if (pattern470 (x2, 
E_V32BImode, 
E_V32SFmode, 
E_V32HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1004 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28884; /* *cond_len_extendv32hfv32sf */

        case E_V64SFmode:
          if (pattern470 (x2, 
E_V64BImode, 
E_V64SFmode, 
E_V64HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1005 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28885; /* *cond_len_extendv64hfv64sf */

        case E_V128SFmode:
          if (pattern470 (x2, 
E_V128BImode, 
E_V128SFmode, 
E_V128HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1006 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28886; /* *cond_len_extendv128hfv128sf */

        case E_V256SFmode:
          if (pattern470 (x2, 
E_V256BImode, 
E_V256SFmode, 
E_V256HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1007 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28887; /* *cond_len_extendv256hfv256sf */

        case E_V512SFmode:
          if (pattern470 (x2, 
E_V512BImode, 
E_V512SFmode, 
E_V512HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1008 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28888; /* *cond_len_extendv512hfv512sf */

        case E_V1024SFmode:
          if (pattern470 (x2, 
E_V1024BImode, 
E_V1024SFmode, 
E_V1024HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1009 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28889; /* *cond_len_extendv1024hfv1024sf */

        case E_V1DFmode:
          if (pattern470 (x2, 
E_V1BImode, 
E_V1DFmode, 
E_V1SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1010 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28890; /* *cond_len_extendv1sfv1df */

        case E_V2DFmode:
          if (pattern470 (x2, 
E_V2BImode, 
E_V2DFmode, 
E_V2SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1011 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28891; /* *cond_len_extendv2sfv2df */

        case E_V4DFmode:
          if (pattern470 (x2, 
E_V4BImode, 
E_V4DFmode, 
E_V4SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1012 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28892; /* *cond_len_extendv4sfv4df */

        case E_V8DFmode:
          if (pattern470 (x2, 
E_V8BImode, 
E_V8DFmode, 
E_V8SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1013 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28893; /* *cond_len_extendv8sfv8df */

        case E_V16DFmode:
          if (pattern470 (x2, 
E_V16BImode, 
E_V16DFmode, 
E_V16SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1014 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28894; /* *cond_len_extendv16sfv16df */

        case E_V32DFmode:
          if (pattern470 (x2, 
E_V32BImode, 
E_V32DFmode, 
E_V32SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1015 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28895; /* *cond_len_extendv32sfv32df */

        case E_V64DFmode:
          if (pattern470 (x2, 
E_V64BImode, 
E_V64DFmode, 
E_V64SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1016 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28896; /* *cond_len_extendv64sfv64df */

        case E_V128DFmode:
          if (pattern470 (x2, 
E_V128BImode, 
E_V128DFmode, 
E_V128SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1017 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28897; /* *cond_len_extendv128sfv128df */

        case E_V256DFmode:
          if (pattern470 (x2, 
E_V256BImode, 
E_V256DFmode, 
E_V256SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1018 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28898; /* *cond_len_extendv256sfv256df */

        case E_V512DFmode:
          if (pattern470 (x2, 
E_V512BImode, 
E_V512DFmode, 
E_V512SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1019 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28899; /* *cond_len_extendv512sfv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_476 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V16HImode, 
E_V16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V16BImode)
      && vector_const_0_operand (operands[3], E_V16HImode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return 4291; /* *pred_broadcastv16hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V16HImode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return -1;
  return 4413; /* *pred_broadcastv16hi_imm */
}

 int
recog_483 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1024BImode)
      && vector_const_0_operand (operands[3], E_V1024QImode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
    return 4284; /* *pred_broadcastv1024qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1024BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1024QImode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 4406; /* *pred_broadcastv1024qi_imm */
}

 int
recog_491 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V4QImode, 
E_V4BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V4BImode)
      && vector_const_0_operand (operands[3], E_V4QImode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
    return 4276; /* *pred_broadcastv4qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V4BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V4QImode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
    return -1;
  return 4398; /* *pred_broadcastv4qi_imm */
}

 int
recog_499 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF32BImode)
      && vector_const_0_operand (operands[3], E_RVVM1SFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 4268; /* *pred_broadcastrvvm1sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM1SFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 4390; /* *pred_broadcastrvvm1sf_imm */
}

 int
recog_506 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF8BImode)
      && vector_const_0_operand (operands[3], E_RVVM2HFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return 4261; /* *pred_broadcastrvvm2hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM2HFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4383; /* *pred_broadcastrvvm2hf_imm */
}

 int
recog_514 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V128DFmode, 
E_V128BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V128DImode)
      && (
#line 8239 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 302 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return 20702; /* pred_gatherv128df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 302 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 20824; /* pred_gatherv128df_scalar */
}

 int
recog_519 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V4DFmode, 
E_V4BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V4DImode)
      && (
#line 8239 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 20697; /* pred_gatherv4df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 20819; /* pred_gatherv4df_scalar */
}

 int
recog_523 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V512SFmode, 
E_V512BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V512SImode)
      && (
#line 8239 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 293 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return 20693; /* pred_gatherv512sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 293 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 20815; /* pred_gatherv512sf_scalar */
}

 int
recog_528 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V16SFmode, 
E_V16BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V16SImode)
      && (
#line 8239 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return 20688; /* pred_gatherv16sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 20810; /* pred_gatherv16sf_scalar */
}

 int
recog_535 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V512HFmode, 
E_V512BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V512HImode)
      && (
#line 8239 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
    return 20681; /* pred_gatherv512hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 20803; /* pred_gatherv512hf_scalar */
}

 int
recog_540 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V16HFmode, 
E_V16BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V16HImode)
      && (
#line 8239 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 20676; /* pred_gatherv16hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 20798; /* pred_gatherv16hf_scalar */
}

 int
recog_543 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V2HFmode, 
E_V2BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V2HImode)
      && (
#line 8239 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 20673; /* pred_gatherv2hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 20795; /* pred_gatherv2hf_scalar */
}

 int
recog_548 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V64DImode, 
E_V64BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V64DImode)
      && (
#line 8239 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return 20668; /* pred_gatherv64di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 20790; /* pred_gatherv64di_scalar */
}

 int
recog_553 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V2DImode, 
E_V2BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V2DImode)
      && (
#line 8239 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return 20663; /* pred_gatherv2di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 20785; /* pred_gatherv2di_scalar */
}

 int
recog_558 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V128SImode, 
E_V128BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V128SImode)
      && (
#line 8239 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return 20658; /* pred_gatherv128si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 20780; /* pred_gatherv128si_scalar */
}

 int
recog_563 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V4SImode, 
E_V4BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V4SImode)
      && (
#line 8239 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 20653; /* pred_gatherv4si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 20775; /* pred_gatherv4si_scalar */
}

 int
recog_568 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V512HImode, 
E_V512BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V512HImode)
      && (
#line 8239 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return 20648; /* pred_gatherv512hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 20770; /* pred_gatherv512hi_scalar */
}

 int
recog_573 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V16HImode, 
E_V16BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V16HImode)
      && (
#line 8239 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return 20643; /* pred_gatherv16hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return -1;
  return 20765; /* pred_gatherv16hi_scalar */
}

 int
recog_579 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V2048QImode)
      && (
#line 8239 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return 20637; /* pred_gatherv2048qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 20759; /* pred_gatherv2048qi_scalar */
}

 int
recog_584 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V64QImode, 
E_V64BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V64QImode)
      && (
#line 8239 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return 20632; /* pred_gatherv64qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 20754; /* pred_gatherv64qi_scalar */
}

 int
recog_588 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V4QImode, 
E_V4BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V4QImode)
      && (
#line 8239 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
    return 20628; /* pred_gatherv4qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
    return -1;
  return 20750; /* pred_gatherv4qi_scalar */
}

 int
recog_593 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_RVVM4DImode)
      && (
#line 8239 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 20623; /* pred_gatherrvvm4df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 20745; /* pred_gatherrvvm4df_scalar */
}

 int
recog_598 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern558 (x2))
    {
    case 0:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8089; /* pred_mulhsurvvm8qi */

    case 1:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8092; /* pred_mulhsurvvm4qi */

    case 2:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8095; /* pred_mulhsurvvm2qi */

    case 3:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8098; /* pred_mulhsurvvm1qi */

    case 4:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8101; /* pred_mulhsurvvmf2qi */

    case 5:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8104; /* pred_mulhsurvvmf4qi */

    case 6:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 502 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8107; /* pred_mulhsurvvmf8qi */

    case 7:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8110; /* pred_mulhsurvvm8hi */

    case 8:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8113; /* pred_mulhsurvvm4hi */

    case 9:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8116; /* pred_mulhsurvvm2hi */

    case 10:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8119; /* pred_mulhsurvvm1hi */

    case 11:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8122; /* pred_mulhsurvvmf2hi */

    case 12:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 504 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8125; /* pred_mulhsurvvmf4hi */

    case 13:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8128; /* pred_mulhsurvvm8si */

    case 14:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8131; /* pred_mulhsurvvm4si */

    case 15:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8134; /* pred_mulhsurvvm2si */

    case 16:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8137; /* pred_mulhsurvvm1si */

    case 17:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 506 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8140; /* pred_mulhsurvvmf2si */

    case 18:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 508 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8143; /* pred_mulhsurvvm8di */

    case 19:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 508 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8146; /* pred_mulhsurvvm4di */

    case 20:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 508 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8149; /* pred_mulhsurvvm2di */

    case 21:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 508 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8152; /* pred_mulhsurvvm1di */

    case 22:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 8155; /* pred_mulhsuv1qi */

    case 23:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 8158; /* pred_mulhsuv2qi */

    case 24:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 8161; /* pred_mulhsuv4qi */

    case 25:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 8164; /* pred_mulhsuv8qi */

    case 26:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 8167; /* pred_mulhsuv16qi */

    case 27:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 8170; /* pred_mulhsuv32qi */

    case 28:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8173; /* pred_mulhsuv64qi */

    case 29:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 517 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8176; /* pred_mulhsuv128qi */

    case 30:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8179; /* pred_mulhsuv256qi */

    case 31:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8182; /* pred_mulhsuv512qi */

    case 32:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8185; /* pred_mulhsuv1024qi */

    case 33:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8188; /* pred_mulhsuv2048qi */

    case 34:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8191; /* pred_mulhsuv4096qi */

    case 35:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 8194; /* pred_mulhsuv1hi */

    case 36:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 8197; /* pred_mulhsuv2hi */

    case 37:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 8200; /* pred_mulhsuv4hi */

    case 38:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 8203; /* pred_mulhsuv8hi */

    case 39:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 8206; /* pred_mulhsuv16hi */

    case 40:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8209; /* pred_mulhsuv32hi */

    case 41:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8212; /* pred_mulhsuv64hi */

    case 42:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8215; /* pred_mulhsuv128hi */

    case 43:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 531 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8218; /* pred_mulhsuv256hi */

    case 44:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 532 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8221; /* pred_mulhsuv512hi */

    case 45:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 533 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8224; /* pred_mulhsuv1024hi */

    case 46:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 534 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8227; /* pred_mulhsuv2048hi */

    case 47:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 535 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 8230; /* pred_mulhsuv1si */

    case 48:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 536 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 8233; /* pred_mulhsuv2si */

    case 49:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 537 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 8236; /* pred_mulhsuv4si */

    case 50:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 538 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 8239; /* pred_mulhsuv8si */

    case 51:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 539 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8242; /* pred_mulhsuv16si */

    case 52:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 540 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8245; /* pred_mulhsuv32si */

    case 53:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 541 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8248; /* pred_mulhsuv64si */

    case 54:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 542 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8251; /* pred_mulhsuv128si */

    case 55:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 543 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8254; /* pred_mulhsuv256si */

    case 56:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 544 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8257; /* pred_mulhsuv512si */

    case 57:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 545 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8260; /* pred_mulhsuv1024si */

    case 58:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 546 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)))
        return -1;
      return 8263; /* pred_mulhsuv1di */

    case 59:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 547 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)))
        return -1;
      return 8266; /* pred_mulhsuv2di */

    case 60:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 548 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)))
        return -1;
      return 8269; /* pred_mulhsuv4di */

    case 61:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 549 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8272; /* pred_mulhsuv8di */

    case 62:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 550 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8275; /* pred_mulhsuv16di */

    case 63:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 551 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8278; /* pred_mulhsuv32di */

    case 64:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 552 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8281; /* pred_mulhsuv64di */

    case 65:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 553 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8284; /* pred_mulhsuv128di */

    case 66:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 554 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8287; /* pred_mulhsuv256di */

    case 67:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 555 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8290; /* pred_mulhsuv512di */

    case 68:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8293; /* pred_mulhsurvvm8qi_scalar */

    case 69:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8296; /* pred_mulhsurvvm4qi_scalar */

    case 70:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8299; /* pred_mulhsurvvm2qi_scalar */

    case 71:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8302; /* pred_mulhsurvvm1qi_scalar */

    case 72:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8305; /* pred_mulhsurvvmf2qi_scalar */

    case 73:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8308; /* pred_mulhsurvvmf4qi_scalar */

    case 74:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8311; /* pred_mulhsurvvmf8qi_scalar */

    case 75:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8314; /* pred_mulhsurvvm8hi_scalar */

    case 76:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8317; /* pred_mulhsurvvm4hi_scalar */

    case 77:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8320; /* pred_mulhsurvvm2hi_scalar */

    case 78:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8323; /* pred_mulhsurvvm1hi_scalar */

    case 79:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8326; /* pred_mulhsurvvmf2hi_scalar */

    case 80:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8329; /* pred_mulhsurvvmf4hi_scalar */

    case 81:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8332; /* pred_mulhsurvvm8si_scalar */

    case 82:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8335; /* pred_mulhsurvvm4si_scalar */

    case 83:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8338; /* pred_mulhsurvvm2si_scalar */

    case 84:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8341; /* pred_mulhsurvvm1si_scalar */

    case 85:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8344; /* pred_mulhsurvvmf2si_scalar */

    case 86:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 8347; /* pred_mulhsuv1qi_scalar */

    case 87:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 8350; /* pred_mulhsuv2qi_scalar */

    case 88:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 8353; /* pred_mulhsuv4qi_scalar */

    case 89:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 8356; /* pred_mulhsuv8qi_scalar */

    case 90:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 8359; /* pred_mulhsuv16qi_scalar */

    case 91:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 8362; /* pred_mulhsuv32qi_scalar */

    case 92:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8365; /* pred_mulhsuv64qi_scalar */

    case 93:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8368; /* pred_mulhsuv128qi_scalar */

    case 94:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8371; /* pred_mulhsuv256qi_scalar */

    case 95:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8374; /* pred_mulhsuv512qi_scalar */

    case 96:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8377; /* pred_mulhsuv1024qi_scalar */

    case 97:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8380; /* pred_mulhsuv2048qi_scalar */

    case 98:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8383; /* pred_mulhsuv4096qi_scalar */

    case 99:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 8386; /* pred_mulhsuv1hi_scalar */

    case 100:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 8389; /* pred_mulhsuv2hi_scalar */

    case 101:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 8392; /* pred_mulhsuv4hi_scalar */

    case 102:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 8395; /* pred_mulhsuv8hi_scalar */

    case 103:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 8398; /* pred_mulhsuv16hi_scalar */

    case 104:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8401; /* pred_mulhsuv32hi_scalar */

    case 105:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8404; /* pred_mulhsuv64hi_scalar */

    case 106:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8407; /* pred_mulhsuv128hi_scalar */

    case 107:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8410; /* pred_mulhsuv256hi_scalar */

    case 108:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8413; /* pred_mulhsuv512hi_scalar */

    case 109:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8416; /* pred_mulhsuv1024hi_scalar */

    case 110:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8419; /* pred_mulhsuv2048hi_scalar */

    case 111:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 8422; /* pred_mulhsuv1si_scalar */

    case 112:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 8425; /* pred_mulhsuv2si_scalar */

    case 113:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 8428; /* pred_mulhsuv4si_scalar */

    case 114:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 8431; /* pred_mulhsuv8si_scalar */

    case 115:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8434; /* pred_mulhsuv16si_scalar */

    case 116:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8437; /* pred_mulhsuv32si_scalar */

    case 117:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8440; /* pred_mulhsuv64si_scalar */

    case 118:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8443; /* pred_mulhsuv128si_scalar */

    case 119:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8446; /* pred_mulhsuv256si_scalar */

    case 120:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8449; /* pred_mulhsuv512si_scalar */

    case 121:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8452; /* pred_mulhsuv1024si_scalar */

    case 122:
      if (!(
#line 3149 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 790 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8455; /* *pred_mulhsurvvm8di_scalar */

    case 123:
      if (!(
#line 3149 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 790 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8458; /* *pred_mulhsurvvm4di_scalar */

    case 124:
      if (!(
#line 3149 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 791 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8461; /* *pred_mulhsurvvm2di_scalar */

    case 125:
      if (!(
#line 3149 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 791 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8464; /* *pred_mulhsurvvm1di_scalar */

    case 126:
      if (!(
#line 3171 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 790 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8467; /* *pred_mulhsurvvm8di_extended_scalar */

    case 127:
      if (!(
#line 3171 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 790 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8470; /* *pred_mulhsurvvm4di_extended_scalar */

    case 128:
      if (!(
#line 3171 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 791 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8473; /* *pred_mulhsurvvm2di_extended_scalar */

    case 129:
      if (!(
#line 3171 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 791 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8476; /* *pred_mulhsurvvm1di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_605 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern604 (x2))
    {
    case 0:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32945; /* pred_vbrevrvvm8qi */

    case 1:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32948; /* pred_vbrevrvvm4qi */

    case 2:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32951; /* pred_vbrevrvvm2qi */

    case 3:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32954; /* pred_vbrevrvvm1qi */

    case 4:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32957; /* pred_vbrevrvvm8hi */

    case 5:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32960; /* pred_vbrevrvvm4hi */

    case 6:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32963; /* pred_vbrevrvvm2hi */

    case 7:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32966; /* pred_vbrevrvvm1hi */

    case 8:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32969; /* pred_vbrevrvvm8si */

    case 9:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32972; /* pred_vbrevrvvm4si */

    case 10:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32975; /* pred_vbrevrvvm2si */

    case 11:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32978; /* pred_vbrevrvvm1si */

    case 12:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32981; /* pred_vbrevrvvm8di */

    case 13:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32984; /* pred_vbrevrvvm4di */

    case 14:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32987; /* pred_vbrevrvvm2di */

    case 15:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32990; /* pred_vbrevrvvm1di */

    case 16:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 32993; /* pred_vbrevrvvmf2qi */

    case 17:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 32996; /* pred_vbrevrvvmf4qi */

    case 18:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 32999; /* pred_vbrevrvvmf8qi */

    case 19:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 33002; /* pred_vbrevrvvmf2hi */

    case 20:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 33005; /* pred_vbrevrvvmf4hi */

    case 21:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 33008; /* pred_vbrevrvvmf2si */

    case 22:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 33011; /* pred_vbrevv1qi */

    case 23:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 33014; /* pred_vbrevv2qi */

    case 24:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 33017; /* pred_vbrevv4qi */

    case 25:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 33020; /* pred_vbrevv8qi */

    case 26:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 33023; /* pred_vbrevv16qi */

    case 27:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 33026; /* pred_vbrevv32qi */

    case 28:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33029; /* pred_vbrevv64qi */

    case 29:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33032; /* pred_vbrevv128qi */

    case 30:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33035; /* pred_vbrevv256qi */

    case 31:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33038; /* pred_vbrevv512qi */

    case 32:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33041; /* pred_vbrevv1024qi */

    case 33:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33044; /* pred_vbrevv2048qi */

    case 34:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33047; /* pred_vbrevv4096qi */

    case 35:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 33050; /* pred_vbrevv1hi */

    case 36:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 33053; /* pred_vbrevv2hi */

    case 37:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 33056; /* pred_vbrevv4hi */

    case 38:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 33059; /* pred_vbrevv8hi */

    case 39:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 33062; /* pred_vbrevv16hi */

    case 40:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33065; /* pred_vbrevv32hi */

    case 41:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33068; /* pred_vbrevv64hi */

    case 42:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33071; /* pred_vbrevv128hi */

    case 43:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33074; /* pred_vbrevv256hi */

    case 44:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33077; /* pred_vbrevv512hi */

    case 45:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33080; /* pred_vbrevv1024hi */

    case 46:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33083; /* pred_vbrevv2048hi */

    case 47:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 33086; /* pred_vbrevv1si */

    case 48:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 33089; /* pred_vbrevv2si */

    case 49:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 33092; /* pred_vbrevv4si */

    case 50:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 33095; /* pred_vbrevv8si */

    case 51:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33098; /* pred_vbrevv16si */

    case 52:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33101; /* pred_vbrevv32si */

    case 53:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33104; /* pred_vbrevv64si */

    case 54:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33107; /* pred_vbrevv128si */

    case 55:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33110; /* pred_vbrevv256si */

    case 56:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33113; /* pred_vbrevv512si */

    case 57:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33116; /* pred_vbrevv1024si */

    case 58:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33119; /* pred_vbrevv1di */

    case 59:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33122; /* pred_vbrevv2di */

    case 60:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33125; /* pred_vbrevv4di */

    case 61:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33128; /* pred_vbrevv8di */

    case 62:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33131; /* pred_vbrevv16di */

    case 63:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33134; /* pred_vbrevv32di */

    case 64:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33137; /* pred_vbrevv64di */

    case 65:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33140; /* pred_vbrevv128di */

    case 66:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33143; /* pred_vbrevv256di */

    case 67:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33146; /* pred_vbrevv512di */

    default:
      return -1;
    }
}

 int
recog_621 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM8DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM8DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM8DImode)
      || !(
#line 5331 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13093; /* *pred_mul_plusrvvm8di_undef */
}

 int
recog_625 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVMF2QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVMF2QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVMF2QImode)
      || !(
#line 5331 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
    return -1;
  return 13097; /* *pred_mul_plusrvvmf2qi_undef */
}

 int
recog_629 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVMF4HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVMF4HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVMF4HImode)
      || !(
#line 5331 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return -1;
  return 13101; /* *pred_mul_plusrvvmf4hi_undef */
}

 int
recog_633 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V4QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V4QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V4QImode)
      || !(
#line 5331 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
    return -1;
  return 13105; /* *pred_mul_plusv4qi_undef */
}

 int
recog_637 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V64QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V64QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V64QImode)
      || !(
#line 5331 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13109; /* *pred_mul_plusv64qi_undef */
}

 int
recog_642 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V2048QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V2048QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V2048QImode)
      || !(
#line 5331 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13114; /* *pred_mul_plusv2048qi_undef */
}

 int
recog_647 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V8HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V8HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V8HImode)
      || !(
#line 5331 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return -1;
  return 13119; /* *pred_mul_plusv8hi_undef */
}

 int
recog_652 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V256HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V256HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V256HImode)
      || !(
#line 5331 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13124; /* *pred_mul_plusv256hi_undef */
}

 int
recog_657 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V2SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V2SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V2SImode)
      || !(
#line 5331 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 13129; /* *pred_mul_plusv2si_undef */
}

 int
recog_662 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V64SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V64SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V64SImode)
      || !(
#line 5331 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13134; /* *pred_mul_plusv64si_undef */
}

 int
recog_668 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V2DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V2DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V2DImode)
      || !(
#line 5331 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13140; /* *pred_mul_plusv2di_undef */
}

 int
recog_674 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V128DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V128DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V128DImode)
      || !(
#line 5331 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13146; /* *pred_mul_plusv128di_undef */
}

 int
recog_680 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V64DImode, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_673 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V64DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return 13213; /* *pred_maddv64di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13281; /* *pred_maccv64di */
}

 int
recog_686 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_667 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V1DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 13207; /* *pred_maddv1di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13275; /* *pred_maccv1di */
}

 int
recog_693 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V16SImode, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_660 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V16SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 13200; /* *pred_maddv16si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13268; /* *pred_maccv16si */
}

 int
recog_700 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V512HImode, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_653 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V512HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return 13193; /* *pred_maddv512hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13261; /* *pred_maccv512hi */
}

 int
recog_707 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V4HImode, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_646 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V4HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return 13186; /* *pred_maddv4hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return -1;
  return 13254; /* *pred_maccv4hi */
}

 int
recog_714 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V256QImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_639 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V256QImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return 13179; /* *pred_maddv256qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13247; /* *pred_maccv256qi */
}

 int
recog_721 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V32DImode, 
E_V32BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return 13348; /* *pred_maddv32di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13416; /* *pred_maccv32di_scalar */
}

 int
recog_728 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return 13341; /* *pred_maddv512si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13409; /* *pred_maccv512si_scalar */
}

 int
recog_735 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 13334; /* *pred_maddv4si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 13402; /* *pred_maccv4si_scalar */
}

 int
recog_742 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return 13327; /* *pred_maddv128hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13395; /* *pred_maccv128hi_scalar */
}

 int
recog_749 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 1);
  operands[2] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  x11 = XEXP (x8, 0);
  x12 = XEXP (x11, 0);
  x13 = XEXP (x12, 0);
  switch (GET_CODE (x13))
    {
    case REG:
    case SUBREG:
      operands[3] = x13;
      x14 = XEXP (x11, 1);
      switch (GET_CODE (x14))
        {
        case ZERO_EXTEND:
          switch (pattern703 (x2))
            {
            case 0:
              if (!
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13818; /* pred_widen_mul_plusurvvm8hi */

            case 1:
              if (!
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13820; /* pred_widen_mul_plusurvvm4hi */

            case 2:
              if (!
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13822; /* pred_widen_mul_plusurvvm2hi */

            case 3:
              if (!
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13824; /* pred_widen_mul_plusurvvm1hi */

            case 4:
              if (!
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13826; /* pred_widen_mul_plusurvvmf2hi */

            case 5:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13828; /* pred_widen_mul_plusurvvmf4hi */

            case 6:
              if (!
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13830; /* pred_widen_mul_plusurvvm8si */

            case 7:
              if (!
#line 41 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
                return -1;
              return 32548; /* pred_matrix_mul_plusurvvm8si_qoq */

            case 8:
              if (!
#line 113 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
                return -1;
              return 32564; /* pred_matrix_mul_plusurvvm8si_dod */

            case 9:
              if (!
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13832; /* pred_widen_mul_plusurvvm4si */

            case 10:
              if (!
#line 41 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
                return -1;
              return 32550; /* pred_matrix_mul_plusurvvm4si_qoq */

            case 11:
              if (!
#line 113 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
                return -1;
              return 32566; /* pred_matrix_mul_plusurvvm4si_dod */

            case 12:
              if (!
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13834; /* pred_widen_mul_plusurvvm2si */

            case 13:
              if (!
#line 41 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
                return -1;
              return 32552; /* pred_matrix_mul_plusurvvm2si_qoq */

            case 14:
              if (!
#line 113 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
                return -1;
              return 32568; /* pred_matrix_mul_plusurvvm2si_dod */

            case 15:
              if (!
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13836; /* pred_widen_mul_plusurvvm1si */

            case 16:
              if (!
#line 41 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
                return -1;
              return 32554; /* pred_matrix_mul_plusurvvm1si_qoq */

            case 17:
              if (!
#line 113 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
                return -1;
              return 32570; /* pred_matrix_mul_plusurvvm1si_dod */

            case 18:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13838; /* pred_widen_mul_plusurvvmf2si */

            case 19:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13840; /* pred_widen_mul_plusurvvm8di */

            case 20:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13842; /* pred_widen_mul_plusurvvm4di */

            case 21:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13844; /* pred_widen_mul_plusurvvm2di */

            case 22:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13846; /* pred_widen_mul_plusurvvm1di */

            case 23:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 13848; /* pred_widen_mul_plusuv1hi */

            case 24:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 13850; /* pred_widen_mul_plusuv2hi */

            case 25:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 13852; /* pred_widen_mul_plusuv4hi */

            case 26:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 13854; /* pred_widen_mul_plusuv8hi */

            case 27:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 13856; /* pred_widen_mul_plusuv16hi */

            case 28:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 13858; /* pred_widen_mul_plusuv32hi */

            case 29:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 13860; /* pred_widen_mul_plusuv64hi */

            case 30:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 13862; /* pred_widen_mul_plusuv128hi */

            case 31:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 13864; /* pred_widen_mul_plusuv256hi */

            case 32:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 13866; /* pred_widen_mul_plusuv512hi */

            case 33:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 13868; /* pred_widen_mul_plusuv1024hi */

            case 34:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 13870; /* pred_widen_mul_plusuv2048hi */

            case 35:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 13872; /* pred_widen_mul_plusuv1si */

            case 36:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 13874; /* pred_widen_mul_plusuv2si */

            case 37:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 13876; /* pred_widen_mul_plusuv4si */

            case 38:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 13878; /* pred_widen_mul_plusuv8si */

            case 39:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 13880; /* pred_widen_mul_plusuv16si */

            case 40:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 13882; /* pred_widen_mul_plusuv32si */

            case 41:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 13884; /* pred_widen_mul_plusuv64si */

            case 42:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 13886; /* pred_widen_mul_plusuv128si */

            case 43:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 13888; /* pred_widen_mul_plusuv256si */

            case 44:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 13890; /* pred_widen_mul_plusuv512si */

            case 45:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 13892; /* pred_widen_mul_plusuv1024si */

            case 46:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13894; /* pred_widen_mul_plusuv1di */

            case 47:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13896; /* pred_widen_mul_plusuv2di */

            case 48:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13898; /* pred_widen_mul_plusuv4di */

            case 49:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 13900; /* pred_widen_mul_plusuv8di */

            case 50:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 13902; /* pred_widen_mul_plusuv16di */

            case 51:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 13904; /* pred_widen_mul_plusuv32di */

            case 52:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 13906; /* pred_widen_mul_plusuv64di */

            case 53:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 13908; /* pred_widen_mul_plusuv128di */

            case 54:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 13910; /* pred_widen_mul_plusuv256di */

            case 55:
              if (!(
#line 5884 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 13912; /* pred_widen_mul_plusuv512di */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          x15 = XEXP (x14, 0);
          operands[4] = x15;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SImode:
              if (pattern731 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
                return -1;
              switch (GET_MODE (operands[4]))
                {
                case E_RVVM4QImode:
                  if (!register_operand (operands[4], E_RVVM4QImode)
                      || !
#line 89 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
                    return -1;
                  return 32559; /* pred_matrix_mul_plususrvvm8si_qoq */

                case E_RVVM8QImode:
                  if (!register_operand (operands[4], E_RVVM8QImode)
                      || !
#line 161 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
                    return -1;
                  return 32575; /* pred_matrix_mul_plususrvvm8si_dod */

                default:
                  return -1;
                }

            case E_RVVM4SImode:
              if (pattern731 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
                return -1;
              switch (GET_MODE (operands[4]))
                {
                case E_RVVM2QImode:
                  if (!register_operand (operands[4], E_RVVM2QImode)
                      || !
#line 89 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
                    return -1;
                  return 32560; /* pred_matrix_mul_plususrvvm4si_qoq */

                case E_RVVM4QImode:
                  if (!register_operand (operands[4], E_RVVM4QImode)
                      || !
#line 161 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
                    return -1;
                  return 32576; /* pred_matrix_mul_plususrvvm4si_dod */

                default:
                  return -1;
                }

            case E_RVVM2SImode:
              if (pattern731 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
                return -1;
              switch (GET_MODE (operands[4]))
                {
                case E_RVVM1QImode:
                  if (!register_operand (operands[4], E_RVVM1QImode)
                      || !
#line 89 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
                    return -1;
                  return 32561; /* pred_matrix_mul_plususrvvm2si_qoq */

                case E_RVVM2QImode:
                  if (!register_operand (operands[4], E_RVVM2QImode)
                      || !
#line 161 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
                    return -1;
                  return 32577; /* pred_matrix_mul_plususrvvm2si_dod */

                default:
                  return -1;
                }

            case E_RVVM1SImode:
              if (pattern731 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
                return -1;
              switch (GET_MODE (operands[4]))
                {
                case E_RVVMF2QImode:
                  if (!register_operand (operands[4], E_RVVMF2QImode)
                      || !
#line 89 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
                    return -1;
                  return 32562; /* pred_matrix_mul_plususrvvm1si_qoq */

                case E_RVVM1QImode:
                  if (!register_operand (operands[4], E_RVVM1QImode)
                      || !
#line 161 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
                    return -1;
                  return 32578; /* pred_matrix_mul_plususrvvm1si_dod */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x16 = XEXP (x13, 0);
      operands[3] = x16;
      x14 = XEXP (x11, 1);
      switch (GET_CODE (x14))
        {
        case ZERO_EXTEND:
          switch (pattern705 (x2))
            {
            case 0:
              if (!
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13914; /* pred_widen_mul_plusurvvm8hi_scalar */

            case 1:
              if (!
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13916; /* pred_widen_mul_plusurvvm4hi_scalar */

            case 2:
              if (!
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13918; /* pred_widen_mul_plusurvvm2hi_scalar */

            case 3:
              if (!
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13920; /* pred_widen_mul_plusurvvm1hi_scalar */

            case 4:
              if (!
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13922; /* pred_widen_mul_plusurvvmf2hi_scalar */

            case 5:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13924; /* pred_widen_mul_plusurvvmf4hi_scalar */

            case 6:
              if (!
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13926; /* pred_widen_mul_plusurvvm8si_scalar */

            case 7:
              if (!
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13928; /* pred_widen_mul_plusurvvm4si_scalar */

            case 8:
              if (!
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13930; /* pred_widen_mul_plusurvvm2si_scalar */

            case 9:
              if (!
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13932; /* pred_widen_mul_plusurvvm1si_scalar */

            case 10:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13934; /* pred_widen_mul_plusurvvmf2si_scalar */

            case 11:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13936; /* pred_widen_mul_plusurvvm8di_scalar */

            case 12:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13938; /* pred_widen_mul_plusurvvm4di_scalar */

            case 13:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13940; /* pred_widen_mul_plusurvvm2di_scalar */

            case 14:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13942; /* pred_widen_mul_plusurvvm1di_scalar */

            case 15:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 13944; /* pred_widen_mul_plusuv1hi_scalar */

            case 16:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 13946; /* pred_widen_mul_plusuv2hi_scalar */

            case 17:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 13948; /* pred_widen_mul_plusuv4hi_scalar */

            case 18:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 13950; /* pred_widen_mul_plusuv8hi_scalar */

            case 19:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 13952; /* pred_widen_mul_plusuv16hi_scalar */

            case 20:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 13954; /* pred_widen_mul_plusuv32hi_scalar */

            case 21:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 13956; /* pred_widen_mul_plusuv64hi_scalar */

            case 22:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 13958; /* pred_widen_mul_plusuv128hi_scalar */

            case 23:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 13960; /* pred_widen_mul_plusuv256hi_scalar */

            case 24:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 13962; /* pred_widen_mul_plusuv512hi_scalar */

            case 25:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 13964; /* pred_widen_mul_plusuv1024hi_scalar */

            case 26:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 13966; /* pred_widen_mul_plusuv2048hi_scalar */

            case 27:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 13968; /* pred_widen_mul_plusuv1si_scalar */

            case 28:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 13970; /* pred_widen_mul_plusuv2si_scalar */

            case 29:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 13972; /* pred_widen_mul_plusuv4si_scalar */

            case 30:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 13974; /* pred_widen_mul_plusuv8si_scalar */

            case 31:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 13976; /* pred_widen_mul_plusuv16si_scalar */

            case 32:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 13978; /* pred_widen_mul_plusuv32si_scalar */

            case 33:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 13980; /* pred_widen_mul_plusuv64si_scalar */

            case 34:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 13982; /* pred_widen_mul_plusuv128si_scalar */

            case 35:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 13984; /* pred_widen_mul_plusuv256si_scalar */

            case 36:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 13986; /* pred_widen_mul_plusuv512si_scalar */

            case 37:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 13988; /* pred_widen_mul_plusuv1024si_scalar */

            case 38:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13990; /* pred_widen_mul_plusuv1di_scalar */

            case 39:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13992; /* pred_widen_mul_plusuv2di_scalar */

            case 40:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13994; /* pred_widen_mul_plusuv4di_scalar */

            case 41:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 13996; /* pred_widen_mul_plusuv8di_scalar */

            case 42:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 13998; /* pred_widen_mul_plusuv16di_scalar */

            case 43:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14000; /* pred_widen_mul_plusuv32di_scalar */

            case 44:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14002; /* pred_widen_mul_plusuv64di_scalar */

            case 45:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14004; /* pred_widen_mul_plusuv128di_scalar */

            case 46:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14006; /* pred_widen_mul_plusuv256di_scalar */

            case 47:
              if (!(
#line 5909 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14008; /* pred_widen_mul_plusuv512di_scalar */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern705 (x2))
            {
            case 0:
              if (!
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14105; /* pred_widen_mul_plususrvvm8hi_scalar */

            case 1:
              if (!
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14106; /* pred_widen_mul_plususrvvm4hi_scalar */

            case 2:
              if (!
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14107; /* pred_widen_mul_plususrvvm2hi_scalar */

            case 3:
              if (!
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14108; /* pred_widen_mul_plususrvvm1hi_scalar */

            case 4:
              if (!
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14109; /* pred_widen_mul_plususrvvmf2hi_scalar */

            case 5:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14110; /* pred_widen_mul_plususrvvmf4hi_scalar */

            case 6:
              if (!
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14111; /* pred_widen_mul_plususrvvm8si_scalar */

            case 7:
              if (!
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14112; /* pred_widen_mul_plususrvvm4si_scalar */

            case 8:
              if (!
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14113; /* pred_widen_mul_plususrvvm2si_scalar */

            case 9:
              if (!
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14114; /* pred_widen_mul_plususrvvm1si_scalar */

            case 10:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14115; /* pred_widen_mul_plususrvvmf2si_scalar */

            case 11:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14116; /* pred_widen_mul_plususrvvm8di_scalar */

            case 12:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14117; /* pred_widen_mul_plususrvvm4di_scalar */

            case 13:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14118; /* pred_widen_mul_plususrvvm2di_scalar */

            case 14:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14119; /* pred_widen_mul_plususrvvm1di_scalar */

            case 15:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 14120; /* pred_widen_mul_plususv1hi_scalar */

            case 16:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 14121; /* pred_widen_mul_plususv2hi_scalar */

            case 17:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 14122; /* pred_widen_mul_plususv4hi_scalar */

            case 18:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 14123; /* pred_widen_mul_plususv8hi_scalar */

            case 19:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 14124; /* pred_widen_mul_plususv16hi_scalar */

            case 20:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14125; /* pred_widen_mul_plususv32hi_scalar */

            case 21:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14126; /* pred_widen_mul_plususv64hi_scalar */

            case 22:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14127; /* pred_widen_mul_plususv128hi_scalar */

            case 23:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14128; /* pred_widen_mul_plususv256hi_scalar */

            case 24:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14129; /* pred_widen_mul_plususv512hi_scalar */

            case 25:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14130; /* pred_widen_mul_plususv1024hi_scalar */

            case 26:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14131; /* pred_widen_mul_plususv2048hi_scalar */

            case 27:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 14132; /* pred_widen_mul_plususv1si_scalar */

            case 28:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 14133; /* pred_widen_mul_plususv2si_scalar */

            case 29:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 14134; /* pred_widen_mul_plususv4si_scalar */

            case 30:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 14135; /* pred_widen_mul_plususv8si_scalar */

            case 31:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14136; /* pred_widen_mul_plususv16si_scalar */

            case 32:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14137; /* pred_widen_mul_plususv32si_scalar */

            case 33:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14138; /* pred_widen_mul_plususv64si_scalar */

            case 34:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14139; /* pred_widen_mul_plususv128si_scalar */

            case 35:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14140; /* pred_widen_mul_plususv256si_scalar */

            case 36:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14141; /* pred_widen_mul_plususv512si_scalar */

            case 37:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14142; /* pred_widen_mul_plususv1024si_scalar */

            case 38:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14143; /* pred_widen_mul_plususv1di_scalar */

            case 39:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14144; /* pred_widen_mul_plususv2di_scalar */

            case 40:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14145; /* pred_widen_mul_plususv4di_scalar */

            case 41:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14146; /* pred_widen_mul_plususv8di_scalar */

            case 42:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14147; /* pred_widen_mul_plususv16di_scalar */

            case 43:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14148; /* pred_widen_mul_plususv32di_scalar */

            case 44:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14149; /* pred_widen_mul_plususv64di_scalar */

            case 45:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14150; /* pred_widen_mul_plususv128di_scalar */

            case 46:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14151; /* pred_widen_mul_plususv256di_scalar */

            case 47:
              if (!(
#line 5983 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14152; /* pred_widen_mul_plususv512di_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_776 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V2048HImode) == 0
      && (
#line 5613 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return 13495; /* *pred_minus_mulv2048hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V2048HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V2048HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2048HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return 13563; /* *pred_nmsubv2048hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13631; /* *pred_nmsacv2048hi */
}

 int
recog_782 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V32HImode, 
E_V32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V32HImode) == 0
      && (
#line 5613 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return 13489; /* *pred_minus_mulv32hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V32HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V32HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V32HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return 13557; /* *pred_nmsubv32hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13625; /* *pred_nmsacv32hi */
}

 int
recog_788 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V4096QImode) == 0
      && (
#line 5613 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
    return 13483; /* *pred_minus_mulv4096qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V4096QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V4096QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4096QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
    return 13551; /* *pred_nmsubv4096qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13619; /* *pred_nmsacv4096qi */
}

 int
recog_796 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V16QImode, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V16QImode) == 0
      && (
#line 5613 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
    return 13475; /* *pred_minus_mulv16qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V16QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V16QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
    return 13543; /* *pred_nmsubv16qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
    return -1;
  return 13611; /* *pred_nmsacv16qi */
}

 int
recog_804 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V512DImode, 
E_V512BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return 13720; /* *pred_nmsubv512di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13788; /* *pred_nmsacv512di_scalar */
}

 int
recog_809 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V16DImode, 
E_V16BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 13715; /* *pred_nmsubv16di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13783; /* *pred_nmsacv16di_scalar */
}

 int
recog_817 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return 13707; /* *pred_nmsubv128si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13775; /* *pred_nmsacv128si_scalar */
}

 int
recog_825 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return 13699; /* *pred_nmsubv2048hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13767; /* *pred_nmsacv2048hi_scalar */
}

 int
recog_833 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      if (pattern710 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13653; /* *pred_nmsubrvvm8qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13721; /* *pred_nmsacrvvm8qi_scalar */

    case E_RVVM4QImode:
      if (pattern710 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13654; /* *pred_nmsubrvvm4qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13722; /* *pred_nmsacrvvm4qi_scalar */

    case E_RVVM2QImode:
      if (pattern710 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13655; /* *pred_nmsubrvvm2qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13723; /* *pred_nmsacrvvm2qi_scalar */

    case E_RVVM1QImode:
      if (pattern710 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13656; /* *pred_nmsubrvvm1qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13724; /* *pred_nmsacrvvm1qi_scalar */

    case E_RVVM8HImode:
      if (pattern710 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13657; /* *pred_nmsubrvvm8hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13725; /* *pred_nmsacrvvm8hi_scalar */

    case E_RVVM4HImode:
      if (pattern710 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13658; /* *pred_nmsubrvvm4hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13726; /* *pred_nmsacrvvm4hi_scalar */

    case E_RVVM2HImode:
      if (pattern710 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13659; /* *pred_nmsubrvvm2hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13727; /* *pred_nmsacrvvm2hi_scalar */

    case E_RVVM1HImode:
      if (pattern710 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13660; /* *pred_nmsubrvvm1hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13728; /* *pred_nmsacrvvm1hi_scalar */

    case E_RVVM8SImode:
      if (pattern710 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13661; /* *pred_nmsubrvvm8si_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13729; /* *pred_nmsacrvvm8si_scalar */

    case E_RVVM4SImode:
      if (pattern710 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13662; /* *pred_nmsubrvvm4si_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13730; /* *pred_nmsacrvvm4si_scalar */

    case E_RVVM2SImode:
      if (pattern710 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13663; /* *pred_nmsubrvvm2si_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13731; /* *pred_nmsacrvvm2si_scalar */

    case E_RVVM1SImode:
      if (pattern710 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13664; /* *pred_nmsubrvvm1si_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13732; /* *pred_nmsacrvvm1si_scalar */

    case E_RVVM8DImode:
      if (pattern710 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13665; /* *pred_nmsubrvvm8di_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13733; /* *pred_nmsacrvvm8di_scalar */

    case E_RVVM4DImode:
      if (pattern710 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13666; /* *pred_nmsubrvvm4di_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13734; /* *pred_nmsacrvvm4di_scalar */

    case E_RVVM2DImode:
      if (pattern710 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13667; /* *pred_nmsubrvvm2di_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13735; /* *pred_nmsacrvvm2di_scalar */

    case E_RVVM1DImode:
      if (pattern710 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13668; /* *pred_nmsubrvvm1di_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13736; /* *pred_nmsacrvvm1di_scalar */

    case E_RVVMF2QImode:
      if (pattern710 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13669; /* *pred_nmsubrvvmf2qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 13737; /* *pred_nmsacrvvmf2qi_scalar */

    case E_RVVMF4QImode:
      if (pattern710 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13670; /* *pred_nmsubrvvmf4qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 13738; /* *pred_nmsacrvvmf4qi_scalar */

    case E_RVVMF8QImode:
      if (pattern710 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 13671; /* *pred_nmsubrvvmf8qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 13739; /* *pred_nmsacrvvmf8qi_scalar */

    case E_RVVMF2HImode:
      if (pattern710 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13672; /* *pred_nmsubrvvmf2hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 13740; /* *pred_nmsacrvvmf2hi_scalar */

    case E_RVVMF4HImode:
      if (pattern710 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 13673; /* *pred_nmsubrvvmf4hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 13741; /* *pred_nmsacrvvmf4hi_scalar */

    case E_RVVMF2SImode:
      if (pattern710 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 13674; /* *pred_nmsubrvvmf2si_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 13742; /* *pred_nmsacrvvmf2si_scalar */

    case E_V1QImode:
      if (pattern710 (x2, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 13675; /* *pred_nmsubv1qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 13743; /* *pred_nmsacv1qi_scalar */

    case E_V2QImode:
      if (pattern710 (x2, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 13676; /* *pred_nmsubv2qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 13744; /* *pred_nmsacv2qi_scalar */

    case E_V4QImode:
      if (pattern710 (x2, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 13677; /* *pred_nmsubv4qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 13745; /* *pred_nmsacv4qi_scalar */

    case E_V8QImode:
      if (pattern710 (x2, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 13678; /* *pred_nmsubv8qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 13746; /* *pred_nmsacv8qi_scalar */

    case E_V16QImode:
      if (pattern710 (x2, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 13679; /* *pred_nmsubv16qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 13747; /* *pred_nmsacv16qi_scalar */

    case E_V32QImode:
      if (pattern710 (x2, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 13680; /* *pred_nmsubv32qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 13748; /* *pred_nmsacv32qi_scalar */

    case E_V64QImode:
      if (pattern710 (x2, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 13681; /* *pred_nmsubv64qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 13749; /* *pred_nmsacv64qi_scalar */

    case E_V128QImode:
      if (pattern710 (x2, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 13682; /* *pred_nmsubv128qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 13750; /* *pred_nmsacv128qi_scalar */

    case E_V256QImode:
      if (pattern710 (x2, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 13683; /* *pred_nmsubv256qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 13751; /* *pred_nmsacv256qi_scalar */

    case E_V512QImode:
      if (pattern710 (x2, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 13684; /* *pred_nmsubv512qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 13752; /* *pred_nmsacv512qi_scalar */

    case E_V1024QImode:
      if (pattern710 (x2, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 13685; /* *pred_nmsubv1024qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 13753; /* *pred_nmsacv1024qi_scalar */

    case E_V2048QImode:
      if (pattern710 (x2, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 13686; /* *pred_nmsubv2048qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 13754; /* *pred_nmsacv2048qi_scalar */

    case E_V4096QImode:
      if (pattern710 (x2, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 13687; /* *pred_nmsubv4096qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 13755; /* *pred_nmsacv4096qi_scalar */

    case E_V1HImode:
      if (pattern710 (x2, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 13688; /* *pred_nmsubv1hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 13756; /* *pred_nmsacv1hi_scalar */

    case E_V2HImode:
      if (pattern710 (x2, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 13689; /* *pred_nmsubv2hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 13757; /* *pred_nmsacv2hi_scalar */

    case E_V4HImode:
      if (pattern710 (x2, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 13690; /* *pred_nmsubv4hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 13758; /* *pred_nmsacv4hi_scalar */

    case E_V8HImode:
      if (pattern710 (x2, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5719 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 13691; /* *pred_nmsubv8hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5749 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 13759; /* *pred_nmsacv8hi_scalar */

    case E_V16HImode:
      return recog_832 (x1, insn, pnum_clobbers);

    case E_V32HImode:
      return recog_831 (x1, insn, pnum_clobbers);

    case E_V64HImode:
      return recog_830 (x1, insn, pnum_clobbers);

    case E_V128HImode:
      return recog_829 (x1, insn, pnum_clobbers);

    case E_V256HImode:
      return recog_828 (x1, insn, pnum_clobbers);

    case E_V512HImode:
      return recog_827 (x1, insn, pnum_clobbers);

    case E_V1024HImode:
      return recog_826 (x1, insn, pnum_clobbers);

    case E_V2048HImode:
      return recog_825 (x1, insn, pnum_clobbers);

    case E_V1SImode:
      return recog_824 (x1, insn, pnum_clobbers);

    case E_V2SImode:
      return recog_823 (x1, insn, pnum_clobbers);

    case E_V4SImode:
      return recog_822 (x1, insn, pnum_clobbers);

    case E_V8SImode:
      return recog_821 (x1, insn, pnum_clobbers);

    case E_V16SImode:
      return recog_820 (x1, insn, pnum_clobbers);

    case E_V32SImode:
      return recog_819 (x1, insn, pnum_clobbers);

    case E_V64SImode:
      return recog_818 (x1, insn, pnum_clobbers);

    case E_V128SImode:
      return recog_817 (x1, insn, pnum_clobbers);

    case E_V256SImode:
      return recog_816 (x1, insn, pnum_clobbers);

    case E_V512SImode:
      return recog_815 (x1, insn, pnum_clobbers);

    case E_V1024SImode:
      return recog_814 (x1, insn, pnum_clobbers);

    case E_V1DImode:
      return recog_813 (x1, insn, pnum_clobbers);

    case E_V2DImode:
      return recog_812 (x1, insn, pnum_clobbers);

    case E_V4DImode:
      return recog_811 (x1, insn, pnum_clobbers);

    case E_V8DImode:
      return recog_810 (x1, insn, pnum_clobbers);

    case E_V16DImode:
      return recog_809 (x1, insn, pnum_clobbers);

    case E_V32DImode:
      return recog_808 (x1, insn, pnum_clobbers);

    case E_V64DImode:
      return recog_807 (x1, insn, pnum_clobbers);

    case E_V128DImode:
      return recog_806 (x1, insn, pnum_clobbers);

    case E_V256DImode:
      return recog_805 (x1, insn, pnum_clobbers);

    case E_V512DImode:
      return recog_804 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_848 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern493 (x2, 
E_V8DImode, 
E_V8BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V8DImode)
      && (
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return 6539; /* pred_ashlv8di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 6836; /* pred_ashlv8di_scalar */
}

 int
recog_851 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern493 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V1DImode)
      && (
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 6488; /* pred_ashlv1di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 6827; /* pred_ashlv1di_scalar */
}

 int
recog_854 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern493 (x2, 
E_V256SImode, 
E_V256BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V256SImode)
      && (
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return 6437; /* pred_ashlv256si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 6818; /* pred_ashlv256si_scalar */
}

 int
recog_857 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern493 (x2, 
E_V32SImode, 
E_V32BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V32SImode)
      && (
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return 6386; /* pred_ashlv32si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 6809; /* pred_ashlv32si_scalar */
}

 int
recog_861 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern493 (x2, 
E_V2SImode, 
E_V2BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V2SImode)
      && (
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 6318; /* pred_ashlv2si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 6797; /* pred_ashlv2si_scalar */
}

 int
recog_866 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern493 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V256HImode)
      && (
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 6233; /* pred_ashlv256hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 6782; /* pred_ashlv256hi_scalar */
}

 int
recog_871 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern672 (x2, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V512SImode)
      && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return 32896; /* pred_vwsllv512di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 32944; /* pred_vwsllv512di_scalar */
}

 int
recog_876 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern672 (x2, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V16SImode)
      && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 32891; /* pred_vwsllv16di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 32939; /* pred_vwsllv16di_scalar */
}

 int
recog_881 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  x6 = XEXP (x3, 1);
  switch (GET_CODE (x6))
    {
    case SIGN_EXTEND:
      switch (pattern534 (x2))
        {
        case 0:
          if (!
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9305; /* pred_dual_widen_mulsrvvm8hi */

        case 1:
          if (!
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9311; /* pred_dual_widen_mulsrvvm4hi */

        case 2:
          if (!
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9317; /* pred_dual_widen_mulsrvvm2hi */

        case 3:
          if (!
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9323; /* pred_dual_widen_mulsrvvm1hi */

        case 4:
          if (!
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9329; /* pred_dual_widen_mulsrvvmf2hi */

        case 5:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9335; /* pred_dual_widen_mulsrvvmf4hi */

        case 6:
          if (!
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9341; /* pred_dual_widen_mulsrvvm8si */

        case 7:
          if (!
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9347; /* pred_dual_widen_mulsrvvm4si */

        case 8:
          if (!
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9353; /* pred_dual_widen_mulsrvvm2si */

        case 9:
          if (!
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9359; /* pred_dual_widen_mulsrvvm1si */

        case 10:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9365; /* pred_dual_widen_mulsrvvmf2si */

        case 11:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9371; /* pred_dual_widen_mulsrvvm8di */

        case 12:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9377; /* pred_dual_widen_mulsrvvm4di */

        case 13:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9383; /* pred_dual_widen_mulsrvvm2di */

        case 14:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9389; /* pred_dual_widen_mulsrvvm1di */

        case 15:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9395; /* pred_dual_widen_mulsv1hi */

        case 16:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9401; /* pred_dual_widen_mulsv2hi */

        case 17:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9407; /* pred_dual_widen_mulsv4hi */

        case 18:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9413; /* pred_dual_widen_mulsv8hi */

        case 19:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9419; /* pred_dual_widen_mulsv16hi */

        case 20:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9425; /* pred_dual_widen_mulsv32hi */

        case 21:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9431; /* pred_dual_widen_mulsv64hi */

        case 22:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9437; /* pred_dual_widen_mulsv128hi */

        case 23:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9443; /* pred_dual_widen_mulsv256hi */

        case 24:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9449; /* pred_dual_widen_mulsv512hi */

        case 25:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9455; /* pred_dual_widen_mulsv1024hi */

        case 26:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9461; /* pred_dual_widen_mulsv2048hi */

        case 27:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9467; /* pred_dual_widen_mulsv1si */

        case 28:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9473; /* pred_dual_widen_mulsv2si */

        case 29:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9479; /* pred_dual_widen_mulsv4si */

        case 30:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9485; /* pred_dual_widen_mulsv8si */

        case 31:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9491; /* pred_dual_widen_mulsv16si */

        case 32:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9497; /* pred_dual_widen_mulsv32si */

        case 33:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9503; /* pred_dual_widen_mulsv64si */

        case 34:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9509; /* pred_dual_widen_mulsv128si */

        case 35:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9515; /* pred_dual_widen_mulsv256si */

        case 36:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9521; /* pred_dual_widen_mulsv512si */

        case 37:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9527; /* pred_dual_widen_mulsv1024si */

        case 38:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9533; /* pred_dual_widen_mulsv1di */

        case 39:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9539; /* pred_dual_widen_mulsv2di */

        case 40:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9545; /* pred_dual_widen_mulsv4di */

        case 41:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9551; /* pred_dual_widen_mulsv8di */

        case 42:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9557; /* pred_dual_widen_mulsv16di */

        case 43:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9563; /* pred_dual_widen_mulsv32di */

        case 44:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9569; /* pred_dual_widen_mulsv64di */

        case 45:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9575; /* pred_dual_widen_mulsv128di */

        case 46:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9581; /* pred_dual_widen_mulsv256di */

        case 47:
          if (!(
#line 4005 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9587; /* pred_dual_widen_mulsv512di */

        case 48:
          if (!
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9593; /* pred_dual_widen_mulsrvvm8hi_scalar */

        case 49:
          if (!
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9599; /* pred_dual_widen_mulsrvvm4hi_scalar */

        case 50:
          if (!
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9605; /* pred_dual_widen_mulsrvvm2hi_scalar */

        case 51:
          if (!
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9611; /* pred_dual_widen_mulsrvvm1hi_scalar */

        case 52:
          if (!
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9617; /* pred_dual_widen_mulsrvvmf2hi_scalar */

        case 53:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9623; /* pred_dual_widen_mulsrvvmf4hi_scalar */

        case 54:
          if (!
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9629; /* pred_dual_widen_mulsrvvm8si_scalar */

        case 55:
          if (!
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9635; /* pred_dual_widen_mulsrvvm4si_scalar */

        case 56:
          if (!
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9641; /* pred_dual_widen_mulsrvvm2si_scalar */

        case 57:
          if (!
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9647; /* pred_dual_widen_mulsrvvm1si_scalar */

        case 58:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9653; /* pred_dual_widen_mulsrvvmf2si_scalar */

        case 59:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9659; /* pred_dual_widen_mulsrvvm8di_scalar */

        case 60:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9665; /* pred_dual_widen_mulsrvvm4di_scalar */

        case 61:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9671; /* pred_dual_widen_mulsrvvm2di_scalar */

        case 62:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9677; /* pred_dual_widen_mulsrvvm1di_scalar */

        case 63:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9683; /* pred_dual_widen_mulsv1hi_scalar */

        case 64:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9689; /* pred_dual_widen_mulsv2hi_scalar */

        case 65:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9695; /* pred_dual_widen_mulsv4hi_scalar */

        case 66:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9701; /* pred_dual_widen_mulsv8hi_scalar */

        case 67:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9707; /* pred_dual_widen_mulsv16hi_scalar */

        case 68:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9713; /* pred_dual_widen_mulsv32hi_scalar */

        case 69:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9719; /* pred_dual_widen_mulsv64hi_scalar */

        case 70:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9725; /* pred_dual_widen_mulsv128hi_scalar */

        case 71:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9731; /* pred_dual_widen_mulsv256hi_scalar */

        case 72:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9737; /* pred_dual_widen_mulsv512hi_scalar */

        case 73:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9743; /* pred_dual_widen_mulsv1024hi_scalar */

        case 74:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9749; /* pred_dual_widen_mulsv2048hi_scalar */

        case 75:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9755; /* pred_dual_widen_mulsv1si_scalar */

        case 76:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9761; /* pred_dual_widen_mulsv2si_scalar */

        case 77:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9767; /* pred_dual_widen_mulsv4si_scalar */

        case 78:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9773; /* pred_dual_widen_mulsv8si_scalar */

        case 79:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9779; /* pred_dual_widen_mulsv16si_scalar */

        case 80:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9785; /* pred_dual_widen_mulsv32si_scalar */

        case 81:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9791; /* pred_dual_widen_mulsv64si_scalar */

        case 82:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9797; /* pred_dual_widen_mulsv128si_scalar */

        case 83:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9803; /* pred_dual_widen_mulsv256si_scalar */

        case 84:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9809; /* pred_dual_widen_mulsv512si_scalar */

        case 85:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9815; /* pred_dual_widen_mulsv1024si_scalar */

        case 86:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9821; /* pred_dual_widen_mulsv1di_scalar */

        case 87:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9827; /* pred_dual_widen_mulsv2di_scalar */

        case 88:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9833; /* pred_dual_widen_mulsv4di_scalar */

        case 89:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9839; /* pred_dual_widen_mulsv8di_scalar */

        case 90:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9845; /* pred_dual_widen_mulsv16di_scalar */

        case 91:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9851; /* pred_dual_widen_mulsv32di_scalar */

        case 92:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9857; /* pred_dual_widen_mulsv64di_scalar */

        case 93:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9863; /* pred_dual_widen_mulsv128di_scalar */

        case 94:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9869; /* pred_dual_widen_mulsv256di_scalar */

        case 95:
          if (!(
#line 4028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9875; /* pred_dual_widen_mulsv512di_scalar */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern534 (x2))
        {
        case 0:
          if (!
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10453; /* pred_widen_mulsurvvm8hi */

        case 1:
          if (!
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10454; /* pred_widen_mulsurvvm4hi */

        case 2:
          if (!
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10455; /* pred_widen_mulsurvvm2hi */

        case 3:
          if (!
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10456; /* pred_widen_mulsurvvm1hi */

        case 4:
          if (!
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10457; /* pred_widen_mulsurvvmf2hi */

        case 5:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10458; /* pred_widen_mulsurvvmf4hi */

        case 6:
          if (!
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10459; /* pred_widen_mulsurvvm8si */

        case 7:
          if (!
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10460; /* pred_widen_mulsurvvm4si */

        case 8:
          if (!
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10461; /* pred_widen_mulsurvvm2si */

        case 9:
          if (!
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10462; /* pred_widen_mulsurvvm1si */

        case 10:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10463; /* pred_widen_mulsurvvmf2si */

        case 11:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10464; /* pred_widen_mulsurvvm8di */

        case 12:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10465; /* pred_widen_mulsurvvm4di */

        case 13:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10466; /* pred_widen_mulsurvvm2di */

        case 14:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10467; /* pred_widen_mulsurvvm1di */

        case 15:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10468; /* pred_widen_mulsuv1hi */

        case 16:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10469; /* pred_widen_mulsuv2hi */

        case 17:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10470; /* pred_widen_mulsuv4hi */

        case 18:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10471; /* pred_widen_mulsuv8hi */

        case 19:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10472; /* pred_widen_mulsuv16hi */

        case 20:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10473; /* pred_widen_mulsuv32hi */

        case 21:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10474; /* pred_widen_mulsuv64hi */

        case 22:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10475; /* pred_widen_mulsuv128hi */

        case 23:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10476; /* pred_widen_mulsuv256hi */

        case 24:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10477; /* pred_widen_mulsuv512hi */

        case 25:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10478; /* pred_widen_mulsuv1024hi */

        case 26:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10479; /* pred_widen_mulsuv2048hi */

        case 27:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10480; /* pred_widen_mulsuv1si */

        case 28:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10481; /* pred_widen_mulsuv2si */

        case 29:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10482; /* pred_widen_mulsuv4si */

        case 30:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10483; /* pred_widen_mulsuv8si */

        case 31:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10484; /* pred_widen_mulsuv16si */

        case 32:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10485; /* pred_widen_mulsuv32si */

        case 33:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10486; /* pred_widen_mulsuv64si */

        case 34:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10487; /* pred_widen_mulsuv128si */

        case 35:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10488; /* pred_widen_mulsuv256si */

        case 36:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10489; /* pred_widen_mulsuv512si */

        case 37:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10490; /* pred_widen_mulsuv1024si */

        case 38:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10491; /* pred_widen_mulsuv1di */

        case 39:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10492; /* pred_widen_mulsuv2di */

        case 40:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10493; /* pred_widen_mulsuv4di */

        case 41:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10494; /* pred_widen_mulsuv8di */

        case 42:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10495; /* pred_widen_mulsuv16di */

        case 43:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10496; /* pred_widen_mulsuv32di */

        case 44:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10497; /* pred_widen_mulsuv64di */

        case 45:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10498; /* pred_widen_mulsuv128di */

        case 46:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10499; /* pred_widen_mulsuv256di */

        case 47:
          if (!(
#line 4160 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10500; /* pred_widen_mulsuv512di */

        case 48:
          if (!
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10501; /* pred_widen_mulsurvvm8hi_scalar */

        case 49:
          if (!
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10502; /* pred_widen_mulsurvvm4hi_scalar */

        case 50:
          if (!
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10503; /* pred_widen_mulsurvvm2hi_scalar */

        case 51:
          if (!
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10504; /* pred_widen_mulsurvvm1hi_scalar */

        case 52:
          if (!
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10505; /* pred_widen_mulsurvvmf2hi_scalar */

        case 53:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10506; /* pred_widen_mulsurvvmf4hi_scalar */

        case 54:
          if (!
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10507; /* pred_widen_mulsurvvm8si_scalar */

        case 55:
          if (!
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10508; /* pred_widen_mulsurvvm4si_scalar */

        case 56:
          if (!
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10509; /* pred_widen_mulsurvvm2si_scalar */

        case 57:
          if (!
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10510; /* pred_widen_mulsurvvm1si_scalar */

        case 58:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10511; /* pred_widen_mulsurvvmf2si_scalar */

        case 59:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10512; /* pred_widen_mulsurvvm8di_scalar */

        case 60:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10513; /* pred_widen_mulsurvvm4di_scalar */

        case 61:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10514; /* pred_widen_mulsurvvm2di_scalar */

        case 62:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10515; /* pred_widen_mulsurvvm1di_scalar */

        case 63:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10516; /* pred_widen_mulsuv1hi_scalar */

        case 64:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10517; /* pred_widen_mulsuv2hi_scalar */

        case 65:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10518; /* pred_widen_mulsuv4hi_scalar */

        case 66:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10519; /* pred_widen_mulsuv8hi_scalar */

        case 67:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10520; /* pred_widen_mulsuv16hi_scalar */

        case 68:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10521; /* pred_widen_mulsuv32hi_scalar */

        case 69:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10522; /* pred_widen_mulsuv64hi_scalar */

        case 70:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10523; /* pred_widen_mulsuv128hi_scalar */

        case 71:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10524; /* pred_widen_mulsuv256hi_scalar */

        case 72:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10525; /* pred_widen_mulsuv512hi_scalar */

        case 73:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10526; /* pred_widen_mulsuv1024hi_scalar */

        case 74:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10527; /* pred_widen_mulsuv2048hi_scalar */

        case 75:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10528; /* pred_widen_mulsuv1si_scalar */

        case 76:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10529; /* pred_widen_mulsuv2si_scalar */

        case 77:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10530; /* pred_widen_mulsuv4si_scalar */

        case 78:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10531; /* pred_widen_mulsuv8si_scalar */

        case 79:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10532; /* pred_widen_mulsuv16si_scalar */

        case 80:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10533; /* pred_widen_mulsuv32si_scalar */

        case 81:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10534; /* pred_widen_mulsuv64si_scalar */

        case 82:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10535; /* pred_widen_mulsuv128si_scalar */

        case 83:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10536; /* pred_widen_mulsuv256si_scalar */

        case 84:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10537; /* pred_widen_mulsuv512si_scalar */

        case 85:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10538; /* pred_widen_mulsuv1024si_scalar */

        case 86:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10539; /* pred_widen_mulsuv1di_scalar */

        case 87:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10540; /* pred_widen_mulsuv2di_scalar */

        case 88:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10541; /* pred_widen_mulsuv4di_scalar */

        case 89:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10542; /* pred_widen_mulsuv8di_scalar */

        case 90:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10543; /* pred_widen_mulsuv16di_scalar */

        case 91:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10544; /* pred_widen_mulsuv32di_scalar */

        case 92:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10545; /* pred_widen_mulsuv64di_scalar */

        case 93:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10546; /* pred_widen_mulsuv128di_scalar */

        case 94:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10547; /* pred_widen_mulsuv256di_scalar */

        case 95:
          if (!(
#line 4183 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10548; /* pred_widen_mulsuv512di_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_894 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  switch (XVECLEN (x4, 0))
    {
    case 3:
      return recog_606 (x1, insn, pnum_clobbers);

    case 2:
      switch (XINT (x4, 1))
        {
        case 99:
          return recog_600 (x1, insn, pnum_clobbers);

        case 100:
          return recog_599 (x1, insn, pnum_clobbers);

        case 101:
          return recog_598 (x1, insn, pnum_clobbers);

        case 140:
          switch (pattern561 (x2))
            {
            case 0:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14786; /* pred_fmaxrvvm8hf */

            case 1:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14788; /* pred_fmaxrvvm4hf */

            case 2:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14790; /* pred_fmaxrvvm2hf */

            case 3:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14792; /* pred_fmaxrvvm1hf */

            case 4:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14794; /* pred_fmaxrvvmf2hf */

            case 5:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14796; /* pred_fmaxrvvmf4hf */

            case 6:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14798; /* pred_fmaxrvvm8sf */

            case 7:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14800; /* pred_fmaxrvvm4sf */

            case 8:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14802; /* pred_fmaxrvvm2sf */

            case 9:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14804; /* pred_fmaxrvvm1sf */

            case 10:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14806; /* pred_fmaxrvvmf2sf */

            case 11:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14808; /* pred_fmaxrvvm8df */

            case 12:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14810; /* pred_fmaxrvvm4df */

            case 13:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14812; /* pred_fmaxrvvm2df */

            case 14:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14814; /* pred_fmaxrvvm1df */

            case 15:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                return -1;
              return 14816; /* pred_fmaxv1hf */

            case 16:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                return -1;
              return 14818; /* pred_fmaxv2hf */

            case 17:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                return -1;
              return 14820; /* pred_fmaxv4hf */

            case 18:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                return -1;
              return 14822; /* pred_fmaxv8hf */

            case 19:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                return -1;
              return 14824; /* pred_fmaxv16hf */

            case 20:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14826; /* pred_fmaxv32hf */

            case 21:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14828; /* pred_fmaxv64hf */

            case 22:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14830; /* pred_fmaxv128hf */

            case 23:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14832; /* pred_fmaxv256hf */

            case 24:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14834; /* pred_fmaxv512hf */

            case 25:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14836; /* pred_fmaxv1024hf */

            case 26:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14838; /* pred_fmaxv2048hf */

            case 27:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14840; /* pred_fmaxv1sf */

            case 28:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14842; /* pred_fmaxv2sf */

            case 29:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14844; /* pred_fmaxv4sf */

            case 30:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14846; /* pred_fmaxv8sf */

            case 31:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14848; /* pred_fmaxv16sf */

            case 32:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14850; /* pred_fmaxv32sf */

            case 33:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14852; /* pred_fmaxv64sf */

            case 34:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14854; /* pred_fmaxv128sf */

            case 35:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14856; /* pred_fmaxv256sf */

            case 36:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14858; /* pred_fmaxv512sf */

            case 37:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14860; /* pred_fmaxv1024sf */

            case 38:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14862; /* pred_fmaxv1df */

            case 39:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14864; /* pred_fmaxv2df */

            case 40:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14866; /* pred_fmaxv4df */

            case 41:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14868; /* pred_fmaxv8df */

            case 42:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14870; /* pred_fmaxv16df */

            case 43:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14872; /* pred_fmaxv32df */

            case 44:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14874; /* pred_fmaxv64df */

            case 45:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14876; /* pred_fmaxv128df */

            case 46:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14878; /* pred_fmaxv256df */

            case 47:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14880; /* pred_fmaxv512df */

            case 48:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14942; /* pred_fmaxrvvm8hf_scalar */

            case 49:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14944; /* pred_fmaxrvvm4hf_scalar */

            case 50:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14946; /* pred_fmaxrvvm2hf_scalar */

            case 51:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14948; /* pred_fmaxrvvm1hf_scalar */

            case 52:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14950; /* pred_fmaxrvvmf2hf_scalar */

            case 53:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14952; /* pred_fmaxrvvmf4hf_scalar */

            case 54:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14954; /* pred_fmaxrvvm8sf_scalar */

            case 55:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14956; /* pred_fmaxrvvm4sf_scalar */

            case 56:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14958; /* pred_fmaxrvvm2sf_scalar */

            case 57:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14960; /* pred_fmaxrvvm1sf_scalar */

            case 58:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14962; /* pred_fmaxrvvmf2sf_scalar */

            case 59:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14964; /* pred_fmaxrvvm8df_scalar */

            case 60:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14966; /* pred_fmaxrvvm4df_scalar */

            case 61:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14968; /* pred_fmaxrvvm2df_scalar */

            case 62:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14970; /* pred_fmaxrvvm1df_scalar */

            default:
              return -1;
            }

        case 141:
          switch (pattern561 (x2))
            {
            case 0:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14787; /* pred_fminrvvm8hf */

            case 1:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14789; /* pred_fminrvvm4hf */

            case 2:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14791; /* pred_fminrvvm2hf */

            case 3:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14793; /* pred_fminrvvm1hf */

            case 4:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14795; /* pred_fminrvvmf2hf */

            case 5:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14797; /* pred_fminrvvmf4hf */

            case 6:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14799; /* pred_fminrvvm8sf */

            case 7:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14801; /* pred_fminrvvm4sf */

            case 8:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14803; /* pred_fminrvvm2sf */

            case 9:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14805; /* pred_fminrvvm1sf */

            case 10:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14807; /* pred_fminrvvmf2sf */

            case 11:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14809; /* pred_fminrvvm8df */

            case 12:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14811; /* pred_fminrvvm4df */

            case 13:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14813; /* pred_fminrvvm2df */

            case 14:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14815; /* pred_fminrvvm1df */

            case 15:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                return -1;
              return 14817; /* pred_fminv1hf */

            case 16:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                return -1;
              return 14819; /* pred_fminv2hf */

            case 17:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                return -1;
              return 14821; /* pred_fminv4hf */

            case 18:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                return -1;
              return 14823; /* pred_fminv8hf */

            case 19:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                return -1;
              return 14825; /* pred_fminv16hf */

            case 20:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14827; /* pred_fminv32hf */

            case 21:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14829; /* pred_fminv64hf */

            case 22:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14831; /* pred_fminv128hf */

            case 23:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14833; /* pred_fminv256hf */

            case 24:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14835; /* pred_fminv512hf */

            case 25:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14837; /* pred_fminv1024hf */

            case 26:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14839; /* pred_fminv2048hf */

            case 27:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14841; /* pred_fminv1sf */

            case 28:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14843; /* pred_fminv2sf */

            case 29:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14845; /* pred_fminv4sf */

            case 30:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14847; /* pred_fminv8sf */

            case 31:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14849; /* pred_fminv16sf */

            case 32:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14851; /* pred_fminv32sf */

            case 33:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14853; /* pred_fminv64sf */

            case 34:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14855; /* pred_fminv128sf */

            case 35:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14857; /* pred_fminv256sf */

            case 36:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14859; /* pred_fminv512sf */

            case 37:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14861; /* pred_fminv1024sf */

            case 38:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14863; /* pred_fminv1df */

            case 39:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14865; /* pred_fminv2df */

            case 40:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14867; /* pred_fminv4df */

            case 41:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14869; /* pred_fminv8df */

            case 42:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14871; /* pred_fminv16df */

            case 43:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14873; /* pred_fminv32df */

            case 44:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14875; /* pred_fminv64df */

            case 45:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14877; /* pred_fminv128df */

            case 46:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14879; /* pred_fminv256df */

            case 47:
              if (!(
#line 6245 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14881; /* pred_fminv512df */

            case 48:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14943; /* pred_fminrvvm8hf_scalar */

            case 49:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14945; /* pred_fminrvvm4hf_scalar */

            case 50:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14947; /* pred_fminrvvm2hf_scalar */

            case 51:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14949; /* pred_fminrvvm1hf_scalar */

            case 52:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14951; /* pred_fminrvvmf2hf_scalar */

            case 53:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14953; /* pred_fminrvvmf4hf_scalar */

            case 54:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14955; /* pred_fminrvvm8sf_scalar */

            case 55:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14957; /* pred_fminrvvm4sf_scalar */

            case 56:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14959; /* pred_fminrvvm2sf_scalar */

            case 57:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14961; /* pred_fminrvvm1sf_scalar */

            case 58:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14963; /* pred_fminrvvmf2sf_scalar */

            case 59:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14965; /* pred_fminrvvm8df_scalar */

            case 60:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14967; /* pred_fminrvvm4df_scalar */

            case 61:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14969; /* pred_fminrvvm2df_scalar */

            case 62:
              if (!(
#line 6313 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14971; /* pred_fminrvvm1df_scalar */

            default:
              return -1;
            }

        case 123:
          return recog_602 (x1, insn, pnum_clobbers);

        case 124:
          return recog_601 (x1, insn, pnum_clobbers);

        case 134:
          return recog_596 (x1, insn, pnum_clobbers);

        case 135:
          x5 = XEXP (x2, 0);
          x6 = XVECEXP (x5, 0, 1);
          operands[5] = x6;
          x7 = XVECEXP (x5, 0, 2);
          operands[6] = x7;
          x8 = XVECEXP (x5, 0, 3);
          operands[7] = x8;
          x9 = XVECEXP (x5, 0, 4);
          operands[8] = x9;
          x10 = XVECEXP (x4, 0, 0);
          operands[3] = x10;
          x11 = XVECEXP (x4, 0, 1);
          operands[4] = x11;
          return recog_595 (x1, insn, pnum_clobbers);

        case 95:
          return recog_597 (x1, insn, pnum_clobbers);

        case 172:
          switch (pattern564 (x2))
            {
            case 0:
              if (!
#line 181 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVFNRCLIPXFQF))
                return -1;
              return 32579; /* pred_sf_vfnrcliprvvm2qi_x_f_qf */

            case 1:
              if (!
#line 181 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVFNRCLIPXFQF))
                return -1;
              return 32581; /* pred_sf_vfnrcliprvvm1qi_x_f_qf */

            case 2:
              if (!
#line 181 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVFNRCLIPXFQF))
                return -1;
              return 32583; /* pred_sf_vfnrcliprvvmf2qi_x_f_qf */

            case 3:
              if (!
#line 181 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVFNRCLIPXFQF))
                return -1;
              return 32585; /* pred_sf_vfnrcliprvvmf4qi_x_f_qf */

            case 4:
              if (!(
#line 181 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVFNRCLIPXFQF) && 
#line 4857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 32587; /* pred_sf_vfnrcliprvvmf8qi_x_f_qf */

            default:
              return -1;
            }

        case 173:
          switch (pattern564 (x2))
            {
            case 0:
              if (!
#line 181 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVFNRCLIPXFQF))
                return -1;
              return 32580; /* pred_sf_vfnrclipurvvm2qi_x_f_qf */

            case 1:
              if (!
#line 181 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVFNRCLIPXFQF))
                return -1;
              return 32582; /* pred_sf_vfnrclipurvvm1qi_x_f_qf */

            case 2:
              if (!
#line 181 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVFNRCLIPXFQF))
                return -1;
              return 32584; /* pred_sf_vfnrclipurvvmf2qi_x_f_qf */

            case 3:
              if (!
#line 181 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVFNRCLIPXFQF))
                return -1;
              return 32586; /* pred_sf_vfnrclipurvvmf4qi_x_f_qf */

            case 4:
              if (!(
#line 181 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVFNRCLIPXFQF) && 
#line 4857 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 32588; /* pred_sf_vfnrclipurvvmf8qi_x_f_qf */

            default:
              return -1;
            }

        case 199:
          switch (pattern565 (x2))
            {
            case 0:
              if (!(
#line 382 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33353; /* pred_vclmulrvvm8di */

            case 1:
              if (!(
#line 382 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33355; /* pred_vclmulrvvm4di */

            case 2:
              if (!(
#line 382 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33357; /* pred_vclmulrvvm2di */

            case 3:
              if (!(
#line 382 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33359; /* pred_vclmulrvvm1di */

            case 4:
              if (!(
#line 437 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33361; /* *pred_vclmulrvvm8di_scalar */

            case 5:
              if (!(
#line 437 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33363; /* *pred_vclmulrvvm4di_scalar */

            case 6:
              if (!(
#line 437 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33365; /* *pred_vclmulrvvm2di_scalar */

            case 7:
              if (!(
#line 437 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33367; /* *pred_vclmulrvvm1di_scalar */

            case 8:
              if (!(
#line 459 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33369; /* *pred_vclmulrvvm8di_extend_scalar */

            case 9:
              if (!(
#line 459 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33371; /* *pred_vclmulrvvm4di_extend_scalar */

            case 10:
              if (!(
#line 459 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33373; /* *pred_vclmulrvvm2di_extend_scalar */

            case 11:
              if (!(
#line 459 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33375; /* *pred_vclmulrvvm1di_extend_scalar */

            default:
              return -1;
            }

        case 200:
          switch (pattern565 (x2))
            {
            case 0:
              if (!(
#line 382 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33354; /* pred_vclmulhrvvm8di */

            case 1:
              if (!(
#line 382 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33356; /* pred_vclmulhrvvm4di */

            case 2:
              if (!(
#line 382 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33358; /* pred_vclmulhrvvm2di */

            case 3:
              if (!(
#line 382 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33360; /* pred_vclmulhrvvm1di */

            case 4:
              if (!(
#line 437 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33362; /* *pred_vclmulhrvvm8di_scalar */

            case 5:
              if (!(
#line 437 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33364; /* *pred_vclmulhrvvm4di_scalar */

            case 6:
              if (!(
#line 437 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33366; /* *pred_vclmulhrvvm2di_scalar */

            case 7:
              if (!(
#line 437 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33368; /* *pred_vclmulhrvvm1di_scalar */

            case 8:
              if (!(
#line 459 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33370; /* *pred_vclmulhrvvm8di_extend_scalar */

            case 9:
              if (!(
#line 459 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33372; /* *pred_vclmulhrvvm4di_extend_scalar */

            case 10:
              if (!(
#line 459 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33374; /* *pred_vclmulhrvvm2di_extend_scalar */

            case 11:
              if (!(
#line 459 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBC) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 33376; /* *pred_vclmulhrvvm1di_extend_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      return recog_607 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_906 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern492 (x2))
    {
    case 0:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5501; /* pred_xorrvvm8qi */

    case 1:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5518; /* pred_xorrvvm4qi */

    case 2:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5535; /* pred_xorrvvm2qi */

    case 3:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5552; /* pred_xorrvvm1qi */

    case 4:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5569; /* pred_xorrvvm8hi */

    case 5:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5586; /* pred_xorrvvm4hi */

    case 6:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5603; /* pred_xorrvvm2hi */

    case 7:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5620; /* pred_xorrvvm1hi */

    case 8:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5637; /* pred_xorrvvm8si */

    case 9:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5654; /* pred_xorrvvm4si */

    case 10:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5671; /* pred_xorrvvm2si */

    case 11:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5688; /* pred_xorrvvm1si */

    case 12:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5705; /* pred_xorrvvm8di */

    case 13:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5722; /* pred_xorrvvm4di */

    case 14:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5739; /* pred_xorrvvm2di */

    case 15:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5756; /* pred_xorrvvm1di */

    case 16:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5773; /* pred_xorrvvmf2qi */

    case 17:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5790; /* pred_xorrvvmf4qi */

    case 18:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5807; /* pred_xorrvvmf8qi */

    case 19:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5824; /* pred_xorrvvmf2hi */

    case 20:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5841; /* pred_xorrvvmf4hi */

    case 21:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5858; /* pred_xorrvvmf2si */

    case 22:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5875; /* pred_xorv1qi */

    case 23:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5892; /* pred_xorv2qi */

    case 24:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5909; /* pred_xorv4qi */

    case 25:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5926; /* pred_xorv8qi */

    case 26:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5943; /* pred_xorv16qi */

    case 27:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5960; /* pred_xorv32qi */

    case 28:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5977; /* pred_xorv64qi */

    case 29:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 5994; /* pred_xorv128qi */

    case 30:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6011; /* pred_xorv256qi */

    case 31:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6028; /* pred_xorv512qi */

    case 32:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6045; /* pred_xorv1024qi */

    case 33:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6062; /* pred_xorv2048qi */

    case 34:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6079; /* pred_xorv4096qi */

    case 35:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6096; /* pred_xorv1hi */

    case 36:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6113; /* pred_xorv2hi */

    case 37:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6130; /* pred_xorv4hi */

    case 38:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6147; /* pred_xorv8hi */

    case 39:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6164; /* pred_xorv16hi */

    case 40:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6181; /* pred_xorv32hi */

    case 41:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6198; /* pred_xorv64hi */

    case 42:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6215; /* pred_xorv128hi */

    case 43:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6232; /* pred_xorv256hi */

    case 44:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6249; /* pred_xorv512hi */

    case 45:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6266; /* pred_xorv1024hi */

    case 46:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6283; /* pred_xorv2048hi */

    case 47:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6300; /* pred_xorv1si */

    case 48:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6317; /* pred_xorv2si */

    case 49:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6334; /* pred_xorv4si */

    case 50:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6351; /* pred_xorv8si */

    case 51:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6368; /* pred_xorv16si */

    case 52:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6385; /* pred_xorv32si */

    case 53:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6402; /* pred_xorv64si */

    case 54:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6419; /* pred_xorv128si */

    case 55:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6436; /* pred_xorv256si */

    case 56:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6453; /* pred_xorv512si */

    case 57:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6470; /* pred_xorv1024si */

    case 58:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6487; /* pred_xorv1di */

    case 59:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6504; /* pred_xorv2di */

    case 60:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6521; /* pred_xorv4di */

    case 61:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6538; /* pred_xorv8di */

    case 62:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6555; /* pred_xorv16di */

    case 63:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6572; /* pred_xorv32di */

    case 64:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6589; /* pred_xorv64di */

    case 65:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6606; /* pred_xorv128di */

    case 66:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6623; /* pred_xorv256di */

    case 67:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6640; /* pred_xorv512di */

    case 68:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6860; /* pred_xorrvvm8qi_scalar */

    case 69:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6869; /* pred_xorrvvm4qi_scalar */

    case 70:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6878; /* pred_xorrvvm2qi_scalar */

    case 71:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6887; /* pred_xorrvvm1qi_scalar */

    case 72:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6896; /* pred_xorrvvmf2qi_scalar */

    case 73:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6905; /* pred_xorrvvmf4qi_scalar */

    case 74:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6914; /* pred_xorrvvmf8qi_scalar */

    case 75:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6923; /* pred_xorrvvm8hi_scalar */

    case 76:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6932; /* pred_xorrvvm4hi_scalar */

    case 77:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6941; /* pred_xorrvvm2hi_scalar */

    case 78:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6950; /* pred_xorrvvm1hi_scalar */

    case 79:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6959; /* pred_xorrvvmf2hi_scalar */

    case 80:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6968; /* pred_xorrvvmf4hi_scalar */

    case 81:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6977; /* pred_xorrvvm8si_scalar */

    case 82:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6986; /* pred_xorrvvm4si_scalar */

    case 83:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6995; /* pred_xorrvvm2si_scalar */

    case 84:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7004; /* pred_xorrvvm1si_scalar */

    case 85:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7013; /* pred_xorrvvmf2si_scalar */

    case 86:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7022; /* pred_xorv1qi_scalar */

    case 87:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7031; /* pred_xorv2qi_scalar */

    case 88:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7040; /* pred_xorv4qi_scalar */

    case 89:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7049; /* pred_xorv8qi_scalar */

    case 90:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7058; /* pred_xorv16qi_scalar */

    case 91:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7067; /* pred_xorv32qi_scalar */

    case 92:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7076; /* pred_xorv64qi_scalar */

    case 93:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7085; /* pred_xorv128qi_scalar */

    case 94:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7094; /* pred_xorv256qi_scalar */

    case 95:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7103; /* pred_xorv512qi_scalar */

    case 96:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7112; /* pred_xorv1024qi_scalar */

    case 97:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7121; /* pred_xorv2048qi_scalar */

    case 98:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7130; /* pred_xorv4096qi_scalar */

    case 99:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7139; /* pred_xorv1hi_scalar */

    case 100:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7148; /* pred_xorv2hi_scalar */

    case 101:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7157; /* pred_xorv4hi_scalar */

    case 102:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7166; /* pred_xorv8hi_scalar */

    case 103:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7175; /* pred_xorv16hi_scalar */

    case 104:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7184; /* pred_xorv32hi_scalar */

    case 105:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7193; /* pred_xorv64hi_scalar */

    case 106:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7202; /* pred_xorv128hi_scalar */

    case 107:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7211; /* pred_xorv256hi_scalar */

    case 108:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7220; /* pred_xorv512hi_scalar */

    case 109:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7229; /* pred_xorv1024hi_scalar */

    case 110:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7238; /* pred_xorv2048hi_scalar */

    case 111:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7247; /* pred_xorv1si_scalar */

    case 112:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7256; /* pred_xorv2si_scalar */

    case 113:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7265; /* pred_xorv4si_scalar */

    case 114:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7274; /* pred_xorv8si_scalar */

    case 115:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7283; /* pred_xorv16si_scalar */

    case 116:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7292; /* pred_xorv32si_scalar */

    case 117:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7301; /* pred_xorv64si_scalar */

    case 118:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7310; /* pred_xorv128si_scalar */

    case 119:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7319; /* pred_xorv256si_scalar */

    case 120:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7328; /* pred_xorv512si_scalar */

    case 121:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7337; /* pred_xorv1024si_scalar */

    case 122:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7670; /* *pred_xorrvvm8di_scalar */

    case 123:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7679; /* *pred_xorrvvm4di_scalar */

    case 124:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7688; /* *pred_xorrvvm2di_scalar */

    case 125:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7697; /* *pred_xorrvvm1di_scalar */

    case 126:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7706; /* *pred_xorv1di_scalar */

    case 127:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7715; /* *pred_xorv2di_scalar */

    case 128:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7724; /* *pred_xorv4di_scalar */

    case 129:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7733; /* *pred_xorv8di_scalar */

    case 130:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7742; /* *pred_xorv16di_scalar */

    case 131:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7751; /* *pred_xorv32di_scalar */

    case 132:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7760; /* *pred_xorv64di_scalar */

    case 133:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7769; /* *pred_xorv128di_scalar */

    case 134:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7778; /* *pred_xorv256di_scalar */

    case 135:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7787; /* *pred_xorv512di_scalar */

    case 136:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7796; /* *pred_xorrvvm8di_extended_scalar */

    case 137:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7805; /* *pred_xorrvvm4di_extended_scalar */

    case 138:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7814; /* *pred_xorrvvm2di_extended_scalar */

    case 139:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7823; /* *pred_xorrvvm1di_extended_scalar */

    case 140:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7832; /* *pred_xorv1di_extended_scalar */

    case 141:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7841; /* *pred_xorv2di_extended_scalar */

    case 142:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7850; /* *pred_xorv4di_extended_scalar */

    case 143:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7859; /* *pred_xorv8di_extended_scalar */

    case 144:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7868; /* *pred_xorv16di_extended_scalar */

    case 145:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7877; /* *pred_xorv32di_extended_scalar */

    case 146:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7886; /* *pred_xorv64di_extended_scalar */

    case 147:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7895; /* *pred_xorv128di_extended_scalar */

    case 148:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7904; /* *pred_xorv256di_extended_scalar */

    case 149:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7913; /* *pred_xorv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_919 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[3] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[4] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[5] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[6] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[7] = x10;
      return recog_883 (x1, insn, pnum_clobbers);

    case UNSPEC:
      if (XVECLEN (x5, 0) != 2
          || XINT (x5, 1) != 123)
        return -1;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XVECEXP (x5, 0, 0);
      operands[3] = x11;
      x12 = XVECEXP (x5, 0, 1);
      switch (GET_CODE (x12))
        {
        case REG:
        case SUBREG:
          operands[4] = x12;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8HFmode:
              if (pattern711 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
                  || !(
#line 6404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15128; /* pred_ncopysignrvvm8hf */

            case E_RVVM4HFmode:
              if (pattern711 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
                  || !(
#line 6404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15129; /* pred_ncopysignrvvm4hf */

            case E_RVVM2HFmode:
              if (pattern711 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 6404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15130; /* pred_ncopysignrvvm2hf */

            case E_RVVM1HFmode:
              if (pattern711 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 6404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15131; /* pred_ncopysignrvvm1hf */

            case E_RVVMF2HFmode:
              if (pattern711 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 6404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15132; /* pred_ncopysignrvvmf2hf */

            case E_RVVMF4HFmode:
              if (pattern711 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 6404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 15133; /* pred_ncopysignrvvmf4hf */

            case E_RVVM8SFmode:
              if (pattern711 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
                  || !(
#line 6404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15134; /* pred_ncopysignrvvm8sf */

            case E_RVVM4SFmode:
              if (pattern711 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 6404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15135; /* pred_ncopysignrvvm4sf */

            case E_RVVM2SFmode:
              if (pattern711 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 6404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15136; /* pred_ncopysignrvvm2sf */

            case E_RVVM1SFmode:
              if (pattern711 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 6404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15137; /* pred_ncopysignrvvm1sf */

            case E_RVVMF2SFmode:
              if (pattern711 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 6404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 15138; /* pred_ncopysignrvvmf2sf */

            case E_RVVM8DFmode:
              if (pattern711 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 6404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15139; /* pred_ncopysignrvvm8df */

            case E_RVVM4DFmode:
              if (pattern711 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 6404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15140; /* pred_ncopysignrvvm4df */

            case E_RVVM2DFmode:
              if (pattern711 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 6404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15141; /* pred_ncopysignrvvm2df */

            case E_RVVM1DFmode:
              if (pattern711 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 6404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15142; /* pred_ncopysignrvvm1df */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x13 = XEXP (x12, 0);
          operands[4] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8HFmode:
              if (pattern712 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode) != 0
                  || !(
#line 6447 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15239; /* pred_ncopysignrvvm8hf_scalar */

            case E_RVVM4HFmode:
              if (pattern712 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0
                  || !(
#line 6447 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15240; /* pred_ncopysignrvvm4hf_scalar */

            case E_RVVM2HFmode:
              if (pattern712 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0
                  || !(
#line 6447 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15241; /* pred_ncopysignrvvm2hf_scalar */

            case E_RVVM1HFmode:
              if (pattern712 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0
                  || !(
#line 6447 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15242; /* pred_ncopysignrvvm1hf_scalar */

            case E_RVVMF2HFmode:
              if (pattern712 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0
                  || !(
#line 6447 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15243; /* pred_ncopysignrvvmf2hf_scalar */

            case E_RVVMF4HFmode:
              if (pattern712 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0
                  || !(
#line 6447 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 15244; /* pred_ncopysignrvvmf4hf_scalar */

            case E_RVVM8SFmode:
              if (pattern712 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode, 
E_SFmode) != 0
                  || !(
#line 6447 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15245; /* pred_ncopysignrvvm8sf_scalar */

            case E_RVVM4SFmode:
              if (pattern712 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0
                  || !(
#line 6447 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15246; /* pred_ncopysignrvvm4sf_scalar */

            case E_RVVM2SFmode:
              if (pattern712 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0
                  || !(
#line 6447 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15247; /* pred_ncopysignrvvm2sf_scalar */

            case E_RVVM1SFmode:
              if (pattern712 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0
                  || !(
#line 6447 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15248; /* pred_ncopysignrvvm1sf_scalar */

            case E_RVVMF2SFmode:
              if (pattern712 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0
                  || !(
#line 6447 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 15249; /* pred_ncopysignrvvmf2sf_scalar */

            case E_RVVM8DFmode:
              if (pattern712 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode, 
E_DFmode) != 0
                  || !(
#line 6447 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15250; /* pred_ncopysignrvvm8df_scalar */

            case E_RVVM4DFmode:
              if (pattern712 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode, 
E_DFmode) != 0
                  || !(
#line 6447 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15251; /* pred_ncopysignrvvm4df_scalar */

            case E_RVVM2DFmode:
              if (pattern712 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode, 
E_DFmode) != 0
                  || !(
#line 6447 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15252; /* pred_ncopysignrvvm2df_scalar */

            case E_RVVM1DFmode:
              if (pattern712 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode, 
E_DFmode) != 0
                  || !(
#line 6447 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15253; /* pred_ncopysignrvvm1df_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_923 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern474 (x2))
    {
    case 0:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))))
        return -1;
      return 1255; /* *pred_mov_widthwrvvm8qi */

    case 1:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))))
        return -1;
      return 1261; /* *pred_mov_widthwrvvm4qi */

    case 2:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))))
        return -1;
      return 1267; /* *pred_mov_widthwrvvm2qi */

    case 3:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))))
        return -1;
      return 1273; /* *pred_mov_widthwrvvm1qi */

    case 4:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))))
        return -1;
      return 1279; /* *pred_mov_widthwrvvm8hi */

    case 5:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))))
        return -1;
      return 1285; /* *pred_mov_widthwrvvm4hi */

    case 6:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))))
        return -1;
      return 1291; /* *pred_mov_widthwrvvm2hi */

    case 7:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))))
        return -1;
      return 1297; /* *pred_mov_widthwrvvm1hi */

    case 8:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))))
        return -1;
      return 1303; /* *pred_mov_widthwrvvm8si */

    case 9:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))))
        return -1;
      return 1309; /* *pred_mov_widthwrvvm4si */

    case 10:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))))
        return -1;
      return 1315; /* *pred_mov_widthwrvvm2si */

    case 11:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))))
        return -1;
      return 1321; /* *pred_mov_widthwrvvm1si */

    case 12:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1327; /* *pred_mov_widthwrvvm8di */

    case 13:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1333; /* *pred_mov_widthwrvvm4di */

    case 14:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1339; /* *pred_mov_widthwrvvm2di */

    case 15:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1345; /* *pred_mov_widthwrvvm1di */

    case 16:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1351; /* *pred_mov_widthwrvvmf2qi */

    case 17:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1357; /* *pred_mov_widthwrvvmf4qi */

    case 18:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1363; /* *pred_mov_widthwrvvmf8qi */

    case 19:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1369; /* *pred_mov_widthwrvvmf2hi */

    case 20:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1375; /* *pred_mov_widthwrvvmf4hi */

    case 21:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1381; /* *pred_mov_widthwrvvmf2si */

    case 22:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1387; /* *pred_mov_widthwrvvm8bf */

    case 23:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1393; /* *pred_mov_widthwrvvm4bf */

    case 24:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1399; /* *pred_mov_widthwrvvm2bf */

    case 25:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1405; /* *pred_mov_widthwrvvm1bf */

    case 26:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1411; /* *pred_mov_widthwrvvmf2bf */

    case 27:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1417; /* *pred_mov_widthwrvvmf4bf */

    case 28:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1423; /* *pred_mov_widthwrvvm8hf */

    case 29:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1429; /* *pred_mov_widthwrvvm4hf */

    case 30:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1435; /* *pred_mov_widthwrvvm2hf */

    case 31:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1441; /* *pred_mov_widthwrvvm1hf */

    case 32:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1447; /* *pred_mov_widthwrvvmf2hf */

    case 33:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1453; /* *pred_mov_widthwrvvmf4hf */

    case 34:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1459; /* *pred_mov_widthwrvvm8sf */

    case 35:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1465; /* *pred_mov_widthwrvvm4sf */

    case 36:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1471; /* *pred_mov_widthwrvvm2sf */

    case 37:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1477; /* *pred_mov_widthwrvvm1sf */

    case 38:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1483; /* *pred_mov_widthwrvvmf2sf */

    case 39:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1489; /* *pred_mov_widthwrvvm8df */

    case 40:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1495; /* *pred_mov_widthwrvvm4df */

    case 41:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1501; /* *pred_mov_widthwrvvm2df */

    case 42:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1507; /* *pred_mov_widthwrvvm1df */

    case 43:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 1513; /* *pred_mov_widthwv1qi */

    case 44:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 1519; /* *pred_mov_widthwv2qi */

    case 45:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 1525; /* *pred_mov_widthwv4qi */

    case 46:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 1531; /* *pred_mov_widthwv8qi */

    case 47:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 1537; /* *pred_mov_widthwv16qi */

    case 48:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 1543; /* *pred_mov_widthwv32qi */

    case 49:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1549; /* *pred_mov_widthwv64qi */

    case 50:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1555; /* *pred_mov_widthwv128qi */

    case 51:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1561; /* *pred_mov_widthwv256qi */

    case 52:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1567; /* *pred_mov_widthwv512qi */

    case 53:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1573; /* *pred_mov_widthwv1024qi */

    case 54:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1579; /* *pred_mov_widthwv2048qi */

    case 55:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1585; /* *pred_mov_widthwv4096qi */

    case 56:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 1591; /* *pred_mov_widthwv1hi */

    case 57:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 1597; /* *pred_mov_widthwv2hi */

    case 58:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 1603; /* *pred_mov_widthwv4hi */

    case 59:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 1609; /* *pred_mov_widthwv8hi */

    case 60:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 1615; /* *pred_mov_widthwv16hi */

    case 61:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1621; /* *pred_mov_widthwv32hi */

    case 62:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1627; /* *pred_mov_widthwv64hi */

    case 63:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1633; /* *pred_mov_widthwv128hi */

    case 64:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1639; /* *pred_mov_widthwv256hi */

    case 65:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1645; /* *pred_mov_widthwv512hi */

    case 66:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1651; /* *pred_mov_widthwv1024hi */

    case 67:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1657; /* *pred_mov_widthwv2048hi */

    case 68:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 1663; /* *pred_mov_widthwv1si */

    case 69:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 1669; /* *pred_mov_widthwv2si */

    case 70:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 1675; /* *pred_mov_widthwv4si */

    case 71:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 1681; /* *pred_mov_widthwv8si */

    case 72:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1687; /* *pred_mov_widthwv16si */

    case 73:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1693; /* *pred_mov_widthwv32si */

    case 74:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1699; /* *pred_mov_widthwv64si */

    case 75:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1705; /* *pred_mov_widthwv128si */

    case 76:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1711; /* *pred_mov_widthwv256si */

    case 77:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1717; /* *pred_mov_widthwv512si */

    case 78:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1723; /* *pred_mov_widthwv1024si */

    case 79:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1729; /* *pred_mov_widthwv1di */

    case 80:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1735; /* *pred_mov_widthwv2di */

    case 81:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1741; /* *pred_mov_widthwv4di */

    case 82:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1747; /* *pred_mov_widthwv8di */

    case 83:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1753; /* *pred_mov_widthwv16di */

    case 84:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1759; /* *pred_mov_widthwv32di */

    case 85:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1765; /* *pred_mov_widthwv64di */

    case 86:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1771; /* *pred_mov_widthwv128di */

    case 87:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1777; /* *pred_mov_widthwv256di */

    case 88:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1783; /* *pred_mov_widthwv512di */

    case 89:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1789; /* *pred_mov_widthwv1hf */

    case 90:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1795; /* *pred_mov_widthwv2hf */

    case 91:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1801; /* *pred_mov_widthwv4hf */

    case 92:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1807; /* *pred_mov_widthwv8hf */

    case 93:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1813; /* *pred_mov_widthwv16hf */

    case 94:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1819; /* *pred_mov_widthwv32hf */

    case 95:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1825; /* *pred_mov_widthwv64hf */

    case 96:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1831; /* *pred_mov_widthwv128hf */

    case 97:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1837; /* *pred_mov_widthwv256hf */

    case 98:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1843; /* *pred_mov_widthwv512hf */

    case 99:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1849; /* *pred_mov_widthwv1024hf */

    case 100:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1855; /* *pred_mov_widthwv2048hf */

    case 101:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1861; /* *pred_mov_widthwv1sf */

    case 102:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1867; /* *pred_mov_widthwv2sf */

    case 103:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1873; /* *pred_mov_widthwv4sf */

    case 104:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1879; /* *pred_mov_widthwv8sf */

    case 105:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1885; /* *pred_mov_widthwv16sf */

    case 106:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1891; /* *pred_mov_widthwv32sf */

    case 107:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1897; /* *pred_mov_widthwv64sf */

    case 108:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1903; /* *pred_mov_widthwv128sf */

    case 109:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1909; /* *pred_mov_widthwv256sf */

    case 110:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1915; /* *pred_mov_widthwv512sf */

    case 111:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1921; /* *pred_mov_widthwv1024sf */

    case 112:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1927; /* *pred_mov_widthwv1df */

    case 113:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1933; /* *pred_mov_widthwv2df */

    case 114:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1939; /* *pred_mov_widthwv4df */

    case 115:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1945; /* *pred_mov_widthwv8df */

    case 116:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1951; /* *pred_mov_widthwv16df */

    case 117:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1957; /* *pred_mov_widthwv32df */

    case 118:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1963; /* *pred_mov_widthwv64df */

    case 119:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1969; /* *pred_mov_widthwv128df */

    case 120:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1975; /* *pred_mov_widthwv256df */

    case 121:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1981; /* *pred_mov_widthwv512df */

    default:
      return -1;
    }
}

 int
recog_936 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern724 (x2))
    {
    case 0:
      if (vector_shift_operand (operands[4], E_RVVM4QImode)
          && 
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12235; /* pred_narrow_cliprvvm8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12331; /* pred_narrow_cliprvvm8hi_scalar */

    case 1:
      if (vector_shift_operand (operands[4], E_RVVM2QImode)
          && 
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12237; /* pred_narrow_cliprvvm4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12333; /* pred_narrow_cliprvvm4hi_scalar */

    case 2:
      if (vector_shift_operand (operands[4], E_RVVM1QImode)
          && 
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12239; /* pred_narrow_cliprvvm2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12335; /* pred_narrow_cliprvvm2hi_scalar */

    case 3:
      if (vector_shift_operand (operands[4], E_RVVMF2QImode)
          && 
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12241; /* pred_narrow_cliprvvm1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12337; /* pred_narrow_cliprvvm1hi_scalar */

    case 4:
      if (vector_shift_operand (operands[4], E_RVVMF4QImode)
          && 
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12243; /* pred_narrow_cliprvvmf2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12339; /* pred_narrow_cliprvvmf2hi_scalar */

    case 5:
      if (vector_shift_operand (operands[4], E_RVVMF8QImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12245; /* pred_narrow_cliprvvmf4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12341; /* pred_narrow_cliprvvmf4hi_scalar */

    case 6:
      if (vector_shift_operand (operands[4], E_RVVM4HImode)
          && 
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12247; /* pred_narrow_cliprvvm8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12343; /* pred_narrow_cliprvvm8si_scalar */

    case 7:
      if (vector_shift_operand (operands[4], E_RVVM2HImode)
          && 
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12249; /* pred_narrow_cliprvvm4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12345; /* pred_narrow_cliprvvm4si_scalar */

    case 8:
      if (vector_shift_operand (operands[4], E_RVVM1HImode)
          && 
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12251; /* pred_narrow_cliprvvm2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12347; /* pred_narrow_cliprvvm2si_scalar */

    case 9:
      if (vector_shift_operand (operands[4], E_RVVMF2HImode)
          && 
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12253; /* pred_narrow_cliprvvm1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12349; /* pred_narrow_cliprvvm1si_scalar */

    case 10:
      if (vector_shift_operand (operands[4], E_RVVMF4HImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12255; /* pred_narrow_cliprvvmf2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12351; /* pred_narrow_cliprvvmf2si_scalar */

    case 11:
      if (vector_shift_operand (operands[4], E_RVVM4SImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12257; /* pred_narrow_cliprvvm8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12353; /* pred_narrow_cliprvvm8di_scalar */

    case 12:
      if (vector_shift_operand (operands[4], E_RVVM2SImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12259; /* pred_narrow_cliprvvm4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12355; /* pred_narrow_cliprvvm4di_scalar */

    case 13:
      if (vector_shift_operand (operands[4], E_RVVM1SImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12261; /* pred_narrow_cliprvvm2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12357; /* pred_narrow_cliprvvm2di_scalar */

    case 14:
      if (vector_shift_operand (operands[4], E_RVVMF2SImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12263; /* pred_narrow_cliprvvm1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12359; /* pred_narrow_cliprvvm1di_scalar */

    case 15:
      if (vector_shift_operand (operands[4], E_V1QImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 12265; /* pred_narrow_clipv1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 12361; /* pred_narrow_clipv1hi_scalar */

    case 16:
      if (vector_shift_operand (operands[4], E_V2QImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 12267; /* pred_narrow_clipv2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 12363; /* pred_narrow_clipv2hi_scalar */

    case 17:
      if (vector_shift_operand (operands[4], E_V4QImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 12269; /* pred_narrow_clipv4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12365; /* pred_narrow_clipv4hi_scalar */

    case 18:
      if (vector_shift_operand (operands[4], E_V8QImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 12271; /* pred_narrow_clipv8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12367; /* pred_narrow_clipv8hi_scalar */

    case 19:
      if (vector_shift_operand (operands[4], E_V16QImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 12273; /* pred_narrow_clipv16hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12369; /* pred_narrow_clipv16hi_scalar */

    case 20:
      if (vector_shift_operand (operands[4], E_V32QImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 12275; /* pred_narrow_clipv32hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12371; /* pred_narrow_clipv32hi_scalar */

    case 21:
      if (vector_shift_operand (operands[4], E_V64QImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 12277; /* pred_narrow_clipv64hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12373; /* pred_narrow_clipv64hi_scalar */

    case 22:
      if (vector_shift_operand (operands[4], E_V128QImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 12279; /* pred_narrow_clipv128hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12375; /* pred_narrow_clipv128hi_scalar */

    case 23:
      if (vector_shift_operand (operands[4], E_V256QImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 12281; /* pred_narrow_clipv256hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12377; /* pred_narrow_clipv256hi_scalar */

    case 24:
      if (vector_shift_operand (operands[4], E_V512QImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 12283; /* pred_narrow_clipv512hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12379; /* pred_narrow_clipv512hi_scalar */

    case 25:
      if (vector_shift_operand (operands[4], E_V1024QImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 12285; /* pred_narrow_clipv1024hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12381; /* pred_narrow_clipv1024hi_scalar */

    case 26:
      if (vector_shift_operand (operands[4], E_V2048QImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 12287; /* pred_narrow_clipv2048hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12383; /* pred_narrow_clipv2048hi_scalar */

    case 27:
      if (vector_shift_operand (operands[4], E_V1HImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 12289; /* pred_narrow_clipv1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 12385; /* pred_narrow_clipv1si_scalar */

    case 28:
      if (vector_shift_operand (operands[4], E_V2HImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 12291; /* pred_narrow_clipv2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 12387; /* pred_narrow_clipv2si_scalar */

    case 29:
      if (vector_shift_operand (operands[4], E_V4HImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 12293; /* pred_narrow_clipv4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12389; /* pred_narrow_clipv4si_scalar */

    case 30:
      if (vector_shift_operand (operands[4], E_V8HImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 12295; /* pred_narrow_clipv8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12391; /* pred_narrow_clipv8si_scalar */

    case 31:
      if (vector_shift_operand (operands[4], E_V16HImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 12297; /* pred_narrow_clipv16si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12393; /* pred_narrow_clipv16si_scalar */

    case 32:
      if (vector_shift_operand (operands[4], E_V32HImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 12299; /* pred_narrow_clipv32si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12395; /* pred_narrow_clipv32si_scalar */

    case 33:
      if (vector_shift_operand (operands[4], E_V64HImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 12301; /* pred_narrow_clipv64si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12397; /* pred_narrow_clipv64si_scalar */

    case 34:
      if (vector_shift_operand (operands[4], E_V128HImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 12303; /* pred_narrow_clipv128si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12399; /* pred_narrow_clipv128si_scalar */

    case 35:
      if (vector_shift_operand (operands[4], E_V256HImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 12305; /* pred_narrow_clipv256si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12401; /* pred_narrow_clipv256si_scalar */

    case 36:
      if (vector_shift_operand (operands[4], E_V512HImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 12307; /* pred_narrow_clipv512si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12403; /* pred_narrow_clipv512si_scalar */

    case 37:
      if (vector_shift_operand (operands[4], E_V1024HImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 12309; /* pred_narrow_clipv1024si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12405; /* pred_narrow_clipv1024si_scalar */

    case 38:
      if (vector_shift_operand (operands[4], E_V1SImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 12311; /* pred_narrow_clipv1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12407; /* pred_narrow_clipv1di_scalar */

    case 39:
      if (vector_shift_operand (operands[4], E_V2SImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 12313; /* pred_narrow_clipv2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12409; /* pred_narrow_clipv2di_scalar */

    case 40:
      if (vector_shift_operand (operands[4], E_V4SImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 12315; /* pred_narrow_clipv4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12411; /* pred_narrow_clipv4di_scalar */

    case 41:
      if (vector_shift_operand (operands[4], E_V8SImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 12317; /* pred_narrow_clipv8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12413; /* pred_narrow_clipv8di_scalar */

    case 42:
      if (vector_shift_operand (operands[4], E_V16SImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 12319; /* pred_narrow_clipv16di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12415; /* pred_narrow_clipv16di_scalar */

    case 43:
      if (vector_shift_operand (operands[4], E_V32SImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 12321; /* pred_narrow_clipv32di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12417; /* pred_narrow_clipv32di_scalar */

    case 44:
      if (vector_shift_operand (operands[4], E_V64SImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 12323; /* pred_narrow_clipv64di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12419; /* pred_narrow_clipv64di_scalar */

    case 45:
      if (vector_shift_operand (operands[4], E_V128SImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 12325; /* pred_narrow_clipv128di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12421; /* pred_narrow_clipv128di_scalar */

    case 46:
      if (vector_shift_operand (operands[4], E_V256SImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 12327; /* pred_narrow_clipv256di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12423; /* pred_narrow_clipv256di_scalar */

    case 47:
      if (vector_shift_operand (operands[4], E_V512SImode)
          && (
#line 4702 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 12329; /* pred_narrow_clipv512di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4725 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12425; /* pred_narrow_clipv512di_scalar */

    default:
      return -1;
    }
}

 int
recog_1047 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM2HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM2HFmode)
      || !(
#line 6715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15738; /* *pred_mul_neg_addrvvm2hf_undef */
}

 int
recog_1056 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM8DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM8DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM8DFmode)
      || !(
#line 6715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15756; /* *pred_mul_neg_addrvvm8df_undef */
}

 int
recog_1066 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V64HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V64HFmode)
      || !(
#line 6715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15776; /* *pred_mul_neg_addv64hf_undef */
}

 int
recog_1076 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V16SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V16SFmode)
      || !(
#line 6715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15796; /* *pred_mul_neg_addv16sf_undef */
}

 int
recog_1086 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V8DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V8DFmode)
      || !(
#line 6715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15816; /* *pred_mul_neg_addv8df_undef */
}

 int
recog_1096 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1089 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V64DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return 15918; /* *pred_nmsubv64df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 16014; /* *pred_nmsacv64df */
}

 int
recog_1106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1079 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V128SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V128SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return 15898; /* *pred_nmsubv128sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15994; /* *pred_nmsacv128sf */
}

 int
recog_1116 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1069 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V512HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V512HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return 15878; /* *pred_nmsubv512hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15974; /* *pred_nmsacv512hf */
}

 int
recog_1126 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1059 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM1DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM1DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15858; /* *pred_nmsubrvvm1df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15954; /* *pred_nmsacrvvm1df */
}

 int
recog_1136 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1049 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVMF2HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVMF2HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15838; /* *pred_nmsubrvvmf2hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15934; /* *pred_nmsacrvvmf2hf */
}

 int
recog_1146 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM2HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM2HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM2HFmode)
      || !(
#line 6502 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15259; /* *pred_mul_subrvvm2hf_undef */
}

 int
recog_1153 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM1SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM1SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM1SFmode)
      || !(
#line 6502 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15273; /* *pred_mul_subrvvm1sf_undef */
}

 int
recog_1160 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V2HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V2HFmode)
      || !(
#line 6502 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15287; /* *pred_mul_subv2hf_undef */
}

 int
recog_1167 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V256HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V256HFmode)
      || !(
#line 6502 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15301; /* *pred_mul_subv256hf_undef */
}

 int
recog_1174 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V8SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V8SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V8SFmode)
      || !(
#line 6502 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15315; /* *pred_mul_subv8sf_undef */
}

 int
recog_1181 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V1024SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V1024SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V1024SFmode)
      || !(
#line 6502 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15329; /* *pred_mul_subv1024sf_undef */
}

 int
recog_1188 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V64DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V64DFmode)
      || !(
#line 6502 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15343; /* *pred_mul_subv64df_undef */
}

 int
recog_1195 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1188 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return 15439; /* *pred_msubv64df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15535; /* *pred_msacv64df */
}

 int
recog_1202 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1181 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1024SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V1024SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return 15425; /* *pred_msubv1024sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15521; /* *pred_msacv1024sf */
}

 int
recog_1209 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1174 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V8SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V8SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15411; /* *pred_msubv8sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15507; /* *pred_msacv8sf */
}

 int
recog_1216 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1167 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return 15397; /* *pred_msubv256hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15493; /* *pred_msacv256hf */
}

 int
recog_1223 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1160 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return 15383; /* *pred_msubv2hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15479; /* *pred_msacv2hf */
}

 int
recog_1230 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1153 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM1SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM1SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15369; /* *pred_msubrvvm1sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15465; /* *pred_msacrvvm1sf */
}

 int
recog_1237 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1146 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM2HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15355; /* *pred_msubrvvm2hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15451; /* *pred_msacrvvm2hf */
}

 int
recog_1244 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVMF2HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVMF2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVMF2HFmode)
      || !(
#line 6715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15743; /* *pred_mul_neg_subrvvmf2hf_undef */
}

 int
recog_1251 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM8DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM8DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM8DFmode)
      || !(
#line 6715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15757; /* *pred_mul_neg_subrvvm8df_undef */
}

 int
recog_1258 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V8HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V8HFmode)
      || !(
#line 6715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return -1;
  return 15771; /* *pred_mul_neg_subv8hf_undef */
}

 int
recog_1265 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1024HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1024HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1024HFmode)
      || !(
#line 6715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15785; /* *pred_mul_neg_subv1024hf_undef */
}

 int
recog_1272 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V32SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V32SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V32SFmode)
      || !(
#line 6715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15799; /* *pred_mul_neg_subv32sf_undef */
}

 int
recog_1279 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V2DFmode)
      || !(
#line 6715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15813; /* *pred_mul_neg_subv2df_undef */
}

 int
recog_1286 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V256DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V256DFmode)
      || !(
#line 6715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15827; /* *pred_mul_neg_subv256df_undef */
}

 int
recog_1293 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1282 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V16DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V16DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return 15915; /* *pred_nmaddv16df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 16011; /* *pred_nmaccv16df */
}

 int
recog_1300 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1275 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V256SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V256SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return 15901; /* *pred_nmaddv256sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15997; /* *pred_nmaccv256sf */
}

 int
recog_1307 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1268 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V2SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V2SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15887; /* *pred_nmaddv2sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15983; /* *pred_nmaccv2sf */
}

 int
recog_1314 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1261 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V64HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V64HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return 15873; /* *pred_nmaddv64hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15969; /* *pred_nmaccv64hf */
}

 int
recog_1322 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1253 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM2DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM2DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15857; /* *pred_nmaddrvvm2df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15953; /* *pred_nmaccrvvm2df */
}

 int
recog_1330 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1245 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVMF4HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVMF4HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
    return 15841; /* *pred_nmaddrvvmf4hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 15937; /* *pred_nmaccrvvmf4hf */
}

 int
recog_1338 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XVECEXP (x5, 0, 5);
  operands[9] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  x12 = XEXP (x3, 1);
  switch (GET_CODE (x12))
    {
    case REG:
    case SUBREG:
      switch (pattern713 (x2))
        {
        case 0:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14500; /* pred_subrvvm8hf */

        case 1:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14504; /* pred_subrvvm4hf */

        case 2:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14508; /* pred_subrvvm2hf */

        case 3:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14512; /* pred_subrvvm1hf */

        case 4:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14516; /* pred_subrvvmf2hf */

        case 5:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14520; /* pred_subrvvmf4hf */

        case 6:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14524; /* pred_subrvvm8sf */

        case 7:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14528; /* pred_subrvvm4sf */

        case 8:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14532; /* pred_subrvvm2sf */

        case 9:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14536; /* pred_subrvvm1sf */

        case 10:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14540; /* pred_subrvvmf2sf */

        case 11:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14544; /* pred_subrvvm8df */

        case 12:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14548; /* pred_subrvvm4df */

        case 13:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14552; /* pred_subrvvm2df */

        case 14:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14556; /* pred_subrvvm1df */

        case 15:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 14560; /* pred_subv1hf */

        case 16:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 14564; /* pred_subv2hf */

        case 17:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 14568; /* pred_subv4hf */

        case 18:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 14572; /* pred_subv8hf */

        case 19:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 14576; /* pred_subv16hf */

        case 20:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14580; /* pred_subv32hf */

        case 21:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14584; /* pred_subv64hf */

        case 22:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14588; /* pred_subv128hf */

        case 23:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14592; /* pred_subv256hf */

        case 24:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14596; /* pred_subv512hf */

        case 25:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14600; /* pred_subv1024hf */

        case 26:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14604; /* pred_subv2048hf */

        case 27:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14608; /* pred_subv1sf */

        case 28:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14612; /* pred_subv2sf */

        case 29:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14616; /* pred_subv4sf */

        case 30:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14620; /* pred_subv8sf */

        case 31:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14624; /* pred_subv16sf */

        case 32:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14628; /* pred_subv32sf */

        case 33:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14632; /* pred_subv64sf */

        case 34:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14636; /* pred_subv128sf */

        case 35:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14640; /* pred_subv256sf */

        case 36:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14644; /* pred_subv512sf */

        case 37:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14648; /* pred_subv1024sf */

        case 38:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14652; /* pred_subv1df */

        case 39:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14656; /* pred_subv2df */

        case 40:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14660; /* pred_subv4df */

        case 41:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14664; /* pred_subv8df */

        case 42:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14668; /* pred_subv16df */

        case 43:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14672; /* pred_subv32df */

        case 44:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14676; /* pred_subv64df */

        case 45:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14680; /* pred_subv128df */

        case 46:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14684; /* pred_subv256df */

        case 47:
          if (!(
#line 6202 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14688; /* pred_subv512df */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern728 (x2))
        {
        case 0:
          if (!(
#line 6336 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14972; /* pred_subrvvm8hf_scalar */

        case 1:
          if (!(
#line 6336 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14974; /* pred_subrvvm4hf_scalar */

        case 2:
          if (!(
#line 6336 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14976; /* pred_subrvvm2hf_scalar */

        case 3:
          if (!(
#line 6336 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14978; /* pred_subrvvm1hf_scalar */

        case 4:
          if (!(
#line 6336 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14980; /* pred_subrvvmf2hf_scalar */

        case 5:
          if (!(
#line 6336 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14982; /* pred_subrvvmf4hf_scalar */

        case 6:
          if (!(
#line 6336 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14984; /* pred_subrvvm8sf_scalar */

        case 7:
          if (!(
#line 6336 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14986; /* pred_subrvvm4sf_scalar */

        case 8:
          if (!(
#line 6336 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14988; /* pred_subrvvm2sf_scalar */

        case 9:
          if (!(
#line 6336 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14990; /* pred_subrvvm1sf_scalar */

        case 10:
          if (!(
#line 6336 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14992; /* pred_subrvvmf2sf_scalar */

        case 11:
          if (!(
#line 6336 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14994; /* pred_subrvvm8df_scalar */

        case 12:
          if (!(
#line 6336 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14996; /* pred_subrvvm4df_scalar */

        case 13:
          if (!(
#line 6336 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14998; /* pred_subrvvm2df_scalar */

        case 14:
          if (!(
#line 6336 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 15000; /* pred_subrvvm1df_scalar */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x13 = XEXP (x12, 0);
      switch (GET_CODE (x13))
        {
        case REG:
        case SUBREG:
          operands[4] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              if (pattern542 (x2, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16613; /* pred_single_widen_subrvvm8sf */

            case E_RVVM4SFmode:
              if (pattern542 (x2, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16614; /* pred_single_widen_subrvvm4sf */

            case E_RVVM2SFmode:
              if (pattern542 (x2, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16615; /* pred_single_widen_subrvvm2sf */

            case E_RVVM1SFmode:
              if (pattern542 (x2, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16616; /* pred_single_widen_subrvvm1sf */

            case E_RVVMF2SFmode:
              if (pattern542 (x2, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 16617; /* pred_single_widen_subrvvmf2sf */

            case E_RVVM8DFmode:
              if (pattern542 (x2, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16618; /* pred_single_widen_subrvvm8df */

            case E_RVVM4DFmode:
              if (pattern542 (x2, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16619; /* pred_single_widen_subrvvm4df */

            case E_RVVM2DFmode:
              if (pattern542 (x2, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16620; /* pred_single_widen_subrvvm2df */

            case E_RVVM1DFmode:
              if (pattern542 (x2, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16621; /* pred_single_widen_subrvvm1df */

            case E_V1SFmode:
              if (pattern542 (x2, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16622; /* pred_single_widen_subv1sf */

            case E_V2SFmode:
              if (pattern542 (x2, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16623; /* pred_single_widen_subv2sf */

            case E_V4SFmode:
              if (pattern542 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16624; /* pred_single_widen_subv4sf */

            case E_V8SFmode:
              if (pattern542 (x2, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16625; /* pred_single_widen_subv8sf */

            case E_V16SFmode:
              if (pattern542 (x2, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16626; /* pred_single_widen_subv16sf */

            case E_V32SFmode:
              if (pattern542 (x2, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16627; /* pred_single_widen_subv32sf */

            case E_V64SFmode:
              if (pattern542 (x2, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16628; /* pred_single_widen_subv64sf */

            case E_V128SFmode:
              if (pattern542 (x2, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16629; /* pred_single_widen_subv128sf */

            case E_V256SFmode:
              if (pattern542 (x2, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16630; /* pred_single_widen_subv256sf */

            case E_V512SFmode:
              if (pattern542 (x2, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16631; /* pred_single_widen_subv512sf */

            case E_V1024SFmode:
              if (pattern542 (x2, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16632; /* pred_single_widen_subv1024sf */

            case E_V1DFmode:
              if (pattern542 (x2, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16633; /* pred_single_widen_subv1df */

            case E_V2DFmode:
              if (pattern542 (x2, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16634; /* pred_single_widen_subv2df */

            case E_V4DFmode:
              if (pattern542 (x2, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16635; /* pred_single_widen_subv4df */

            case E_V8DFmode:
              if (pattern542 (x2, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16636; /* pred_single_widen_subv8df */

            case E_V16DFmode:
              if (pattern542 (x2, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16637; /* pred_single_widen_subv16df */

            case E_V32DFmode:
              if (pattern542 (x2, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16638; /* pred_single_widen_subv32df */

            case E_V64DFmode:
              if (pattern542 (x2, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16639; /* pred_single_widen_subv64df */

            case E_V128DFmode:
              if (pattern542 (x2, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16640; /* pred_single_widen_subv128df */

            case E_V256DFmode:
              if (pattern542 (x2, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16641; /* pred_single_widen_subv256df */

            case E_V512DFmode:
              if (pattern542 (x2, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0
                  || !(
#line 7115 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16642; /* pred_single_widen_subv512df */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          switch (pattern734 (x2))
            {
            case 0:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16644; /* pred_single_widen_subrvvm8sf_scalar */

            case 1:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16646; /* pred_single_widen_subrvvm4sf_scalar */

            case 2:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16648; /* pred_single_widen_subrvvm2sf_scalar */

            case 3:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16650; /* pred_single_widen_subrvvm1sf_scalar */

            case 4:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 16652; /* pred_single_widen_subrvvmf2sf_scalar */

            case 5:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16654; /* pred_single_widen_subrvvm8df_scalar */

            case 6:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16656; /* pred_single_widen_subrvvm4df_scalar */

            case 7:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16658; /* pred_single_widen_subrvvm2df_scalar */

            case 8:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16660; /* pred_single_widen_subrvvm1df_scalar */

            case 9:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16662; /* pred_single_widen_subv1sf_scalar */

            case 10:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16664; /* pred_single_widen_subv2sf_scalar */

            case 11:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16666; /* pred_single_widen_subv4sf_scalar */

            case 12:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16668; /* pred_single_widen_subv8sf_scalar */

            case 13:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16670; /* pred_single_widen_subv16sf_scalar */

            case 14:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16672; /* pred_single_widen_subv32sf_scalar */

            case 15:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16674; /* pred_single_widen_subv64sf_scalar */

            case 16:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16676; /* pred_single_widen_subv128sf_scalar */

            case 17:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16678; /* pred_single_widen_subv256sf_scalar */

            case 18:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16680; /* pred_single_widen_subv512sf_scalar */

            case 19:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16682; /* pred_single_widen_subv1024sf_scalar */

            case 20:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16684; /* pred_single_widen_subv1df_scalar */

            case 21:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16686; /* pred_single_widen_subv2df_scalar */

            case 22:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16688; /* pred_single_widen_subv4df_scalar */

            case 23:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16690; /* pred_single_widen_subv8df_scalar */

            case 24:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16692; /* pred_single_widen_subv16df_scalar */

            case 25:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16694; /* pred_single_widen_subv32df_scalar */

            case 26:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16696; /* pred_single_widen_subv64df_scalar */

            case 27:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16698; /* pred_single_widen_subv128df_scalar */

            case 28:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16700; /* pred_single_widen_subv256df_scalar */

            case 29:
              if (!(
#line 7141 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16702; /* pred_single_widen_subv512df_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1362 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V512QImode:
      if (!register_operand (operands[3], E_V512QImode)
          || !vector_arith_operand (operands[4], E_V512QImode)
          || !(
#line 4769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12458; /* *pred_cmpv512qi_merge_tie_mask */

    case E_V512HImode:
      if (!register_operand (operands[3], E_V512HImode)
          || !vector_arith_operand (operands[4], E_V512HImode)
          || !(
#line 4769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12471; /* *pred_cmpv512hi_merge_tie_mask */

    case E_V512SImode:
      if (!register_operand (operands[3], E_V512SImode)
          || !vector_arith_operand (operands[4], E_V512SImode)
          || !(
#line 4769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12483; /* *pred_cmpv512si_merge_tie_mask */

    case E_V512DImode:
      if (!register_operand (operands[3], E_V512DImode)
          || !vector_arith_operand (operands[4], E_V512DImode)
          || !(
#line 4769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12494; /* *pred_cmpv512di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1371 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern536 (x2, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V8BImode))
    {
      res = recog_1356 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V8BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V8BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V8QImode:
      if (!register_operand (operands[4], E_V8QImode)
          || !vector_arith_operand (operands[5], E_V8QImode))
        return -1;
      if ((
#line 4793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8QImode)) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 12520; /* *pred_cmpv8qi */
      if (!(
#line 4814 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8QImode)) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 12588; /* *pred_cmpv8qi_narrow */

    case E_V8HImode:
      if (!register_operand (operands[4], E_V8HImode)
          || !vector_arith_operand (operands[5], E_V8HImode))
        return -1;
      if ((
#line 4793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8HImode)) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 12533; /* *pred_cmpv8hi */
      if (!(
#line 4814 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8HImode)) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12601; /* *pred_cmpv8hi_narrow */

    case E_V8SImode:
      if (!register_operand (operands[4], E_V8SImode)
          || !vector_arith_operand (operands[5], E_V8SImode))
        return -1;
      if ((
#line 4793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8SImode)) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 12545; /* *pred_cmpv8si */
      if (!(
#line 4814 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8SImode)) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12613; /* *pred_cmpv8si_narrow */

    case E_V8DImode:
      if (!register_operand (operands[4], E_V8DImode)
          || !vector_arith_operand (operands[5], E_V8DImode))
        return -1;
      if ((
#line 4793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8DImode)) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 12556; /* *pred_cmpv8di */
      if (!(
#line 4814 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8DImode)) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12624; /* *pred_cmpv8di_narrow */

    default:
      return -1;
    }
}

 int
recog_1378 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1SImode:
      if (!register_operand (operands[3], E_RVVM1SImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM1SImode)
          || !
#line 4851 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12642; /* *pred_ltgervvm1si_merge_tie_mask */

    case E_RVVM2DImode:
      if (!register_operand (operands[3], E_RVVM2DImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM2DImode)
          || !(
#line 4851 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12645; /* *pred_ltgervvm2di_merge_tie_mask */

    case E_RVVMF4QImode:
      if (!register_operand (operands[3], E_RVVMF4QImode)
          || !vector_neg_arith_operand (operands[4], E_RVVMF4QImode)
          || !(
#line 4851 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 12648; /* *pred_ltgervvmf4qi_merge_tie_mask */

    case E_RVVMF2HImode:
      if (!register_operand (operands[3], E_RVVMF2HImode)
          || !vector_neg_arith_operand (operands[4], E_RVVMF2HImode)
          || !(
#line 4851 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 12650; /* *pred_ltgervvmf2hi_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1383 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8QImode:
      if (!register_operand (operands[3], E_V8QImode)
          || !vector_neg_arith_operand (operands[4], E_V8QImode)
          || !(
#line 4851 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 12656; /* *pred_ltgev8qi_merge_tie_mask */

    case E_V8HImode:
      if (!register_operand (operands[3], E_V8HImode)
          || !vector_neg_arith_operand (operands[4], E_V8HImode)
          || !(
#line 4851 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12669; /* *pred_ltgev8hi_merge_tie_mask */

    case E_V8SImode:
      if (!register_operand (operands[3], E_V8SImode)
          || !vector_neg_arith_operand (operands[4], E_V8SImode)
          || !(
#line 4851 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12681; /* *pred_ltgev8si_merge_tie_mask */

    case E_V8DImode:
      if (!register_operand (operands[3], E_V8DImode)
          || !vector_neg_arith_operand (operands[4], E_V8DImode)
          || !(
#line 4851 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12692; /* *pred_ltgev8di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1390 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V1024QImode:
      if (!register_operand (operands[3], E_V1024QImode)
          || !vector_neg_arith_operand (operands[4], E_V1024QImode)
          || !(
#line 4851 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12663; /* *pred_ltgev1024qi_merge_tie_mask */

    case E_V1024HImode:
      if (!register_operand (operands[3], E_V1024HImode)
          || !vector_neg_arith_operand (operands[4], E_V1024HImode)
          || !(
#line 4851 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12676; /* *pred_ltgev1024hi_merge_tie_mask */

    case E_V1024SImode:
      if (!register_operand (operands[3], E_V1024SImode)
          || !vector_neg_arith_operand (operands[4], E_V1024SImode)
          || !(
#line 4851 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12688; /* *pred_ltgev1024si_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1396 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern537 (x2, 
E_V32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V32BImode))
    {
      res = recog_1385 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V32BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V32BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V32QImode:
      if (!register_operand (operands[4], E_V32QImode)
          || !vector_neg_arith_operand (operands[5], E_V32QImode))
        return -1;
      if ((
#line 4875 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32QImode)) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 12726; /* *pred_ltgev32qi */
      if (!(
#line 4896 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32QImode)) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 12794; /* *pred_ltgev32qi_narrow */

    case E_V32HImode:
      if (!register_operand (operands[4], E_V32HImode)
          || !vector_neg_arith_operand (operands[5], E_V32HImode))
        return -1;
      if ((
#line 4875 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32HImode)) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 12739; /* *pred_ltgev32hi */
      if (!(
#line 4896 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32HImode)) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12807; /* *pred_ltgev32hi_narrow */

    case E_V32SImode:
      if (!register_operand (operands[4], E_V32SImode)
          || !vector_neg_arith_operand (operands[5], E_V32SImode))
        return -1;
      if ((
#line 4875 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32SImode)) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 12751; /* *pred_ltgev32si */
      if (!(
#line 4896 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32SImode)) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12819; /* *pred_ltgev32si_narrow */

    case E_V32DImode:
      if (!register_operand (operands[4], E_V32DImode)
          || !vector_neg_arith_operand (operands[5], E_V32DImode))
        return -1;
      if ((
#line 4875 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32DImode)) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 12762; /* *pred_ltgev32di */
      if (!(
#line 4896 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32DImode)) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12830; /* *pred_ltgev32di_narrow */

    default:
      return -1;
    }
}

 int
recog_1402 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM2QImode:
      if (!register_operand (operands[3], E_RVVM2QImode)
          || GET_MODE (x9) != E_RVVM2QImode
          || !register_operand (operands[4], E_QImode)
          || !
#line 4935 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12837; /* *pred_cmprvvm2qi_scalar_merge_tie_mask */

    case E_RVVM4HImode:
      if (!register_operand (operands[3], E_RVVM4HImode)
          || GET_MODE (x9) != E_RVVM4HImode
          || !register_operand (operands[4], E_HImode)
          || !
#line 4935 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12843; /* *pred_cmprvvm4hi_scalar_merge_tie_mask */

    case E_RVVM8SImode:
      if (!register_operand (operands[3], E_RVVM8SImode)
          || GET_MODE (x9) != E_RVVM8SImode
          || !register_operand (operands[4], E_SImode)
          || !
#line 4935 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12848; /* *pred_cmprvvm8si_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1408 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V2QImode:
      if (!register_operand (operands[3], E_V2QImode)
          || GET_MODE (x9) != E_V2QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4935 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 12854; /* *pred_cmpv2qi_scalar_merge_tie_mask */

    case E_V2HImode:
      if (!register_operand (operands[3], E_V2HImode)
          || GET_MODE (x9) != E_V2HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4935 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 12867; /* *pred_cmpv2hi_scalar_merge_tie_mask */

    case E_V2SImode:
      if (!register_operand (operands[3], E_V2SImode)
          || GET_MODE (x9) != E_V2SImode
          || !register_operand (operands[4], E_SImode)
          || !(
#line 4935 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 12879; /* *pred_cmpv2si_scalar_merge_tie_mask */

    case E_V2DImode:
      if (!register_operand (operands[3], E_V2DImode)
          || GET_MODE (x9) != E_V2DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5045 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13002; /* *pred_cmpv2di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1415 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V256QImode:
      if (!register_operand (operands[3], E_V256QImode)
          || GET_MODE (x9) != E_V256QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4935 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12861; /* *pred_cmpv256qi_scalar_merge_tie_mask */

    case E_V256HImode:
      if (!register_operand (operands[3], E_V256HImode)
          || GET_MODE (x9) != E_V256HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4935 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12874; /* *pred_cmpv256hi_scalar_merge_tie_mask */

    case E_V256SImode:
      if (!register_operand (operands[3], E_V256SImode)
          || GET_MODE (x9) != E_V256SImode
          || !register_operand (operands[4], E_SImode)
          || !(
#line 4935 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12886; /* *pred_cmpv256si_scalar_merge_tie_mask */

    case E_V256DImode:
      if (!register_operand (operands[3], E_V256DImode)
          || GET_MODE (x9) != E_V256DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5045 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 13009; /* *pred_cmpv256di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1424 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern571 (x2, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V16BImode))
    {
      res = recog_1411 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V16BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V16BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V16QImode:
      if (!register_operand (operands[4], E_V16QImode)
          || GET_MODE (x9) != E_V16QImode
          || !register_operand (operands[5], E_QImode))
        return -1;
      if ((
#line 4960 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16QImode)) && 
#line 734 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 12911; /* *pred_cmpv16qi_scalar */
      if (!(
#line 4982 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16QImode)) && 
#line 734 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 12965; /* *pred_cmpv16qi_scalar_narrow */

    case E_V16HImode:
      if (!register_operand (operands[4], E_V16HImode)
          || GET_MODE (x9) != E_V16HImode
          || !register_operand (operands[5], E_HImode))
        return -1;
      if ((
#line 4960 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16HImode)) && 
#line 747 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 12924; /* *pred_cmpv16hi_scalar */
      if (!(
#line 4982 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16HImode)) && 
#line 747 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12978; /* *pred_cmpv16hi_scalar_narrow */

    case E_V16SImode:
      if (!register_operand (operands[4], E_V16SImode)
          || GET_MODE (x9) != E_V16SImode
          || !register_operand (operands[5], E_SImode))
        return -1;
      if ((
#line 4960 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16SImode)) && 
#line 759 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 12936; /* *pred_cmpv16si_scalar */
      if (!(
#line 4982 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16SImode)) && 
#line 759 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12990; /* *pred_cmpv16si_scalar_narrow */

    case E_V16DImode:
      if (!register_operand (operands[4], E_V16DImode)
          || GET_MODE (x9) != E_V16DImode
          || !register_operand (operands[5], E_DImode))
        return -1;
      if ((
#line 5070 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16DImode)) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 13019; /* *pred_cmpv16di_scalar */
      if (!(
#line 5092 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16DImode)) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 13033; /* *pred_cmpv16di_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1430 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != VEC_DUPLICATE)
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      return recog_1429 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (!register_operand (x6, E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVMF8BImode:
          if (pattern571 (x2, 
E_RVVMF8BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) == 0
              && (
#line 5114 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 13039; /* *pred_cmprvvm8di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_RVVMF8BImode, 
E_RVVM8DImode) != 0)
            return -1;
          if ((
#line 5140 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8DImode) && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 13053; /* *pred_cmprvvm8di_extended_scalar */
          if (!(
#line 5162 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8DImode) && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13067; /* *pred_cmprvvm8di_extended_scalar_narrow */

        case E_RVVMF16BImode:
          if (pattern571 (x2, 
E_RVVMF16BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) == 0
              && (
#line 5114 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 13040; /* *pred_cmprvvm4di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_RVVMF16BImode, 
E_RVVM4DImode) != 0)
            return -1;
          if ((
#line 5140 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4DImode) && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 13054; /* *pred_cmprvvm4di_extended_scalar */
          if (!(
#line 5162 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4DImode) && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13068; /* *pred_cmprvvm4di_extended_scalar_narrow */

        case E_RVVMF32BImode:
          if (pattern571 (x2, 
E_RVVMF32BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) == 0
              && (
#line 5114 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 13041; /* *pred_cmprvvm2di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_RVVMF32BImode, 
E_RVVM2DImode) != 0)
            return -1;
          if ((
#line 5140 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2DImode) && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 13055; /* *pred_cmprvvm2di_extended_scalar */
          if (!(
#line 5162 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2DImode) && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13069; /* *pred_cmprvvm2di_extended_scalar_narrow */

        case E_RVVMF64BImode:
          if (pattern571 (x2, 
E_RVVMF64BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) == 0
              && (
#line 5114 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 13042; /* *pred_cmprvvm1di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_RVVMF64BImode, 
E_RVVM1DImode) != 0)
            return -1;
          if ((
#line 5140 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1DImode) && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 13056; /* *pred_cmprvvm1di_extended_scalar */
          if (!(
#line 5162 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1DImode) && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13070; /* *pred_cmprvvm1di_extended_scalar_narrow */

        case E_V1BImode:
          if (pattern571 (x2, 
E_V1BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_V1DImode, 
E_V1BImode) == 0
              && (
#line 5114 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return 13043; /* *pred_cmpv1di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_V1BImode, 
E_V1DImode) != 0)
            return -1;
          if ((
#line 5140 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1DImode) && !TARGET_64BIT) && 
#line 777 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return 13057; /* *pred_cmpv1di_extended_scalar */
          if (!(
#line 5162 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1DImode) && !TARGET_64BIT) && 
#line 777 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13071; /* *pred_cmpv1di_extended_scalar_narrow */

        case E_V2BImode:
          if (pattern571 (x2, 
E_V2BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_V2DImode, 
E_V2BImode) == 0
              && (
#line 5114 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return 13044; /* *pred_cmpv2di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_V2BImode, 
E_V2DImode) != 0)
            return -1;
          if ((
#line 5140 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2DImode) && !TARGET_64BIT) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return 13058; /* *pred_cmpv2di_extended_scalar */
          if (!(
#line 5162 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2DImode) && !TARGET_64BIT) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13072; /* *pred_cmpv2di_extended_scalar_narrow */

        case E_V4BImode:
          if (pattern571 (x2, 
E_V4BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_V4DImode, 
E_V4BImode) == 0
              && (
#line 5114 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return 13045; /* *pred_cmpv4di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_V4BImode, 
E_V4DImode) != 0)
            return -1;
          if ((
#line 5140 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4DImode) && !TARGET_64BIT) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return 13059; /* *pred_cmpv4di_extended_scalar */
          if (!(
#line 5162 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4DImode) && !TARGET_64BIT) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13073; /* *pred_cmpv4di_extended_scalar_narrow */

        case E_V8BImode:
          if (pattern571 (x2, 
E_V8BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_V8DImode, 
E_V8BImode) == 0
              && (
#line 5114 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return 13046; /* *pred_cmpv8di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_V8BImode, 
E_V8DImode) != 0)
            return -1;
          if ((
#line 5140 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8DImode) && !TARGET_64BIT) && 
#line 780 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return 13060; /* *pred_cmpv8di_extended_scalar */
          if (!(
#line 5162 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8DImode) && !TARGET_64BIT) && 
#line 780 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 13074; /* *pred_cmpv8di_extended_scalar_narrow */

        case E_V16BImode:
          if (pattern571 (x2, 
E_V16BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_V16DImode, 
E_V16BImode) == 0
              && (
#line 5114 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return 13047; /* *pred_cmpv16di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_V16BImode, 
E_V16DImode) != 0)
            return -1;
          if ((
#line 5140 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16DImode) && !TARGET_64BIT) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return 13061; /* *pred_cmpv16di_extended_scalar */
          if (!(
#line 5162 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16DImode) && !TARGET_64BIT) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 13075; /* *pred_cmpv16di_extended_scalar_narrow */

        case E_V32BImode:
          if (pattern571 (x2, 
E_V32BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_V32DImode, 
E_V32BImode) == 0
              && (
#line 5114 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return 13048; /* *pred_cmpv32di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_V32BImode, 
E_V32DImode) != 0)
            return -1;
          if ((
#line 5140 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32DImode) && !TARGET_64BIT) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return 13062; /* *pred_cmpv32di_extended_scalar */
          if (!(
#line 5162 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32DImode) && !TARGET_64BIT) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 13076; /* *pred_cmpv32di_extended_scalar_narrow */

        case E_V64BImode:
          if (pattern571 (x2, 
E_V64BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_V64DImode, 
E_V64BImode) == 0
              && (
#line 5114 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return 13049; /* *pred_cmpv64di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_V64BImode, 
E_V64DImode) != 0)
            return -1;
          if ((
#line 5140 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V64DImode) && !TARGET_64BIT) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return 13063; /* *pred_cmpv64di_extended_scalar */
          if (!(
#line 5162 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V64DImode) && !TARGET_64BIT) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 13077; /* *pred_cmpv64di_extended_scalar_narrow */

        case E_V128BImode:
          if (pattern571 (x2, 
E_V128BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_V128DImode, 
E_V128BImode) == 0
              && (
#line 5114 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return 13050; /* *pred_cmpv128di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_V128BImode, 
E_V128DImode) != 0)
            return -1;
          if ((
#line 5140 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128DImode) && !TARGET_64BIT) && 
#line 784 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return 13064; /* *pred_cmpv128di_extended_scalar */
          if (!(
#line 5162 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128DImode) && !TARGET_64BIT) && 
#line 784 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 13078; /* *pred_cmpv128di_extended_scalar_narrow */

        case E_V256BImode:
          if (pattern571 (x2, 
E_V256BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_V256DImode, 
E_V256BImode) == 0
              && (
#line 5114 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return 13051; /* *pred_cmpv256di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_V256BImode, 
E_V256DImode) != 0)
            return -1;
          if ((
#line 5140 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256DImode) && !TARGET_64BIT) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return 13065; /* *pred_cmpv256di_extended_scalar */
          if (!(
#line 5162 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256DImode) && !TARGET_64BIT) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 13079; /* *pred_cmpv256di_extended_scalar_narrow */

        case E_V512BImode:
          if (pattern571 (x2, 
E_V512BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_V512DImode, 
E_V512BImode) == 0
              && (
#line 5114 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return 13052; /* *pred_cmpv512di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_V512BImode, 
E_V512DImode) != 0)
            return -1;
          if ((
#line 5140 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512DImode) && !TARGET_64BIT) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return 13066; /* *pred_cmpv512di_extended_scalar */
          if (!(
#line 5162 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512DImode) && !TARGET_64BIT) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 13080; /* *pred_cmpv512di_extended_scalar_narrow */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1477 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (pattern107 (x3))
        {
        case 0:
          if (!
#line 276 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB))
            return -1;
          return 527; /* *popcountsi2 */

        case 1:
          if (!
#line 304 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB))
            return -1;
          return 539; /* *popcountdi2 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 5
          || XINT (x4, 1) != 93
          || pattern329 (x4) != 0)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      switch (GET_CODE (x5))
        {
        case AND:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          x8 = XVECEXP (x4, 0, 1);
          operands[3] = x8;
          if (!vector_length_operand (operands[3], E_VOIDmode))
            return -1;
          x9 = XVECEXP (x4, 0, 2);
          operands[4] = x9;
          if (!const_int_operand (operands[4], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern549 (x3, 
E_SImode))
                {
                case 0:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
                    return -1;
                  return 14333; /* pred_popcountrvvmf64bisi */

                case 1:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 14335; /* pred_popcountrvvmf32bisi */

                case 2:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 14337; /* pred_popcountrvvmf16bisi */

                case 3:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 14339; /* pred_popcountrvvmf8bisi */

                case 4:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 14341; /* pred_popcountrvvmf4bisi */

                case 5:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 14343; /* pred_popcountrvvmf2bisi */

                case 6:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 14345; /* pred_popcountrvvm1bisi */

                case 7:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode)))))
                    return -1;
                  return 14347; /* pred_popcountv1bisi */

                case 8:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode)))))
                    return -1;
                  return 14349; /* pred_popcountv2bisi */

                case 9:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode)))))
                    return -1;
                  return 14351; /* pred_popcountv4bisi */

                case 10:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode)))))
                    return -1;
                  return 14353; /* pred_popcountv8bisi */

                case 11:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode)))))
                    return -1;
                  return 14355; /* pred_popcountv16bisi */

                case 12:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)))))
                    return -1;
                  return 14357; /* pred_popcountv32bisi */

                case 13:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64))))
                    return -1;
                  return 14359; /* pred_popcountv64bisi */

                case 14:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128))))
                    return -1;
                  return 14361; /* pred_popcountv128bisi */

                case 15:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256))))
                    return -1;
                  return 14363; /* pred_popcountv256bisi */

                case 16:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512))))
                    return -1;
                  return 14365; /* pred_popcountv512bisi */

                case 17:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024))))
                    return -1;
                  return 14367; /* pred_popcountv1024bisi */

                case 18:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048))))
                    return -1;
                  return 14369; /* pred_popcountv2048bisi */

                case 19:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096))))
                    return -1;
                  return 14371; /* pred_popcountv4096bisi */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern549 (x3, 
E_DImode))
                {
                case 0:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
                    return -1;
                  return 14334; /* pred_popcountrvvmf64bidi */

                case 1:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 14336; /* pred_popcountrvvmf32bidi */

                case 2:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 14338; /* pred_popcountrvvmf16bidi */

                case 3:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 14340; /* pred_popcountrvvmf8bidi */

                case 4:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 14342; /* pred_popcountrvvmf4bidi */

                case 5:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 14344; /* pred_popcountrvvmf2bidi */

                case 6:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 14346; /* pred_popcountrvvm1bidi */

                case 7:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode)))))
                    return -1;
                  return 14348; /* pred_popcountv1bidi */

                case 8:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode)))))
                    return -1;
                  return 14350; /* pred_popcountv2bidi */

                case 9:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode)))))
                    return -1;
                  return 14352; /* pred_popcountv4bidi */

                case 10:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode)))))
                    return -1;
                  return 14354; /* pred_popcountv8bidi */

                case 11:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode)))))
                    return -1;
                  return 14356; /* pred_popcountv16bidi */

                case 12:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)))))
                    return -1;
                  return 14358; /* pred_popcountv32bidi */

                case 13:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64))))
                    return -1;
                  return 14360; /* pred_popcountv64bidi */

                case 14:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128))))
                    return -1;
                  return 14362; /* pred_popcountv128bidi */

                case 15:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256))))
                    return -1;
                  return 14364; /* pred_popcountv256bidi */

                case 16:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512))))
                    return -1;
                  return 14366; /* pred_popcountv512bidi */

                case 17:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024))))
                    return -1;
                  return 14368; /* pred_popcountv1024bidi */

                case 18:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048))))
                    return -1;
                  return 14370; /* pred_popcountv2048bidi */

                case 19:
                  if (!(
#line 6097 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096))))
                    return -1;
                  return 14372; /* pred_popcountv4096bidi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x5, 0) != 5
              || XINT (x5, 1) != 171)
            return -1;
          x9 = XVECEXP (x4, 0, 2);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          switch (pattern456 (x3))
            {
            case 0:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF64BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
                return -1;
              return 32205; /* *vcond_mask_len_popcount_rvvmf64bisi */

            case 1:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF32BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 32207; /* *vcond_mask_len_popcount_rvvmf32bisi */

            case 2:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF16BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 32209; /* *vcond_mask_len_popcount_rvvmf16bisi */

            case 3:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF8BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 32211; /* *vcond_mask_len_popcount_rvvmf8bisi */

            case 4:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF4BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 32213; /* *vcond_mask_len_popcount_rvvmf4bisi */

            case 5:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF2BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 32215; /* *vcond_mask_len_popcount_rvvmf2bisi */

            case 6:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVM1BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 32217; /* *vcond_mask_len_popcount_rvvm1bisi */

            case 7:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode)))))
                return -1;
              return 32219; /* *vcond_mask_len_popcount_v1bisi */

            case 8:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode)))))
                return -1;
              return 32221; /* *vcond_mask_len_popcount_v2bisi */

            case 9:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode)))))
                return -1;
              return 32223; /* *vcond_mask_len_popcount_v4bisi */

            case 10:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V8BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode)))))
                return -1;
              return 32225; /* *vcond_mask_len_popcount_v8bisi */

            case 11:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V16BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode)))))
                return -1;
              return 32227; /* *vcond_mask_len_popcount_v16bisi */

            case 12:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V32BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)))))
                return -1;
              return 32229; /* *vcond_mask_len_popcount_v32bisi */

            case 13:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V64BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64))))
                return -1;
              return 32231; /* *vcond_mask_len_popcount_v64bisi */

            case 14:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V128BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128))))
                return -1;
              return 32233; /* *vcond_mask_len_popcount_v128bisi */

            case 15:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V256BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256))))
                return -1;
              return 32235; /* *vcond_mask_len_popcount_v256bisi */

            case 16:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V512BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512))))
                return -1;
              return 32237; /* *vcond_mask_len_popcount_v512bisi */

            case 17:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1024BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024))))
                return -1;
              return 32239; /* *vcond_mask_len_popcount_v1024bisi */

            case 18:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2048BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048))))
                return -1;
              return 32241; /* *vcond_mask_len_popcount_v2048bisi */

            case 19:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4096BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096))))
                return -1;
              return 32243; /* *vcond_mask_len_popcount_v4096bisi */

            case 20:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF64BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
                return -1;
              return 32206; /* *vcond_mask_len_popcount_rvvmf64bidi */

            case 21:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF32BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 32208; /* *vcond_mask_len_popcount_rvvmf32bidi */

            case 22:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF16BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 32210; /* *vcond_mask_len_popcount_rvvmf16bidi */

            case 23:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF8BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 32212; /* *vcond_mask_len_popcount_rvvmf8bidi */

            case 24:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF4BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 32214; /* *vcond_mask_len_popcount_rvvmf4bidi */

            case 25:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF2BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 32216; /* *vcond_mask_len_popcount_rvvmf2bidi */

            case 26:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVM1BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 32218; /* *vcond_mask_len_popcount_rvvm1bidi */

            case 27:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode)))))
                return -1;
              return 32220; /* *vcond_mask_len_popcount_v1bidi */

            case 28:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode)))))
                return -1;
              return 32222; /* *vcond_mask_len_popcount_v2bidi */

            case 29:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode)))))
                return -1;
              return 32224; /* *vcond_mask_len_popcount_v4bidi */

            case 30:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V8BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode)))))
                return -1;
              return 32226; /* *vcond_mask_len_popcount_v8bidi */

            case 31:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V16BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode)))))
                return -1;
              return 32228; /* *vcond_mask_len_popcount_v16bidi */

            case 32:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V32BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)))))
                return -1;
              return 32230; /* *vcond_mask_len_popcount_v32bidi */

            case 33:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V64BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64))))
                return -1;
              return 32232; /* *vcond_mask_len_popcount_v64bidi */

            case 34:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V128BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128))))
                return -1;
              return 32234; /* *vcond_mask_len_popcount_v128bidi */

            case 35:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V256BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256))))
                return -1;
              return 32236; /* *vcond_mask_len_popcount_v256bidi */

            case 36:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V512BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512))))
                return -1;
              return 32238; /* *vcond_mask_len_popcount_v512bidi */

            case 37:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1024BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024))))
                return -1;
              return 32240; /* *vcond_mask_len_popcount_v1024bidi */

            case 38:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2048BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048))))
                return -1;
              return 32242; /* *vcond_mask_len_popcount_v2048bidi */

            case 39:
              if (!(
#line 1519 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4096BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096))))
                return -1;
              return 32244; /* *vcond_mask_len_popcount_v4096bidi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PARALLEL:
      switch (pattern109 (x3))
        {
        case 0:
          if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 33151; /* pred_vpopcountrvvm8qi */

        case 1:
          if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 33154; /* pred_vpopcountrvvm4qi */

        case 2:
          if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 33157; /* pred_vpopcountrvvm2qi */

        case 3:
          if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 33160; /* pred_vpopcountrvvm1qi */

        case 4:
          if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 33163; /* pred_vpopcountrvvm8hi */

        case 5:
          if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 33166; /* pred_vpopcountrvvm4hi */

        case 6:
          if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 33169; /* pred_vpopcountrvvm2hi */

        case 7:
          if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 33172; /* pred_vpopcountrvvm1hi */

        case 8:
          if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 33175; /* pred_vpopcountrvvm8si */

        case 9:
          if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 33178; /* pred_vpopcountrvvm4si */

        case 10:
          if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 33181; /* pred_vpopcountrvvm2si */

        case 11:
          if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 33184; /* pred_vpopcountrvvm1si */

        case 12:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33187; /* pred_vpopcountrvvm8di */

        case 13:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33190; /* pred_vpopcountrvvm4di */

        case 14:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33193; /* pred_vpopcountrvvm2di */

        case 15:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33196; /* pred_vpopcountrvvm1di */

        case 16:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 33199; /* pred_vpopcountrvvmf2qi */

        case 17:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 33202; /* pred_vpopcountrvvmf4qi */

        case 18:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 33205; /* pred_vpopcountrvvmf8qi */

        case 19:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 33208; /* pred_vpopcountrvvmf2hi */

        case 20:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 33211; /* pred_vpopcountrvvmf4hi */

        case 21:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 33214; /* pred_vpopcountrvvmf2si */

        case 22:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 33217; /* pred_vpopcountv1qi */

        case 23:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 33220; /* pred_vpopcountv2qi */

        case 24:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 33223; /* pred_vpopcountv4qi */

        case 25:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 33226; /* pred_vpopcountv8qi */

        case 26:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 33229; /* pred_vpopcountv16qi */

        case 27:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 33232; /* pred_vpopcountv32qi */

        case 28:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33235; /* pred_vpopcountv64qi */

        case 29:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33238; /* pred_vpopcountv128qi */

        case 30:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33241; /* pred_vpopcountv256qi */

        case 31:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33244; /* pred_vpopcountv512qi */

        case 32:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33247; /* pred_vpopcountv1024qi */

        case 33:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33250; /* pred_vpopcountv2048qi */

        case 34:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33253; /* pred_vpopcountv4096qi */

        case 35:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 33256; /* pred_vpopcountv1hi */

        case 36:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 33259; /* pred_vpopcountv2hi */

        case 37:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 33262; /* pred_vpopcountv4hi */

        case 38:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 33265; /* pred_vpopcountv8hi */

        case 39:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 33268; /* pred_vpopcountv16hi */

        case 40:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33271; /* pred_vpopcountv32hi */

        case 41:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33274; /* pred_vpopcountv64hi */

        case 42:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33277; /* pred_vpopcountv128hi */

        case 43:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33280; /* pred_vpopcountv256hi */

        case 44:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33283; /* pred_vpopcountv512hi */

        case 45:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33286; /* pred_vpopcountv1024hi */

        case 46:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33289; /* pred_vpopcountv2048hi */

        case 47:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 33292; /* pred_vpopcountv1si */

        case 48:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 33295; /* pred_vpopcountv2si */

        case 49:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 33298; /* pred_vpopcountv4si */

        case 50:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 33301; /* pred_vpopcountv8si */

        case 51:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33304; /* pred_vpopcountv16si */

        case 52:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33307; /* pred_vpopcountv32si */

        case 53:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33310; /* pred_vpopcountv64si */

        case 54:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33313; /* pred_vpopcountv128si */

        case 55:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33316; /* pred_vpopcountv256si */

        case 56:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33319; /* pred_vpopcountv512si */

        case 57:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33322; /* pred_vpopcountv1024si */

        case 58:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33325; /* pred_vpopcountv1di */

        case 59:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33328; /* pred_vpopcountv2di */

        case 60:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33331; /* pred_vpopcountv4di */

        case 61:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33334; /* pred_vpopcountv8di */

        case 62:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33337; /* pred_vpopcountv16di */

        case 63:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33340; /* pred_vpopcountv32di */

        case 64:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33343; /* pred_vpopcountv64di */

        case 65:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33346; /* pred_vpopcountv128di */

        case 66:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33349; /* pred_vpopcountv256di */

        case 67:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33352; /* pred_vpopcountv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1493 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case LSHIFTRT:
      return recog_28 (x1, insn, pnum_clobbers);

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 93
          || GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != VEC_SELECT
          || GET_MODE (x5) != E_DImode
          || pattern333 (x4) != 0
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      switch (GET_MODE (operands[1]))
        {
        case E_RVVM8DImode:
          if (!register_operand (operands[1], E_RVVM8DImode)
              || !(
#line 8065 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20017; /* pred_extract_first_truncrvvm8di */

        case E_RVVM4DImode:
          if (!register_operand (operands[1], E_RVVM4DImode)
              || !(
#line 8065 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20018; /* pred_extract_first_truncrvvm4di */

        case E_RVVM2DImode:
          if (!register_operand (operands[1], E_RVVM2DImode)
              || !(
#line 8065 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20019; /* pred_extract_first_truncrvvm2di */

        case E_RVVM1DImode:
          if (!register_operand (operands[1], E_RVVM1DImode)
              || !(
#line 8065 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20020; /* pred_extract_first_truncrvvm1di */

        case E_V1DImode:
          if (!register_operand (operands[1], E_V1DImode)
              || !(
#line 8065 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20021; /* pred_extract_first_truncv1di */

        case E_V2DImode:
          if (!register_operand (operands[1], E_V2DImode)
              || !(
#line 8065 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20022; /* pred_extract_first_truncv2di */

        case E_V4DImode:
          if (!register_operand (operands[1], E_V4DImode)
              || !(
#line 8065 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20023; /* pred_extract_first_truncv4di */

        case E_V8DImode:
          if (!register_operand (operands[1], E_V8DImode)
              || !(
#line 8065 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20024; /* pred_extract_first_truncv8di */

        case E_V16DImode:
          if (!register_operand (operands[1], E_V16DImode)
              || !(
#line 8065 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20025; /* pred_extract_first_truncv16di */

        case E_V32DImode:
          if (!register_operand (operands[1], E_V32DImode)
              || !(
#line 8065 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20026; /* pred_extract_first_truncv32di */

        case E_V64DImode:
          if (!register_operand (operands[1], E_V64DImode)
              || !(
#line 8065 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20027; /* pred_extract_first_truncv64di */

        case E_V128DImode:
          if (!register_operand (operands[1], E_V128DImode)
              || !(
#line 8065 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20028; /* pred_extract_first_truncv128di */

        case E_V256DImode:
          if (!register_operand (operands[1], E_V256DImode)
              || !(
#line 8065 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20029; /* pred_extract_first_truncv256di */

        case E_V512DImode:
          if (!register_operand (operands[1], E_V512DImode)
              || !(
#line 8065 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20030; /* pred_extract_first_truncv512di */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern156 (x3))
        {
        case 0:
          if (!
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26287; /* truncrvvm8hirvvm4qi2 */

        case 1:
          if (!
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26288; /* truncrvvm4hirvvm2qi2 */

        case 2:
          if (!
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26289; /* truncrvvm2hirvvm1qi2 */

        case 3:
          if (!
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26290; /* truncrvvm1hirvvmf2qi2 */

        case 4:
          if (!
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26291; /* truncrvvmf2hirvvmf4qi2 */

        case 5:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26292; /* truncrvvmf4hirvvmf8qi2 */

        case 6:
          if (!
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26293; /* truncrvvm8sirvvm4hi2 */

        case 7:
          if (!
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26294; /* truncrvvm4sirvvm2hi2 */

        case 8:
          if (!
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26295; /* truncrvvm2sirvvm1hi2 */

        case 9:
          if (!
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26296; /* truncrvvm1sirvvmf2hi2 */

        case 10:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26297; /* truncrvvmf2sirvvmf4hi2 */

        case 11:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26298; /* truncrvvm8dirvvm4si2 */

        case 12:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26299; /* truncrvvm4dirvvm2si2 */

        case 13:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26300; /* truncrvvm2dirvvm1si2 */

        case 14:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26301; /* truncrvvm1dirvvmf2si2 */

        case 15:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 26302; /* truncv1hiv1qi2 */

        case 16:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 26303; /* truncv2hiv2qi2 */

        case 17:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 26304; /* truncv4hiv4qi2 */

        case 18:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 26305; /* truncv8hiv8qi2 */

        case 19:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 26306; /* truncv16hiv16qi2 */

        case 20:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26307; /* truncv32hiv32qi2 */

        case 21:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26308; /* truncv64hiv64qi2 */

        case 22:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26309; /* truncv128hiv128qi2 */

        case 23:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26310; /* truncv256hiv256qi2 */

        case 24:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26311; /* truncv512hiv512qi2 */

        case 25:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26312; /* truncv1024hiv1024qi2 */

        case 26:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26313; /* truncv2048hiv2048qi2 */

        case 27:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 26314; /* truncv1siv1hi2 */

        case 28:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 26315; /* truncv2siv2hi2 */

        case 29:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 26316; /* truncv4siv4hi2 */

        case 30:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 26317; /* truncv8siv8hi2 */

        case 31:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26318; /* truncv16siv16hi2 */

        case 32:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26319; /* truncv32siv32hi2 */

        case 33:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26320; /* truncv64siv64hi2 */

        case 34:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26321; /* truncv128siv128hi2 */

        case 35:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26322; /* truncv256siv256hi2 */

        case 36:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26323; /* truncv512siv512hi2 */

        case 37:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26324; /* truncv1024siv1024hi2 */

        case 38:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26325; /* truncv1div1si2 */

        case 39:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26326; /* truncv2div2si2 */

        case 40:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26327; /* truncv4div4si2 */

        case 41:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26328; /* truncv8div8si2 */

        case 42:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26329; /* truncv16div16si2 */

        case 43:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26330; /* truncv32div32si2 */

        case 44:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26331; /* truncv64div64si2 */

        case 45:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26332; /* truncv128div128si2 */

        case 46:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26333; /* truncv256div256si2 */

        case 47:
          if (!(
#line 797 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26334; /* truncv512div512si2 */

        default:
          return -1;
        }

    case ASHIFTRT:
      return recog_30 (x1, insn, pnum_clobbers);

    case ASHIFT:
      return recog_29 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_1501 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      res = recog_107 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (const_int_operand (operands[2], E_DImode)
          && GET_CODE (x4) == SUBREG
          && known_eq (SUBREG_BYTE (x4), 0)
          && GET_MODE (x4) == E_DImode)
        {
          x6 = XEXP (x4, 0);
          if (GET_MODE (x6) == E_SImode)
            {
              switch (GET_CODE (x6))
                {
                case CLZ:
                  x7 = XEXP (x6, 0);
                  operands[1] = x7;
                  if (register_operand (operands[1], E_SImode)
                      && 
#line 296 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB && ((INTVAL (operands[2]) & 0x3f) == 0x3f)))
                    return 534; /* *clzdisi2_sext */
                  break;

                case CTZ:
                  x7 = XEXP (x6, 0);
                  operands[1] = x7;
                  if (register_operand (operands[1], E_SImode)
                      && 
#line 296 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB && ((INTVAL (operands[2]) & 0x3f) == 0x3f)))
                    return 535; /* *ctzdisi2_sext */
                  break;

                case POPCOUNT:
                  x7 = XEXP (x6, 0);
                  operands[1] = x7;
                  if (register_operand (operands[1], E_SImode)
                      && 
#line 296 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB && ((INTVAL (operands[2]) & 0x3f) == 0x3f)))
                    return 536; /* *popcountdisi2_sext */
                  break;

                default:
                  break;
                }
            }
        }
      operands[1] = x4;
      if (register_operand (operands[1], E_DImode))
        {
          if (not_single_bit_mask_operand (operands[2], E_DImode)
              && (
#line 840 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 630; /* *bclridi */
          if (const_nottwobits_not_arith_operand (operands[2], E_DImode))
            {
              if ((
#line 849 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && !paradoxical_subreg_p (operands[1])) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 632; /* *bclridi_nottwobits */
              if (
#line 869 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBS
   && clz_hwi (~UINTVAL (operands[2])) > 33))
                return 633; /* *bclridisi_nottwobits */
            }
        }
      if (GET_CODE (x4) == SUBREG
          && known_eq (SUBREG_BYTE (x4), 0)
          && GET_MODE (x4) == E_DImode)
        {
          x6 = XEXP (x4, 0);
          if (GET_CODE (x6) == LSHIFTRT
              && GET_MODE (x6) == E_SImode
              && x5 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
            {
              x7 = XEXP (x6, 0);
              operands[1] = x7;
              if (register_operand (operands[1], E_SImode))
                {
                  x8 = XEXP (x6, 1);
                  operands[2] = x8;
                  if (register_operand (operands[2], E_QImode)
                      && 
#line 962 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBS))
                    return 639; /* *bextdisi */
                }
            }
        }
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      operands[2] = x5;
      if (not_uimm_extra_bit_or_nottwobits (operands[2], E_DImode)
          && (
#line 1041 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && !not_single_bit_mask_operand (operands[2], VOIDmode)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return 649; /* *andidi_extrabit */
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !
#line 1067 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBA
   && !paradoxical_subreg_p (operands[1])
   /* Only profitable if synthesis takes more than one insn.  */
   && riscv_const_insns (operands[2], false) != 1
   /* We need the upper half to be zero.  */
   && (INTVAL (operands[2]) & HOST_WIDE_INT_C (0xffffffff00000000)) == 0
   /* And the the adjusted constant must either be something we can
      implement with andi or bclri.  */
   && ((SMALL_OPERAND (sext_hwi (INTVAL (operands[2]), 32))
        || (TARGET_ZBS && popcount_hwi (INTVAL (operands[2])) == 31))
       && INTVAL (operands[2]) != 0x7fffffff)))
        return -1;
      return 650; /* *bitmanip.md:1063 */

    case ASHIFT:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      switch (pattern230 (x3))
        {
        case 0:
          if (immediate_operand (operands[2], E_VOIDmode)
              && (
#line 2992 "../../../gcc/config/riscv/riscv.md"
((!SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))
    && (!TARGET_ZBS || popcount_hwi (INTVAL (operands[3])) > 1)
    && (INTVAL (operands[3]) & ((1ULL << INTVAL (operands[2])) - 1)) == 0)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return 323; /* and_shift_reversesi */
          break;

        case 1:
          if (immediate_operand (operands[2], E_VOIDmode)
              && (
#line 2992 "../../../gcc/config/riscv/riscv.md"
((!SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))
    && (!TARGET_ZBS || popcount_hwi (INTVAL (operands[3])) > 1)
    && (INTVAL (operands[3]) & ((1ULL << INTVAL (operands[2])) - 1)) == 0)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 326; /* and_shift_reversedi */
          if (immediate_operand (operands[2], E_QImode))
            {
              if (pnum_clobbers != NULL
                  && 
#line 3138 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && !TARGET_ZBA
   && ((INTVAL (operands[3]) >> INTVAL (operands[2])) == 0xffffffff)))
                {
                  *pnum_clobbers = 1;
                  return 337; /* zero_extendsidi2_shifted */
                }
              if (
#line 183 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA
   && (INTVAL (operands[3]) >> INTVAL (operands[2])) == 0xffffffff))
                return 514; /* *slliuw */
            }
          break;

        default:
          break;
        }
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT
          || XWINT (x5, 0) != 65280L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern229 (x3, 
E_SImode) != 0
              || !(
#line 136 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZBKB) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 673; /* *riscv_packh_si_2 */

        case E_DImode:
          if (pattern229 (x3, 
E_DImode) != 0
              || !(
#line 136 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZBKB) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 674; /* *riscv_packh_di_2 */

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          return recog_108 (x1, insn, pnum_clobbers);

        case SIGN_EXTEND:
          switch (pattern260 (x3, pnum_clobbers))
            {
            case 0:
              if ((
#line 736 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 611; /* *bitmanip.md:724 */
                }
              if (!(
#line 736 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 613; /* *bitmanip.md:724 */

            case 1:
              if ((
#line 764 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 615; /* *bitmanip.md:752 */
                }
              if (!(
#line 764 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 617; /* *bitmanip.md:752 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern260 (x3, pnum_clobbers))
            {
            case 0:
              if ((
#line 736 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 612; /* *bitmanip.md:724 */
                }
              if (!(
#line 736 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 614; /* *bitmanip.md:724 */

            case 1:
              if ((
#line 764 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 616; /* *bitmanip.md:752 */
                }
              if (!(
#line 764 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 618; /* *bitmanip.md:752 */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern262 (x3))
            {
            case 0:
              if (!(
#line 943 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 637; /* *bextseqzdisi */

            case 1:
              if (!(
#line 943 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 638; /* *bextseqzdisi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ROTATE:
      x6 = XEXP (x4, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
        return -1;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      switch (pattern292 (x3))
        {
        case 0:
          if (!(
#line 832 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 627; /* *bclrsi */

        case 1:
          if (!(
#line 832 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 628; /* *bclrdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1510 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_CODE (x3))
    {
    case LT:
      if (GET_MODE (x3) == E_DImode)
        {
          x5 = XEXP (x3, 1);
          if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
              && register_operand (operands[0], E_DImode)
              && register_operand (operands[1], E_SImode)
              && 
#line 3043 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return 332; /* *lshrsi3_zero_extend_3 */
        }
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (pattern269 (x3))
        {
        case 0:
          if (
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return 429; /* slt_sisi3 */
          break;

        case 1:
          if (
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return 431; /* slt_disi3 */
          break;

        case 2:
          if (
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return 433; /* slt_didi3 */
          break;

        default:
          break;
        }
      break;

    case EQ:
      x5 = XEXP (x3, 1);
      if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          switch (pattern105 (x3))
            {
            case 0:
              if (
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
                return 411; /* *seq_zero_sisi */
              break;

            case 1:
              if (
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return 412; /* *seq_zero_disi */
              break;

            case 2:
              if (
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return 413; /* *seq_zero_didi */
              break;

            default:
              break;
            }
        }
      break;

    case GT:
      switch (pattern220 (x3))
        {
        case 0:
          if (
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return 417; /* *sgt_sisi */
          break;

        case 1:
          if (
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return 419; /* *sgt_disi */
          break;

        case 2:
          if (
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return 421; /* *sgt_didi */
          break;

        default:
          break;
        }
      break;

    case GE:
      x5 = XEXP (x3, 1);
      if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
        {
          switch (pattern105 (x3))
            {
            case 0:
              if (
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
                return 423; /* *sge_sisi */
              break;

            case 1:
              if (
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return 425; /* *sge_disi */
              break;

            case 2:
              if (
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return 427; /* *sge_didi */
              break;

            default:
              break;
            }
        }
      break;

    case LE:
      switch (pattern221 (x3))
        {
        case 0:
          if (
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return 435; /* *sle_sisi */
          break;

        case 1:
          if (
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return 437; /* *sle_disi */
          break;

        case 2:
          if (
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return 439; /* *sle_didi */
          break;

        case 3:
          if (
#line 570 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return 33923; /* riscv_cv_alu_slet */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[1] = x3;
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern339 (
E_SImode))
        {
        case 0:
          if (!(
#line 3528 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && ((
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
            return -1;
          return 387; /* *cstoresfsi4 */

        case 1:
          if (!(
#line 3528 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && ((
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
            return -1;
          return 389; /* *cstoredfsi4 */

        case 2:
          if (!(
#line 3528 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && ((
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
            return -1;
          return 391; /* *cstorehfsi4 */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern339 (
E_DImode))
        {
        case 0:
          if (!(
#line 3528 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && ((
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
            return -1;
          return 388; /* *cstoresfdi4 */

        case 1:
          if (!(
#line 3528 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && ((
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
            return -1;
          return 390; /* *cstoredfdi4 */

        case 2:
          if (!(
#line 3528 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && ((
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
            return -1;
          return 392; /* *cstorehfdi4 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1513 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF8x2QImode:
      if (pattern757 (x1, 
E_RVVMF8x2QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21768; /* pred_fault_loadrvvmf8x2qi */

    case E_RVVMF8x3QImode:
      if (pattern757 (x1, 
E_RVVMF8x3QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21769; /* pred_fault_loadrvvmf8x3qi */

    case E_RVVMF8x4QImode:
      if (pattern757 (x1, 
E_RVVMF8x4QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21770; /* pred_fault_loadrvvmf8x4qi */

    case E_RVVMF8x5QImode:
      if (pattern757 (x1, 
E_RVVMF8x5QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21771; /* pred_fault_loadrvvmf8x5qi */

    case E_RVVMF8x6QImode:
      if (pattern757 (x1, 
E_RVVMF8x6QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21772; /* pred_fault_loadrvvmf8x6qi */

    case E_RVVMF8x7QImode:
      if (pattern757 (x1, 
E_RVVMF8x7QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21773; /* pred_fault_loadrvvmf8x7qi */

    case E_RVVMF8x8QImode:
      if (pattern757 (x1, 
E_RVVMF8x8QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21774; /* pred_fault_loadrvvmf8x8qi */

    case E_RVVMF4x2HImode:
      if (pattern757 (x1, 
E_RVVMF4x2HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21775; /* pred_fault_loadrvvmf4x2hi */

    case E_RVVMF4x3HImode:
      if (pattern757 (x1, 
E_RVVMF4x3HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21776; /* pred_fault_loadrvvmf4x3hi */

    case E_RVVMF4x4HImode:
      if (pattern757 (x1, 
E_RVVMF4x4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21777; /* pred_fault_loadrvvmf4x4hi */

    case E_RVVMF4x5HImode:
      if (pattern757 (x1, 
E_RVVMF4x5HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21778; /* pred_fault_loadrvvmf4x5hi */

    case E_RVVMF4x6HImode:
      if (pattern757 (x1, 
E_RVVMF4x6HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21779; /* pred_fault_loadrvvmf4x6hi */

    case E_RVVMF4x7HImode:
      if (pattern757 (x1, 
E_RVVMF4x7HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21780; /* pred_fault_loadrvvmf4x7hi */

    case E_RVVMF4x8HImode:
      if (pattern757 (x1, 
E_RVVMF4x8HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21781; /* pred_fault_loadrvvmf4x8hi */

    case E_RVVMF2x2SImode:
      if (pattern757 (x1, 
E_RVVMF2x2SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21782; /* pred_fault_loadrvvmf2x2si */

    case E_RVVMF2x3SImode:
      if (pattern757 (x1, 
E_RVVMF2x3SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21783; /* pred_fault_loadrvvmf2x3si */

    case E_RVVMF2x4SImode:
      if (pattern757 (x1, 
E_RVVMF2x4SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21784; /* pred_fault_loadrvvmf2x4si */

    case E_RVVMF2x5SImode:
      if (pattern757 (x1, 
E_RVVMF2x5SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21785; /* pred_fault_loadrvvmf2x5si */

    case E_RVVMF2x6SImode:
      if (pattern757 (x1, 
E_RVVMF2x6SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21786; /* pred_fault_loadrvvmf2x6si */

    case E_RVVMF2x7SImode:
      if (pattern757 (x1, 
E_RVVMF2x7SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21787; /* pred_fault_loadrvvmf2x7si */

    case E_RVVMF2x8SImode:
      if (pattern757 (x1, 
E_RVVMF2x8SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21788; /* pred_fault_loadrvvmf2x8si */

    case E_RVVM1x2DImode:
      if (pattern757 (x1, 
E_RVVM1x2DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1188 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21789; /* pred_fault_loadrvvm1x2di */

    case E_RVVM1x3DImode:
      if (pattern757 (x1, 
E_RVVM1x3DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1189 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21790; /* pred_fault_loadrvvm1x3di */

    case E_RVVM1x4DImode:
      if (pattern757 (x1, 
E_RVVM1x4DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1190 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21791; /* pred_fault_loadrvvm1x4di */

    case E_RVVM1x5DImode:
      if (pattern757 (x1, 
E_RVVM1x5DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1191 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21792; /* pred_fault_loadrvvm1x5di */

    case E_RVVM1x6DImode:
      if (pattern757 (x1, 
E_RVVM1x6DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1192 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21793; /* pred_fault_loadrvvm1x6di */

    case E_RVVM1x7DImode:
      if (pattern757 (x1, 
E_RVVM1x7DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1193 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21794; /* pred_fault_loadrvvm1x7di */

    case E_RVVM1x8DImode:
      if (pattern757 (x1, 
E_RVVM1x8DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1194 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21795; /* pred_fault_loadrvvm1x8di */

    case E_RVVMF4x2BFmode:
      if (pattern757 (x1, 
E_RVVMF4x2BFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1195 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21796; /* pred_fault_loadrvvmf4x2bf */

    case E_RVVMF4x3BFmode:
      if (pattern757 (x1, 
E_RVVMF4x3BFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1196 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21797; /* pred_fault_loadrvvmf4x3bf */

    case E_RVVMF4x4BFmode:
      if (pattern757 (x1, 
E_RVVMF4x4BFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1197 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21798; /* pred_fault_loadrvvmf4x4bf */

    case E_RVVMF4x5BFmode:
      if (pattern757 (x1, 
E_RVVMF4x5BFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1198 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21799; /* pred_fault_loadrvvmf4x5bf */

    case E_RVVMF4x6BFmode:
      if (pattern757 (x1, 
E_RVVMF4x6BFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1199 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21800; /* pred_fault_loadrvvmf4x6bf */

    case E_RVVMF4x7BFmode:
      if (pattern757 (x1, 
E_RVVMF4x7BFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1200 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21801; /* pred_fault_loadrvvmf4x7bf */

    case E_RVVMF4x8BFmode:
      if (pattern757 (x1, 
E_RVVMF4x8BFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1201 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21802; /* pred_fault_loadrvvmf4x8bf */

    case E_RVVMF4x2HFmode:
      if (pattern757 (x1, 
E_RVVMF4x2HFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1202 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21803; /* pred_fault_loadrvvmf4x2hf */

    case E_RVVMF4x3HFmode:
      if (pattern757 (x1, 
E_RVVMF4x3HFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1203 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21804; /* pred_fault_loadrvvmf4x3hf */

    case E_RVVMF4x4HFmode:
      if (pattern757 (x1, 
E_RVVMF4x4HFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1204 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21805; /* pred_fault_loadrvvmf4x4hf */

    case E_RVVMF4x5HFmode:
      if (pattern757 (x1, 
E_RVVMF4x5HFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1205 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21806; /* pred_fault_loadrvvmf4x5hf */

    case E_RVVMF4x6HFmode:
      if (pattern757 (x1, 
E_RVVMF4x6HFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1206 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21807; /* pred_fault_loadrvvmf4x6hf */

    case E_RVVMF4x7HFmode:
      if (pattern757 (x1, 
E_RVVMF4x7HFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1207 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21808; /* pred_fault_loadrvvmf4x7hf */

    case E_RVVMF4x8HFmode:
      if (pattern757 (x1, 
E_RVVMF4x8HFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1208 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21809; /* pred_fault_loadrvvmf4x8hf */

    case E_RVVMF2x2SFmode:
      if (pattern757 (x1, 
E_RVVMF2x2SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1209 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21810; /* pred_fault_loadrvvmf2x2sf */

    case E_RVVMF2x3SFmode:
      if (pattern757 (x1, 
E_RVVMF2x3SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1210 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21811; /* pred_fault_loadrvvmf2x3sf */

    case E_RVVMF2x4SFmode:
      if (pattern757 (x1, 
E_RVVMF2x4SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1211 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21812; /* pred_fault_loadrvvmf2x4sf */

    case E_RVVMF2x5SFmode:
      if (pattern757 (x1, 
E_RVVMF2x5SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1212 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21813; /* pred_fault_loadrvvmf2x5sf */

    case E_RVVMF2x6SFmode:
      if (pattern757 (x1, 
E_RVVMF2x6SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1213 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21814; /* pred_fault_loadrvvmf2x6sf */

    case E_RVVMF2x7SFmode:
      if (pattern757 (x1, 
E_RVVMF2x7SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1214 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21815; /* pred_fault_loadrvvmf2x7sf */

    case E_RVVMF2x8SFmode:
      if (pattern757 (x1, 
E_RVVMF2x8SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1215 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21816; /* pred_fault_loadrvvmf2x8sf */

    case E_RVVM1x2DFmode:
      if (pattern757 (x1, 
E_RVVM1x2DFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1216 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21817; /* pred_fault_loadrvvm1x2df */

    case E_RVVM1x3DFmode:
      if (pattern757 (x1, 
E_RVVM1x3DFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1217 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21818; /* pred_fault_loadrvvm1x3df */

    case E_RVVM1x4DFmode:
      if (pattern757 (x1, 
E_RVVM1x4DFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1218 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21819; /* pred_fault_loadrvvm1x4df */

    case E_RVVM1x5DFmode:
      if (pattern757 (x1, 
E_RVVM1x5DFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1219 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21820; /* pred_fault_loadrvvm1x5df */

    case E_RVVM1x6DFmode:
      if (pattern757 (x1, 
E_RVVM1x6DFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1220 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21821; /* pred_fault_loadrvvm1x6df */

    case E_RVVM1x7DFmode:
      if (pattern757 (x1, 
E_RVVM1x7DFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1221 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21822; /* pred_fault_loadrvvm1x7df */

    case E_RVVM1x8DFmode:
      if (pattern757 (x1, 
E_RVVM1x8DFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1222 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21823; /* pred_fault_loadrvvm1x8df */

    case E_RVVMF4x2QImode:
      if (pattern757 (x1, 
E_RVVMF4x2QImode, 
E_RVVMF32BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21824; /* pred_fault_loadrvvmf4x2qi */

    case E_RVVMF4x3QImode:
      if (pattern757 (x1, 
E_RVVMF4x3QImode, 
E_RVVMF32BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21825; /* pred_fault_loadrvvmf4x3qi */

    case E_RVVMF4x4QImode:
      if (pattern757 (x1, 
E_RVVMF4x4QImode, 
E_RVVMF32BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21826; /* pred_fault_loadrvvmf4x4qi */

    case E_RVVMF4x5QImode:
      if (pattern757 (x1, 
E_RVVMF4x5QImode, 
E_RVVMF32BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21827; /* pred_fault_loadrvvmf4x5qi */

    case E_RVVMF4x6QImode:
      if (pattern757 (x1, 
E_RVVMF4x6QImode, 
E_RVVMF32BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21828; /* pred_fault_loadrvvmf4x6qi */

    case E_RVVMF4x7QImode:
      if (pattern757 (x1, 
E_RVVMF4x7QImode, 
E_RVVMF32BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21829; /* pred_fault_loadrvvmf4x7qi */

    case E_RVVMF4x8QImode:
      if (pattern757 (x1, 
E_RVVMF4x8QImode, 
E_RVVMF32BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21830; /* pred_fault_loadrvvmf4x8qi */

    case E_RVVMF2x2HImode:
      if (pattern757 (x1, 
E_RVVMF2x2HImode, 
E_RVVMF32BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21831; /* pred_fault_loadrvvmf2x2hi */

    case E_RVVMF2x3HImode:
      if (pattern757 (x1, 
E_RVVMF2x3HImode, 
E_RVVMF32BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21832; /* pred_fault_loadrvvmf2x3hi */

    case E_RVVMF2x4HImode:
      if (pattern757 (x1, 
E_RVVMF2x4HImode, 
E_RVVMF32BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21833; /* pred_fault_loadrvvmf2x4hi */

    case E_RVVMF2x5HImode:
      if (pattern757 (x1, 
E_RVVMF2x5HImode, 
E_RVVMF32BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21834; /* pred_fault_loadrvvmf2x5hi */

    case E_RVVMF2x6HImode:
      if (pattern757 (x1, 
E_RVVMF2x6HImode, 
E_RVVMF32BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21835; /* pred_fault_loadrvvmf2x6hi */

    case E_RVVMF2x7HImode:
      if (pattern757 (x1, 
E_RVVMF2x7HImode, 
E_RVVMF32BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21836; /* pred_fault_loadrvvmf2x7hi */

    case E_RVVMF2x8HImode:
      if (pattern757 (x1, 
E_RVVMF2x8HImode, 
E_RVVMF32BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21837; /* pred_fault_loadrvvmf2x8hi */

    case E_RVVM1x2SImode:
      if (pattern757 (x1, 
E_RVVM1x2SImode, 
E_RVVMF32BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21838; /* pred_fault_loadrvvm1x2si */

    case E_RVVM1x3SImode:
      if (pattern757 (x1, 
E_RVVM1x3SImode, 
E_RVVMF32BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21839; /* pred_fault_loadrvvm1x3si */

    case E_RVVM1x4SImode:
      if (pattern757 (x1, 
E_RVVM1x4SImode, 
E_RVVMF32BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21840; /* pred_fault_loadrvvm1x4si */

    case E_RVVM1x5SImode:
      if (pattern757 (x1, 
E_RVVM1x5SImode, 
E_RVVMF32BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21841; /* pred_fault_loadrvvm1x5si */

    case E_RVVM1x6SImode:
      if (pattern757 (x1, 
E_RVVM1x6SImode, 
E_RVVMF32BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21842; /* pred_fault_loadrvvm1x6si */

    case E_RVVM1x7SImode:
      if (pattern757 (x1, 
E_RVVM1x7SImode, 
E_RVVMF32BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21843; /* pred_fault_loadrvvm1x7si */

    case E_RVVM1x8SImode:
      if (pattern757 (x1, 
E_RVVM1x8SImode, 
E_RVVMF32BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21844; /* pred_fault_loadrvvm1x8si */

    case E_RVVM2x2DImode:
      if (pattern757 (x1, 
E_RVVM2x2DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21845; /* pred_fault_loadrvvm2x2di */

    case E_RVVM2x3DImode:
      if (pattern757 (x1, 
E_RVVM2x3DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21846; /* pred_fault_loadrvvm2x3di */

    case E_RVVM2x4DImode:
      if (pattern757 (x1, 
E_RVVM2x4DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21847; /* pred_fault_loadrvvm2x4di */

    case E_RVVMF2x2BFmode:
      if (pattern757 (x1, 
E_RVVMF2x2BFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21848; /* pred_fault_loadrvvmf2x2bf */

    case E_RVVMF2x3BFmode:
      if (pattern757 (x1, 
E_RVVMF2x3BFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21849; /* pred_fault_loadrvvmf2x3bf */

    case E_RVVMF2x4BFmode:
      if (pattern757 (x1, 
E_RVVMF2x4BFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21850; /* pred_fault_loadrvvmf2x4bf */

    case E_RVVMF2x5BFmode:
      if (pattern757 (x1, 
E_RVVMF2x5BFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21851; /* pred_fault_loadrvvmf2x5bf */

    case E_RVVMF2x6BFmode:
      if (pattern757 (x1, 
E_RVVMF2x6BFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21852; /* pred_fault_loadrvvmf2x6bf */

    case E_RVVMF2x7BFmode:
      if (pattern757 (x1, 
E_RVVMF2x7BFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21853; /* pred_fault_loadrvvmf2x7bf */

    case E_RVVMF2x8BFmode:
      if (pattern757 (x1, 
E_RVVMF2x8BFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21854; /* pred_fault_loadrvvmf2x8bf */

    case E_RVVMF2x2HFmode:
      if (pattern757 (x1, 
E_RVVMF2x2HFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21855; /* pred_fault_loadrvvmf2x2hf */

    case E_RVVMF2x3HFmode:
      if (pattern757 (x1, 
E_RVVMF2x3HFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21856; /* pred_fault_loadrvvmf2x3hf */

    case E_RVVMF2x4HFmode:
      if (pattern757 (x1, 
E_RVVMF2x4HFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21857; /* pred_fault_loadrvvmf2x4hf */

    case E_RVVMF2x5HFmode:
      if (pattern757 (x1, 
E_RVVMF2x5HFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21858; /* pred_fault_loadrvvmf2x5hf */

    case E_RVVMF2x6HFmode:
      if (pattern757 (x1, 
E_RVVMF2x6HFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21859; /* pred_fault_loadrvvmf2x6hf */

    case E_RVVMF2x7HFmode:
      if (pattern757 (x1, 
E_RVVMF2x7HFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21860; /* pred_fault_loadrvvmf2x7hf */

    case E_RVVMF2x8HFmode:
      if (pattern757 (x1, 
E_RVVMF2x8HFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21861; /* pred_fault_loadrvvmf2x8hf */

    case E_RVVM1x2SFmode:
      if (pattern757 (x1, 
E_RVVM1x2SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21862; /* pred_fault_loadrvvm1x2sf */

    case E_RVVM1x3SFmode:
      if (pattern757 (x1, 
E_RVVM1x3SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21863; /* pred_fault_loadrvvm1x3sf */

    case E_RVVM1x4SFmode:
      if (pattern757 (x1, 
E_RVVM1x4SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21864; /* pred_fault_loadrvvm1x4sf */

    case E_RVVM1x5SFmode:
      if (pattern757 (x1, 
E_RVVM1x5SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21865; /* pred_fault_loadrvvm1x5sf */

    case E_RVVM1x6SFmode:
      if (pattern757 (x1, 
E_RVVM1x6SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21866; /* pred_fault_loadrvvm1x6sf */

    case E_RVVM1x7SFmode:
      if (pattern757 (x1, 
E_RVVM1x7SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21867; /* pred_fault_loadrvvm1x7sf */

    case E_RVVM1x8SFmode:
      if (pattern757 (x1, 
E_RVVM1x8SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21868; /* pred_fault_loadrvvm1x8sf */

    case E_RVVM2x2DFmode:
      if (pattern757 (x1, 
E_RVVM2x2DFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21869; /* pred_fault_loadrvvm2x2df */

    case E_RVVM2x3DFmode:
      if (pattern757 (x1, 
E_RVVM2x3DFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21870; /* pred_fault_loadrvvm2x3df */

    case E_RVVM2x4DFmode:
      if (pattern757 (x1, 
E_RVVM2x4DFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21871; /* pred_fault_loadrvvm2x4df */

    case E_RVVMF2x2QImode:
      if (pattern757 (x1, 
E_RVVMF2x2QImode, 
E_RVVMF16BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21872; /* pred_fault_loadrvvmf2x2qi */

    case E_RVVMF2x3QImode:
      if (pattern757 (x1, 
E_RVVMF2x3QImode, 
E_RVVMF16BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21873; /* pred_fault_loadrvvmf2x3qi */

    case E_RVVMF2x4QImode:
      if (pattern757 (x1, 
E_RVVMF2x4QImode, 
E_RVVMF16BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21874; /* pred_fault_loadrvvmf2x4qi */

    case E_RVVMF2x5QImode:
      if (pattern757 (x1, 
E_RVVMF2x5QImode, 
E_RVVMF16BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21875; /* pred_fault_loadrvvmf2x5qi */

    case E_RVVMF2x6QImode:
      if (pattern757 (x1, 
E_RVVMF2x6QImode, 
E_RVVMF16BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21876; /* pred_fault_loadrvvmf2x6qi */

    case E_RVVMF2x7QImode:
      if (pattern757 (x1, 
E_RVVMF2x7QImode, 
E_RVVMF16BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21877; /* pred_fault_loadrvvmf2x7qi */

    case E_RVVMF2x8QImode:
      if (pattern757 (x1, 
E_RVVMF2x8QImode, 
E_RVVMF16BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21878; /* pred_fault_loadrvvmf2x8qi */

    case E_RVVM1x2HImode:
      if (pattern757 (x1, 
E_RVVM1x2HImode, 
E_RVVMF16BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21879; /* pred_fault_loadrvvm1x2hi */

    case E_RVVM1x3HImode:
      if (pattern757 (x1, 
E_RVVM1x3HImode, 
E_RVVMF16BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21880; /* pred_fault_loadrvvm1x3hi */

    case E_RVVM1x4HImode:
      if (pattern757 (x1, 
E_RVVM1x4HImode, 
E_RVVMF16BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21881; /* pred_fault_loadrvvm1x4hi */

    case E_RVVM1x5HImode:
      if (pattern757 (x1, 
E_RVVM1x5HImode, 
E_RVVMF16BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21882; /* pred_fault_loadrvvm1x5hi */

    case E_RVVM1x6HImode:
      if (pattern757 (x1, 
E_RVVM1x6HImode, 
E_RVVMF16BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21883; /* pred_fault_loadrvvm1x6hi */

    case E_RVVM1x7HImode:
      if (pattern757 (x1, 
E_RVVM1x7HImode, 
E_RVVMF16BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21884; /* pred_fault_loadrvvm1x7hi */

    case E_RVVM1x8HImode:
      if (pattern757 (x1, 
E_RVVM1x8HImode, 
E_RVVMF16BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21885; /* pred_fault_loadrvvm1x8hi */

    case E_RVVM2x2SImode:
      if (pattern757 (x1, 
E_RVVM2x2SImode, 
E_RVVMF16BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21886; /* pred_fault_loadrvvm2x2si */

    case E_RVVM2x3SImode:
      if (pattern757 (x1, 
E_RVVM2x3SImode, 
E_RVVMF16BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21887; /* pred_fault_loadrvvm2x3si */

    case E_RVVM2x4SImode:
      if (pattern757 (x1, 
E_RVVM2x4SImode, 
E_RVVMF16BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21888; /* pred_fault_loadrvvm2x4si */

    case E_RVVM4x2DImode:
      if (pattern757 (x1, 
E_RVVM4x2DImode, 
E_RVVMF16BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21889; /* pred_fault_loadrvvm4x2di */

    case E_RVVM1x2BFmode:
      if (pattern757 (x1, 
E_RVVM1x2BFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21890; /* pred_fault_loadrvvm1x2bf */

    case E_RVVM1x3BFmode:
      if (pattern757 (x1, 
E_RVVM1x3BFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21891; /* pred_fault_loadrvvm1x3bf */

    case E_RVVM1x4BFmode:
      if (pattern757 (x1, 
E_RVVM1x4BFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21892; /* pred_fault_loadrvvm1x4bf */

    case E_RVVM1x5BFmode:
      if (pattern757 (x1, 
E_RVVM1x5BFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21893; /* pred_fault_loadrvvm1x5bf */

    case E_RVVM1x6BFmode:
      if (pattern757 (x1, 
E_RVVM1x6BFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21894; /* pred_fault_loadrvvm1x6bf */

    case E_RVVM1x7BFmode:
      if (pattern757 (x1, 
E_RVVM1x7BFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21895; /* pred_fault_loadrvvm1x7bf */

    case E_RVVM1x8BFmode:
      if (pattern757 (x1, 
E_RVVM1x8BFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21896; /* pred_fault_loadrvvm1x8bf */

    case E_RVVM1x2HFmode:
      if (pattern757 (x1, 
E_RVVM1x2HFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21897; /* pred_fault_loadrvvm1x2hf */

    case E_RVVM1x3HFmode:
      if (pattern757 (x1, 
E_RVVM1x3HFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21898; /* pred_fault_loadrvvm1x3hf */

    case E_RVVM1x4HFmode:
      if (pattern757 (x1, 
E_RVVM1x4HFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21899; /* pred_fault_loadrvvm1x4hf */

    case E_RVVM1x5HFmode:
      if (pattern757 (x1, 
E_RVVM1x5HFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21900; /* pred_fault_loadrvvm1x5hf */

    case E_RVVM1x6HFmode:
      if (pattern757 (x1, 
E_RVVM1x6HFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21901; /* pred_fault_loadrvvm1x6hf */

    case E_RVVM1x7HFmode:
      if (pattern757 (x1, 
E_RVVM1x7HFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21902; /* pred_fault_loadrvvm1x7hf */

    case E_RVVM1x8HFmode:
      if (pattern757 (x1, 
E_RVVM1x8HFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21903; /* pred_fault_loadrvvm1x8hf */

    case E_RVVM2x2SFmode:
      if (pattern757 (x1, 
E_RVVM2x2SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21904; /* pred_fault_loadrvvm2x2sf */

    case E_RVVM2x3SFmode:
      if (pattern757 (x1, 
E_RVVM2x3SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21905; /* pred_fault_loadrvvm2x3sf */

    case E_RVVM2x4SFmode:
      if (pattern757 (x1, 
E_RVVM2x4SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21906; /* pred_fault_loadrvvm2x4sf */

    case E_RVVM4x2DFmode:
      if (pattern757 (x1, 
E_RVVM4x2DFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21907; /* pred_fault_loadrvvm4x2df */

    case E_RVVM1x2QImode:
      if (pattern757 (x1, 
E_RVVM1x2QImode, 
E_RVVMF8BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21908; /* pred_fault_loadrvvm1x2qi */

    case E_RVVM1x3QImode:
      if (pattern757 (x1, 
E_RVVM1x3QImode, 
E_RVVMF8BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21909; /* pred_fault_loadrvvm1x3qi */

    case E_RVVM1x4QImode:
      if (pattern757 (x1, 
E_RVVM1x4QImode, 
E_RVVMF8BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21910; /* pred_fault_loadrvvm1x4qi */

    case E_RVVM1x5QImode:
      if (pattern757 (x1, 
E_RVVM1x5QImode, 
E_RVVMF8BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21911; /* pred_fault_loadrvvm1x5qi */

    case E_RVVM1x6QImode:
      if (pattern757 (x1, 
E_RVVM1x6QImode, 
E_RVVMF8BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21912; /* pred_fault_loadrvvm1x6qi */

    case E_RVVM1x7QImode:
      if (pattern757 (x1, 
E_RVVM1x7QImode, 
E_RVVMF8BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21913; /* pred_fault_loadrvvm1x7qi */

    case E_RVVM1x8QImode:
      if (pattern757 (x1, 
E_RVVM1x8QImode, 
E_RVVMF8BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21914; /* pred_fault_loadrvvm1x8qi */

    case E_RVVM2x2HImode:
      if (pattern757 (x1, 
E_RVVM2x2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21915; /* pred_fault_loadrvvm2x2hi */

    case E_RVVM2x3HImode:
      if (pattern757 (x1, 
E_RVVM2x3HImode, 
E_RVVMF8BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21916; /* pred_fault_loadrvvm2x3hi */

    case E_RVVM2x4HImode:
      if (pattern757 (x1, 
E_RVVM2x4HImode, 
E_RVVMF8BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21917; /* pred_fault_loadrvvm2x4hi */

    case E_RVVM4x2SImode:
      if (pattern757 (x1, 
E_RVVM4x2SImode, 
E_RVVMF8BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21918; /* pred_fault_loadrvvm4x2si */

    case E_RVVM2x2BFmode:
      if (pattern757 (x1, 
E_RVVM2x2BFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21919; /* pred_fault_loadrvvm2x2bf */

    case E_RVVM2x3BFmode:
      if (pattern757 (x1, 
E_RVVM2x3BFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21920; /* pred_fault_loadrvvm2x3bf */

    case E_RVVM2x4BFmode:
      if (pattern757 (x1, 
E_RVVM2x4BFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21921; /* pred_fault_loadrvvm2x4bf */

    case E_RVVM2x2HFmode:
      if (pattern757 (x1, 
E_RVVM2x2HFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21922; /* pred_fault_loadrvvm2x2hf */

    case E_RVVM2x3HFmode:
      if (pattern757 (x1, 
E_RVVM2x3HFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21923; /* pred_fault_loadrvvm2x3hf */

    case E_RVVM2x4HFmode:
      if (pattern757 (x1, 
E_RVVM2x4HFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21924; /* pred_fault_loadrvvm2x4hf */

    case E_RVVM4x2SFmode:
      if (pattern757 (x1, 
E_RVVM4x2SFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21925; /* pred_fault_loadrvvm4x2sf */

    case E_RVVM2x2QImode:
      if (pattern757 (x1, 
E_RVVM2x2QImode, 
E_RVVMF4BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21926; /* pred_fault_loadrvvm2x2qi */

    case E_RVVM2x3QImode:
      if (pattern757 (x1, 
E_RVVM2x3QImode, 
E_RVVMF4BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21927; /* pred_fault_loadrvvm2x3qi */

    case E_RVVM2x4QImode:
      if (pattern757 (x1, 
E_RVVM2x4QImode, 
E_RVVMF4BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21928; /* pred_fault_loadrvvm2x4qi */

    case E_RVVM4x2HImode:
      if (pattern757 (x1, 
E_RVVM4x2HImode, 
E_RVVMF4BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21929; /* pred_fault_loadrvvm4x2hi */

    case E_RVVM4x2BFmode:
      if (pattern757 (x1, 
E_RVVM4x2BFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21930; /* pred_fault_loadrvvm4x2bf */

    case E_RVVM4x2HFmode:
      if (pattern757 (x1, 
E_RVVM4x2HFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21931; /* pred_fault_loadrvvm4x2hf */

    case E_RVVM4x2QImode:
      if (pattern757 (x1, 
E_RVVM4x2QImode, 
E_RVVMF2BImode) != 0
          || !
#line 8466 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21932; /* pred_fault_loadrvvm4x2qi */

    default:
      return -1;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern236 (x2))
    {
    case 0:
      if (!(
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9297 (insn, operands);

    case 1:
      if (!(
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9299 (insn, operands);

    case 2:
      if (!(
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9301 (insn, operands);

    case 3:
      if (!(
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9303 (insn, operands);

    case 4:
      if (!(
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9305 (insn, operands);

    case 5:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9307 (insn, operands);

    case 6:
      if (!(
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9309 (insn, operands);

    case 7:
      if (!(
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9311 (insn, operands);

    case 8:
      if (!(
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9313 (insn, operands);

    case 9:
      if (!(
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9315 (insn, operands);

    case 10:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9317 (insn, operands);

    case 11:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9319 (insn, operands);

    case 12:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9321 (insn, operands);

    case 13:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9323 (insn, operands);

    case 14:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9325 (insn, operands);

    case 15:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9327 (insn, operands);

    case 16:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9329 (insn, operands);

    case 17:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9331 (insn, operands);

    case 18:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9333 (insn, operands);

    case 19:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9335 (insn, operands);

    case 20:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9337 (insn, operands);

    case 21:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9339 (insn, operands);

    case 22:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9341 (insn, operands);

    case 23:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9343 (insn, operands);

    case 24:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9345 (insn, operands);

    case 25:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9347 (insn, operands);

    case 26:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9349 (insn, operands);

    case 27:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9351 (insn, operands);

    case 28:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9353 (insn, operands);

    case 29:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9355 (insn, operands);

    case 30:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9357 (insn, operands);

    case 31:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9359 (insn, operands);

    case 32:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9361 (insn, operands);

    case 33:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9363 (insn, operands);

    case 34:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9365 (insn, operands);

    case 35:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9367 (insn, operands);

    case 36:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9369 (insn, operands);

    case 37:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9371 (insn, operands);

    case 38:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9373 (insn, operands);

    case 39:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9375 (insn, operands);

    case 40:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9377 (insn, operands);

    case 41:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9379 (insn, operands);

    case 42:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9381 (insn, operands);

    case 43:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9383 (insn, operands);

    case 44:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9385 (insn, operands);

    case 45:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9387 (insn, operands);

    case 46:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9389 (insn, operands);

    case 47:
      if (!((
#line 961 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 963 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9391 (insn, operands);

    case 48:
      if (!(
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9440 (insn, operands);

    case 49:
      if (!(
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9441 (insn, operands);

    case 50:
      if (!(
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9442 (insn, operands);

    case 51:
      if (!(
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9443 (insn, operands);

    case 52:
      if (!(
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9444 (insn, operands);

    case 53:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9445 (insn, operands);

    case 54:
      if (!(
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9446 (insn, operands);

    case 55:
      if (!(
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9447 (insn, operands);

    case 56:
      if (!(
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9448 (insn, operands);

    case 57:
      if (!(
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9449 (insn, operands);

    case 58:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9450 (insn, operands);

    case 59:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9451 (insn, operands);

    case 60:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9452 (insn, operands);

    case 61:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9453 (insn, operands);

    case 62:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9454 (insn, operands);

    case 63:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9455 (insn, operands);

    case 64:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9456 (insn, operands);

    case 65:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9457 (insn, operands);

    case 66:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9458 (insn, operands);

    case 67:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9459 (insn, operands);

    case 68:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9460 (insn, operands);

    case 69:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9461 (insn, operands);

    case 70:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9462 (insn, operands);

    case 71:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9463 (insn, operands);

    case 72:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9464 (insn, operands);

    case 73:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9465 (insn, operands);

    case 74:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9466 (insn, operands);

    case 75:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9467 (insn, operands);

    case 76:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9468 (insn, operands);

    case 77:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9469 (insn, operands);

    case 78:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9470 (insn, operands);

    case 79:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9471 (insn, operands);

    case 80:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9472 (insn, operands);

    case 81:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9473 (insn, operands);

    case 82:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9474 (insn, operands);

    case 83:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9475 (insn, operands);

    case 84:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9476 (insn, operands);

    case 85:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9477 (insn, operands);

    case 86:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9478 (insn, operands);

    case 87:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9479 (insn, operands);

    case 88:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9480 (insn, operands);

    case 89:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9481 (insn, operands);

    case 90:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9482 (insn, operands);

    case 91:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9483 (insn, operands);

    case 92:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9484 (insn, operands);

    case 93:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9485 (insn, operands);

    case 94:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9486 (insn, operands);

    case 95:
      if (!((
#line 1005 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1007 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9487 (insn, operands);

    case 96:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9489 (insn, operands);

    case 97:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9491 (insn, operands);

    case 98:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9493 (insn, operands);

    case 99:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9495 (insn, operands);

    case 100:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9497 (insn, operands);

    case 101:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9499 (insn, operands);

    case 102:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9501 (insn, operands);

    case 103:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9503 (insn, operands);

    case 104:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9505 (insn, operands);

    case 105:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9507 (insn, operands);

    case 106:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9509 (insn, operands);

    case 107:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9511 (insn, operands);

    case 108:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9513 (insn, operands);

    case 109:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9515 (insn, operands);

    case 110:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9517 (insn, operands);

    case 111:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9519 (insn, operands);

    case 112:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9521 (insn, operands);

    case 113:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9523 (insn, operands);

    case 114:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9525 (insn, operands);

    case 115:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9527 (insn, operands);

    case 116:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9529 (insn, operands);

    case 117:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9531 (insn, operands);

    case 118:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9533 (insn, operands);

    case 119:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9535 (insn, operands);

    case 120:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9537 (insn, operands);

    case 121:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9539 (insn, operands);

    case 122:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9541 (insn, operands);

    case 123:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9543 (insn, operands);

    case 124:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9545 (insn, operands);

    case 125:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9547 (insn, operands);

    case 126:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9549 (insn, operands);

    case 127:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9551 (insn, operands);

    case 128:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9553 (insn, operands);

    case 129:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9555 (insn, operands);

    case 130:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9557 (insn, operands);

    case 131:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9559 (insn, operands);

    case 132:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9561 (insn, operands);

    case 133:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9563 (insn, operands);

    case 134:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9565 (insn, operands);

    case 135:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9567 (insn, operands);

    case 136:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9569 (insn, operands);

    case 137:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9571 (insn, operands);

    case 138:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9573 (insn, operands);

    case 139:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9575 (insn, operands);

    case 140:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9577 (insn, operands);

    case 141:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9579 (insn, operands);

    case 142:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9581 (insn, operands);

    case 143:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1031 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9583 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_29 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1DImode)
      && reg_or_mem_operand (operands[1], E_V1DImode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return gen_split_280 (insn, operands);
      if (((
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1DImode)
       || register_operand (operands[1], V1DImode))) && 
#line 4319 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1441 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V1DImode)
       || !register_operand (operands[1], V1DImode)))))
        return gen_split_1962 (insn, operands);
    }
  if (!register_operand (operands[0], E_V1DImode)
      || !register_operand (operands[1], E_V1DImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2127 (insn, operands);
}

 rtx_insn *
split_34 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1SImode)
      && reg_or_mem_operand (operands[1], E_V1SImode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return gen_split_269 (insn, operands);
      if (((
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1SImode)
       || register_operand (operands[1], V1SImode))) && 
#line 4314 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1441 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V1SImode)
       || !register_operand (operands[1], V1SImode)))))
        return gen_split_1957 (insn, operands);
    }
  if (!register_operand (operands[0], E_V1SImode)
      || !register_operand (operands[1], E_V1SImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2116 (insn, operands);
}

 rtx_insn *
split_40 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16QImode)
      && reg_or_mem_operand (operands[1], E_V16QImode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return gen_split_248 (insn, operands);
      if (((
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16QImode)
       || register_operand (operands[1], V16QImode))) && 
#line 4308 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1441 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V16QImode)
       || !register_operand (operands[1], V16QImode)))))
        return gen_split_1951 (insn, operands);
    }
  if (!register_operand (operands[0], E_V16QImode)
      || !register_operand (operands[1], E_V16QImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2095 (insn, operands);
}

 rtx_insn *
split_46 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8BImode)
      && reg_or_mem_operand (operands[1], E_V8BImode)
      && ((
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8BImode)
       || register_operand (operands[1], V8BImode))) && 
#line 4343 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1441 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V8BImode)
       || !register_operand (operands[1], V8BImode)))))
    return gen_split_1985 (insn, operands);
  if (!register_operand (operands[0], E_V8BImode)
      || !register_operand (operands[1], E_V8BImode)
      || !((
#line 1530 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1532 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2173 (insn, operands);
}

 rtx_insn *
split_51 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256DFmode)
      && reg_or_mem_operand (operands[1], E_V256DFmode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 303 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return gen_split_321 (insn, operands);
  if (!register_operand (operands[0], E_V256DFmode)
      || !register_operand (operands[1], E_V256DFmode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 303 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2168 (insn, operands);
}

 rtx_insn *
split_57 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256SFmode)
      && reg_or_mem_operand (operands[1], E_V256SFmode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 292 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return gen_split_310 (insn, operands);
  if (!register_operand (operands[0], E_V256SFmode)
      || !register_operand (operands[1], E_V256SFmode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 292 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2157 (insn, operands);
}

 rtx_insn *
split_63 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V512HFmode)
      && reg_or_mem_operand (operands[1], E_V512HFmode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
    return gen_split_299 (insn, operands);
  if (!register_operand (operands[0], E_V512HFmode)
      || !register_operand (operands[1], E_V512HFmode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2146 (insn, operands);
}

 rtx_insn *
split_69 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256DImode)
      && reg_or_mem_operand (operands[1], E_V256DImode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return gen_split_288 (insn, operands);
  if (!register_operand (operands[0], E_V256DImode)
      || !register_operand (operands[1], E_V256DImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2135 (insn, operands);
}

 rtx_insn *
split_75 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256SImode)
      && reg_or_mem_operand (operands[1], E_V256SImode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return gen_split_277 (insn, operands);
  if (!register_operand (operands[0], E_V256SImode)
      || !register_operand (operands[1], E_V256SImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2124 (insn, operands);
}

 rtx_insn *
split_82 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256HImode)
      && reg_or_mem_operand (operands[1], E_V256HImode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return gen_split_265 (insn, operands);
  if (!register_operand (operands[0], E_V256HImode)
      || !register_operand (operands[1], E_V256HImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2112 (insn, operands);
}

 rtx_insn *
split_89 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V512QImode)
      && reg_or_mem_operand (operands[1], E_V512QImode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return gen_split_253 (insn, operands);
  if (!register_operand (operands[0], E_V512QImode)
      || !register_operand (operands[1], E_V512QImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2100 (insn, operands);
}

 rtx_insn *
split_96 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF4BImode)
      && reg_or_mem_operand (operands[1], E_RVVMF4BImode)
      && 
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return gen_split_241 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF4BImode)
      || !register_operand (operands[1], E_RVVMF4BImode)
      || !(
#line 1294 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1296 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1578 (insn, operands);
}

 rtx_insn *
split_103 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF2HFmode)
      && reg_or_mem_operand (operands[1], E_RVVMF2HFmode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return gen_split_226 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF2HFmode)
      || !register_operand (operands[1], E_RVVMF2HFmode)
      || !((
#line 1257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 938 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1259 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1570 (insn, operands);
}

 rtx_insn *
split_110 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !splittable_const_int_operand (operands[1], E_SImode)
          || !(
#line 2471 "../../../gcc/config/riscv/riscv.md"
(!ira_in_progress
   && !(p2m1_shift_operand (operands[1], SImode)
	|| high_mask_shift_operand (operands[1], SImode)
	|| exact_log2 (INTVAL (operands[1])) >= 0)) && 
#line 2476 "../../../gcc/config/riscv/riscv.md"
( 1)))
        return NULL;
      return gen_split_18 (insn, operands);

    case E_DImode:
      return split_109 (x1, insn);

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !move_operand (operands[1], E_DFmode)
          || !
#line 2733 "../../../gcc/config/riscv/riscv.md"
(reload_completed
   && riscv_split_64bit_move_p (operands[0], operands[1])))
        return NULL;
      return gen_split_21 (insn, operands);

    case E_RVVM8QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM8QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM8QImode))
        return NULL;
      if (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return gen_split_197 (insn, operands);
      if (!(
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM8QImode)
   && !memory_operand (operands[1], RVVM8QImode))))
        return NULL;
      return gen_split_1531 (insn, operands);

    case E_RVVM4QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM4QImode))
        return NULL;
      if (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return gen_split_198 (insn, operands);
      if (!(
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM4QImode)
   && !memory_operand (operands[1], RVVM4QImode))))
        return NULL;
      return gen_split_1532 (insn, operands);

    case E_RVVM2QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2QImode))
        return NULL;
      if (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return gen_split_199 (insn, operands);
      if (!(
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM2QImode)
   && !memory_operand (operands[1], RVVM2QImode))))
        return NULL;
      return gen_split_1533 (insn, operands);

    case E_RVVM1QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1QImode))
        return NULL;
      if (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return gen_split_200 (insn, operands);
      if (!(
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM1QImode)
   && !memory_operand (operands[1], RVVM1QImode))))
        return NULL;
      return gen_split_1534 (insn, operands);

    case E_RVVM8HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM8HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM8HImode))
        return NULL;
      if (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return gen_split_201 (insn, operands);
      if (!(
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM8HImode)
   && !memory_operand (operands[1], RVVM8HImode))))
        return NULL;
      return gen_split_1535 (insn, operands);

    case E_RVVM4HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM4HImode))
        return NULL;
      if (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return gen_split_202 (insn, operands);
      if (!(
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM4HImode)
   && !memory_operand (operands[1], RVVM4HImode))))
        return NULL;
      return gen_split_1536 (insn, operands);

    case E_RVVM2HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2HImode))
        return NULL;
      if (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return gen_split_203 (insn, operands);
      if (!(
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM2HImode)
   && !memory_operand (operands[1], RVVM2HImode))))
        return NULL;
      return gen_split_1537 (insn, operands);

    case E_RVVM1HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1HImode))
        return NULL;
      if (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return gen_split_204 (insn, operands);
      if (!(
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM1HImode)
   && !memory_operand (operands[1], RVVM1HImode))))
        return NULL;
      return gen_split_1538 (insn, operands);

    case E_RVVM8SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM8SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM8SImode))
        return NULL;
      if (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return gen_split_205 (insn, operands);
      if (!(
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM8SImode)
   && !memory_operand (operands[1], RVVM8SImode))))
        return NULL;
      return gen_split_1547 (insn, operands);

    case E_RVVM4SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM4SImode))
        return NULL;
      if (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return gen_split_206 (insn, operands);
      if (!(
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM4SImode)
   && !memory_operand (operands[1], RVVM4SImode))))
        return NULL;
      return gen_split_1548 (insn, operands);

    case E_RVVM2SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2SImode))
        return NULL;
      if (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return gen_split_207 (insn, operands);
      if (!(
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM2SImode)
   && !memory_operand (operands[1], RVVM2SImode))))
        return NULL;
      return gen_split_1549 (insn, operands);

    case E_RVVM1SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1SImode))
        return NULL;
      if (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return gen_split_208 (insn, operands);
      if (!(
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM1SImode)
   && !memory_operand (operands[1], RVVM1SImode))))
        return NULL;
      return gen_split_1550 (insn, operands);

    case E_RVVM8DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM8DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM8DImode))
        return NULL;
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return gen_split_209 (insn, operands);
      if (!((
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 924 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM8DImode)
   && !memory_operand (operands[1], RVVM8DImode))))
        return NULL;
      return gen_split_1555 (insn, operands);

    case E_RVVM4DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM4DImode))
        return NULL;
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return gen_split_210 (insn, operands);
      if (!((
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 924 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM4DImode)
   && !memory_operand (operands[1], RVVM4DImode))))
        return NULL;
      return gen_split_1556 (insn, operands);

    case E_RVVM2DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2DImode))
        return NULL;
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return gen_split_211 (insn, operands);
      if (!((
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 925 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM2DImode)
   && !memory_operand (operands[1], RVVM2DImode))))
        return NULL;
      return gen_split_1557 (insn, operands);

    case E_RVVM1DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1DImode))
        return NULL;
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return gen_split_212 (insn, operands);
      if (!((
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 925 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM1DImode)
   && !memory_operand (operands[1], RVVM1DImode))))
        return NULL;
      return gen_split_1558 (insn, operands);

    case E_RVVMF8QImode:
      return split_108 (x1, insn);

    case E_RVVMF4HImode:
      return split_107 (x1, insn);

    case E_RVVMF2SImode:
      return split_106 (x1, insn);

    case E_RVVM8BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM8BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM8BFmode))
        return NULL;
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return gen_split_216 (insn, operands);
      if (!((
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 913 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM8BFmode)
   && !memory_operand (operands[1], RVVM8BFmode))))
        return NULL;
      return gen_split_1539 (insn, operands);

    case E_RVVM4BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM4BFmode))
        return NULL;
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return gen_split_217 (insn, operands);
      if (!((
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 913 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM4BFmode)
   && !memory_operand (operands[1], RVVM4BFmode))))
        return NULL;
      return gen_split_1540 (insn, operands);

    case E_RVVM2BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2BFmode))
        return NULL;
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return gen_split_218 (insn, operands);
      if (!((
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 914 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM2BFmode)
   && !memory_operand (operands[1], RVVM2BFmode))))
        return NULL;
      return gen_split_1541 (insn, operands);

    case E_RVVM1BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1BFmode))
        return NULL;
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return gen_split_219 (insn, operands);
      if (!((
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 914 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM1BFmode)
   && !memory_operand (operands[1], RVVM1BFmode))))
        return NULL;
      return gen_split_1542 (insn, operands);

    case E_RVVMF2BFmode:
      return split_105 (x1, insn);

    case E_RVVMF4BFmode:
      return split_104 (x1, insn);

    case E_RVVM8HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM8HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM8HFmode))
        return NULL;
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return gen_split_222 (insn, operands);
      if (!((
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 916 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM8HFmode)
   && !memory_operand (operands[1], RVVM8HFmode))))
        return NULL;
      return gen_split_1543 (insn, operands);

    case E_RVVM4HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM4HFmode))
        return NULL;
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return gen_split_223 (insn, operands);
      if (!((
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 916 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM4HFmode)
   && !memory_operand (operands[1], RVVM4HFmode))))
        return NULL;
      return gen_split_1544 (insn, operands);

    case E_RVVM2HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2HFmode))
        return NULL;
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return gen_split_224 (insn, operands);
      if (!((
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 917 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM2HFmode)
   && !memory_operand (operands[1], RVVM2HFmode))))
        return NULL;
      return gen_split_1545 (insn, operands);

    case E_RVVM1HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1HFmode))
        return NULL;
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return gen_split_225 (insn, operands);
      if (!((
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 917 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM1HFmode)
   && !memory_operand (operands[1], RVVM1HFmode))))
        return NULL;
      return gen_split_1546 (insn, operands);

    case E_RVVMF2HFmode:
      return split_103 (x1, insn);

    case E_RVVMF4HFmode:
      return split_102 (x1, insn);

    case E_RVVM8SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM8SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM8SFmode))
        return NULL;
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return gen_split_228 (insn, operands);
      if (!((
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 921 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM8SFmode)
   && !memory_operand (operands[1], RVVM8SFmode))))
        return NULL;
      return gen_split_1551 (insn, operands);

    case E_RVVM4SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM4SFmode))
        return NULL;
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return gen_split_229 (insn, operands);
      if (!((
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 921 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM4SFmode)
   && !memory_operand (operands[1], RVVM4SFmode))))
        return NULL;
      return gen_split_1552 (insn, operands);

    case E_RVVM2SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2SFmode))
        return NULL;
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return gen_split_230 (insn, operands);
      if (!((
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 922 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM2SFmode)
   && !memory_operand (operands[1], RVVM2SFmode))))
        return NULL;
      return gen_split_1553 (insn, operands);

    case E_RVVM1SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1SFmode))
        return NULL;
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return gen_split_231 (insn, operands);
      if (!((
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 922 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM1SFmode)
   && !memory_operand (operands[1], RVVM1SFmode))))
        return NULL;
      return gen_split_1554 (insn, operands);

    case E_RVVMF2SFmode:
      return split_101 (x1, insn);

    case E_RVVM8DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM8DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM8DFmode))
        return NULL;
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return gen_split_233 (insn, operands);
      if (!((
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 927 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM8DFmode)
   && !memory_operand (operands[1], RVVM8DFmode))))
        return NULL;
      return gen_split_1559 (insn, operands);

    case E_RVVM4DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM4DFmode))
        return NULL;
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return gen_split_234 (insn, operands);
      if (!((
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 927 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM4DFmode)
   && !memory_operand (operands[1], RVVM4DFmode))))
        return NULL;
      return gen_split_1560 (insn, operands);

    case E_RVVM2DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2DFmode))
        return NULL;
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return gen_split_235 (insn, operands);
      if (!((
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 928 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM2DFmode)
   && !memory_operand (operands[1], RVVM2DFmode))))
        return NULL;
      return gen_split_1561 (insn, operands);

    case E_RVVM1DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1DFmode))
        return NULL;
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return gen_split_236 (insn, operands);
      if (!((
#line 1222 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 928 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1227 "../../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM1DFmode)
   && !memory_operand (operands[1], RVVM1DFmode))))
        return NULL;
      return gen_split_1562 (insn, operands);

    case E_RVVMF64BImode:
      return split_100 (x1, insn);

    case E_RVVMF32BImode:
      return split_99 (x1, insn);

    case E_RVVMF16BImode:
      return split_98 (x1, insn);

    case E_RVVMF8BImode:
      return split_97 (x1, insn);

    case E_RVVMF4BImode:
      return split_96 (x1, insn);

    case E_RVVMF2BImode:
      return split_95 (x1, insn);

    case E_RVVM1BImode:
      return split_94 (x1, insn);

    case E_V1QImode:
      return split_44 (x1, insn);

    case E_V2QImode:
      return split_43 (x1, insn);

    case E_V4QImode:
      return split_42 (x1, insn);

    case E_V8QImode:
      return split_41 (x1, insn);

    case E_V16QImode:
      return split_40 (x1, insn);

    case E_V32QImode:
      return split_93 (x1, insn);

    case E_V64QImode:
      return split_92 (x1, insn);

    case E_V128QImode:
      return split_91 (x1, insn);

    case E_V256QImode:
      return split_90 (x1, insn);

    case E_V512QImode:
      return split_89 (x1, insn);

    case E_V1024QImode:
      return split_88 (x1, insn);

    case E_V2048QImode:
      return split_87 (x1, insn);

    case E_V4096QImode:
      return split_86 (x1, insn);

    case E_V1HImode:
      return split_39 (x1, insn);

    case E_V2HImode:
      return split_38 (x1, insn);

    case E_V4HImode:
      return split_37 (x1, insn);

    case E_V8HImode:
      return split_36 (x1, insn);

    case E_V16HImode:
      return split_35 (x1, insn);

    case E_V32HImode:
      return split_85 (x1, insn);

    case E_V64HImode:
      return split_84 (x1, insn);

    case E_V128HImode:
      return split_83 (x1, insn);

    case E_V256HImode:
      return split_82 (x1, insn);

    case E_V512HImode:
      return split_81 (x1, insn);

    case E_V1024HImode:
      return split_80 (x1, insn);

    case E_V2048HImode:
      return split_79 (x1, insn);

    case E_V1SImode:
      return split_34 (x1, insn);

    case E_V2SImode:
      return split_33 (x1, insn);

    case E_V4SImode:
      return split_32 (x1, insn);

    case E_V8SImode:
      return split_31 (x1, insn);

    case E_V16SImode:
      return split_30 (x1, insn);

    case E_V32SImode:
      return split_78 (x1, insn);

    case E_V64SImode:
      return split_77 (x1, insn);

    case E_V128SImode:
      return split_76 (x1, insn);

    case E_V256SImode:
      return split_75 (x1, insn);

    case E_V512SImode:
      return split_74 (x1, insn);

    case E_V1024SImode:
      return split_73 (x1, insn);

    case E_V1DImode:
      return split_29 (x1, insn);

    case E_V2DImode:
      return split_28 (x1, insn);

    case E_V4DImode:
      return split_27 (x1, insn);

    case E_V8DImode:
      return split_26 (x1, insn);

    case E_V16DImode:
      return split_25 (x1, insn);

    case E_V32DImode:
      return split_72 (x1, insn);

    case E_V64DImode:
      return split_71 (x1, insn);

    case E_V128DImode:
      return split_70 (x1, insn);

    case E_V256DImode:
      return split_69 (x1, insn);

    case E_V512DImode:
      return split_68 (x1, insn);

    case E_V1HFmode:
      return split_24 (x1, insn);

    case E_V2HFmode:
      return split_23 (x1, insn);

    case E_V4HFmode:
      return split_22 (x1, insn);

    case E_V8HFmode:
      return split_21 (x1, insn);

    case E_V16HFmode:
      return split_20 (x1, insn);

    case E_V32HFmode:
      return split_67 (x1, insn);

    case E_V64HFmode:
      return split_66 (x1, insn);

    case E_V128HFmode:
      return split_65 (x1, insn);

    case E_V256HFmode:
      return split_64 (x1, insn);

    case E_V512HFmode:
      return split_63 (x1, insn);

    case E_V1024HFmode:
      return split_62 (x1, insn);

    case E_V2048HFmode:
      return split_61 (x1, insn);

    case E_V1SFmode:
      return split_19 (x1, insn);

    case E_V2SFmode:
      return split_18 (x1, insn);

    case E_V4SFmode:
      return split_17 (x1, insn);

    case E_V8SFmode:
      return split_16 (x1, insn);

    case E_V16SFmode:
      return split_15 (x1, insn);

    case E_V32SFmode:
      return split_60 (x1, insn);

    case E_V64SFmode:
      return split_59 (x1, insn);

    case E_V128SFmode:
      return split_58 (x1, insn);

    case E_V256SFmode:
      return split_57 (x1, insn);

    case E_V512SFmode:
      return split_56 (x1, insn);

    case E_V1024SFmode:
      return split_55 (x1, insn);

    case E_V1DFmode:
      return split_14 (x1, insn);

    case E_V2DFmode:
      return split_13 (x1, insn);

    case E_V4DFmode:
      return split_12 (x1, insn);

    case E_V8DFmode:
      return split_11 (x1, insn);

    case E_V16DFmode:
      return split_10 (x1, insn);

    case E_V32DFmode:
      return split_54 (x1, insn);

    case E_V64DFmode:
      return split_53 (x1, insn);

    case E_V128DFmode:
      return split_52 (x1, insn);

    case E_V256DFmode:
      return split_51 (x1, insn);

    case E_V512DFmode:
      return split_50 (x1, insn);

    case E_RVVMF8x2QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF8x2QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF8x2QImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_323 (insn, operands);

    case E_RVVMF8x3QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF8x3QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF8x3QImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_324 (insn, operands);

    case E_RVVMF8x4QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF8x4QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF8x4QImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_325 (insn, operands);

    case E_RVVMF8x5QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF8x5QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF8x5QImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_326 (insn, operands);

    case E_RVVMF8x6QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF8x6QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF8x6QImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_327 (insn, operands);

    case E_RVVMF8x7QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF8x7QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF8x7QImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_328 (insn, operands);

    case E_RVVMF8x8QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF8x8QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF8x8QImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1173 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_329 (insn, operands);

    case E_RVVMF4x2HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x2HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x2HImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1174 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_330 (insn, operands);

    case E_RVVMF4x3HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x3HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x3HImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1175 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_331 (insn, operands);

    case E_RVVMF4x4HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x4HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x4HImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_332 (insn, operands);

    case E_RVVMF4x5HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x5HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x5HImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_333 (insn, operands);

    case E_RVVMF4x6HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x6HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x6HImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_334 (insn, operands);

    case E_RVVMF4x7HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x7HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x7HImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1179 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_335 (insn, operands);

    case E_RVVMF4x8HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x8HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x8HImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_336 (insn, operands);

    case E_RVVMF2x2SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x2SImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x2SImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_337 (insn, operands);

    case E_RVVMF2x3SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x3SImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x3SImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1182 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_338 (insn, operands);

    case E_RVVMF2x4SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x4SImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x4SImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_339 (insn, operands);

    case E_RVVMF2x5SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x5SImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x5SImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_340 (insn, operands);

    case E_RVVMF2x6SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x6SImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x6SImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1185 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_341 (insn, operands);

    case E_RVVMF2x7SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x7SImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x7SImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1186 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_342 (insn, operands);

    case E_RVVMF2x8SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x8SImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x8SImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1187 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_343 (insn, operands);

    case E_RVVM1x2DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x2DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x2DImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1188 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_344 (insn, operands);

    case E_RVVM1x3DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x3DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x3DImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1189 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_345 (insn, operands);

    case E_RVVM1x4DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x4DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x4DImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1190 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_346 (insn, operands);

    case E_RVVM1x5DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x5DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x5DImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1191 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_347 (insn, operands);

    case E_RVVM1x6DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x6DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x6DImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1192 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_348 (insn, operands);

    case E_RVVM1x7DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x7DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x7DImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1193 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_349 (insn, operands);

    case E_RVVM1x8DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x8DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x8DImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1194 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_350 (insn, operands);

    case E_RVVMF4x2BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x2BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x2BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1195 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_351 (insn, operands);

    case E_RVVMF4x3BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x3BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x3BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1196 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_352 (insn, operands);

    case E_RVVMF4x4BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x4BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x4BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1197 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_353 (insn, operands);

    case E_RVVMF4x5BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x5BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x5BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1198 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_354 (insn, operands);

    case E_RVVMF4x6BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x6BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x6BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1199 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_355 (insn, operands);

    case E_RVVMF4x7BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x7BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x7BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1200 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_356 (insn, operands);

    case E_RVVMF4x8BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x8BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x8BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1201 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_357 (insn, operands);

    case E_RVVMF4x2HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x2HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x2HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1202 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_358 (insn, operands);

    case E_RVVMF4x3HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x3HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x3HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1203 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_359 (insn, operands);

    case E_RVVMF4x4HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x4HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x4HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1204 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_360 (insn, operands);

    case E_RVVMF4x5HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x5HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x5HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1205 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_361 (insn, operands);

    case E_RVVMF4x6HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x6HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x6HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1206 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_362 (insn, operands);

    case E_RVVMF4x7HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x7HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x7HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1207 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_363 (insn, operands);

    case E_RVVMF4x8HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x8HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x8HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1208 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_364 (insn, operands);

    case E_RVVMF2x2SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x2SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x2SFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1209 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_365 (insn, operands);

    case E_RVVMF2x3SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x3SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x3SFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1210 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_366 (insn, operands);

    case E_RVVMF2x4SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x4SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x4SFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1211 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_367 (insn, operands);

    case E_RVVMF2x5SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x5SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x5SFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1212 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_368 (insn, operands);

    case E_RVVMF2x6SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x6SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x6SFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1213 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_369 (insn, operands);

    case E_RVVMF2x7SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x7SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x7SFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1214 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_370 (insn, operands);

    case E_RVVMF2x8SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x8SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x8SFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1215 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_371 (insn, operands);

    case E_RVVM1x2DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x2DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x2DFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1216 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return NULL;
      return gen_split_372 (insn, operands);

    case E_RVVM1x3DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x3DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x3DFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1217 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return NULL;
      return gen_split_373 (insn, operands);

    case E_RVVM1x4DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x4DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x4DFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1218 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return NULL;
      return gen_split_374 (insn, operands);

    case E_RVVM1x5DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x5DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x5DFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1219 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return NULL;
      return gen_split_375 (insn, operands);

    case E_RVVM1x6DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x6DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x6DFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1220 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return NULL;
      return gen_split_376 (insn, operands);

    case E_RVVM1x7DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x7DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x7DFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1221 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return NULL;
      return gen_split_377 (insn, operands);

    case E_RVVM1x8DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x8DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x8DFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1222 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return NULL;
      return gen_split_378 (insn, operands);

    case E_RVVMF4x2QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x2QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x2QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_379 (insn, operands);

    case E_RVVMF4x3QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x3QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x3QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_380 (insn, operands);

    case E_RVVMF4x4QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x4QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x4QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_381 (insn, operands);

    case E_RVVMF4x5QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x5QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x5QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_382 (insn, operands);

    case E_RVVMF4x6QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x6QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x6QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_383 (insn, operands);

    case E_RVVMF4x7QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x7QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x7QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_384 (insn, operands);

    case E_RVVMF4x8QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x8QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x8QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_385 (insn, operands);

    case E_RVVMF2x2HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x2HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x2HImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_386 (insn, operands);

    case E_RVVMF2x3HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x3HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x3HImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_387 (insn, operands);

    case E_RVVMF2x4HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x4HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x4HImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_388 (insn, operands);

    case E_RVVMF2x5HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x5HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x5HImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_389 (insn, operands);

    case E_RVVMF2x6HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x6HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x6HImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_390 (insn, operands);

    case E_RVVMF2x7HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x7HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x7HImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_391 (insn, operands);

    case E_RVVMF2x8HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x8HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x8HImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_392 (insn, operands);

    case E_RVVM1x2SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x2SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x2SImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_393 (insn, operands);

    case E_RVVM1x3SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x3SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x3SImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_394 (insn, operands);

    case E_RVVM1x4SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x4SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x4SImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_395 (insn, operands);

    case E_RVVM1x5SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x5SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x5SImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_396 (insn, operands);

    case E_RVVM1x6SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x6SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x6SImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_397 (insn, operands);

    case E_RVVM1x7SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x7SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x7SImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_398 (insn, operands);

    case E_RVVM1x8SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x8SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x8SImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_399 (insn, operands);

    case E_RVVM2x2DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x2DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x2DImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1247 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_400 (insn, operands);

    case E_RVVM2x3DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x3DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x3DImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1248 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_401 (insn, operands);

    case E_RVVM2x4DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x4DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x4DImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1249 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_402 (insn, operands);

    case E_RVVMF2x2BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x2BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x2BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1250 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_403 (insn, operands);

    case E_RVVMF2x3BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x3BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x3BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1251 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_404 (insn, operands);

    case E_RVVMF2x4BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x4BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x4BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1252 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_405 (insn, operands);

    case E_RVVMF2x5BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x5BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x5BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1253 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_406 (insn, operands);

    case E_RVVMF2x6BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x6BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x6BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1254 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_407 (insn, operands);

    case E_RVVMF2x7BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x7BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x7BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1255 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_408 (insn, operands);

    case E_RVVMF2x8BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x8BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x8BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1256 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_409 (insn, operands);

    case E_RVVMF2x2HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x2HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x2HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1257 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_410 (insn, operands);

    case E_RVVMF2x3HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x3HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x3HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1258 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_411 (insn, operands);

    case E_RVVMF2x4HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x4HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x4HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1259 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_412 (insn, operands);

    case E_RVVMF2x5HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x5HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x5HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1260 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_413 (insn, operands);

    case E_RVVMF2x6HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x6HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x6HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1261 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_414 (insn, operands);

    case E_RVVMF2x7HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x7HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x7HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1262 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_415 (insn, operands);

    case E_RVVMF2x8HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x8HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x8HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1263 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_416 (insn, operands);

    case E_RVVM1x2SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x2SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x2SFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1264 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_417 (insn, operands);

    case E_RVVM1x3SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x3SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x3SFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1265 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_418 (insn, operands);

    case E_RVVM1x4SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x4SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x4SFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1266 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_419 (insn, operands);

    case E_RVVM1x5SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x5SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x5SFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1267 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_420 (insn, operands);

    case E_RVVM1x6SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x6SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x6SFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1268 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_421 (insn, operands);

    case E_RVVM1x7SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x7SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x7SFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1269 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_422 (insn, operands);

    case E_RVVM1x8SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x8SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x8SFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1270 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_423 (insn, operands);

    case E_RVVM2x2DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x2DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x2DFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1271 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return NULL;
      return gen_split_424 (insn, operands);

    case E_RVVM2x3DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x3DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x3DFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1272 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return NULL;
      return gen_split_425 (insn, operands);

    case E_RVVM2x4DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x4DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x4DFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1273 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return NULL;
      return gen_split_426 (insn, operands);

    case E_RVVMF2x2QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x2QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x2QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_427 (insn, operands);

    case E_RVVMF2x3QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x3QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x3QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_428 (insn, operands);

    case E_RVVMF2x4QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x4QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x4QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_429 (insn, operands);

    case E_RVVMF2x5QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x5QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x5QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_430 (insn, operands);

    case E_RVVMF2x6QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x6QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x6QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_431 (insn, operands);

    case E_RVVMF2x7QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x7QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x7QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_432 (insn, operands);

    case E_RVVMF2x8QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x8QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x8QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_433 (insn, operands);

    case E_RVVM1x2HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x2HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x2HImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_434 (insn, operands);

    case E_RVVM1x3HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x3HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x3HImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_435 (insn, operands);

    case E_RVVM1x4HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x4HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x4HImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_436 (insn, operands);

    case E_RVVM1x5HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x5HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x5HImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_437 (insn, operands);

    case E_RVVM1x6HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x6HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x6HImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_438 (insn, operands);

    case E_RVVM1x7HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x7HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x7HImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_439 (insn, operands);

    case E_RVVM1x8HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x8HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x8HImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_440 (insn, operands);

    case E_RVVM2x2SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x2SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x2SImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_441 (insn, operands);

    case E_RVVM2x3SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x3SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x3SImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_442 (insn, operands);

    case E_RVVM2x4SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x4SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x4SImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_443 (insn, operands);

    case E_RVVM4x2DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4x2DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM4x2DImode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1294 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_444 (insn, operands);

    case E_RVVM1x2BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x2BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x2BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1295 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_445 (insn, operands);

    case E_RVVM1x3BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x3BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x3BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1296 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_446 (insn, operands);

    case E_RVVM1x4BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x4BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x4BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1297 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_447 (insn, operands);

    case E_RVVM1x5BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x5BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x5BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1298 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_448 (insn, operands);

    case E_RVVM1x6BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x6BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x6BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1299 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_449 (insn, operands);

    case E_RVVM1x7BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x7BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x7BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1300 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_450 (insn, operands);

    case E_RVVM1x8BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x8BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x8BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1301 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_451 (insn, operands);

    case E_RVVM1x2HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x2HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x2HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1302 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_452 (insn, operands);

    case E_RVVM1x3HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x3HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x3HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1303 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_453 (insn, operands);

    case E_RVVM1x4HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x4HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x4HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1304 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_454 (insn, operands);

    case E_RVVM1x5HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x5HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x5HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1305 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_455 (insn, operands);

    case E_RVVM1x6HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x6HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x6HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1306 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_456 (insn, operands);

    case E_RVVM1x7HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x7HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x7HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1307 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_457 (insn, operands);

    case E_RVVM1x8HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x8HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x8HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1308 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_458 (insn, operands);

    case E_RVVM2x2SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x2SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x2SFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1309 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_459 (insn, operands);

    case E_RVVM2x3SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x3SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x3SFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1310 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_460 (insn, operands);

    case E_RVVM2x4SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x4SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x4SFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1311 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_461 (insn, operands);

    case E_RVVM4x2DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4x2DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM4x2DFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1312 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return NULL;
      return gen_split_462 (insn, operands);

    case E_RVVM1x2QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x2QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x2QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_463 (insn, operands);

    case E_RVVM1x3QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x3QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x3QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_464 (insn, operands);

    case E_RVVM1x4QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x4QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x4QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_465 (insn, operands);

    case E_RVVM1x5QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x5QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x5QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_466 (insn, operands);

    case E_RVVM1x6QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x6QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x6QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_467 (insn, operands);

    case E_RVVM1x7QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x7QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x7QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_468 (insn, operands);

    case E_RVVM1x8QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x8QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x8QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_469 (insn, operands);

    case E_RVVM2x2HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x2HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x2HImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_470 (insn, operands);

    case E_RVVM2x3HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x3HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x3HImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_471 (insn, operands);

    case E_RVVM2x4HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x4HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x4HImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_472 (insn, operands);

    case E_RVVM4x2SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4x2SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM4x2SImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_473 (insn, operands);

    case E_RVVM2x2BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x2BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x2BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1327 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_474 (insn, operands);

    case E_RVVM2x3BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x3BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x3BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1328 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_475 (insn, operands);

    case E_RVVM2x4BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x4BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x4BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1329 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_476 (insn, operands);

    case E_RVVM2x2HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x2HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x2HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1330 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_477 (insn, operands);

    case E_RVVM2x3HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x3HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x3HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1331 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_478 (insn, operands);

    case E_RVVM2x4HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x4HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x4HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1332 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_479 (insn, operands);

    case E_RVVM4x2SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4x2SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM4x2SFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1333 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_480 (insn, operands);

    case E_RVVM2x2QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x2QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x2QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_481 (insn, operands);

    case E_RVVM2x3QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x3QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x3QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_482 (insn, operands);

    case E_RVVM2x4QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x4QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x4QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_483 (insn, operands);

    case E_RVVM4x2HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4x2HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM4x2HImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_484 (insn, operands);

    case E_RVVM4x2BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4x2BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM4x2BFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1341 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_485 (insn, operands);

    case E_RVVM4x2HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4x2HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM4x2HFmode)
          || !(
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1342 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_486 (insn, operands);

    case E_RVVM4x2QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4x2QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM4x2QImode)
          || !
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_487 (insn, operands);

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode)
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !(
#line 1257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_1563 (insn, operands);

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode)
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !(
#line 1257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_1564 (insn, operands);

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || !register_operand (operands[1], E_RVVMF2HImode)
          || !(
#line 1257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_1566 (insn, operands);

    case E_V1BImode:
      return split_49 (x1, insn);

    case E_V2BImode:
      return split_48 (x1, insn);

    case E_V4BImode:
      return split_47 (x1, insn);

    case E_V8BImode:
      return split_46 (x1, insn);

    case E_V16BImode:
      return split_45 (x1, insn);

    case E_V32BImode:
      if (!register_operand (operands[0], E_V32BImode)
          || !register_operand (operands[1], E_V32BImode)
          || !((
#line 1530 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1532 "../../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2175 (insn, operands);

    case E_V64BImode:
      if (!register_operand (operands[0], E_V64BImode)
          || !register_operand (operands[1], E_V64BImode)
          || !((
#line 1530 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1532 "../../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2176 (insn, operands);

    case E_V128BImode:
      if (!register_operand (operands[0], E_V128BImode)
          || !register_operand (operands[1], E_V128BImode)
          || !((
#line 1530 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1532 "../../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2177 (insn, operands);

    case E_V256BImode:
      if (!register_operand (operands[0], E_V256BImode)
          || !register_operand (operands[1], E_V256BImode)
          || !((
#line 1530 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1532 "../../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2178 (insn, operands);

    case E_V512BImode:
      if (!register_operand (operands[0], E_V512BImode)
          || !register_operand (operands[1], E_V512BImode)
          || !((
#line 1530 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1532 "../../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2179 (insn, operands);

    case E_V1024BImode:
      if (!register_operand (operands[0], E_V1024BImode)
          || !register_operand (operands[1], E_V1024BImode)
          || !((
#line 1530 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1532 "../../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2180 (insn, operands);

    case E_V2048BImode:
      if (!register_operand (operands[0], E_V2048BImode)
          || !register_operand (operands[1], E_V2048BImode)
          || !((
#line 1530 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1532 "../../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2181 (insn, operands);

    case E_V4096BImode:
      if (!register_operand (operands[0], E_V4096BImode)
          || !register_operand (operands[1], E_V4096BImode)
          || !((
#line 1530 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1532 "../../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2182 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_128 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8QImode, 7))))
        return NULL;
      return gen_split_802 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4QImode, 7))))
        return NULL;
      return gen_split_808 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2QImode, 7))))
        return NULL;
      return gen_split_814 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1QImode, 7))))
        return NULL;
      return gen_split_820 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HImode, 7))))
        return NULL;
      return gen_split_826 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HImode, 7))))
        return NULL;
      return gen_split_832 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HImode, 7))))
        return NULL;
      return gen_split_838 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HImode, 7))))
        return NULL;
      return gen_split_844 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SImode, 7))))
        return NULL;
      return gen_split_850 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SImode, 7))))
        return NULL;
      return gen_split_856 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SImode, 7))))
        return NULL;
      return gen_split_862 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SImode, 7))))
        return NULL;
      return gen_split_868 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DImode, 7))))
        return NULL;
      return gen_split_874 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DImode, 7))))
        return NULL;
      return gen_split_880 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DImode, 7))))
        return NULL;
      return gen_split_886 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DImode, 7))))
        return NULL;
      return gen_split_892 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2QImode, 7))))
        return NULL;
      return gen_split_898 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4QImode, 7))))
        return NULL;
      return gen_split_904 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF8QImode, 7))))
        return NULL;
      return gen_split_910 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HImode, 7))))
        return NULL;
      return gen_split_916 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HImode, 7))))
        return NULL;
      return gen_split_922 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SImode, 7))))
        return NULL;
      return gen_split_928 (insn, operands);

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8BFmode, 7))))
        return NULL;
      return gen_split_934 (insn, operands);

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4BFmode, 7))))
        return NULL;
      return gen_split_940 (insn, operands);

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2BFmode, 7))))
        return NULL;
      return gen_split_946 (insn, operands);

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1BFmode, 7))))
        return NULL;
      return gen_split_952 (insn, operands);

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2BFmode, 7))))
        return NULL;
      return gen_split_958 (insn, operands);

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4BFmode, 7))))
        return NULL;
      return gen_split_964 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HFmode, 7))))
        return NULL;
      return gen_split_970 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HFmode, 7))))
        return NULL;
      return gen_split_976 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HFmode, 7))))
        return NULL;
      return gen_split_982 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HFmode, 7))))
        return NULL;
      return gen_split_988 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HFmode, 7))))
        return NULL;
      return gen_split_994 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HFmode, 7))))
        return NULL;
      return gen_split_1000 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SFmode, 7))))
        return NULL;
      return gen_split_1006 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SFmode, 7))))
        return NULL;
      return gen_split_1012 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SFmode, 7))))
        return NULL;
      return gen_split_1018 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SFmode, 7))))
        return NULL;
      return gen_split_1024 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SFmode, 7))))
        return NULL;
      return gen_split_1030 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DFmode, 7))))
        return NULL;
      return gen_split_1036 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DFmode, 7))))
        return NULL;
      return gen_split_1042 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DFmode, 7))))
        return NULL;
      return gen_split_1048 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DFmode, 7))))
        return NULL;
      return gen_split_1054 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1QImode, 7))))
        return NULL;
      return gen_split_1060 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2QImode, 7))))
        return NULL;
      return gen_split_1066 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4QImode, 7))))
        return NULL;
      return gen_split_1072 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8QImode, 7))))
        return NULL;
      return gen_split_1078 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16QImode, 7))))
        return NULL;
      return gen_split_1084 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32QImode, 7))))
        return NULL;
      return gen_split_1090 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64QImode, 7))))
        return NULL;
      return gen_split_1096 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128QImode, 7))))
        return NULL;
      return gen_split_1102 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256QImode, 7))))
        return NULL;
      return gen_split_1108 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512QImode, 7))))
        return NULL;
      return gen_split_1114 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024QImode, 7))))
        return NULL;
      return gen_split_1120 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048QImode, 7))))
        return NULL;
      return gen_split_1126 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4096QImode, 7))))
        return NULL;
      return gen_split_1132 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HImode, 7))))
        return NULL;
      return gen_split_1138 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HImode, 7))))
        return NULL;
      return gen_split_1144 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HImode, 7))))
        return NULL;
      return gen_split_1150 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HImode, 7))))
        return NULL;
      return gen_split_1156 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HImode, 7))))
        return NULL;
      return gen_split_1162 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HImode, 7))))
        return NULL;
      return gen_split_1168 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HImode, 7))))
        return NULL;
      return gen_split_1174 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HImode, 7))))
        return NULL;
      return gen_split_1180 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HImode, 7))))
        return NULL;
      return gen_split_1186 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HImode, 7))))
        return NULL;
      return gen_split_1192 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HImode, 7))))
        return NULL;
      return gen_split_1198 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HImode, 7))))
        return NULL;
      return gen_split_1204 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SImode, 7))))
        return NULL;
      return gen_split_1210 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SImode, 7))))
        return NULL;
      return gen_split_1216 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SImode, 7))))
        return NULL;
      return gen_split_1222 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SImode, 7))))
        return NULL;
      return gen_split_1228 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SImode, 7))))
        return NULL;
      return gen_split_1234 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SImode, 7))))
        return NULL;
      return gen_split_1240 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SImode, 7))))
        return NULL;
      return gen_split_1246 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SImode, 7))))
        return NULL;
      return gen_split_1252 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SImode, 7))))
        return NULL;
      return gen_split_1258 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SImode, 7))))
        return NULL;
      return gen_split_1264 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SImode, 7))))
        return NULL;
      return gen_split_1270 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DImode, 7))))
        return NULL;
      return gen_split_1276 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DImode, 7))))
        return NULL;
      return gen_split_1282 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DImode, 7))))
        return NULL;
      return gen_split_1288 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DImode, 7))))
        return NULL;
      return gen_split_1294 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DImode, 7))))
        return NULL;
      return gen_split_1300 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DImode, 7))))
        return NULL;
      return gen_split_1306 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DImode, 7))))
        return NULL;
      return gen_split_1312 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DImode, 7))))
        return NULL;
      return gen_split_1318 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DImode, 7))))
        return NULL;
      return gen_split_1324 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DImode, 7))))
        return NULL;
      return gen_split_1330 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HFmode, 7))))
        return NULL;
      return gen_split_1336 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HFmode, 7))))
        return NULL;
      return gen_split_1342 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HFmode, 7))))
        return NULL;
      return gen_split_1348 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HFmode, 7))))
        return NULL;
      return gen_split_1354 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HFmode, 7))))
        return NULL;
      return gen_split_1360 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HFmode, 7))))
        return NULL;
      return gen_split_1366 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HFmode, 7))))
        return NULL;
      return gen_split_1372 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HFmode, 7))))
        return NULL;
      return gen_split_1378 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HFmode, 7))))
        return NULL;
      return gen_split_1384 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HFmode, 7))))
        return NULL;
      return gen_split_1390 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HFmode, 7))))
        return NULL;
      return gen_split_1396 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HFmode, 7))))
        return NULL;
      return gen_split_1402 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SFmode, 7))))
        return NULL;
      return gen_split_1408 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SFmode, 7))))
        return NULL;
      return gen_split_1414 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SFmode, 7))))
        return NULL;
      return gen_split_1420 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SFmode, 7))))
        return NULL;
      return gen_split_1426 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SFmode, 7))))
        return NULL;
      return gen_split_1432 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SFmode, 7))))
        return NULL;
      return gen_split_1438 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SFmode, 7))))
        return NULL;
      return gen_split_1444 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SFmode, 7))))
        return NULL;
      return gen_split_1450 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SFmode, 7))))
        return NULL;
      return gen_split_1456 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SFmode, 7))))
        return NULL;
      return gen_split_1462 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SFmode, 7))))
        return NULL;
      return gen_split_1468 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DFmode, 7))))
        return NULL;
      return gen_split_1474 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DFmode, 7))))
        return NULL;
      return gen_split_1480 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DFmode, 7))))
        return NULL;
      return gen_split_1486 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DFmode, 7))))
        return NULL;
      return gen_split_1492 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DFmode, 7))))
        return NULL;
      return gen_split_1498 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DFmode, 7))))
        return NULL;
      return gen_split_1504 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DFmode, 7))))
        return NULL;
      return gen_split_1510 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DFmode, 7))))
        return NULL;
      return gen_split_1516 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DFmode, 7))))
        return NULL;
      return gen_split_1522 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DFmode, 7))))
        return NULL;
      return gen_split_1528 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_137 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern142 (x2))
    {
    case 0:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5457 (insn, operands);

    case 1:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5458 (insn, operands);

    case 2:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5459 (insn, operands);

    case 3:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5460 (insn, operands);

    case 4:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5461 (insn, operands);

    case 5:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5462 (insn, operands);

    case 6:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5463 (insn, operands);

    case 7:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5464 (insn, operands);

    case 8:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5465 (insn, operands);

    case 9:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5466 (insn, operands);

    case 10:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5467 (insn, operands);

    case 11:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5468 (insn, operands);

    case 12:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5469 (insn, operands);

    case 13:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5470 (insn, operands);

    case 14:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5471 (insn, operands);

    case 15:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5472 (insn, operands);

    case 16:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5473 (insn, operands);

    case 17:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5474 (insn, operands);

    case 18:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5475 (insn, operands);

    case 19:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5476 (insn, operands);

    case 20:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5477 (insn, operands);

    case 21:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5478 (insn, operands);

    case 22:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5479 (insn, operands);

    case 23:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5480 (insn, operands);

    case 24:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5481 (insn, operands);

    case 25:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5482 (insn, operands);

    case 26:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5483 (insn, operands);

    case 27:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5484 (insn, operands);

    case 28:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5485 (insn, operands);

    case 29:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5486 (insn, operands);

    case 30:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5487 (insn, operands);

    case 31:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5488 (insn, operands);

    case 32:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5489 (insn, operands);

    case 33:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5490 (insn, operands);

    case 34:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5491 (insn, operands);

    case 35:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5492 (insn, operands);

    case 36:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5493 (insn, operands);

    case 37:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5494 (insn, operands);

    case 38:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5495 (insn, operands);

    case 39:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5496 (insn, operands);

    case 40:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5497 (insn, operands);

    case 41:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5498 (insn, operands);

    case 42:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5499 (insn, operands);

    case 43:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5500 (insn, operands);

    case 44:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5501 (insn, operands);

    case 45:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5502 (insn, operands);

    case 46:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5503 (insn, operands);

    case 47:
      if (!((
#line 1292 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1294 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5504 (insn, operands);

    case 48:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9704 (insn, operands);

    case 49:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9705 (insn, operands);

    case 50:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9706 (insn, operands);

    case 51:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9707 (insn, operands);

    case 52:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9708 (insn, operands);

    case 53:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9709 (insn, operands);

    case 54:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9710 (insn, operands);

    case 55:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9711 (insn, operands);

    case 56:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9712 (insn, operands);

    case 57:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9713 (insn, operands);

    case 58:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9714 (insn, operands);

    case 59:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9715 (insn, operands);

    case 60:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9716 (insn, operands);

    case 61:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9717 (insn, operands);

    case 62:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9718 (insn, operands);

    case 63:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9719 (insn, operands);

    case 64:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9720 (insn, operands);

    case 65:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9721 (insn, operands);

    case 66:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9722 (insn, operands);

    case 67:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9723 (insn, operands);

    case 68:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9724 (insn, operands);

    case 69:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9725 (insn, operands);

    case 70:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9726 (insn, operands);

    case 71:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9727 (insn, operands);

    case 72:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9728 (insn, operands);

    case 73:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9729 (insn, operands);

    case 74:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9730 (insn, operands);

    case 75:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9731 (insn, operands);

    case 76:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9732 (insn, operands);

    case 77:
      if (!((
#line 1162 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1164 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9733 (insn, operands);

    case 78:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9734 (insn, operands);

    case 79:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9735 (insn, operands);

    case 80:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9736 (insn, operands);

    case 81:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9737 (insn, operands);

    case 82:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9738 (insn, operands);

    case 83:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9739 (insn, operands);

    case 84:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9740 (insn, operands);

    case 85:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9741 (insn, operands);

    case 86:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9742 (insn, operands);

    case 87:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9743 (insn, operands);

    case 88:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9744 (insn, operands);

    case 89:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9745 (insn, operands);

    case 90:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9746 (insn, operands);

    case 91:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9747 (insn, operands);

    case 92:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9748 (insn, operands);

    case 93:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9749 (insn, operands);

    case 94:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9750 (insn, operands);

    case 95:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9751 (insn, operands);

    case 96:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9752 (insn, operands);

    case 97:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9753 (insn, operands);

    case 98:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9754 (insn, operands);

    case 99:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9755 (insn, operands);

    case 100:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9756 (insn, operands);

    case 101:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9757 (insn, operands);

    case 102:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9758 (insn, operands);

    case 103:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9759 (insn, operands);

    case 104:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9760 (insn, operands);

    case 105:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9761 (insn, operands);

    case 106:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9762 (insn, operands);

    case 107:
      if (!((
#line 1186 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1188 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9763 (insn, operands);

    case 108:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9764 (insn, operands);

    case 109:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9765 (insn, operands);

    case 110:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9766 (insn, operands);

    case 111:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9767 (insn, operands);

    case 112:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9768 (insn, operands);

    case 113:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9769 (insn, operands);

    case 114:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9770 (insn, operands);

    case 115:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9771 (insn, operands);

    case 116:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9772 (insn, operands);

    case 117:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9773 (insn, operands);

    case 118:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9774 (insn, operands);

    case 119:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9775 (insn, operands);

    case 120:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9776 (insn, operands);

    case 121:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9777 (insn, operands);

    case 122:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9778 (insn, operands);

    case 123:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9779 (insn, operands);

    case 124:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9780 (insn, operands);

    case 125:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9781 (insn, operands);

    case 126:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9782 (insn, operands);

    case 127:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9783 (insn, operands);

    case 128:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9784 (insn, operands);

    case 129:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9785 (insn, operands);

    case 130:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9786 (insn, operands);

    case 131:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9787 (insn, operands);

    case 132:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9788 (insn, operands);

    case 133:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9789 (insn, operands);

    case 134:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9790 (insn, operands);

    case 135:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9791 (insn, operands);

    case 136:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9792 (insn, operands);

    case 137:
      if (!((
#line 1215 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1217 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9793 (insn, operands);

    case 138:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9794 (insn, operands);

    case 139:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9795 (insn, operands);

    case 140:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9796 (insn, operands);

    case 141:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9797 (insn, operands);

    case 142:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9798 (insn, operands);

    case 143:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9799 (insn, operands);

    case 144:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9800 (insn, operands);

    case 145:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9801 (insn, operands);

    case 146:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9802 (insn, operands);

    case 147:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9803 (insn, operands);

    case 148:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9804 (insn, operands);

    case 149:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9805 (insn, operands);

    case 150:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9806 (insn, operands);

    case 151:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9807 (insn, operands);

    case 152:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9808 (insn, operands);

    case 153:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9809 (insn, operands);

    case 154:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9810 (insn, operands);

    case 155:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9811 (insn, operands);

    case 156:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9812 (insn, operands);

    case 157:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9813 (insn, operands);

    case 158:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9814 (insn, operands);

    case 159:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9815 (insn, operands);

    case 160:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9816 (insn, operands);

    case 161:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9817 (insn, operands);

    case 162:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9818 (insn, operands);

    case 163:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9819 (insn, operands);

    case 164:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9820 (insn, operands);

    case 165:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9821 (insn, operands);

    case 166:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9822 (insn, operands);

    case 167:
      if (!((
#line 1240 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1242 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9823 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_147 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      switch (pattern123 (x2))
        {
        case 0:
          if (!(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2596 (insn, operands);

        case 1:
          if (!(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2610 (insn, operands);

        case 2:
          if (!(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2624 (insn, operands);

        case 3:
          if (!(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2638 (insn, operands);

        case 4:
          if (!(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2652 (insn, operands);

        case 5:
          if (!(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2666 (insn, operands);

        case 6:
          if (!(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2680 (insn, operands);

        case 7:
          if (!(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2694 (insn, operands);

        case 8:
          if (!(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2708 (insn, operands);

        case 9:
          if (!(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2722 (insn, operands);

        case 10:
          if (!(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2736 (insn, operands);

        case 11:
          if (!(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2750 (insn, operands);

        case 12:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2764 (insn, operands);

        case 13:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2778 (insn, operands);

        case 14:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2792 (insn, operands);

        case 15:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2806 (insn, operands);

        case 16:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2820 (insn, operands);

        case 17:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2834 (insn, operands);

        case 18:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2848 (insn, operands);

        case 19:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2862 (insn, operands);

        case 20:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2876 (insn, operands);

        case 21:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2890 (insn, operands);

        case 22:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2904 (insn, operands);

        case 23:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2918 (insn, operands);

        case 24:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2932 (insn, operands);

        case 25:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2946 (insn, operands);

        case 26:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2960 (insn, operands);

        case 27:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2974 (insn, operands);

        case 28:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2988 (insn, operands);

        case 29:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3002 (insn, operands);

        case 30:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3016 (insn, operands);

        case 31:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3030 (insn, operands);

        case 32:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3044 (insn, operands);

        case 33:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3058 (insn, operands);

        case 34:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3072 (insn, operands);

        case 35:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3086 (insn, operands);

        case 36:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3100 (insn, operands);

        case 37:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3114 (insn, operands);

        case 38:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3128 (insn, operands);

        case 39:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3142 (insn, operands);

        case 40:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3156 (insn, operands);

        case 41:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3170 (insn, operands);

        case 42:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3184 (insn, operands);

        case 43:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3198 (insn, operands);

        case 44:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3212 (insn, operands);

        case 45:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3226 (insn, operands);

        case 46:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3240 (insn, operands);

        case 47:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3254 (insn, operands);

        case 48:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3268 (insn, operands);

        case 49:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3282 (insn, operands);

        case 50:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3296 (insn, operands);

        case 51:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3310 (insn, operands);

        case 52:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3324 (insn, operands);

        case 53:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3338 (insn, operands);

        case 54:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3352 (insn, operands);

        case 55:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3366 (insn, operands);

        case 56:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3380 (insn, operands);

        case 57:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3394 (insn, operands);

        case 58:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3408 (insn, operands);

        case 59:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3422 (insn, operands);

        case 60:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3436 (insn, operands);

        case 61:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3450 (insn, operands);

        case 62:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3464 (insn, operands);

        case 63:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3478 (insn, operands);

        case 64:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3492 (insn, operands);

        case 65:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3506 (insn, operands);

        case 66:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3520 (insn, operands);

        case 67:
          if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3534 (insn, operands);

        case 68:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5554 (insn, operands);

        case 69:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5558 (insn, operands);

        case 70:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5562 (insn, operands);

        case 71:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5566 (insn, operands);

        case 72:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5570 (insn, operands);

        case 73:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5574 (insn, operands);

        case 74:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5578 (insn, operands);

        case 75:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5582 (insn, operands);

        case 76:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5586 (insn, operands);

        case 77:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5590 (insn, operands);

        case 78:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5594 (insn, operands);

        case 79:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5598 (insn, operands);

        case 80:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5602 (insn, operands);

        case 81:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5606 (insn, operands);

        case 82:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5610 (insn, operands);

        case 83:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5614 (insn, operands);

        case 84:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5618 (insn, operands);

        case 85:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5622 (insn, operands);

        case 86:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5626 (insn, operands);

        case 87:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5630 (insn, operands);

        case 88:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5634 (insn, operands);

        case 89:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5638 (insn, operands);

        case 90:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5642 (insn, operands);

        case 91:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5646 (insn, operands);

        case 92:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5650 (insn, operands);

        case 93:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5654 (insn, operands);

        case 94:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5658 (insn, operands);

        case 95:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5662 (insn, operands);

        case 96:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5666 (insn, operands);

        case 97:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5670 (insn, operands);

        case 98:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5674 (insn, operands);

        case 99:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5678 (insn, operands);

        case 100:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5682 (insn, operands);

        case 101:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5686 (insn, operands);

        case 102:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5690 (insn, operands);

        case 103:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5694 (insn, operands);

        case 104:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5698 (insn, operands);

        case 105:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5702 (insn, operands);

        case 106:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5706 (insn, operands);

        case 107:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5710 (insn, operands);

        case 108:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5714 (insn, operands);

        case 109:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5718 (insn, operands);

        case 110:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5722 (insn, operands);

        case 111:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5726 (insn, operands);

        case 112:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5730 (insn, operands);

        case 113:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5734 (insn, operands);

        case 114:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5738 (insn, operands);

        case 115:
          if (!((
#line 1560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1562 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5742 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      return split_140 (x1, insn);

    case ZERO_EXTEND:
      return split_141 (x1, insn);

    case FLOAT_EXTEND:
      switch (pattern131 (x2))
        {
        case 0:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8902 (insn, operands);

        case 1:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8905 (insn, operands);

        case 2:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8908 (insn, operands);

        case 3:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8911 (insn, operands);

        case 4:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8914 (insn, operands);

        case 5:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8917 (insn, operands);

        case 6:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8920 (insn, operands);

        case 7:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8923 (insn, operands);

        case 8:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8926 (insn, operands);

        case 9:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8929 (insn, operands);

        case 10:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8932 (insn, operands);

        case 11:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8935 (insn, operands);

        case 12:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8938 (insn, operands);

        case 13:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8941 (insn, operands);

        case 14:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8944 (insn, operands);

        case 15:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8947 (insn, operands);

        case 16:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8950 (insn, operands);

        case 17:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8953 (insn, operands);

        case 18:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8956 (insn, operands);

        case 19:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8959 (insn, operands);

        case 20:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8962 (insn, operands);

        case 21:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8965 (insn, operands);

        case 22:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8968 (insn, operands);

        case 23:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8971 (insn, operands);

        case 24:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8974 (insn, operands);

        case 25:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8977 (insn, operands);

        case 26:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8980 (insn, operands);

        case 27:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8983 (insn, operands);

        case 28:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8986 (insn, operands);

        case 29:
          if (!((
#line 758 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 760 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8989 (insn, operands);

        case 30:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9080 (insn, operands);

        case 31:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9081 (insn, operands);

        case 32:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9082 (insn, operands);

        case 33:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9083 (insn, operands);

        case 34:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9084 (insn, operands);

        case 35:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9085 (insn, operands);

        case 36:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9086 (insn, operands);

        case 37:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9087 (insn, operands);

        case 38:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9088 (insn, operands);

        case 39:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9089 (insn, operands);

        case 40:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9090 (insn, operands);

        case 41:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9091 (insn, operands);

        case 42:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9092 (insn, operands);

        case 43:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9093 (insn, operands);

        case 44:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9094 (insn, operands);

        case 45:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9095 (insn, operands);

        case 46:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9096 (insn, operands);

        case 47:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9097 (insn, operands);

        case 48:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9098 (insn, operands);

        case 49:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9099 (insn, operands);

        case 50:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9100 (insn, operands);

        case 51:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9101 (insn, operands);

        case 52:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9102 (insn, operands);

        case 53:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9103 (insn, operands);

        case 54:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9104 (insn, operands);

        case 55:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9105 (insn, operands);

        case 56:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9106 (insn, operands);

        case 57:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9107 (insn, operands);

        case 58:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9108 (insn, operands);

        case 59:
          if (!((
#line 838 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 840 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9109 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_165 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern124 (x2))
    {
    case 0:
      if (!(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2599 (insn, operands);

    case 1:
      if (!(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2613 (insn, operands);

    case 2:
      if (!(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2627 (insn, operands);

    case 3:
      if (!(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2641 (insn, operands);

    case 4:
      if (!(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2655 (insn, operands);

    case 5:
      if (!(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2669 (insn, operands);

    case 6:
      if (!(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2683 (insn, operands);

    case 7:
      if (!(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2697 (insn, operands);

    case 8:
      if (!(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2711 (insn, operands);

    case 9:
      if (!(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2725 (insn, operands);

    case 10:
      if (!(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2739 (insn, operands);

    case 11:
      if (!(
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2753 (insn, operands);

    case 12:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2767 (insn, operands);

    case 13:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2781 (insn, operands);

    case 14:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2795 (insn, operands);

    case 15:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2809 (insn, operands);

    case 16:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2823 (insn, operands);

    case 17:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2837 (insn, operands);

    case 18:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2851 (insn, operands);

    case 19:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2865 (insn, operands);

    case 20:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2879 (insn, operands);

    case 21:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2893 (insn, operands);

    case 22:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2907 (insn, operands);

    case 23:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2921 (insn, operands);

    case 24:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2935 (insn, operands);

    case 25:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2949 (insn, operands);

    case 26:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2963 (insn, operands);

    case 27:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2977 (insn, operands);

    case 28:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2991 (insn, operands);

    case 29:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3005 (insn, operands);

    case 30:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3019 (insn, operands);

    case 31:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3033 (insn, operands);

    case 32:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3047 (insn, operands);

    case 33:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3061 (insn, operands);

    case 34:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3075 (insn, operands);

    case 35:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3089 (insn, operands);

    case 36:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3103 (insn, operands);

    case 37:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3117 (insn, operands);

    case 38:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3131 (insn, operands);

    case 39:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3145 (insn, operands);

    case 40:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3159 (insn, operands);

    case 41:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3173 (insn, operands);

    case 42:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3187 (insn, operands);

    case 43:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3201 (insn, operands);

    case 44:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3215 (insn, operands);

    case 45:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3229 (insn, operands);

    case 46:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3243 (insn, operands);

    case 47:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3257 (insn, operands);

    case 48:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3271 (insn, operands);

    case 49:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3285 (insn, operands);

    case 50:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3299 (insn, operands);

    case 51:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3313 (insn, operands);

    case 52:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3327 (insn, operands);

    case 53:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3341 (insn, operands);

    case 54:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3355 (insn, operands);

    case 55:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3369 (insn, operands);

    case 56:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3383 (insn, operands);

    case 57:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3397 (insn, operands);

    case 58:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3411 (insn, operands);

    case 59:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3425 (insn, operands);

    case 60:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3439 (insn, operands);

    case 61:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3453 (insn, operands);

    case 62:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3467 (insn, operands);

    case 63:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3481 (insn, operands);

    case 64:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3495 (insn, operands);

    case 65:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3509 (insn, operands);

    case 66:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3523 (insn, operands);

    case 67:
      if (!((
#line 484 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3537 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_170 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      return split_142 (x1, insn);

    case AND:
      switch (pattern201 (x2))
        {
        case 0:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10131 (insn, operands);

        case 1:
          if (!(
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10134 (insn, operands);

        case 2:
          if (!(
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10137 (insn, operands);

        case 3:
          if (!(
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10140 (insn, operands);

        case 4:
          if (!(
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10143 (insn, operands);

        case 5:
          if (!(
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10146 (insn, operands);

        case 6:
          if (!(
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10149 (insn, operands);

        case 7:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10152 (insn, operands);

        case 8:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10155 (insn, operands);

        case 9:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10158 (insn, operands);

        case 10:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10161 (insn, operands);

        case 11:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10164 (insn, operands);

        case 12:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10167 (insn, operands);

        case 13:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10170 (insn, operands);

        case 14:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10173 (insn, operands);

        case 15:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10176 (insn, operands);

        case 16:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10179 (insn, operands);

        case 17:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10182 (insn, operands);

        case 18:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10185 (insn, operands);

        case 19:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10188 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern201 (x2))
        {
        case 0:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10132 (insn, operands);

        case 1:
          if (!(
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10135 (insn, operands);

        case 2:
          if (!(
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10138 (insn, operands);

        case 3:
          if (!(
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10141 (insn, operands);

        case 4:
          if (!(
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10144 (insn, operands);

        case 5:
          if (!(
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10147 (insn, operands);

        case 6:
          if (!(
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10150 (insn, operands);

        case 7:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10153 (insn, operands);

        case 8:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10156 (insn, operands);

        case 9:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10159 (insn, operands);

        case 10:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10162 (insn, operands);

        case 11:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10165 (insn, operands);

        case 12:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10168 (insn, operands);

        case 13:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10171 (insn, operands);

        case 14:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10174 (insn, operands);

        case 15:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10177 (insn, operands);

        case 16:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10180 (insn, operands);

        case 17:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10183 (insn, operands);

        case 18:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10186 (insn, operands);

        case 19:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10189 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern201 (x2))
        {
        case 0:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10133 (insn, operands);

        case 1:
          if (!(
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10136 (insn, operands);

        case 2:
          if (!(
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10139 (insn, operands);

        case 3:
          if (!(
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10142 (insn, operands);

        case 4:
          if (!(
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10145 (insn, operands);

        case 5:
          if (!(
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10148 (insn, operands);

        case 6:
          if (!(
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10151 (insn, operands);

        case 7:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10154 (insn, operands);

        case 8:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10157 (insn, operands);

        case 9:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10160 (insn, operands);

        case 10:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10163 (insn, operands);

        case 11:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10166 (insn, operands);

        case 12:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10169 (insn, operands);

        case 13:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10172 (insn, operands);

        case 14:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10175 (insn, operands);

        case 15:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10178 (insn, operands);

        case 16:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10181 (insn, operands);

        case 17:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10184 (insn, operands);

        case 18:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10187 (insn, operands);

        case 19:
          if (!((
#line 1491 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1493 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10190 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_180 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (XVECLEN (x1, 0))
    {
    case 2:
      x2 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x2) != CLOBBER)
        return NULL;
      x3 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x3))
        {
        case SET:
          x4 = XEXP (x3, 1);
          switch (GET_CODE (x4))
            {
            case PLUS:
              x5 = XEXP (x4, 0);
              if (GET_CODE (x5) == AND)
                {
                  x6 = XEXP (x3, 0);
                  operands[0] = x6;
                  switch (pattern345 (x1))
                    {
                    case 0:
                      if (((
#line 883 "../../../gcc/config/riscv/riscv.md"
((LUI_OPERAND (~INTVAL (operands[2]))
    && ((INTVAL (operands[2]) & (-INTVAL (operands[3])))
	== (-INTVAL (operands[3])))
    && riscv_const_insns (operands[3], false)
    && (riscv_const_insns (GEN_INT (~INTVAL (operands[2])
				    | -INTVAL (operands[3])), false)
	<= riscv_const_insns (operands[3], false)))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 891 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                        return gen_split_3 (insn, operands);
                      break;

                    case 1:
                      if (((
#line 883 "../../../gcc/config/riscv/riscv.md"
((LUI_OPERAND (~INTVAL (operands[2]))
    && ((INTVAL (operands[2]) & (-INTVAL (operands[3])))
	== (-INTVAL (operands[3])))
    && riscv_const_insns (operands[3], false)
    && (riscv_const_insns (GEN_INT (~INTVAL (operands[2])
				    | -INTVAL (operands[3])), false)
	<= riscv_const_insns (operands[3], false)))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 891 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                        return gen_split_4 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              break;

            case CONST_INT:
              operands[1] = x4;
              x6 = XEXP (x3, 0);
              operands[0] = x6;
              x7 = XEXP (x2, 0);
              operands[2] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (register_operand (operands[0], E_SImode)
                      && splittable_const_int_operand (operands[1], E_SImode)
                      && register_operand (operands[2], E_SImode))
                    return gen_split_14 (insn, operands);
                  break;

                case E_DImode:
                  if (register_operand (operands[0], E_DImode)
                      && splittable_const_int_operand (operands[1], E_DImode)
                      && register_operand (operands[2], E_DImode)
                      && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                    return gen_split_15 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case IF_THEN_ELSE:
              res = split_175 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case SIGN_EXTEND:
              if (pattern278 (x1) == 0
                  && ((
#line 638 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 643 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return gen_split_133 (insn, operands);
              break;

            case ZERO_EXTEND:
              if (pattern278 (x1) == 0
                  && ((
#line 638 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 643 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return gen_split_134 (insn, operands);
              break;

            case IOR:
              switch (pattern281 (x1))
                {
                case 0:
                  if (((
#line 686 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 691 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_139 (insn, operands);
                  break;

                case 1:
                  if (((
#line 712 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 716 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_147 (insn, operands);
                  break;

                case 2:
                  if (((
#line 686 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 691 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_141 (insn, operands);
                  break;

                case 3:
                  if (((
#line 712 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 716 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_149 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case XOR:
              switch (pattern281 (x1))
                {
                case 0:
                  if (((
#line 686 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 691 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_140 (insn, operands);
                  break;

                case 1:
                  if (((
#line 712 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 716 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_148 (insn, operands);
                  break;

                case 2:
                  if (((
#line 686 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 691 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_142 (insn, operands);
                  break;

                case 3:
                  if (((
#line 712 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 716 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_150 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case AND:
              res = split_176 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case REG:
            case SUBREG:
            case MEM:
              res = split_178 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            default:
              break;
            }
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          operands[1] = x4;
          x7 = XEXP (x2, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && register_operand (operands[2], E_SImode)
                  && (
#line 2455 "../../../gcc/config/riscv/riscv.md"
(riscv_split_symbol (operands[2], operands[1], MAX_MACHINE_MODE, NULL)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return gen_split_16 (insn, operands);
              break;

            case E_DImode:
              if (register_operand (operands[0], E_DImode)
                  && register_operand (operands[2], E_DImode)
                  && (
#line 2455 "../../../gcc/config/riscv/riscv.md"
(riscv_split_symbol (operands[2], operands[1], MAX_MACHINE_MODE, NULL)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return gen_split_17 (insn, operands);
              break;

            default:
              break;
            }
          switch (GET_CODE (x4))
            {
            case SIGN_EXTRACT:
              switch (pattern223 (x1))
                {
                case 0:
                  if (!(
#line 3064 "../../../gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))) && 
#line 3072 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return NULL;
                  return gen_split_46 (insn, operands);

                case 1:
                  if (!((
#line 3064 "../../../gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3072 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return NULL;
                  return gen_split_48 (insn, operands);

                default:
                  return NULL;
                }

            case ZERO_EXTRACT:
              switch (pattern223 (x1))
                {
                case 0:
                  if (!(
#line 3064 "../../../gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))) && 
#line 3072 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return NULL;
                  return gen_split_47 (insn, operands);

                case 1:
                  if (!((
#line 3064 "../../../gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3072 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return NULL;
                  return gen_split_49 (insn, operands);

                default:
                  return NULL;
                }

            case AND:
              return split_177 (x1, insn);

            case SIGN_EXTEND:
              if (GET_MODE (x4) != E_DImode
                  || !register_operand (operands[0], E_DImode))
                return NULL;
              x5 = XEXP (x4, 0);
              if (GET_MODE (x5) != E_SImode)
                return NULL;
              switch (GET_CODE (x5))
                {
                case PLUS:
                  switch (pattern409 (x1))
                    {
                    case 0:
                      if (!(
#line 4563 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT
   && (INTVAL (operands[3]) | ((1 << INTVAL (operands[2])) - 1)) == 0xffffffff) && 
#line 4566 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                        return NULL;
                      return gen_split_103 (insn, operands);

                    case 1:
                      if (!(
#line 4722 "../../../gcc/config/riscv/riscv.md"
((TARGET_64BIT && riscv_const_insns (operands[3], false) == 1)) && 
#line 4724 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                        return NULL;
                      return gen_split_105 (insn, operands);

                    default:
                      return NULL;
                    }

                case DIV:
                  x8 = XEXP (x5, 0);
                  if (GET_CODE (x8) != PLUS
                      || GET_MODE (x8) != E_SImode)
                    return NULL;
                  x9 = XEXP (x8, 0);
                  if (GET_CODE (x9) != ASHIFT
                      || GET_MODE (x9) != E_SImode)
                    return NULL;
                  x10 = XEXP (x9, 0);
                  if (GET_CODE (x10) != SUBREG
                      || maybe_ne (SUBREG_BYTE (x10), 0)
                      || GET_MODE (x10) != E_SImode)
                    return NULL;
                  x11 = XEXP (x8, 1);
                  if (GET_CODE (x11) != SUBREG
                      || maybe_ne (SUBREG_BYTE (x11), 0)
                      || GET_MODE (x11) != E_SImode)
                    return NULL;
                  x12 = XEXP (x10, 0);
                  operands[1] = x12;
                  if (!register_operand (operands[1], E_DImode))
                    return NULL;
                  x13 = XEXP (x9, 1);
                  operands[2] = x13;
                  if (!imm123_operand (operands[2], E_QImode))
                    return NULL;
                  x14 = XEXP (x11, 0);
                  operands[3] = x14;
                  if (!register_operand (operands[3], E_DImode))
                    return NULL;
                  x15 = XEXP (x5, 1);
                  operands[4] = x15;
                  if (!register_operand (operands[4], E_SImode))
                    return NULL;
                  operands[5] = x7;
                  if (!register_operand (operands[5], E_DImode)
                      || !
#line 55 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA))
                    return NULL;
                  return gen_split_106 (insn, operands);

                case ASHIFT:
                  if (pattern397 (x5) != 0)
                    return NULL;
                  x15 = XEXP (x5, 1);
                  x16 = XEXP (x15, 0);
                  x17 = XEXP (x16, 0);
                  x18 = XEXP (x17, 0);
                  operands[1] = x18;
                  if (!register_operand (operands[1], E_DImode))
                    return NULL;
                  x19 = XEXP (x16, 1);
                  operands[2] = x19;
                  if (!const_int_operand (operands[2], E_VOIDmode))
                    return NULL;
                  operands[3] = x7;
                  if (!scratch_operand (operands[3], E_DImode)
                      || !((
#line 638 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 643 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return NULL;
                  return gen_split_135 (insn, operands);

                default:
                  return NULL;
                }

            case PLUS:
              if (GET_MODE (x4) != E_DImode
                  || !register_operand (operands[0], E_DImode))
                return NULL;
              x5 = XEXP (x4, 0);
              if (GET_MODE (x5) != E_DImode)
                return NULL;
              switch (GET_CODE (x5))
                {
                case ASHIFT:
                  if (pattern408 (x1) != 0
                      || !(
#line 4694 "../../../gcc/config/riscv/riscv.md"
((TARGET_64BIT && riscv_const_insns (operands[3], false) == 1)) && 
#line 4696 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return NULL;
                  return gen_split_104 (insn, operands);

                case AND:
                  x8 = XEXP (x5, 0);
                  if (GET_CODE (x8) != ASHIFT
                      || GET_MODE (x8) != E_DImode)
                    return NULL;
                  x9 = XEXP (x8, 0);
                  operands[1] = x9;
                  if (!register_operand (operands[1], E_DImode))
                    return NULL;
                  x11 = XEXP (x8, 1);
                  operands[2] = x11;
                  x15 = XEXP (x5, 1);
                  operands[3] = x15;
                  if (!consecutive_bits_operand (operands[3], E_DImode))
                    return NULL;
                  x20 = XEXP (x4, 1);
                  operands[4] = x20;
                  if (!register_operand (operands[4], E_DImode))
                    return NULL;
                  operands[5] = x7;
                  if (scratch_operand (operands[5], E_DImode)
                      && imm123_operand (operands[2], E_QImode)
                      && (
#line 98 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA
   && riscv_shamt_matches_mask_p (INTVAL (operands[2]), INTVAL (operands[3]))
   && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))) && 
#line 102 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_109 (insn, operands);
                  if (!register_operand (operands[5], E_DImode)
                      || !immediate_operand (operands[2], E_QImode)
                      || !
#line 138 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA))
                    return NULL;
                  return gen_split_110 (insn, operands);

                default:
                  return NULL;
                }

            case IOR:
              x5 = XEXP (x4, 0);
              switch (GET_CODE (x5))
                {
                case NOT:
                  x8 = XEXP (x5, 0);
                  operands[1] = x8;
                  switch (pattern373 (x1))
                    {
                    case 0:
                      if (!((
#line 242 "../../../gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 245 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                        return NULL;
                      return gen_split_113 (insn, operands);

                    case 1:
                      if (!((
#line 242 "../../../gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 245 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                        return NULL;
                      return gen_split_115 (insn, operands);

                    default:
                      return NULL;
                    }

                case SIGN_EXTEND:
                  if (pattern357 (x5) != 0)
                    return NULL;
                  x8 = XEXP (x5, 0);
                  x11 = XEXP (x8, 1);
                  if (GET_CODE (x11) != SUBREG
                      || maybe_ne (SUBREG_BYTE (x11), 0)
                      || GET_MODE (x11) != E_QImode)
                    return NULL;
                  x14 = XEXP (x11, 0);
                  if (GET_CODE (x14) != AND
                      || GET_MODE (x14) != E_DImode
                      || !register_operand (operands[0], E_DImode)
                      || GET_MODE (x4) != E_DImode)
                    return NULL;
                  switch (pattern449 (x1))
                    {
                    case 0:
                      if (!((
#line 686 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 691 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                        return NULL;
                      return gen_split_143 (insn, operands);

                    case 1:
                      if (!((
#line 712 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 716 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                        return NULL;
                      return gen_split_151 (insn, operands);

                    default:
                      return NULL;
                    }

                case ZERO_EXTEND:
                  if (pattern357 (x5) != 0
                      || !register_operand (operands[0], E_DImode)
                      || GET_MODE (x4) != E_DImode)
                    return NULL;
                  x8 = XEXP (x5, 0);
                  x11 = XEXP (x8, 1);
                  if (GET_CODE (x11) == SUBREG)
                    {
                      switch (pattern450 (x1))
                        {
                        case 0:
                          if (((
#line 686 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 691 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                            return gen_split_145 (insn, operands);
                          break;

                        case 1:
                          if (((
#line 712 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 716 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                            return gen_split_153 (insn, operands);
                          break;

                        default:
                          break;
                        }
                    }
                  operands[1] = x11;
                  if (!register_operand (operands[1], E_QImode))
                    return NULL;
                  x20 = XEXP (x4, 1);
                  operands[2] = x20;
                  if (!single_bit_mask_operand (operands[2], E_DImode))
                    return NULL;
                  operands[3] = x7;
                  if (!register_operand (operands[3], E_DImode)
                      || !
#line 803 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBS))
                    return NULL;
                  return gen_split_163 (insn, operands);

                default:
                  return NULL;
                }

            case ZERO_EXTEND:
              if (GET_MODE (x4) != E_DImode)
                return NULL;
              x5 = XEXP (x4, 0);
              if (GET_CODE (x5) != ASHIFT
                  || GET_MODE (x5) != E_SImode
                  || pattern397 (x5) != 0
                  || pattern277 (x1, 
E_DImode) != 0
                  || !((
#line 638 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 643 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return NULL;
              return gen_split_136 (insn, operands);

            case XOR:
              if (GET_MODE (x4) != E_DImode
                  || !register_operand (operands[0], E_DImode))
                return NULL;
              x5 = XEXP (x4, 0);
              if (GET_MODE (x5) != E_DImode)
                return NULL;
              switch (GET_CODE (x5))
                {
                case SIGN_EXTEND:
                  x8 = XEXP (x5, 0);
                  if (GET_CODE (x8) != ASHIFT
                      || GET_MODE (x8) != E_SImode)
                    return NULL;
                  x9 = XEXP (x8, 0);
                  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return NULL;
                  x11 = XEXP (x8, 1);
                  if (GET_CODE (x11) != SUBREG)
                    return NULL;
                  switch (pattern450 (x1))
                    {
                    case 0:
                      if (!((
#line 686 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 691 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                        return NULL;
                      return gen_split_144 (insn, operands);

                    case 1:
                      if (!((
#line 712 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 716 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                        return NULL;
                      return gen_split_152 (insn, operands);

                    default:
                      return NULL;
                    }

                case ZERO_EXTEND:
                  x8 = XEXP (x5, 0);
                  if (GET_CODE (x8) != ASHIFT
                      || GET_MODE (x8) != E_SImode)
                    return NULL;
                  x9 = XEXP (x8, 0);
                  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return NULL;
                  x11 = XEXP (x8, 1);
                  if (GET_CODE (x11) == SUBREG)
                    {
                      switch (pattern450 (x1))
                        {
                        case 0:
                          if (((
#line 686 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 691 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                            return gen_split_146 (insn, operands);
                          break;

                        case 1:
                          if (((
#line 712 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 716 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                            return gen_split_154 (insn, operands);
                          break;

                        default:
                          break;
                        }
                    }
                  operands[1] = x11;
                  if (!register_operand (operands[1], E_QImode))
                    return NULL;
                  x20 = XEXP (x4, 1);
                  operands[2] = x20;
                  if (!single_bit_mask_operand (operands[2], E_DImode))
                    return NULL;
                  operands[3] = x7;
                  if (!register_operand (operands[3], E_DImode)
                      || !
#line 803 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBS))
                    return NULL;
                  return gen_split_164 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case UNSPEC:
          if (XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 0)
            return NULL;
          x21 = XVECEXP (x3, 0, 0);
          operands[0] = x21;
          if (!register_operand (operands[0], E_VOIDmode))
            return NULL;
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          if (!scratch_operand (operands[1], E_VOIDmode)
              || !
#line 3900 "../../../gcc/config/riscv/riscv.md"
(reload_completed))
            return NULL;
          return gen_split_101 (insn, operands);

        default:
          return NULL;
        }

    case 3:
      x3 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x3) != SET)
        return NULL;
      x2 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x2) != CLOBBER)
        return NULL;
      x22 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x22) != CLOBBER)
        return NULL;
      x4 = XEXP (x3, 1);
      switch (GET_CODE (x4))
        {
        case IF_THEN_ELSE:
          if (pattern225 (x3) != 0)
            return NULL;
          x5 = XEXP (x4, 0);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          switch (pattern429 (x1))
            {
            case 0:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_61 (insn, operands);
              break;

            case 1:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_69 (insn, operands);
              break;

            case 2:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_63 (insn, operands);
              break;

            case 3:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_71 (insn, operands);
              break;

            case 4:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_65 (insn, operands);
              break;

            case 5:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_73 (insn, operands);
              break;

            case 6:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && (((
#line 69 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_67 (insn, operands);
              break;

            case 7:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 69 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_75 (insn, operands);
              break;

            case 8:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_62 (insn, operands);
              break;

            case 9:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_70 (insn, operands);
              break;

            case 10:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_64 (insn, operands);
              break;

            case 11:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_72 (insn, operands);
              break;

            case 12:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_66 (insn, operands);
              break;

            case 13:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_74 (insn, operands);
              break;

            case 14:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && (((
#line 69 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_68 (insn, operands);
              break;

            case 15:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 69 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_76 (insn, operands);
              break;

            default:
              break;
            }
          operands[1] = x5;
          switch (pattern431 (x1))
            {
            case 0:
              if (!((
#line 1101 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && TARGET_ZBB) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 1103 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return NULL;
              return gen_split_183 (insn, operands);

            case 1:
              if (!((
#line 1101 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && TARGET_ZBB) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 1103 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return NULL;
              return gen_split_184 (insn, operands);

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x4) != E_DImode)
            return NULL;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != SUBREG
              || maybe_ne (SUBREG_BYTE (x5), 0)
              || GET_MODE (x5) != E_SImode)
            return NULL;
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          if (!register_operand (operands[0], E_DImode))
            return NULL;
          x8 = XEXP (x5, 0);
          if (GET_MODE (x8) != E_DImode)
            return NULL;
          x7 = XEXP (x2, 0);
          operands[3] = x7;
          if (!register_operand (operands[3], E_DImode))
            return NULL;
          x23 = XEXP (x22, 0);
          operands[4] = x23;
          if (!register_operand (operands[4], E_DImode))
            return NULL;
          switch (GET_CODE (x8))
            {
            case SMIN:
              if (pattern509 (x8) != 0
                  || !
#line 563 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB && sext_hwi (INTVAL (operands[2]), 32) >= 0))
                return NULL;
              return gen_split_129 (insn, operands);

            case UMIN:
              if (pattern509 (x8) != 0
                  || !
#line 563 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB && sext_hwi (INTVAL (operands[2]), 32) >= 0))
                return NULL;
              return gen_split_130 (insn, operands);

            case SMAX:
              if (pattern509 (x8) != 0
                  || !
#line 563 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB && sext_hwi (INTVAL (operands[2]), 32) >= 0))
                return NULL;
              return gen_split_131 (insn, operands);

            case UMAX:
              if (pattern509 (x8) != 0
                  || !
#line 563 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB && sext_hwi (INTVAL (operands[2]), 32) >= 0))
                return NULL;
              return gen_split_132 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 4:
      if (pattern112 (x1, 
CLOBBER) != 0)
        return NULL;
      x3 = XVECEXP (x1, 0, 0);
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      x4 = XEXP (x3, 1);
      operands[1] = x4;
      return split_179 (x1, insn);

    default:
      return NULL;
    }
}
